// TJC implementation of procedure compileproc_argument_printable
package tjc;
import tcl.lang.*;

public class CompileprocArgumentPrintableCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 6, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        ExprValue evs2 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 3) {
            throw new TclNumArgsException(interp, 1, objv, "key i");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        setVarScalar(interp, "i", objv[2], compiledLocals, 1);
        { // Invoke: set type [...]
            TclObject tmp0;
            { // Invoke: lindex $... $i
                TclObject tmp1 = null;
                TclObject tmp2;
                try {
                    StringBuffer sbtmp3 = new StringBuffer(64);
                    tmp1 = getVarScalar(interp, "key", compiledLocals, 0);
                    sbtmp3.append(tmp1.toString());
                    sbtmp3.append(",types");
                    initVarScoped(interp, "::_compileproc_key_info", compiledLocals, 2);
                    tmp1 = getVarArray(interp, "::_compileproc_key_info", sbtmp3.toString(), compiledLocals, 2);
                    tmp1.preserve();
                    tmp2 = getVarScalar(interp, "i", compiledLocals, 1);
                    TJC.lindexNonconst(interp, tmp1, tmp2);
                } finally {
                    if ( tmp1 != null ) {
                        tmp1.release();
                    }
                }
            } // End Invoke: lindex
            tmp0 = interp.getResult();
            setVarScalar(interp, "type", tmp0, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: if {$type == {}} ...
            // Binary operator: $type == ""
            TclObject tmp4 = getVarScalar(interp, "type", compiledLocals, 3);
            ExprValue tmp5 = evs0;
            TJC.exprEqualsEmptyString(tmp5, tmp4, false);
            // End Binary operator: ==
            boolean tmp6 = ( tmp5.getIntValue() != 0 );
            if ( tmp6 ) {
                { // Invoke: if ... ...
                    // Binary operator: () || ()
                    // Binary operator: $i < 0
                    TclObject tmp7 = getVarScalar(interp, "i", compiledLocals, 1);
                    ExprValue tmp8 = evs0;
                    TJC.exprInitValue(interp, tmp8, tmp7);
                    ExprValue tmp9 = evs1;
                    tmp9.setIntValue(0);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp8, tmp9);
                    // End Binary operator: <
                    if (!tmp8.getBooleanValue(interp)) {
                    // Binary operator: $i >= $::_compileproc_key_info(...)
                    TclObject tmp10 = getVarScalar(interp, "i", compiledLocals, 1);
                    ExprValue tmp11 = evs1;
                    TJC.exprInitValue(interp, tmp11, tmp10);
                    TclObject tmp12;
                    StringBuffer sbtmp13 = new StringBuffer(64);
                    tmp12 = getVarScalar(interp, "key", compiledLocals, 0);
                    sbtmp13.append(tmp12.toString());
                    sbtmp13.append(",num_args");
                    initVarScoped(interp, "::_compileproc_key_info", compiledLocals, 2);
                    tmp12 = getVarArray(interp, "::_compileproc_key_info", sbtmp13.toString(), compiledLocals, 2);
                    ExprValue tmp14 = evs2;
                    TJC.exprInitValue(interp, tmp14, tmp12);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GEQ, tmp11, tmp14);
                    // End Binary operator: >=
                    tmp8.setIntValue(tmp11.getBooleanValue(interp));
                    } else {
                    tmp8.setIntValue(1);
                    } // End if: !()
                    // End Binary operator: ||
                    boolean tmp15 = ( tmp8.getIntValue() != 0 );
                    if ( tmp15 ) {
                        { // Invoke: error "..."
                            TclObject[] objv16 = TJC.grabObjv(interp, 2);
                            TclObject tmp17;
                            try {
                                // Arg 0 constant: error
                                objv16[0] = const0;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp18 = new StringBuffer(64);
                                sbtmp18.append("index ");
                                tmp17 = getVarScalar(interp, "i", compiledLocals, 1);
                                sbtmp18.append(tmp17.toString());
                                sbtmp18.append(" out of argument range");
                                tmp17 = TclString.newInstance(sbtmp18);
                                tmp17.preserve();
                                objv16[1] = tmp17;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                    ? cmdcache1.cmd : null), objv16, 0);
                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                    updateCmdCache(interp, 1);
                                }
                            } finally {
                                tmp17 = objv16[1];
                                if ( tmp17 != null ) {
                                    tmp17.release();
                                }
                                TJC.releaseObjv(interp, objv16, 2);
                            }
                        } // End Invoke: error
                    }
                } // End Invoke: if
            }
        } // End Invoke: if
        { // Invoke: set print 1
            setVarScalar(interp, "print", const1, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: switch -exact -- $type {constant} ... {variable} ... {command} ... {word} ... default ...
            TclObject tmp19 = getVarScalar(interp, "type", compiledLocals, 3);
            String tmp20 = tmp19.toString();
            int tmp20_length = tmp20.length();
            char tmp20_first = '\n';
            if ( tmp20_length > 0 ) {
                tmp20_first = tmp20.charAt(0);
            }
            if ( tmp20_length == 8 && tmp20_first == 'c'
                    && tmp20.compareTo("constant") == 0 ) {
                // Pattern {constant}
                { // Invoke: set str [...]
                    TclObject tmp21;
                    { // Invoke: lindex $... $i
                        TclObject tmp22 = null;
                        TclObject tmp23;
                        try {
                            StringBuffer sbtmp24 = new StringBuffer(64);
                            tmp22 = getVarScalar(interp, "key", compiledLocals, 0);
                            sbtmp24.append(tmp22.toString());
                            sbtmp24.append(",instrs");
                            initVarScoped(interp, "::_compileproc_key_info", compiledLocals, 2);
                            tmp22 = getVarArray(interp, "::_compileproc_key_info", sbtmp24.toString(), compiledLocals, 2);
                            tmp22.preserve();
                            tmp23 = getVarScalar(interp, "i", compiledLocals, 1);
                            TJC.lindexNonconst(interp, tmp22, tmp23);
                        } finally {
                            if ( tmp22 != null ) {
                                tmp22.release();
                            }
                        }
                    } // End Invoke: lindex
                    tmp21 = interp.getResult();
                    setVarScalar(interp, "str", tmp21, compiledLocals, 5);
                } // End Invoke: set
                { // Invoke: if ... ...
                    // Binary operator: [...] > 20
                    { // Invoke: string length $str
                        TclObject tmp25 = getVarScalar(interp, "str", compiledLocals, 5);
                        int tmp26 = tmp25.toString().length();
                        interp.setResult(tmp26);
                    } // End Invoke: string
                    TclObject tmp27 = interp.getResult();
                    ExprValue tmp28 = evs0;
                    TJC.exprInitValue(interp, tmp28, tmp27);
                    ExprValue tmp29 = evs1;
                    tmp29.setIntValue(20);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GREATER, tmp28, tmp29);
                    // End Binary operator: >
                    boolean tmp30 = ( tmp28.getIntValue() != 0 );
                    if ( tmp30 ) {
                        { // Invoke: set print 0
                            setVarScalar(interp, "print", const2, compiledLocals, 4);
                        } // End Invoke: set
                    }
                } // End Invoke: if
            } else if ( tmp20_length == 8 && tmp20_first == 'v'
                    && tmp20.compareTo("variable") == 0 ) {
                // Pattern {variable}
                { // Invoke: set str [...]
                    TclObject tmp31;
                    { // Invoke: lindex $... $i
                        TclObject tmp32 = null;
                        TclObject tmp33;
                        try {
                            StringBuffer sbtmp34 = new StringBuffer(64);
                            tmp32 = getVarScalar(interp, "key", compiledLocals, 0);
                            sbtmp34.append(tmp32.toString());
                            sbtmp34.append(",instrs");
                            initVarScoped(interp, "::_compileproc_key_info", compiledLocals, 2);
                            tmp32 = getVarArray(interp, "::_compileproc_key_info", sbtmp34.toString(), compiledLocals, 2);
                            tmp32.preserve();
                            tmp33 = getVarScalar(interp, "i", compiledLocals, 1);
                            TJC.lindexNonconst(interp, tmp32, tmp33);
                        } finally {
                            if ( tmp32 != null ) {
                                tmp32.release();
                            }
                        }
                    } // End Invoke: lindex
                    tmp31 = interp.getResult();
                    setVarScalar(interp, "str", tmp31, compiledLocals, 5);
                } // End Invoke: set
                { // Invoke: if ... ...
                    // Binary operator: [...] > 20
                    { // Invoke: string length $str
                        TclObject tmp35 = getVarScalar(interp, "str", compiledLocals, 5);
                        int tmp36 = tmp35.toString().length();
                        interp.setResult(tmp36);
                    } // End Invoke: string
                    TclObject tmp37 = interp.getResult();
                    ExprValue tmp38 = evs0;
                    TJC.exprInitValue(interp, tmp38, tmp37);
                    ExprValue tmp39 = evs1;
                    tmp39.setIntValue(20);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GREATER, tmp38, tmp39);
                    // End Binary operator: >
                    boolean tmp40 = ( tmp38.getIntValue() != 0 );
                    if ( tmp40 ) {
                        { // Invoke: set str ...
                            setVarScalar(interp, "str", const3, compiledLocals, 5);
                        } // End Invoke: set
                    }
                } // End Invoke: if
            } else if ( tmp20_length == 7 && tmp20_first == 'c'
                    && tmp20.compareTo("command") == 0 ) {
                // Pattern {command}
                { // Invoke: set str ...
                    setVarScalar(interp, "str", const4, compiledLocals, 5);
                } // End Invoke: set
            } else if ( tmp20_length == 4 && tmp20_first == 'w'
                    && tmp20.compareTo("word") == 0 ) {
                // Pattern {word}
                { // Invoke: set str [...]
                    TclObject tmp41;
                    { // Invoke: lindex $... $i
                        TclObject tmp42 = null;
                        TclObject tmp43;
                        try {
                            StringBuffer sbtmp44 = new StringBuffer(64);
                            tmp42 = getVarScalar(interp, "key", compiledLocals, 0);
                            sbtmp44.append(tmp42.toString());
                            sbtmp44.append(",instrs");
                            initVarScoped(interp, "::_compileproc_key_info", compiledLocals, 2);
                            tmp42 = getVarArray(interp, "::_compileproc_key_info", sbtmp44.toString(), compiledLocals, 2);
                            tmp42.preserve();
                            tmp43 = getVarScalar(interp, "i", compiledLocals, 1);
                            TJC.lindexNonconst(interp, tmp42, tmp43);
                        } finally {
                            if ( tmp42 != null ) {
                                tmp42.release();
                            }
                        }
                    } // End Invoke: lindex
                    tmp41 = interp.getResult();
                    setVarScalar(interp, "str", tmp41, compiledLocals, 5);
                } // End Invoke: set
                { // Invoke: if ... ...
                    // Binary operator: [...] > 20
                    { // Invoke: string length $str
                        TclObject tmp45 = getVarScalar(interp, "str", compiledLocals, 5);
                        int tmp46 = tmp45.toString().length();
                        interp.setResult(tmp46);
                    } // End Invoke: string
                    TclObject tmp47 = interp.getResult();
                    ExprValue tmp48 = evs0;
                    TJC.exprInitValue(interp, tmp48, tmp47);
                    ExprValue tmp49 = evs1;
                    tmp49.setIntValue(20);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GREATER, tmp48, tmp49);
                    // End Binary operator: >
                    boolean tmp50 = ( tmp48.getIntValue() != 0 );
                    if ( tmp50 ) {
                        { // Invoke: set str ...
                            setVarScalar(interp, "str", const5, compiledLocals, 5);
                        } // End Invoke: set
                    }
                } // End Invoke: if
            } else {
                // Pattern default
                { // Invoke: error "..."
                    TclObject[] objv51 = TJC.grabObjv(interp, 2);
                    TclObject tmp52;
                    try {
                        // Arg 0 constant: error
                        objv51[0] = const0;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp53 = new StringBuffer(64);
                        sbtmp53.append("unknown type ");
                        sbtmp53.append("\"");
                        tmp52 = getVarScalar(interp, "type", compiledLocals, 3);
                        sbtmp53.append(tmp52.toString());
                        sbtmp53.append("\"");
                        sbtmp53.append(" at index ");
                        tmp52 = getVarScalar(interp, "i", compiledLocals, 1);
                        sbtmp53.append(tmp52.toString());
                        tmp52 = TclString.newInstance(sbtmp53);
                        tmp52.preserve();
                        objv51[1] = tmp52;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv51, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp52 = objv51[1];
                        if ( tmp52 != null ) {
                            tmp52.release();
                        }
                        TJC.releaseObjv(interp, objv51, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: switch
        { // Invoke: if {$print} ...
            TclObject tmp54 = getVarScalar(interp, "print", compiledLocals, 4);
            boolean tmp55 = TJC.getBoolean(interp, tmp54);
            if ( tmp55 ) {
                { // Invoke: if ... ...
                    // Binary operator: () || ()
                    // Binary operator: () || ()
                    // Binary operator: () || ()
                    // Binary operator: () || ()
                    // Binary operator: () || ()
                    // Binary operator: () || ()
                    // Binary operator: () || ()
                    // Binary operator: [...] != ()
                    { // Invoke: string first ... $str
                        char tmp56 = '\u0007';
                        TclObject tmp57 = getVarScalar(interp, "str", compiledLocals, 5);
                        String tmp58 = tmp57.toString();
                        int tmp59 = tmp58.indexOf(tmp56);
                        interp.setResult(tmp59);
                    } // End Invoke: string
                    TclObject tmp60 = interp.getResult();
                    ExprValue tmp61 = evs0;
                    TJC.exprInitValue(interp, tmp61, tmp60);
                    // Unary operator: - 1
                    ExprValue tmp62 = evs1;
                    tmp62.setIntValue(-1);
                    // End Unary operator: -
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp61, tmp62);
                    // End Binary operator: !=
                    if (!tmp61.getBooleanValue(interp)) {
                    // Binary operator: [...] != ()
                    { // Invoke: string first ... $str
                        char tmp63 = '\b';
                        TclObject tmp64 = getVarScalar(interp, "str", compiledLocals, 5);
                        String tmp65 = tmp64.toString();
                        int tmp66 = tmp65.indexOf(tmp63);
                        interp.setResult(tmp66);
                    } // End Invoke: string
                    TclObject tmp67 = interp.getResult();
                    ExprValue tmp68 = evs1;
                    TJC.exprInitValue(interp, tmp68, tmp67);
                    // Unary operator: - 1
                    ExprValue tmp69 = evs2;
                    tmp69.setIntValue(-1);
                    // End Unary operator: -
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp68, tmp69);
                    // End Binary operator: !=
                    tmp61.setIntValue(tmp68.getBooleanValue(interp));
                    } else {
                    tmp61.setIntValue(1);
                    } // End if: !()
                    // End Binary operator: ||
                    if (!tmp61.getBooleanValue(interp)) {
                    // Binary operator: [...] != ()
                    { // Invoke: string first ... $str
                        char tmp70 = '\f';
                        TclObject tmp71 = getVarScalar(interp, "str", compiledLocals, 5);
                        String tmp72 = tmp71.toString();
                        int tmp73 = tmp72.indexOf(tmp70);
                        interp.setResult(tmp73);
                    } // End Invoke: string
                    TclObject tmp74 = interp.getResult();
                    ExprValue tmp75 = evs1;
                    TJC.exprInitValue(interp, tmp75, tmp74);
                    // Unary operator: - 1
                    ExprValue tmp76 = evs2;
                    tmp76.setIntValue(-1);
                    // End Unary operator: -
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp75, tmp76);
                    // End Binary operator: !=
                    tmp61.setIntValue(tmp75.getBooleanValue(interp));
                    } else {
                    tmp61.setIntValue(1);
                    } // End if: !()
                    // End Binary operator: ||
                    if (!tmp61.getBooleanValue(interp)) {
                    // Binary operator: [...] != ()
                    { // Invoke: string first ... $str
                        char tmp77 = '\n';
                        TclObject tmp78 = getVarScalar(interp, "str", compiledLocals, 5);
                        String tmp79 = tmp78.toString();
                        int tmp80 = tmp79.indexOf(tmp77);
                        interp.setResult(tmp80);
                    } // End Invoke: string
                    TclObject tmp81 = interp.getResult();
                    ExprValue tmp82 = evs1;
                    TJC.exprInitValue(interp, tmp82, tmp81);
                    // Unary operator: - 1
                    ExprValue tmp83 = evs2;
                    tmp83.setIntValue(-1);
                    // End Unary operator: -
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp82, tmp83);
                    // End Binary operator: !=
                    tmp61.setIntValue(tmp82.getBooleanValue(interp));
                    } else {
                    tmp61.setIntValue(1);
                    } // End if: !()
                    // End Binary operator: ||
                    if (!tmp61.getBooleanValue(interp)) {
                    // Binary operator: [...] != ()
                    { // Invoke: string first ... $str
                        char tmp84 = '\r';
                        TclObject tmp85 = getVarScalar(interp, "str", compiledLocals, 5);
                        String tmp86 = tmp85.toString();
                        int tmp87 = tmp86.indexOf(tmp84);
                        interp.setResult(tmp87);
                    } // End Invoke: string
                    TclObject tmp88 = interp.getResult();
                    ExprValue tmp89 = evs1;
                    TJC.exprInitValue(interp, tmp89, tmp88);
                    // Unary operator: - 1
                    ExprValue tmp90 = evs2;
                    tmp90.setIntValue(-1);
                    // End Unary operator: -
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp89, tmp90);
                    // End Binary operator: !=
                    tmp61.setIntValue(tmp89.getBooleanValue(interp));
                    } else {
                    tmp61.setIntValue(1);
                    } // End if: !()
                    // End Binary operator: ||
                    if (!tmp61.getBooleanValue(interp)) {
                    // Binary operator: [...] != ()
                    { // Invoke: string first ... $str
                        char tmp91 = '\t';
                        TclObject tmp92 = getVarScalar(interp, "str", compiledLocals, 5);
                        String tmp93 = tmp92.toString();
                        int tmp94 = tmp93.indexOf(tmp91);
                        interp.setResult(tmp94);
                    } // End Invoke: string
                    TclObject tmp95 = interp.getResult();
                    ExprValue tmp96 = evs1;
                    TJC.exprInitValue(interp, tmp96, tmp95);
                    // Unary operator: - 1
                    ExprValue tmp97 = evs2;
                    tmp97.setIntValue(-1);
                    // End Unary operator: -
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp96, tmp97);
                    // End Binary operator: !=
                    tmp61.setIntValue(tmp96.getBooleanValue(interp));
                    } else {
                    tmp61.setIntValue(1);
                    } // End if: !()
                    // End Binary operator: ||
                    if (!tmp61.getBooleanValue(interp)) {
                    // Binary operator: [...] != ()
                    { // Invoke: string first ... $str
                        char tmp98 = '\u000B';
                        TclObject tmp99 = getVarScalar(interp, "str", compiledLocals, 5);
                        String tmp100 = tmp99.toString();
                        int tmp101 = tmp100.indexOf(tmp98);
                        interp.setResult(tmp101);
                    } // End Invoke: string
                    TclObject tmp102 = interp.getResult();
                    ExprValue tmp103 = evs1;
                    TJC.exprInitValue(interp, tmp103, tmp102);
                    // Unary operator: - 1
                    ExprValue tmp104 = evs2;
                    tmp104.setIntValue(-1);
                    // End Unary operator: -
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp103, tmp104);
                    // End Binary operator: !=
                    tmp61.setIntValue(tmp103.getBooleanValue(interp));
                    } else {
                    tmp61.setIntValue(1);
                    } // End if: !()
                    // End Binary operator: ||
                    if (!tmp61.getBooleanValue(interp)) {
                    // Binary operator: [...] != ()
                    { // Invoke: string first ... $str
                        char tmp105 = '\\';
                        TclObject tmp106 = getVarScalar(interp, "str", compiledLocals, 5);
                        String tmp107 = tmp106.toString();
                        int tmp108 = tmp107.indexOf(tmp105);
                        interp.setResult(tmp108);
                    } // End Invoke: string
                    TclObject tmp109 = interp.getResult();
                    ExprValue tmp110 = evs1;
                    TJC.exprInitValue(interp, tmp110, tmp109);
                    // Unary operator: - 1
                    ExprValue tmp111 = evs2;
                    tmp111.setIntValue(-1);
                    // End Unary operator: -
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp110, tmp111);
                    // End Binary operator: !=
                    tmp61.setIntValue(tmp110.getBooleanValue(interp));
                    } else {
                    tmp61.setIntValue(1);
                    } // End if: !()
                    // End Binary operator: ||
                    boolean tmp112 = ( tmp61.getIntValue() != 0 );
                    if ( tmp112 ) {
                        { // Invoke: set print 0
                            setVarScalar(interp, "print", const2, compiledLocals, 4);
                        } // End Invoke: set
                    }
                } // End Invoke: if
            }
        } // End Invoke: if
        { // Invoke: if {!$print} ...
            // Unary operator: ! $print
            TclObject tmp113 = getVarScalar(interp, "print", compiledLocals, 4);
            ExprValue tmp114 = evs0;
            if ( tmp113.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp114, tmp113);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp114, tmp113);
            }
            // End Unary operator: !
            boolean tmp115 = ( tmp114.getIntValue() != 0 );
            if ( tmp115 ) {
                { // Invoke: set str "..."
                    setVarScalar(interp, "str", const6, compiledLocals, 5);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: return [...]
            { // Invoke: list $type $str
                TclObject tmp116 = TclList.newInstance();
                TclObject tmp117;
                try {
                    tmp117 = getVarScalar(interp, "type", compiledLocals, 3);
                    TclList.append(interp, tmp116, tmp117);
                    tmp117 = getVarScalar(interp, "str", compiledLocals, 5);
                    TclList.append(interp, tmp116, tmp117);
                } catch (TclException ex) {
                    tmp116.release();
                    throw ex;
                }
                interp.setResult(tmp116);
            } // End Invoke: list
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_argument_printable");
        } finally {
            TJC.exprReleaseValue(interp, evs2);
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("error");
        const0.preserve(); const0.preserve();
        const1 = TclInteger.newInstance(1);
        const1.preserve(); const1.preserve();
        const2 = TclInteger.newInstance(0);
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("$...");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("[...]");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("\"...\"");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("...");
        const6.preserve(); const6.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "error";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "i",
        "::_compileproc_key_info",
        "type",
        "print",
        "str"
    };
} // end class CompileprocArgumentPrintableCmd

