// TJC implementation of procedure compileproc_assign_args_arg
package tjc;
import tcl.lang.*;

public class CompileprocAssignArgsArgCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 3, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "index");
        }
        setVarScalar(interp, "index", objv[1], compiledLocals, 0);
        { // Invoke: if ... ...
            // Unary operator: ! [...]
            { // Invoke: string is integer $index
                TclObject[] objv0 = TJC.grabObjv(interp, 4);
                TclObject tmp1;
                try {
                    // Arg 0 constant: string
                    objv0[0] = const0;
                    // Arg 1 constant: is
                    objv0[1] = const1;
                    // Arg 2 constant: integer
                    objv0[2] = const2;
                    // Arg 3 variable: $index
                    tmp1 = getVarScalar(interp, "index", compiledLocals, 0);
                    tmp1.preserve();
                    objv0[3] = tmp1;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv0, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp1 = objv0[3];
                    if ( tmp1 != null ) {
                        tmp1.release();
                    }
                    TJC.releaseObjv(interp, objv0, 4);
                }
            } // End Invoke: string
            TclObject tmp2 = interp.getResult();
            ExprValue tmp3 = evs0;
            if ( tmp2.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp3, tmp2);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp3, tmp2);
            }
            // End Unary operator: !
            boolean tmp4 = ( tmp3.getIntValue() != 0 );
            if ( tmp4 ) {
                { // Invoke: error "..."
                    TclObject[] objv5 = TJC.grabObjv(interp, 2);
                    TclObject tmp6;
                    try {
                        // Arg 0 constant: error
                        objv5[0] = const3;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp7 = new StringBuffer(64);
                        sbtmp7.append("index ");
                        tmp6 = getVarScalar(interp, "index", compiledLocals, 0);
                        sbtmp7.append(tmp6.toString());
                        sbtmp7.append(" is not an integer");
                        tmp6 = TclString.newInstance(sbtmp7);
                        tmp6.preserve();
                        objv5[1] = tmp6;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv5, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp6 = objv5[1];
                        if ( tmp6 != null ) {
                            tmp6.release();
                        }
                        TJC.releaseObjv(interp, objv5, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: if {$index < 1} ...
            // Binary operator: $index < 1
            TclObject tmp8 = getVarScalar(interp, "index", compiledLocals, 0);
            ExprValue tmp9 = evs0;
            TJC.exprInitValue(interp, tmp9, tmp8);
            ExprValue tmp10 = evs1;
            tmp10.setIntValue(1);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp9, tmp10);
            // End Binary operator: <
            boolean tmp11 = ( tmp9.getIntValue() != 0 );
            if ( tmp11 ) {
                { // Invoke: error "..."
                    TclObject[] objv12 = TJC.grabObjv(interp, 2);
                    TclObject tmp13;
                    try {
                        // Arg 0 constant: error
                        objv12[0] = const3;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp14 = new StringBuffer(64);
                        sbtmp14.append("index ");
                        tmp13 = getVarScalar(interp, "index", compiledLocals, 0);
                        sbtmp14.append(tmp13.toString());
                        sbtmp14.append(" must be greater than 0");
                        tmp13 = TclString.newInstance(sbtmp14);
                        tmp13.preserve();
                        objv12[1] = tmp13;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv12, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp13 = objv12[1];
                        if ( tmp13 != null ) {
                            tmp13.release();
                        }
                        TJC.releaseObjv(interp, objv12, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const4, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: append buffer [...] ... $index ...
            TclObject[] objv15 = TJC.grabObjv(interp, 4);
            TclObject tmp16;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv17 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv17[0] = const5;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv17, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv17, 1);
                    }
                } // End Invoke: emitter_indent
                tmp16 = interp.getResult();
                tmp16.preserve();
                objv15[0] = tmp16;
                // Arg 3 constant: ...
                objv15[1] = const6;
                // Arg 4 variable: $index
                tmp16 = getVarScalar(interp, "index", compiledLocals, 0);
                tmp16.preserve();
                objv15[2] = tmp16;
                // Arg 5 constant: ...
                objv15[3] = const7;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv15, compiledLocals, 1);
            } finally {
                tmp16 = objv15[0];
                if ( tmp16 != null ) {
                    tmp16.release();
                }
                tmp16 = objv15[2];
                if ( tmp16 != null ) {
                    tmp16.release();
                }
                TJC.releaseObjv(interp, objv15, 4);
            }
        } // End Invoke: append
        { // Invoke: emitter_indent_level +1
            TclObject[] objv18 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv18[0] = const8;
                // Arg 1 constant: +1
                objv18[1] = const9;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                    ? cmdcache4.cmd : null), objv18, 0);
                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                    updateCmdCache(interp, 4);
                }
            } finally {
                TJC.releaseObjv(interp, objv18, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: set value ""
            setVarScalar(interp, "value", const4, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: append buffer [...]
            TclObject[] objv19 = TJC.grabObjv(interp, 1);
            TclObject tmp20;
            try {
                // Arg 2 command: [...]
                { // Invoke: ... {} "args" true $value true
                    TclObject[] objv21 = TJC.grabObjv(interp, 6);
                    TclObject tmp22;
                    try {
                        // Arg 0 constant: ...
                        objv21[0] = const10;
                        // Arg 1 constant: {}
                        objv21[1] = const4;
                        // Arg 2 constant: "args"
                        objv21[2] = const11;
                        // Arg 3 constant: true
                        objv21[3] = const12;
                        // Arg 4 variable: $value
                        tmp22 = getVarScalar(interp, "value", compiledLocals, 2);
                        tmp22.preserve();
                        objv21[4] = tmp22;
                        // Arg 5 constant: true
                        objv21[5] = const12;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                            ? cmdcache5.cmd : null), objv21, 0);
                        if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                            updateCmdCache(interp, 5);
                        }
                    } finally {
                        tmp22 = objv21[4];
                        if ( tmp22 != null ) {
                            tmp22.release();
                        }
                        TJC.releaseObjv(interp, objv21, 6);
                    }
                } // End Invoke: ...
                tmp20 = interp.getResult();
                tmp20.preserve();
                objv19[0] = tmp20;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv19, compiledLocals, 1);
            } finally {
                TJC.releaseObjvElems(interp, objv19, 1);
            }
        } // End Invoke: append
        { // Invoke: emitter_indent_level -1
            TclObject[] objv23 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv23[0] = const8;
                // Arg 1 constant: -1
                objv23[1] = const13;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                    ? cmdcache4.cmd : null), objv23, 0);
                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                    updateCmdCache(interp, 4);
                }
            } finally {
                TJC.releaseObjv(interp, objv23, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: append buffer [...] ...
            TclObject[] objv24 = TJC.grabObjv(interp, 2);
            TclObject tmp25;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv26 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv26[0] = const5;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv26, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv26, 1);
                    }
                } // End Invoke: emitter_indent
                tmp25 = interp.getResult();
                tmp25.preserve();
                objv24[0] = tmp25;
                // Arg 3 constant: ...
                objv24[1] = const14;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv24, compiledLocals, 1);
            } finally {
                tmp25 = objv24[0];
                if ( tmp25 != null ) {
                    tmp25.release();
                }
                TJC.releaseObjv(interp, objv24, 2);
            }
        } // End Invoke: append
        { // Invoke: emitter_indent_level +1
            TclObject[] objv27 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv27[0] = const8;
                // Arg 1 constant: +1
                objv27[1] = const9;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                    ? cmdcache4.cmd : null), objv27, 0);
                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                    updateCmdCache(interp, 4);
                }
            } finally {
                TJC.releaseObjv(interp, objv27, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: append buffer [...] ...
            TclObject[] objv28 = TJC.grabObjv(interp, 2);
            TclObject tmp29;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv30 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv30[0] = const5;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv30, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv30, 1);
                    }
                } // End Invoke: emitter_indent
                tmp29 = interp.getResult();
                tmp29.preserve();
                objv28[0] = tmp29;
                // Arg 3 constant: ...
                objv28[1] = const15;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv28, compiledLocals, 1);
            } finally {
                tmp29 = objv28[0];
                if ( tmp29 != null ) {
                    tmp29.release();
                }
                TJC.releaseObjv(interp, objv28, 2);
            }
        } // End Invoke: append
        { // Invoke: append buffer [...] "for (int i = " $index ...
            TclObject[] objv31 = TJC.grabObjv(interp, 4);
            TclObject tmp32;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv33 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv33[0] = const5;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv33, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv33, 1);
                    }
                } // End Invoke: emitter_indent
                tmp32 = interp.getResult();
                tmp32.preserve();
                objv31[0] = tmp32;
                // Arg 3 constant: "for (int i = "
                objv31[1] = const16;
                // Arg 4 variable: $index
                tmp32 = getVarScalar(interp, "index", compiledLocals, 0);
                tmp32.preserve();
                objv31[2] = tmp32;
                // Arg 5 constant: ...
                objv31[3] = const17;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv31, compiledLocals, 1);
            } finally {
                tmp32 = objv31[0];
                if ( tmp32 != null ) {
                    tmp32.release();
                }
                tmp32 = objv31[2];
                if ( tmp32 != null ) {
                    tmp32.release();
                }
                TJC.releaseObjv(interp, objv31, 4);
            }
        } // End Invoke: append
        { // Invoke: emitter_indent_level +1
            TclObject[] objv34 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv34[0] = const8;
                // Arg 1 constant: +1
                objv34[1] = const9;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                    ? cmdcache4.cmd : null), objv34, 0);
                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                    updateCmdCache(interp, 4);
                }
            } finally {
                TJC.releaseObjv(interp, objv34, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: append buffer [...] ...
            TclObject[] objv35 = TJC.grabObjv(interp, 2);
            TclObject tmp36;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv37 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv37[0] = const5;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv37, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv37, 1);
                    }
                } // End Invoke: emitter_indent
                tmp36 = interp.getResult();
                tmp36.preserve();
                objv35[0] = tmp36;
                // Arg 3 constant: ...
                objv35[1] = const18;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv35, compiledLocals, 1);
            } finally {
                tmp36 = objv35[0];
                if ( tmp36 != null ) {
                    tmp36.release();
                }
                TJC.releaseObjv(interp, objv35, 2);
            }
        } // End Invoke: append
        { // Invoke: emitter_indent_level -1
            TclObject[] objv38 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv38[0] = const8;
                // Arg 1 constant: -1
                objv38[1] = const13;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                    ? cmdcache4.cmd : null), objv38, 0);
                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                    updateCmdCache(interp, 4);
                }
            } finally {
                TJC.releaseObjv(interp, objv38, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: append buffer [...] ...
            TclObject[] objv39 = TJC.grabObjv(interp, 2);
            TclObject tmp40;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv41 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv41[0] = const5;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv41, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv41, 1);
                    }
                } // End Invoke: emitter_indent
                tmp40 = interp.getResult();
                tmp40.preserve();
                objv39[0] = tmp40;
                // Arg 3 constant: ...
                objv39[1] = const19;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv39, compiledLocals, 1);
            } finally {
                tmp40 = objv39[0];
                if ( tmp40 != null ) {
                    tmp40.release();
                }
                TJC.releaseObjv(interp, objv39, 2);
            }
        } // End Invoke: append
        { // Invoke: set value argl
            setVarScalar(interp, "value", const20, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: append buffer [...]
            TclObject[] objv42 = TJC.grabObjv(interp, 1);
            TclObject tmp43;
            try {
                // Arg 2 command: [...]
                { // Invoke: ... {} "args" true $value false
                    TclObject[] objv44 = TJC.grabObjv(interp, 6);
                    TclObject tmp45;
                    try {
                        // Arg 0 constant: ...
                        objv44[0] = const10;
                        // Arg 1 constant: {}
                        objv44[1] = const4;
                        // Arg 2 constant: "args"
                        objv44[2] = const11;
                        // Arg 3 constant: true
                        objv44[3] = const12;
                        // Arg 4 variable: $value
                        tmp45 = getVarScalar(interp, "value", compiledLocals, 2);
                        tmp45.preserve();
                        objv44[4] = tmp45;
                        // Arg 5 constant: false
                        objv44[5] = const21;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                            ? cmdcache5.cmd : null), objv44, 0);
                        if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                            updateCmdCache(interp, 5);
                        }
                    } finally {
                        tmp45 = objv44[4];
                        if ( tmp45 != null ) {
                            tmp45.release();
                        }
                        TJC.releaseObjv(interp, objv44, 6);
                    }
                } // End Invoke: ...
                tmp43 = interp.getResult();
                tmp43.preserve();
                objv42[0] = tmp43;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv42, compiledLocals, 1);
            } finally {
                TJC.releaseObjvElems(interp, objv42, 1);
            }
        } // End Invoke: append
        { // Invoke: emitter_indent_level -1
            TclObject[] objv46 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv46[0] = const8;
                // Arg 1 constant: -1
                objv46[1] = const13;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                    ? cmdcache4.cmd : null), objv46, 0);
                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                    updateCmdCache(interp, 4);
                }
            } finally {
                TJC.releaseObjv(interp, objv46, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: append buffer [...] ...
            TclObject[] objv47 = TJC.grabObjv(interp, 2);
            TclObject tmp48;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv49 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv49[0] = const5;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv49, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv49, 1);
                    }
                } // End Invoke: emitter_indent
                tmp48 = interp.getResult();
                tmp48.preserve();
                objv47[0] = tmp48;
                // Arg 3 constant: ...
                objv47[1] = const19;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv47, compiledLocals, 1);
            } finally {
                tmp48 = objv47[0];
                if ( tmp48 != null ) {
                    tmp48.release();
                }
                TJC.releaseObjv(interp, objv47, 2);
            }
        } // End Invoke: append
        { // Invoke: return $buffer
            TclObject tmp50 = getVarScalar(interp, "buffer", compiledLocals, 1);
            interp.resetResult();
            interp.setResult(tmp50);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_assign_args_arg");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;
    TclObject const18;
    TclObject const19;
    TclObject const20;
    TclObject const21;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("string");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("is");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("integer");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("error");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("emitter_indent");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("if ( objv.length <= ");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance(" ) {\n");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("emitter_indent_level");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("+1");
        TclInteger.get(interp, const9);
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("compileproc_set_variable");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("args");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("true");
        TclBoolean.get(interp, const12);
        const12.preserve(); const12.preserve();
        const13 = TclInteger.newInstance(-1);
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("} else {\n");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("TclObject argl = TclList.newInstance();\n");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance("for (int i = ");
        const16.preserve(); const16.preserve();
        const17 = TclString.newInstance("; i < objv.length; i++) {\n");
        const17.preserve(); const17.preserve();
        const18 = TclString.newInstance("TclList.append(interp, argl, objv[i]);\n");
        const18.preserve(); const18.preserve();
        const19 = TclString.newInstance("}\n");
        const19.preserve(); const19.preserve();
        const20 = TclString.newInstance("argl");
        const20.preserve(); const20.preserve();
        const21 = TclString.newInstance("false");
        TclBoolean.get(interp, const21);
        const21.preserve(); const21.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "string";
                break;
            }
            case 2: {
                cmdName = "error";
                break;
            }
            case 3: {
                cmdName = "emitter_indent";
                break;
            }
            case 4: {
                cmdName = "emitter_indent_level";
                break;
            }
            case 5: {
                cmdName = "compileproc_set_variable";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "index",
        "buffer",
        "value"
    };
} // end class CompileprocAssignArgsArgCmd

