// TJC implementation of procedure compileproc_emit_container_foreach
package tjc;
import tcl.lang.*;

public class CompileprocEmitContainerForeachCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 21, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        { // Invoke: global _compileproc
            TJC.makeGlobalLinkVar(interp, "_compileproc", "_compileproc", 1);
        } // End Invoke: global
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: () || ()
            // Unary operator: ! [...]
            { // Invoke: ... $key
                TclObject[] objv0 = TJC.grabObjv(interp, 2);
                TclObject tmp1;
                try {
                    // Arg 0 constant: ...
                    objv0[0] = const1;
                    // Arg 1 variable: $key
                    tmp1 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp1.preserve();
                    objv0[1] = tmp1;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv0, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp1 = objv0[1];
                    if ( tmp1 != null ) {
                        tmp1.release();
                    }
                    TJC.releaseObjv(interp, objv0, 2);
                }
            } // End Invoke: ...
            TclObject tmp2 = interp.getResult();
            ExprValue tmp3 = evs0;
            if ( tmp2.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp3, tmp2);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp3, tmp2);
            }
            // End Unary operator: !
            if (!tmp3.getBooleanValue(interp)) {
            // Unary operator: ! [...]
            { // Invoke: ... $key
                TclObject[] objv4 = TJC.grabObjv(interp, 2);
                TclObject tmp5;
                try {
                    // Arg 0 constant: ...
                    objv4[0] = const2;
                    // Arg 1 variable: $key
                    tmp5 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp5.preserve();
                    objv4[1] = tmp5;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv4, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp5 = objv4[1];
                    if ( tmp5 != null ) {
                        tmp5.release();
                    }
                    TJC.releaseObjv(interp, objv4, 2);
                }
            } // End Invoke: ...
            TclObject tmp6 = interp.getResult();
            ExprValue tmp7 = evs1;
            if ( tmp6.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp7, tmp6);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp7, tmp6);
            }
            // End Unary operator: !
            tmp3.setIntValue(tmp7.getBooleanValue(interp));
            } else {
            tmp3.setIntValue(1);
            } // End if: !()
            // End Binary operator: ||
            boolean tmp8 = ( tmp3.getIntValue() != 0 );
            if ( tmp8 ) {
                { // Invoke: error "..."
                    TclObject[] objv9 = TJC.grabObjv(interp, 2);
                    TclObject tmp10;
                    try {
                        // Arg 0 constant: error
                        objv9[0] = const3;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp11 = new StringBuffer(64);
                        sbtmp11.append("NOT valid or NOT static for key ");
                        tmp10 = getVarScalar(interp, "key", compiledLocals, 0);
                        sbtmp11.append(tmp10.toString());
                        tmp10 = TclString.newInstance(sbtmp11);
                        tmp10.preserve();
                        objv9[1] = tmp10;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv9, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        tmp10 = objv9[1];
                        if ( tmp10 != null ) {
                            tmp10.release();
                        }
                        TJC.releaseObjv(interp, objv9, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set body_keys [...]
            TclObject tmp12;
            { // Invoke: descend_commands $key container
                TclObject[] objv13 = TJC.grabObjv(interp, 3);
                TclObject tmp14;
                try {
                    // Arg 0 constant: descend_commands
                    objv13[0] = const4;
                    // Arg 1 variable: $key
                    tmp14 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp14.preserve();
                    objv13[1] = tmp14;
                    // Arg 2 constant: container
                    objv13[2] = const5;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                        ? cmdcache4.cmd : null), objv13, 0);
                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                        updateCmdCache(interp, 4);
                    }
                } finally {
                    tmp14 = objv13[1];
                    if ( tmp14 != null ) {
                        tmp14.release();
                    }
                    TJC.releaseObjv(interp, objv13, 3);
                }
            } // End Invoke: descend_commands
            tmp12 = interp.getResult();
            setVarScalar(interp, "body_keys", tmp12, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set varlistvalues [...]
            TclObject tmp15;
            { // Invoke: ... $key
                TclObject[] objv16 = TJC.grabObjv(interp, 2);
                TclObject tmp17;
                try {
                    // Arg 0 constant: ...
                    objv16[0] = const6;
                    // Arg 1 variable: $key
                    tmp17 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp17.preserve();
                    objv16[1] = tmp17;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                        ? cmdcache5.cmd : null), objv16, 0);
                    if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                        updateCmdCache(interp, 5);
                    }
                } finally {
                    tmp17 = objv16[1];
                    if ( tmp17 != null ) {
                        tmp17.release();
                    }
                    TJC.releaseObjv(interp, objv16, 2);
                }
            } // End Invoke: ...
            tmp15 = interp.getResult();
            setVarScalar(interp, "varlistvalues", tmp15, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: () != 0
            // Binary operator: [...] % 2
            { // Invoke: llength $varlistvalues
                TclObject tmp18 = getVarScalar(interp, "varlistvalues", compiledLocals, 4);
                int tmp19 = TclList.getLength(interp, tmp18);
                interp.setResult(tmp19);
            } // End Invoke: llength
            TclObject tmp20 = interp.getResult();
            ExprValue tmp21 = evs0;
            TJC.exprInitValue(interp, tmp21, tmp20);
            ExprValue tmp22 = evs1;
            tmp22.setIntValue(2);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MOD, tmp21, tmp22);
            // End Binary operator: %
            ExprValue tmp23 = evs1;
            tmp23.setIntValue(0);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp21, tmp23);
            // End Binary operator: !=
            boolean tmp24 = ( tmp21.getIntValue() != 0 );
            if ( tmp24 ) {
                { // Invoke: error "..."
                    TclObject[] objv25 = TJC.grabObjv(interp, 2);
                    TclObject tmp26;
                    try {
                        // Arg 0 constant: error
                        objv25[0] = const3;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp27 = new StringBuffer(64);
                        sbtmp27.append("expected even number of varnames and varlists, got ");
                        sbtmp27.append("{");
                        tmp26 = getVarScalar(interp, "varlistvalues", compiledLocals, 4);
                        sbtmp27.append(tmp26.toString());
                        sbtmp27.append("}");
                        tmp26 = TclString.newInstance(sbtmp27);
                        tmp26.preserve();
                        objv25[1] = tmp26;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv25, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        tmp26 = objv25[1];
                        if ( tmp26 != null ) {
                            tmp26.release();
                        }
                        TJC.releaseObjv(interp, objv25, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set varnamelist_indexes [...]
            TclObject tmp28;
            { // Invoke: list
                TclObject tmp29 = TclList.newInstance();
                interp.setResult(tmp29);
            } // End Invoke: list
            tmp28 = interp.getResult();
            setVarScalar(interp, "varnamelist_indexes", tmp28, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: set valuelist_indexes [...]
            TclObject tmp30;
            { // Invoke: list
                TclObject tmp31 = TclList.newInstance();
                interp.setResult(tmp31);
            } // End Invoke: list
            tmp30 = interp.getResult();
            setVarScalar(interp, "valuelist_indexes", tmp30, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: foreach {i1 i2} $varlistvalues ...
            TclObject tmp32 = null;
            try {
                tmp32 = getVarScalar(interp, "varlistvalues", compiledLocals, 4);
                tmp32.preserve();
                final int tmp32_length = TclList.getLength(interp, tmp32);

                for ( int index33 = 0 ; index33 < tmp32_length ; index33 += 2 ) {
                    TclObject tmp34 = null;
                    if ( index33 < tmp32_length ) {
                        tmp34 = TclList.index(interp, tmp32, index33);
                    }
                    TclObject tmp35 = null;
                    if ( index33 + 1 < tmp32_length ) {
                        tmp35 = TclList.index(interp, tmp32, index33 + 1);
                    }
                    try {
                        if ( tmp34 == null ) {
                            setVarScalar(interp, "i1", "", compiledLocals, 7);
                        } else {
                            setVarScalar(interp, "i1", tmp34, compiledLocals, 7);
                        }
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "i1");
                    }
                    try {
                        if ( tmp35 == null ) {
                            setVarScalar(interp, "i2", "", compiledLocals, 8);
                        } else {
                            setVarScalar(interp, "i2", tmp35, compiledLocals, 8);
                        }
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "i2");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: lappend varnamelist_indexes $i1
                        TclObject[] objv36 = TJC.grabObjv(interp, 1);
                        TclObject tmp37;
                        try {
                            // Arg 2 variable: $i1
                            tmp37 = getVarScalar(interp, "i1", compiledLocals, 7);
                            tmp37.preserve();
                            objv36[0] = tmp37;
                            interp.resetResult();
                            lappendVarScalar(interp, "varnamelist_indexes", objv36, compiledLocals, 5);
                        } finally {
                            TJC.releaseObjvElems(interp, objv36, 1);
                        }
                    } // End Invoke: lappend
                    { // Invoke: lappend valuelist_indexes $i2
                        TclObject[] objv38 = TJC.grabObjv(interp, 1);
                        TclObject tmp39;
                        try {
                            // Arg 2 variable: $i2
                            tmp39 = getVarScalar(interp, "i2", compiledLocals, 8);
                            tmp39.preserve();
                            objv38[0] = tmp39;
                            interp.resetResult();
                            lappendVarScalar(interp, "valuelist_indexes", objv38, compiledLocals, 6);
                        } finally {
                            TJC.releaseObjvElems(interp, objv38, 1);
                        }
                    } // End Invoke: lappend
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
            } finally {
                if ( tmp32 != null ) {
                    tmp32.release();
                }
            }
        } // End Invoke: foreach
        { // Invoke: set varnamelists [...]
            TclObject tmp40;
            { // Invoke: list
                TclObject tmp41 = TclList.newInstance();
                interp.setResult(tmp41);
            } // End Invoke: list
            tmp40 = interp.getResult();
            setVarScalar(interp, "varnamelists", tmp40, compiledLocals, 9);
        } // End Invoke: set
        { // Invoke: set list_symbols [...]
            TclObject tmp42;
            { // Invoke: list
                TclObject tmp43 = TclList.newInstance();
                interp.setResult(tmp43);
            } // End Invoke: list
            tmp42 = interp.getResult();
            setVarScalar(interp, "list_symbols", tmp42, compiledLocals, 10);
        } // End Invoke: set
        { // Invoke: foreach index $varnamelist_indexes ...
            TclObject tmp44 = null;
            try {
                tmp44 = getVarScalar(interp, "varnamelist_indexes", compiledLocals, 5);
                tmp44.preserve();
                final int tmp44_length = TclList.getLength(interp, tmp44);

                for ( int index45 = 0 ; index45 < tmp44_length ; index45++ ) {
                    TclObject tmp46 = TclList.index(interp, tmp44, index45);
                    try {
                        setVarScalar(interp, "index", tmp46, compiledLocals, 11);
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "index");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: set varlist [...]
                        TclObject tmp47;
                        { // Invoke: ... $key $index
                            TclObject[] objv48 = TJC.grabObjv(interp, 3);
                            TclObject tmp49;
                            try {
                                // Arg 0 constant: ...
                                objv48[0] = const7;
                                // Arg 1 variable: $key
                                tmp49 = getVarScalar(interp, "key", compiledLocals, 0);
                                tmp49.preserve();
                                objv48[1] = tmp49;
                                // Arg 2 variable: $index
                                tmp49 = getVarScalar(interp, "index", compiledLocals, 11);
                                tmp49.preserve();
                                objv48[2] = tmp49;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                    ? cmdcache6.cmd : null), objv48, 0);
                                if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                    updateCmdCache(interp, 6);
                                }
                            } finally {
                                tmp49 = objv48[1];
                                if ( tmp49 != null ) {
                                    tmp49.release();
                                }
                                tmp49 = objv48[2];
                                if ( tmp49 != null ) {
                                    tmp49.release();
                                }
                                TJC.releaseObjv(interp, objv48, 3);
                            }
                        } // End Invoke: ...
                        tmp47 = interp.getResult();
                        setVarScalar(interp, "varlist", tmp47, compiledLocals, 12);
                    } // End Invoke: set
                    { // Invoke: lappend varnamelists $varlist
                        TclObject[] objv50 = TJC.grabObjv(interp, 1);
                        TclObject tmp51;
                        try {
                            // Arg 2 variable: $varlist
                            tmp51 = getVarScalar(interp, "varlist", compiledLocals, 12);
                            tmp51.preserve();
                            objv50[0] = tmp51;
                            interp.resetResult();
                            lappendVarScalar(interp, "varnamelists", objv50, compiledLocals, 9);
                        } finally {
                            TJC.releaseObjvElems(interp, objv50, 1);
                        }
                    } // End Invoke: lappend
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
            } finally {
                if ( tmp44 != null ) {
                    tmp44.release();
                }
            }
        } // End Invoke: foreach
        { // Invoke: set num_locals [...]
            TclObject tmp52;
            { // Invoke: llength $valuelist_indexes
                TclObject tmp53 = getVarScalar(interp, "valuelist_indexes", compiledLocals, 6);
                int tmp54 = TclList.getLength(interp, tmp53);
                interp.setResult(tmp54);
            } // End Invoke: llength
            tmp52 = interp.getResult();
            setVarScalar(interp, "num_locals", tmp52, compiledLocals, 13);
        } // End Invoke: set
        { // Invoke: for {set i 0} {$i < $num_locals} {incr i} ...
            { // Invoke: set i 0
                setVarScalar(interp, "i", const8, compiledLocals, 14);
            } // End Invoke: set
            for ( boolean skip60 = true ; true ; ) {
                if ( skip60 ) {
                    skip60 = false;
                } else {
                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: incr i
                        interp.resetResult();
                        incrVarScalar(interp, "i", 1, compiledLocals, 14);
                    } // End Invoke: incr
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else {
                            throw ex;
                        }
                    }
                }

                // Binary operator: $i < $num_locals
                TclObject tmp55 = getVarScalar(interp, "i", compiledLocals, 14);
                ExprValue tmp56 = evs0;
                TJC.exprInitValue(interp, tmp56, tmp55);
                TclObject tmp57 = getVarScalar(interp, "num_locals", compiledLocals, 13);
                ExprValue tmp58 = evs1;
                TJC.exprInitValue(interp, tmp58, tmp57);
                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp56, tmp58);
                // End Binary operator: <
                boolean tmp59 = ( tmp56.getIntValue() != 0 );
                if ( ! tmp59 ) { break; }

                try {
                if ( false ) { throw (TclException) null; }
                { // Invoke: set tmpsymbol [...]
                    TclObject tmp61;
                    { // Invoke: ...
                        TclObject[] objv62 = TJC.grabObjv(interp, 1);
                        try {
                            // Arg 0 constant: ...
                            objv62[0] = const9;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                ? cmdcache7.cmd : null), objv62, 0);
                            if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                updateCmdCache(interp, 7);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv62, 1);
                        }
                    } // End Invoke: ...
                    tmp61 = interp.getResult();
                    setVarScalar(interp, "tmpsymbol", tmp61, compiledLocals, 15);
                } // End Invoke: set
                { // Invoke: append buffer [...]
                    TclObject[] objv63 = TJC.grabObjv(interp, 1);
                    TclObject tmp64;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: emitter_statement "..."
                            TclObject[] objv65 = TJC.grabObjv(interp, 2);
                            TclObject tmp66;
                            try {
                                // Arg 0 constant: emitter_statement
                                objv65[0] = const10;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp67 = new StringBuffer(64);
                                sbtmp67.append("TclObject ");
                                tmp66 = getVarScalar(interp, "tmpsymbol", compiledLocals, 15);
                                sbtmp67.append(tmp66.toString());
                                sbtmp67.append(" = null");
                                tmp66 = TclString.newInstance(sbtmp67);
                                tmp66.preserve();
                                objv65[1] = tmp66;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                    ? cmdcache8.cmd : null), objv65, 0);
                                if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                    updateCmdCache(interp, 8);
                                }
                            } finally {
                                tmp66 = objv65[1];
                                if ( tmp66 != null ) {
                                    tmp66.release();
                                }
                                TJC.releaseObjv(interp, objv65, 2);
                            }
                        } // End Invoke: emitter_statement
                        tmp64 = interp.getResult();
                        tmp64.preserve();
                        objv63[0] = tmp64;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv63, compiledLocals, 2);
                    } finally {
                        TJC.releaseObjvElems(interp, objv63, 1);
                    }
                } // End Invoke: append
                { // Invoke: lappend list_symbols $tmpsymbol
                    TclObject[] objv68 = TJC.grabObjv(interp, 1);
                    TclObject tmp69;
                    try {
                        // Arg 2 variable: $tmpsymbol
                        tmp69 = getVarScalar(interp, "tmpsymbol", compiledLocals, 15);
                        tmp69.preserve();
                        objv68[0] = tmp69;
                        interp.resetResult();
                        lappendVarScalar(interp, "list_symbols", objv68, compiledLocals, 10);
                    } finally {
                        TJC.releaseObjvElems(interp, objv68, 1);
                    }
                } // End Invoke: lappend
                } catch (TclException ex) {
                    int type = ex.getCompletionCode();
                    if (type == TCL.BREAK) {
                        break;
                    } else if (type == TCL.CONTINUE) {
                        continue;
                    } else {
                        throw ex;
                    }
                }
            }
        } // End Invoke: for
        { // Invoke: append buffer [...]
            TclObject[] objv70 = TJC.grabObjv(interp, 1);
            TclObject tmp71;
            try {
                // Arg 2 command: [...]
                { // Invoke: ...
                    TclObject[] objv72 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: ...
                        objv72[0] = const11;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                            ? cmdcache9.cmd : null), objv72, 0);
                        if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                            updateCmdCache(interp, 9);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv72, 1);
                    }
                } // End Invoke: ...
                tmp71 = interp.getResult();
                tmp71.preserve();
                objv70[0] = tmp71;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv70, compiledLocals, 2);
            } finally {
                TJC.releaseObjvElems(interp, objv70, 1);
            }
        } // End Invoke: append
        { // Invoke: foreach index $valuelist_indexes tmpsymbol $list_symbols ...
            TclObject tmp73 = null;
            TclObject tmp74 = null;
            try {
                tmp73 = getVarScalar(interp, "valuelist_indexes", compiledLocals, 6);
                tmp73.preserve();
                tmp74 = getVarScalar(interp, "list_symbols", compiledLocals, 10);
                tmp74.preserve();
                final int tmp73_length = TclList.getLength(interp, tmp73);
                final int tmp74_length = TclList.getLength(interp, tmp74);
                int num_loops75, max_loops76 = 0;
                num_loops75 = tmp73_length;
                if ( num_loops75 > max_loops76 ) {
                    max_loops76 = num_loops75;
                }
                num_loops75 = tmp74_length;
                if ( num_loops75 > max_loops76 ) {
                    max_loops76 = num_loops75;
                }

                for ( int index77 = 0 ; index77 < max_loops76 ; index77++ ) {
                    TclObject tmp78 = null;
                    if ( index77 < tmp73_length ) {
                        tmp78 = TclList.index(interp, tmp73, index77);
                    }
                    TclObject tmp79 = null;
                    if ( index77 < tmp74_length ) {
                        tmp79 = TclList.index(interp, tmp74, index77);
                    }
                    try {
                        if ( tmp78 == null ) {
                            setVarScalar(interp, "index", "", compiledLocals, 11);
                        } else {
                            setVarScalar(interp, "index", tmp78, compiledLocals, 11);
                        }
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "index");
                    }
                    try {
                        if ( tmp79 == null ) {
                            setVarScalar(interp, "tmpsymbol", "", compiledLocals, 15);
                        } else {
                            setVarScalar(interp, "tmpsymbol", tmp79, compiledLocals, 15);
                        }
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "tmpsymbol");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: set tuple [...]
                        TclObject tmp80;
                        { // Invoke: ... $key $index 0 $tmpsymbol
                            TclObject[] objv81 = TJC.grabObjv(interp, 5);
                            TclObject tmp82;
                            try {
                                // Arg 0 constant: ...
                                objv81[0] = const12;
                                // Arg 1 variable: $key
                                tmp82 = getVarScalar(interp, "key", compiledLocals, 0);
                                tmp82.preserve();
                                objv81[1] = tmp82;
                                // Arg 2 variable: $index
                                tmp82 = getVarScalar(interp, "index", compiledLocals, 11);
                                tmp82.preserve();
                                objv81[2] = tmp82;
                                // Arg 3 constant: 0
                                objv81[3] = const8;
                                // Arg 4 variable: $tmpsymbol
                                tmp82 = getVarScalar(interp, "tmpsymbol", compiledLocals, 15);
                                tmp82.preserve();
                                objv81[4] = tmp82;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                                    ? cmdcache10.cmd : null), objv81, 0);
                                if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                                    updateCmdCache(interp, 10);
                                }
                            } finally {
                                tmp82 = objv81[1];
                                if ( tmp82 != null ) {
                                    tmp82.release();
                                }
                                tmp82 = objv81[2];
                                if ( tmp82 != null ) {
                                    tmp82.release();
                                }
                                tmp82 = objv81[4];
                                if ( tmp82 != null ) {
                                    tmp82.release();
                                }
                                TJC.releaseObjv(interp, objv81, 5);
                            }
                        } // End Invoke: ...
                        tmp80 = interp.getResult();
                        setVarScalar(interp, "tuple", tmp80, compiledLocals, 16);
                    } // End Invoke: set
                    { // Invoke: set list_type [...]
                        TclObject tmp83;
                        { // Invoke: lindex $tuple 0
                            TclObject tmp84 = getVarScalar(interp, "tuple", compiledLocals, 16);
                            tmp84 = TclList.index(interp, tmp84, 0);
                            if ( tmp84 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp84);
                            }
                        } // End Invoke: lindex
                        tmp83 = interp.getResult();
                        setVarScalar(interp, "list_type", tmp83, compiledLocals, 17);
                    } // End Invoke: set
                    { // Invoke: set list_symbol [...]
                        TclObject tmp85;
                        { // Invoke: lindex $tuple 1
                            TclObject tmp86 = getVarScalar(interp, "tuple", compiledLocals, 16);
                            tmp86 = TclList.index(interp, tmp86, 1);
                            if ( tmp86 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp86);
                            }
                        } // End Invoke: lindex
                        tmp85 = interp.getResult();
                        setVarScalar(interp, "list_symbol", tmp85, compiledLocals, 18);
                    } // End Invoke: set
                    { // Invoke: set list_buffer [...]
                        TclObject tmp87;
                        { // Invoke: lindex $tuple 2
                            TclObject tmp88 = getVarScalar(interp, "tuple", compiledLocals, 16);
                            tmp88 = TclList.index(interp, tmp88, 2);
                            if ( tmp88 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp88);
                            }
                        } // End Invoke: lindex
                        tmp87 = interp.getResult();
                        setVarScalar(interp, "list_buffer", tmp87, compiledLocals, 19);
                    } // End Invoke: set
                    { // Invoke: append buffer $list_buffer
                        TclObject[] objv89 = TJC.grabObjv(interp, 1);
                        TclObject tmp90;
                        try {
                            // Arg 2 variable: $list_buffer
                            tmp90 = getVarScalar(interp, "list_buffer", compiledLocals, 19);
                            tmp90.preserve();
                            objv89[0] = tmp90;
                            interp.resetResult();
                            appendVarScalar(interp, "buffer", objv89, compiledLocals, 2);
                        } finally {
                            TJC.releaseObjvElems(interp, objv89, 1);
                        }
                    } // End Invoke: append
                    { // Invoke: if ... ...
                        // Binary operator: $list_type == "constant"
                        TclObject tmp91 = getVarScalar(interp, "list_type", compiledLocals, 17);
                        boolean tmp92 = tmp91.toString().equals("constant");
                        ExprValue tmp93 = evs0;
                        tmp93.setIntValue(tmp92);
                        // End Binary operator: ==
                        boolean tmp94 = ( tmp93.getIntValue() != 0 );
                        if ( tmp94 ) {
                            { // Invoke: append buffer [...] $tmpsymbol " = " $list_symbol ...
                                TclObject[] objv95 = TJC.grabObjv(interp, 5);
                                TclObject tmp96;
                                try {
                                    // Arg 2 command: [...]
                                    { // Invoke: emitter_indent
                                        TclObject[] objv97 = TJC.grabObjv(interp, 1);
                                        try {
                                            // Arg 0 constant: emitter_indent
                                            objv97[0] = const13;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache11_cmdEpoch == cmdcache11.cmdEpoch)
                                                ? cmdcache11.cmd : null), objv97, 0);
                                            if ( cmdcache11_cmdEpoch != cmdcache11.cmdEpoch ) {
                                                updateCmdCache(interp, 11);
                                            }
                                        } finally {
                                            TJC.releaseObjv(interp, objv97, 1);
                                        }
                                    } // End Invoke: emitter_indent
                                    tmp96 = interp.getResult();
                                    tmp96.preserve();
                                    objv95[0] = tmp96;
                                    // Arg 3 variable: $tmpsymbol
                                    tmp96 = getVarScalar(interp, "tmpsymbol", compiledLocals, 15);
                                    tmp96.preserve();
                                    objv95[1] = tmp96;
                                    // Arg 4 constant: " = "
                                    objv95[2] = const14;
                                    // Arg 5 variable: $list_symbol
                                    tmp96 = getVarScalar(interp, "list_symbol", compiledLocals, 18);
                                    tmp96.preserve();
                                    objv95[3] = tmp96;
                                    // Arg 6 constant: ...
                                    objv95[4] = const15;
                                    interp.resetResult();
                                    appendVarScalar(interp, "buffer", objv95, compiledLocals, 2);
                                } finally {
                                    tmp96 = objv95[0];
                                    if ( tmp96 != null ) {
                                        tmp96.release();
                                    }
                                    tmp96 = objv95[1];
                                    if ( tmp96 != null ) {
                                        tmp96.release();
                                    }
                                    tmp96 = objv95[3];
                                    if ( tmp96 != null ) {
                                        tmp96.release();
                                    }
                                    TJC.releaseObjv(interp, objv95, 5);
                                }
                            } // End Invoke: append
                        }
                    } // End Invoke: if
                    { // Invoke: append buffer [...]
                        TclObject[] objv98 = TJC.grabObjv(interp, 1);
                        TclObject tmp99;
                        try {
                            // Arg 2 command: [...]
                            { // Invoke: ... $tmpsymbol
                                TclObject[] objv100 = TJC.grabObjv(interp, 2);
                                TclObject tmp101;
                                try {
                                    // Arg 0 constant: ...
                                    objv100[0] = const16;
                                    // Arg 1 variable: $tmpsymbol
                                    tmp101 = getVarScalar(interp, "tmpsymbol", compiledLocals, 15);
                                    tmp101.preserve();
                                    objv100[1] = tmp101;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache12_cmdEpoch == cmdcache12.cmdEpoch)
                                        ? cmdcache12.cmd : null), objv100, 0);
                                    if ( cmdcache12_cmdEpoch != cmdcache12.cmdEpoch ) {
                                        updateCmdCache(interp, 12);
                                    }
                                } finally {
                                    tmp101 = objv100[1];
                                    if ( tmp101 != null ) {
                                        tmp101.release();
                                    }
                                    TJC.releaseObjv(interp, objv100, 2);
                                }
                            } // End Invoke: ...
                            tmp99 = interp.getResult();
                            tmp99.preserve();
                            objv98[0] = tmp99;
                            interp.resetResult();
                            appendVarScalar(interp, "buffer", objv98, compiledLocals, 2);
                        } finally {
                            TJC.releaseObjvElems(interp, objv98, 1);
                        }
                    } // End Invoke: append
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
            } finally {
                if ( tmp73 != null ) {
                    tmp73.release();
                }
                if ( tmp74 != null ) {
                    tmp74.release();
                }
            }
        } // End Invoke: foreach
        { // Invoke: append buffer [...]
            TclObject[] objv102 = TJC.grabObjv(interp, 1);
            TclObject tmp103;
            try {
                // Arg 2 command: [...]
                { // Invoke: ... $varnamelists $list_symbols
                    TclObject[] objv104 = TJC.grabObjv(interp, 3);
                    TclObject tmp105;
                    try {
                        // Arg 0 constant: ...
                        objv104[0] = const17;
                        // Arg 1 variable: $varnamelists
                        tmp105 = getVarScalar(interp, "varnamelists", compiledLocals, 9);
                        tmp105.preserve();
                        objv104[1] = tmp105;
                        // Arg 2 variable: $list_symbols
                        tmp105 = getVarScalar(interp, "list_symbols", compiledLocals, 10);
                        tmp105.preserve();
                        objv104[2] = tmp105;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache13_cmdEpoch == cmdcache13.cmdEpoch)
                            ? cmdcache13.cmd : null), objv104, 0);
                        if ( cmdcache13_cmdEpoch != cmdcache13.cmdEpoch ) {
                            updateCmdCache(interp, 13);
                        }
                    } finally {
                        tmp105 = objv104[1];
                        if ( tmp105 != null ) {
                            tmp105.release();
                        }
                        tmp105 = objv104[2];
                        if ( tmp105 != null ) {
                            tmp105.release();
                        }
                        TJC.releaseObjv(interp, objv104, 3);
                    }
                } // End Invoke: ...
                tmp103 = interp.getResult();
                tmp103.preserve();
                objv102[0] = tmp103;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv102, compiledLocals, 2);
            } finally {
                TJC.releaseObjvElems(interp, objv102, 1);
            }
        } // End Invoke: append
        { // Invoke: if {$body_keys != {}} ...
            // Binary operator: $body_keys != ""
            TclObject tmp106 = getVarScalar(interp, "body_keys", compiledLocals, 3);
            ExprValue tmp107 = evs0;
            TJC.exprEqualsEmptyString(tmp107, tmp106, true);
            // End Binary operator: !=
            boolean tmp108 = ( tmp107.getIntValue() != 0 );
            if ( tmp108 ) {
                { // Invoke: append buffer ...
                    TclObject[] objv109 = TJC.grabObjv(interp, 1);
                    TclObject tmp110;
                    try {
                        // Arg 2 constant: ...
                        objv109[0] = const18;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv109, compiledLocals, 2);
                    } finally {
                        TJC.releaseObjv(interp, objv109, 1);
                    }
                } // End Invoke: append
                { // Invoke: append buffer [...] [...]
                    TclObject[] objv111 = TJC.grabObjv(interp, 2);
                    TclObject tmp112;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: ...
                            TclObject[] objv113 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: ...
                                objv113[0] = const19;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache14_cmdEpoch == cmdcache14.cmdEpoch)
                                    ? cmdcache14.cmd : null), objv113, 0);
                                if ( cmdcache14_cmdEpoch != cmdcache14.cmdEpoch ) {
                                    updateCmdCache(interp, 14);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv113, 1);
                            }
                        } // End Invoke: ...
                        tmp112 = interp.getResult();
                        tmp112.preserve();
                        objv111[0] = tmp112;
                        // Arg 3 command: [...]
                        { // Invoke: ...
                            TclObject[] objv114 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: ...
                                objv114[0] = const20;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache15_cmdEpoch == cmdcache15.cmdEpoch)
                                    ? cmdcache15.cmd : null), objv114, 0);
                                if ( cmdcache15_cmdEpoch != cmdcache15.cmdEpoch ) {
                                    updateCmdCache(interp, 15);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv114, 1);
                            }
                        } // End Invoke: ...
                        tmp112 = interp.getResult();
                        tmp112.preserve();
                        objv111[1] = tmp112;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv111, compiledLocals, 2);
                    } finally {
                        TJC.releaseObjvElems(interp, objv111, 2);
                    }
                } // End Invoke: append
                { // Invoke: if ... ...
                    TclObject tmp115 = getVarArray(interp, "_compileproc", "options,inline_controls", compiledLocals, 1);
                    ExprValue tmp116 = evs0;
                    TJC.exprInitValue(interp, tmp116, tmp115);
                    boolean tmp117 = tmp116.getBooleanValue(interp);
                    if ( tmp117 ) {
                        { // Invoke: ... foreach 1 1
                            TclObject[] objv118 = TJC.grabObjv(interp, 4);
                            try {
                                // Arg 0 constant: ...
                                objv118[0] = const21;
                                // Arg 1 constant: foreach
                                objv118[1] = const22;
                                // Arg 2 constant: 1
                                objv118[2] = const23;
                                // Arg 3 constant: 1
                                objv118[3] = const23;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache16_cmdEpoch == cmdcache16.cmdEpoch)
                                    ? cmdcache16.cmd : null), objv118, 0);
                                if ( cmdcache16_cmdEpoch != cmdcache16.cmdEpoch ) {
                                    updateCmdCache(interp, 16);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv118, 4);
                            }
                        } // End Invoke: ...
                    }
                } // End Invoke: if
                { // Invoke: foreach body_key $body_keys ...
                    TclObject tmp119 = null;
                    try {
                        tmp119 = getVarScalar(interp, "body_keys", compiledLocals, 3);
                        tmp119.preserve();
                        final int tmp119_length = TclList.getLength(interp, tmp119);

                        for ( int index120 = 0 ; index120 < tmp119_length ; index120++ ) {
                            TclObject tmp121 = TclList.index(interp, tmp119, index120);
                            try {
                                setVarScalar(interp, "body_key", tmp121, compiledLocals, 20);
                            } catch (TclException ex) {
                                TJC.foreachVarErr(interp, "body_key");
                            }

                            try {
                            if ( false ) { throw (TclException) null; }
                            { // Invoke: append buffer [...]
                                TclObject[] objv122 = TJC.grabObjv(interp, 1);
                                TclObject tmp123;
                                try {
                                    // Arg 2 command: [...]
                                    { // Invoke: ... $body_key
                                        TclObject[] objv124 = TJC.grabObjv(interp, 2);
                                        TclObject tmp125;
                                        try {
                                            // Arg 0 constant: ...
                                            objv124[0] = const24;
                                            // Arg 1 variable: $body_key
                                            tmp125 = getVarScalar(interp, "body_key", compiledLocals, 20);
                                            tmp125.preserve();
                                            objv124[1] = tmp125;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache17_cmdEpoch == cmdcache17.cmdEpoch)
                                                ? cmdcache17.cmd : null), objv124, 0);
                                            if ( cmdcache17_cmdEpoch != cmdcache17.cmdEpoch ) {
                                                updateCmdCache(interp, 17);
                                            }
                                        } finally {
                                            tmp125 = objv124[1];
                                            if ( tmp125 != null ) {
                                                tmp125.release();
                                            }
                                            TJC.releaseObjv(interp, objv124, 2);
                                        }
                                    } // End Invoke: ...
                                    tmp123 = interp.getResult();
                                    tmp123.preserve();
                                    objv122[0] = tmp123;
                                    interp.resetResult();
                                    appendVarScalar(interp, "buffer", objv122, compiledLocals, 2);
                                } finally {
                                    TJC.releaseObjvElems(interp, objv122, 1);
                                }
                            } // End Invoke: append
                            } catch (TclException ex) {
                                int type = ex.getCompletionCode();
                                if (type == TCL.BREAK) {
                                    break;
                                } else if (type == TCL.CONTINUE) {
                                    continue;
                                } else {
                                    throw ex;
                                }
                            }
                        }
                    } finally {
                        if ( tmp119 != null ) {
                            tmp119.release();
                        }
                    }
                } // End Invoke: foreach
                { // Invoke: if ... ...
                    TclObject tmp126 = getVarArray(interp, "_compileproc", "options,inline_controls", compiledLocals, 1);
                    ExprValue tmp127 = evs0;
                    TJC.exprInitValue(interp, tmp127, tmp126);
                    boolean tmp128 = tmp127.getBooleanValue(interp);
                    if ( tmp128 ) {
                        { // Invoke: ... foreach
                            TclObject[] objv129 = TJC.grabObjv(interp, 2);
                            try {
                                // Arg 0 constant: ...
                                objv129[0] = const25;
                                // Arg 1 constant: foreach
                                objv129[1] = const22;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache18_cmdEpoch == cmdcache18.cmdEpoch)
                                    ? cmdcache18.cmd : null), objv129, 0);
                                if ( cmdcache18_cmdEpoch != cmdcache18.cmdEpoch ) {
                                    updateCmdCache(interp, 18);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv129, 2);
                            }
                        } // End Invoke: ...
                    }
                } // End Invoke: if
                { // Invoke: append buffer [...]
                    TclObject[] objv130 = TJC.grabObjv(interp, 1);
                    TclObject tmp131;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: ...
                            TclObject[] objv132 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: ...
                                objv132[0] = const26;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache19_cmdEpoch == cmdcache19.cmdEpoch)
                                    ? cmdcache19.cmd : null), objv132, 0);
                                if ( cmdcache19_cmdEpoch != cmdcache19.cmdEpoch ) {
                                    updateCmdCache(interp, 19);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv132, 1);
                            }
                        } // End Invoke: ...
                        tmp131 = interp.getResult();
                        tmp131.preserve();
                        objv130[0] = tmp131;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv130, compiledLocals, 2);
                    } finally {
                        TJC.releaseObjvElems(interp, objv130, 1);
                    }
                } // End Invoke: append
            }
        } // End Invoke: if
        { // Invoke: append buffer [...]
            TclObject[] objv133 = TJC.grabObjv(interp, 1);
            TclObject tmp134;
            try {
                // Arg 2 command: [...]
                { // Invoke: ... $key $list_symbols
                    TclObject[] objv135 = TJC.grabObjv(interp, 3);
                    TclObject tmp136;
                    try {
                        // Arg 0 constant: ...
                        objv135[0] = const27;
                        // Arg 1 variable: $key
                        tmp136 = getVarScalar(interp, "key", compiledLocals, 0);
                        tmp136.preserve();
                        objv135[1] = tmp136;
                        // Arg 2 variable: $list_symbols
                        tmp136 = getVarScalar(interp, "list_symbols", compiledLocals, 10);
                        tmp136.preserve();
                        objv135[2] = tmp136;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache20_cmdEpoch == cmdcache20.cmdEpoch)
                            ? cmdcache20.cmd : null), objv135, 0);
                        if ( cmdcache20_cmdEpoch != cmdcache20.cmdEpoch ) {
                            updateCmdCache(interp, 20);
                        }
                    } finally {
                        tmp136 = objv135[1];
                        if ( tmp136 != null ) {
                            tmp136.release();
                        }
                        tmp136 = objv135[2];
                        if ( tmp136 != null ) {
                            tmp136.release();
                        }
                        TJC.releaseObjv(interp, objv135, 3);
                    }
                } // End Invoke: ...
                tmp134 = interp.getResult();
                tmp134.preserve();
                objv133[0] = tmp134;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv133, compiledLocals, 2);
            } finally {
                TJC.releaseObjvElems(interp, objv133, 1);
            }
        } // End Invoke: append
        { // Invoke: return $buffer
            TclObject tmp137 = getVarScalar(interp, "buffer", compiledLocals, 2);
            interp.resetResult();
            interp.setResult(tmp137);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_emit_container_foreach");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;
    TclObject const18;
    TclObject const19;
    TclObject const20;
    TclObject const21;
    TclObject const22;
    TclObject const23;
    TclObject const24;
    TclObject const25;
    TclObject const26;
    TclObject const27;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("descend_container_is_valid");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("descend_container_is_static");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("error");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("descend_commands");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("container");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("descend_container_foreach_varlistvalues");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("descend_container_foreach_varlist");
        const7.preserve(); const7.preserve();
        const8 = TclInteger.newInstance(0);
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("compileproc_tmpvar_next");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("emitter_statement");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("emitter_container_foreach_try_finally_start");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("compileproc_emit_argument");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("emitter_indent");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance(" = ");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance(";\n");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance("emitter_container_foreach_list_preserve");
        const16.preserve(); const16.preserve();
        const17 = TclString.newInstance("compileproc_container_foreach_loop_start");
        const17.preserve(); const17.preserve();
        const18 = TclString.newInstance("\n");
        const18.preserve(); const18.preserve();
        const19 = TclString.newInstance("emitter_container_for_try_start");
        const19.preserve(); const19.preserve();
        const20 = TclString.newInstance("emitter_container_fake_tclexception");
        const20.preserve(); const20.preserve();
        const21 = TclString.newInstance("compileproc_push_controls_context");
        const21.preserve(); const21.preserve();
        const22 = TclString.newInstance("foreach");
        const22.preserve(); const22.preserve();
        const23 = TclInteger.newInstance(1);
        const23.preserve(); const23.preserve();
        const24 = TclString.newInstance("compileproc_emit_invoke");
        const24.preserve(); const24.preserve();
        const25 = TclString.newInstance("compileproc_pop_controls_context");
        const25.preserve(); const25.preserve();
        const26 = TclString.newInstance("emitter_container_for_try_end");
        const26.preserve(); const26.preserve();
        const27 = TclString.newInstance("compileproc_container_foreach_loop_end");
        const27.preserve(); const27.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;
    WrappedCommand cmdcache8;
    int cmdcache8_cmdEpoch;
    WrappedCommand cmdcache9;
    int cmdcache9_cmdEpoch;
    WrappedCommand cmdcache10;
    int cmdcache10_cmdEpoch;
    WrappedCommand cmdcache11;
    int cmdcache11_cmdEpoch;
    WrappedCommand cmdcache12;
    int cmdcache12_cmdEpoch;
    WrappedCommand cmdcache13;
    int cmdcache13_cmdEpoch;
    WrappedCommand cmdcache14;
    int cmdcache14_cmdEpoch;
    WrappedCommand cmdcache15;
    int cmdcache15_cmdEpoch;
    WrappedCommand cmdcache16;
    int cmdcache16_cmdEpoch;
    WrappedCommand cmdcache17;
    int cmdcache17_cmdEpoch;
    WrappedCommand cmdcache18;
    int cmdcache18_cmdEpoch;
    WrappedCommand cmdcache19;
    int cmdcache19_cmdEpoch;
    WrappedCommand cmdcache20;
    int cmdcache20_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                cmdcache8 = TJC.INVALID_COMMAND_CACHE;
                cmdcache8_cmdEpoch = 0;
                cmdcache9 = TJC.INVALID_COMMAND_CACHE;
                cmdcache9_cmdEpoch = 0;
                cmdcache10 = TJC.INVALID_COMMAND_CACHE;
                cmdcache10_cmdEpoch = 0;
                cmdcache11 = TJC.INVALID_COMMAND_CACHE;
                cmdcache11_cmdEpoch = 0;
                cmdcache12 = TJC.INVALID_COMMAND_CACHE;
                cmdcache12_cmdEpoch = 0;
                cmdcache13 = TJC.INVALID_COMMAND_CACHE;
                cmdcache13_cmdEpoch = 0;
                cmdcache14 = TJC.INVALID_COMMAND_CACHE;
                cmdcache14_cmdEpoch = 0;
                cmdcache15 = TJC.INVALID_COMMAND_CACHE;
                cmdcache15_cmdEpoch = 0;
                cmdcache16 = TJC.INVALID_COMMAND_CACHE;
                cmdcache16_cmdEpoch = 0;
                cmdcache17 = TJC.INVALID_COMMAND_CACHE;
                cmdcache17_cmdEpoch = 0;
                cmdcache18 = TJC.INVALID_COMMAND_CACHE;
                cmdcache18_cmdEpoch = 0;
                cmdcache19 = TJC.INVALID_COMMAND_CACHE;
                cmdcache19_cmdEpoch = 0;
                cmdcache20 = TJC.INVALID_COMMAND_CACHE;
                cmdcache20_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "descend_container_is_valid";
                break;
            }
            case 2: {
                cmdName = "descend_container_is_static";
                break;
            }
            case 3: {
                cmdName = "error";
                break;
            }
            case 4: {
                cmdName = "descend_commands";
                break;
            }
            case 5: {
                cmdName = "descend_container_foreach_varlistvalues";
                break;
            }
            case 6: {
                cmdName = "descend_container_foreach_varlist";
                break;
            }
            case 7: {
                cmdName = "compileproc_tmpvar_next";
                break;
            }
            case 8: {
                cmdName = "emitter_statement";
                break;
            }
            case 9: {
                cmdName = "emitter_container_foreach_try_finally_start";
                break;
            }
            case 10: {
                cmdName = "compileproc_emit_argument";
                break;
            }
            case 11: {
                cmdName = "emitter_indent";
                break;
            }
            case 12: {
                cmdName = "emitter_container_foreach_list_preserve";
                break;
            }
            case 13: {
                cmdName = "compileproc_container_foreach_loop_start";
                break;
            }
            case 14: {
                cmdName = "emitter_container_for_try_start";
                break;
            }
            case 15: {
                cmdName = "emitter_container_fake_tclexception";
                break;
            }
            case 16: {
                cmdName = "compileproc_push_controls_context";
                break;
            }
            case 17: {
                cmdName = "compileproc_emit_invoke";
                break;
            }
            case 18: {
                cmdName = "compileproc_pop_controls_context";
                break;
            }
            case 19: {
                cmdName = "emitter_container_for_try_end";
                break;
            }
            case 20: {
                cmdName = "compileproc_container_foreach_loop_end";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
            case 8: {
                cmdcache8 = lwcmd;
                cmdcache8_cmdEpoch = cmdEpoch;
                break;
            }
            case 9: {
                cmdcache9 = lwcmd;
                cmdcache9_cmdEpoch = cmdEpoch;
                break;
            }
            case 10: {
                cmdcache10 = lwcmd;
                cmdcache10_cmdEpoch = cmdEpoch;
                break;
            }
            case 11: {
                cmdcache11 = lwcmd;
                cmdcache11_cmdEpoch = cmdEpoch;
                break;
            }
            case 12: {
                cmdcache12 = lwcmd;
                cmdcache12_cmdEpoch = cmdEpoch;
                break;
            }
            case 13: {
                cmdcache13 = lwcmd;
                cmdcache13_cmdEpoch = cmdEpoch;
                break;
            }
            case 14: {
                cmdcache14 = lwcmd;
                cmdcache14_cmdEpoch = cmdEpoch;
                break;
            }
            case 15: {
                cmdcache15 = lwcmd;
                cmdcache15_cmdEpoch = cmdEpoch;
                break;
            }
            case 16: {
                cmdcache16 = lwcmd;
                cmdcache16_cmdEpoch = cmdEpoch;
                break;
            }
            case 17: {
                cmdcache17 = lwcmd;
                cmdcache17_cmdEpoch = cmdEpoch;
                break;
            }
            case 18: {
                cmdcache18 = lwcmd;
                cmdcache18_cmdEpoch = cmdEpoch;
                break;
            }
            case 19: {
                cmdcache19 = lwcmd;
                cmdcache19_cmdEpoch = cmdEpoch;
                break;
            }
            case 20: {
                cmdcache20 = lwcmd;
                cmdcache20_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "_compileproc",
        "buffer",
        "body_keys",
        "varlistvalues",
        "varnamelist_indexes",
        "valuelist_indexes",
        "i1",
        "i2",
        "varnamelists",
        "list_symbols",
        "index",
        "varlist",
        "num_locals",
        "i",
        "tmpsymbol",
        "tuple",
        "list_type",
        "list_symbol",
        "list_buffer",
        "body_key"
    };
} // end class CompileprocEmitContainerForeachCmd

