// TJC implementation of procedure compileproc_emit_control_return
package tjc;
import tcl.lang.*;

public class CompileprocEmitControlReturnCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 13, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        { // Invoke: global _compileproc
            TJC.makeGlobalLinkVar(interp, "_compileproc", "_compileproc", 1);
        } // End Invoke: global
        { // Invoke: global _compileproc_ckeys
            TJC.makeGlobalLinkVar(interp, "_compileproc_ckeys", "_compileproc_ckeys", 2);
        } // End Invoke: global
        { // Invoke: set tree [...]
            TclObject tmp0;
            { // Invoke: descend_get_data $key tree
                TclObject[] objv1 = TJC.grabObjv(interp, 3);
                TclObject tmp2;
                try {
                    // Arg 0 constant: descend_get_data
                    objv1[0] = const0;
                    // Arg 1 variable: $key
                    tmp2 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[1] = tmp2;
                    // Arg 2 constant: tree
                    objv1[2] = const1;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[1];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 3);
                }
            } // End Invoke: descend_get_data
            tmp0 = interp.getResult();
            setVarScalar(interp, "tree", tmp0, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set num_args [...]
            TclObject tmp3;
            { // Invoke: llength $tree
                TclObject tmp4 = getVarScalar(interp, "tree", compiledLocals, 3);
                int tmp5 = TclList.getLength(interp, tmp4);
                interp.setResult(tmp5);
            } // End Invoke: llength
            tmp3 = interp.getResult();
            setVarScalar(interp, "num_args", tmp3, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const2, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: if {$num_args == 1} ... elseif {$num_args == 2} ... else ...
            // Binary operator: $num_args == 1
            TclObject tmp6 = getVarScalar(interp, "num_args", compiledLocals, 4);
            ExprValue tmp7 = evs0;
            TJC.exprInitValue(interp, tmp7, tmp6);
            ExprValue tmp8 = evs1;
            tmp8.setIntValue(1);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp7, tmp8);
            // End Binary operator: ==
            boolean tmp9 = ( tmp7.getIntValue() != 0 );
            if ( tmp9 ) {
                { // Invoke: append buffer [...] [...]
                    TclObject[] objv10 = TJC.grabObjv(interp, 2);
                    TclObject tmp11;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: emitter_reset_result
                            TclObject[] objv12 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: emitter_reset_result
                                objv12[0] = const3;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                    ? cmdcache2.cmd : null), objv12, 0);
                                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                    updateCmdCache(interp, 2);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv12, 1);
                            }
                        } // End Invoke: emitter_reset_result
                        tmp11 = interp.getResult();
                        tmp11.preserve();
                        objv10[0] = tmp11;
                        // Arg 3 command: [...]
                        { // Invoke: ...
                            TclObject[] objv13 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: ...
                                objv13[0] = const4;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                    ? cmdcache3.cmd : null), objv13, 0);
                                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                    updateCmdCache(interp, 3);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv13, 1);
                            }
                        } // End Invoke: ...
                        tmp11 = interp.getResult();
                        tmp11.preserve();
                        objv10[1] = tmp11;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv10, compiledLocals, 5);
                    } finally {
                        TJC.releaseObjvElems(interp, objv10, 2);
                    }
                } // End Invoke: append
                { // Invoke: return $buffer
                    TclObject tmp14 = getVarScalar(interp, "buffer", compiledLocals, 5);
                    interp.resetResult();
                    interp.setResult(tmp14);
                    if ( true ) { return; }
                } // End Invoke: return
            } else {
                // Binary operator: $num_args == 2
                TclObject tmp15 = getVarScalar(interp, "num_args", compiledLocals, 4);
                ExprValue tmp16 = evs0;
                TJC.exprInitValue(interp, tmp16, tmp15);
                ExprValue tmp17 = evs1;
                tmp17.setIntValue(2);
                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp16, tmp17);
                // End Binary operator: ==
                boolean tmp18 = ( tmp16.getIntValue() != 0 );
                if ( tmp18 ) {
                } else {
                    { // Invoke: error "..."
                        TclObject[] objv19 = TJC.grabObjv(interp, 2);
                        TclObject tmp20;
                        try {
                            // Arg 0 constant: error
                            objv19[0] = const5;
                            // Arg 1 word: "..."
                            StringBuffer sbtmp21 = new StringBuffer(64);
                            sbtmp21.append("expected return with 1 or 2 arguments, got num_args ");
                            tmp20 = getVarScalar(interp, "num_args", compiledLocals, 4);
                            sbtmp21.append(tmp20.toString());
                            tmp20 = TclString.newInstance(sbtmp21);
                            tmp20.preserve();
                            objv19[1] = tmp20;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                ? cmdcache4.cmd : null), objv19, 0);
                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                updateCmdCache(interp, 4);
                            }
                        } finally {
                            tmp20 = objv19[1];
                            if ( tmp20 != null ) {
                                tmp20.release();
                            }
                            TJC.releaseObjv(interp, objv19, 2);
                        }
                    } // End Invoke: error
                }
            }
        } // End Invoke: if
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const2, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: set tuple [...]
            TclObject tmp22;
            { // Invoke: ... $key 1
                TclObject[] objv23 = TJC.grabObjv(interp, 3);
                TclObject tmp24;
                try {
                    // Arg 0 constant: ...
                    objv23[0] = const6;
                    // Arg 1 variable: $key
                    tmp24 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp24.preserve();
                    objv23[1] = tmp24;
                    // Arg 2 constant: 1
                    objv23[2] = const7;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                        ? cmdcache5.cmd : null), objv23, 0);
                    if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                        updateCmdCache(interp, 5);
                    }
                } finally {
                    tmp24 = objv23[1];
                    if ( tmp24 != null ) {
                        tmp24.release();
                    }
                    TJC.releaseObjv(interp, objv23, 3);
                }
            } // End Invoke: ...
            tmp22 = interp.getResult();
            setVarScalar(interp, "tuple", tmp22, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: set type [...]
            TclObject tmp25;
            { // Invoke: lindex $tuple 0
                TclObject tmp26 = getVarScalar(interp, "tuple", compiledLocals, 6);
                tmp26 = TclList.index(interp, tmp26, 0);
                if ( tmp26 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp26);
                }
            } // End Invoke: lindex
            tmp25 = interp.getResult();
            setVarScalar(interp, "type", tmp25, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: set ckeys [...]
            TclObject tmp27;
            { // Invoke: lindex $tuple 1
                TclObject tmp28 = getVarScalar(interp, "tuple", compiledLocals, 6);
                tmp28 = TclList.index(interp, tmp28, 1);
                if ( tmp28 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp28);
                }
            } // End Invoke: lindex
            tmp27 = interp.getResult();
            setVarScalar(interp, "ckeys", tmp27, compiledLocals, 8);
        } // End Invoke: set
        { // Invoke: if {$type == "command"} ... else ...
            // Binary operator: $type == "command"
            TclObject tmp29 = getVarScalar(interp, "type", compiledLocals, 7);
            boolean tmp30 = tmp29.toString().equals("command");
            ExprValue tmp31 = evs0;
            tmp31.setIntValue(tmp30);
            // End Binary operator: ==
            boolean tmp32 = ( tmp31.getIntValue() != 0 );
            if ( tmp32 ) {
                { // Invoke: foreach ckey $ckeys ...
                    TclObject tmp33 = null;
                    try {
                        tmp33 = getVarScalar(interp, "ckeys", compiledLocals, 8);
                        tmp33.preserve();
                        final int tmp33_length = TclList.getLength(interp, tmp33);

                        for ( int index34 = 0 ; index34 < tmp33_length ; index34++ ) {
                            TclObject tmp35 = TclList.index(interp, tmp33, index34);
                            try {
                                setVarScalar(interp, "ckey", tmp35, compiledLocals, 9);
                            } catch (TclException ex) {
                                TJC.foreachVarErr(interp, "ckey");
                            }

                            try {
                            if ( false ) { throw (TclException) null; }
                            { // Invoke: append buffer [...]
                                TclObject[] objv36 = TJC.grabObjv(interp, 1);
                                TclObject tmp37;
                                try {
                                    // Arg 2 command: [...]
                                    { // Invoke: ... $ckey
                                        TclObject[] objv38 = TJC.grabObjv(interp, 2);
                                        TclObject tmp39;
                                        try {
                                            // Arg 0 constant: ...
                                            objv38[0] = const8;
                                            // Arg 1 variable: $ckey
                                            tmp39 = getVarScalar(interp, "ckey", compiledLocals, 9);
                                            tmp39.preserve();
                                            objv38[1] = tmp39;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                                ? cmdcache6.cmd : null), objv38, 0);
                                            if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                                updateCmdCache(interp, 6);
                                            }
                                        } finally {
                                            tmp39 = objv38[1];
                                            if ( tmp39 != null ) {
                                                tmp39.release();
                                            }
                                            TJC.releaseObjv(interp, objv38, 2);
                                        }
                                    } // End Invoke: ...
                                    tmp37 = interp.getResult();
                                    tmp37.preserve();
                                    objv36[0] = tmp37;
                                    interp.resetResult();
                                    appendVarScalar(interp, "buffer", objv36, compiledLocals, 5);
                                } finally {
                                    TJC.releaseObjvElems(interp, objv36, 1);
                                }
                            } // End Invoke: append
                            } catch (TclException ex) {
                                int type = ex.getCompletionCode();
                                if (type == TCL.BREAK) {
                                    break;
                                } else if (type == TCL.CONTINUE) {
                                    continue;
                                } else {
                                    throw ex;
                                }
                            }
                        }
                    } finally {
                        if ( tmp33 != null ) {
                            tmp33.release();
                        }
                    }
                } // End Invoke: foreach
                { // Invoke: append buffer [...]
                    TclObject[] objv40 = TJC.grabObjv(interp, 1);
                    TclObject tmp41;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: ...
                            TclObject[] objv42 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: ...
                                objv42[0] = const4;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                    ? cmdcache3.cmd : null), objv42, 0);
                                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                    updateCmdCache(interp, 3);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv42, 1);
                            }
                        } // End Invoke: ...
                        tmp41 = interp.getResult();
                        tmp41.preserve();
                        objv40[0] = tmp41;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv40, compiledLocals, 5);
                    } finally {
                        TJC.releaseObjvElems(interp, objv40, 1);
                    }
                } // End Invoke: append
            } else {
                { // Invoke: set tuple [...]
                    TclObject tmp43;
                    { // Invoke: ... $key 1
                        TclObject[] objv44 = TJC.grabObjv(interp, 3);
                        TclObject tmp45;
                        try {
                            // Arg 0 constant: ...
                            objv44[0] = const9;
                            // Arg 1 variable: $key
                            tmp45 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp45.preserve();
                            objv44[1] = tmp45;
                            // Arg 2 constant: 1
                            objv44[2] = const7;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                ? cmdcache7.cmd : null), objv44, 0);
                            if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                updateCmdCache(interp, 7);
                            }
                        } finally {
                            tmp45 = objv44[1];
                            if ( tmp45 != null ) {
                                tmp45.release();
                            }
                            TJC.releaseObjv(interp, objv44, 3);
                        }
                    } // End Invoke: ...
                    tmp43 = interp.getResult();
                    setVarScalar(interp, "tuple", tmp43, compiledLocals, 6);
                } // End Invoke: set
                { // Invoke: set obj_type [...]
                    TclObject tmp46;
                    { // Invoke: lindex $tuple 0
                        TclObject tmp47 = getVarScalar(interp, "tuple", compiledLocals, 6);
                        tmp47 = TclList.index(interp, tmp47, 0);
                        if ( tmp47 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp47);
                        }
                    } // End Invoke: lindex
                    tmp46 = interp.getResult();
                    setVarScalar(interp, "obj_type", tmp46, compiledLocals, 10);
                } // End Invoke: set
                { // Invoke: set obj_symbol [...]
                    TclObject tmp48;
                    { // Invoke: lindex $tuple 1
                        TclObject tmp49 = getVarScalar(interp, "tuple", compiledLocals, 6);
                        tmp49 = TclList.index(interp, tmp49, 1);
                        if ( tmp49 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp49);
                        }
                    } // End Invoke: lindex
                    tmp48 = interp.getResult();
                    setVarScalar(interp, "obj_symbol", tmp48, compiledLocals, 11);
                } // End Invoke: set
                { // Invoke: set obj_buffer [...]
                    TclObject tmp50;
                    { // Invoke: lindex $tuple 2
                        TclObject tmp51 = getVarScalar(interp, "tuple", compiledLocals, 6);
                        tmp51 = TclList.index(interp, tmp51, 2);
                        if ( tmp51 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp51);
                        }
                    } // End Invoke: lindex
                    tmp50 = interp.getResult();
                    setVarScalar(interp, "obj_buffer", tmp50, compiledLocals, 12);
                } // End Invoke: set
                { // Invoke: append buffer $obj_buffer [...]
                    TclObject[] objv52 = TJC.grabObjv(interp, 2);
                    TclObject tmp53;
                    try {
                        // Arg 2 variable: $obj_buffer
                        tmp53 = getVarScalar(interp, "obj_buffer", compiledLocals, 12);
                        tmp53.preserve();
                        objv52[0] = tmp53;
                        // Arg 3 command: [...]
                        { // Invoke: ... $obj_symbol
                            TclObject[] objv54 = TJC.grabObjv(interp, 2);
                            TclObject tmp55;
                            try {
                                // Arg 0 constant: ...
                                objv54[0] = const10;
                                // Arg 1 variable: $obj_symbol
                                tmp55 = getVarScalar(interp, "obj_symbol", compiledLocals, 11);
                                tmp55.preserve();
                                objv54[1] = tmp55;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                    ? cmdcache8.cmd : null), objv54, 0);
                                if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                    updateCmdCache(interp, 8);
                                }
                            } finally {
                                tmp55 = objv54[1];
                                if ( tmp55 != null ) {
                                    tmp55.release();
                                }
                                TJC.releaseObjv(interp, objv54, 2);
                            }
                        } // End Invoke: ...
                        tmp53 = interp.getResult();
                        tmp53.preserve();
                        objv52[1] = tmp53;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv52, compiledLocals, 5);
                    } finally {
                        TJC.releaseObjvElems(interp, objv52, 2);
                    }
                } // End Invoke: append
            }
        } // End Invoke: if
        { // Invoke: return $buffer
            TclObject tmp56 = getVarScalar(interp, "buffer", compiledLocals, 5);
            interp.resetResult();
            interp.setResult(tmp56);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_emit_control_return");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("descend_get_data");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("tree");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("emitter_reset_result");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("emitter_control_return");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("error");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("compileproc_get_argument_tuple");
        const6.preserve(); const6.preserve();
        const7 = TclInteger.newInstance(1);
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("compileproc_emit_invoke");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("compileproc_emit_argument");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("emitter_control_return_argument");
        const10.preserve(); const10.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;
    WrappedCommand cmdcache8;
    int cmdcache8_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                cmdcache8 = TJC.INVALID_COMMAND_CACHE;
                cmdcache8_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "descend_get_data";
                break;
            }
            case 2: {
                cmdName = "emitter_reset_result";
                break;
            }
            case 3: {
                cmdName = "emitter_control_return";
                break;
            }
            case 4: {
                cmdName = "error";
                break;
            }
            case 5: {
                cmdName = "compileproc_get_argument_tuple";
                break;
            }
            case 6: {
                cmdName = "compileproc_emit_invoke";
                break;
            }
            case 7: {
                cmdName = "compileproc_emit_argument";
                break;
            }
            case 8: {
                cmdName = "emitter_control_return_argument";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
            case 8: {
                cmdcache8 = lwcmd;
                cmdcache8_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "_compileproc",
        "_compileproc_ckeys",
        "tree",
        "num_args",
        "buffer",
        "tuple",
        "type",
        "ckeys",
        "ckey",
        "obj_type",
        "obj_symbol",
        "obj_buffer"
    };
} // end class CompileprocEmitControlReturnCmd

