// TJC implementation of procedure compileproc_emit_invoke_call_impl
package tjc;
import tcl.lang.*;

public class CompileprocEmitInvokeCallImplCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 8, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 5) {
            throw new TclNumArgsException(interp, 1, objv, "key arraysym tmpsymbol userdata");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        setVarScalar(interp, "arraysym", objv[2], compiledLocals, 1);
        setVarScalar(interp, "tmpsymbol", objv[3], compiledLocals, 2);
        setVarScalar(interp, "userdata", objv[4], compiledLocals, 3);
        { // Invoke: global _compileproc
            TJC.makeGlobalLinkVar(interp, "_compileproc", "_compileproc", 4);
        } // End Invoke: global
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const0, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: if ... ... else ...
            TclObject tmp0 = getVarArray(interp, "_compileproc", "options,cache_commands", compiledLocals, 4);
            ExprValue tmp1 = evs0;
            TJC.exprInitValue(interp, tmp1, tmp0);
            boolean tmp2 = tmp1.getBooleanValue(interp);
            if ( tmp2 ) {
                { // Invoke: set cmdsym [...]
                    TclObject tmp3;
                    { // Invoke: ... $key
                        TclObject[] objv4 = TJC.grabObjv(interp, 2);
                        TclObject tmp5;
                        try {
                            // Arg 0 constant: ...
                            objv4[0] = const1;
                            // Arg 1 variable: $key
                            tmp5 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp5.preserve();
                            objv4[1] = tmp5;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                ? cmdcache1.cmd : null), objv4, 0);
                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                updateCmdCache(interp, 1);
                            }
                        } finally {
                            tmp5 = objv4[1];
                            if ( tmp5 != null ) {
                                tmp5.release();
                            }
                            TJC.releaseObjv(interp, objv4, 2);
                        }
                    } // End Invoke: ...
                    tmp3 = interp.getResult();
                    setVarScalar(interp, "cmdsym", tmp3, compiledLocals, 6);
                } // End Invoke: set
                { // Invoke: if {$cmdsym == {}} ... else ...
                    // Binary operator: $cmdsym == ""
                    TclObject tmp6 = getVarScalar(interp, "cmdsym", compiledLocals, 6);
                    ExprValue tmp7 = evs0;
                    TJC.exprEqualsEmptyString(tmp7, tmp6, false);
                    // End Binary operator: ==
                    boolean tmp8 = ( tmp7.getIntValue() != 0 );
                    if ( tmp8 ) {
                        { // Invoke: set cmdsym_buffer {}
                            setVarScalar(interp, "cmdsym_buffer", const0, compiledLocals, 7);
                        } // End Invoke: set
                    } else {
                        { // Invoke: set cmdsym_buffer [...]
                            TclObject tmp9;
                            { // Invoke: ... $cmdsym
                                TclObject[] objv10 = TJC.grabObjv(interp, 2);
                                TclObject tmp11;
                                try {
                                    // Arg 0 constant: ...
                                    objv10[0] = const2;
                                    // Arg 1 variable: $cmdsym
                                    tmp11 = getVarScalar(interp, "cmdsym", compiledLocals, 6);
                                    tmp11.preserve();
                                    objv10[1] = tmp11;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                        ? cmdcache2.cmd : null), objv10, 0);
                                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                        updateCmdCache(interp, 2);
                                    }
                                } finally {
                                    tmp11 = objv10[1];
                                    if ( tmp11 != null ) {
                                        tmp11.release();
                                    }
                                    TJC.releaseObjv(interp, objv10, 2);
                                }
                            } // End Invoke: ...
                            tmp9 = interp.getResult();
                            setVarScalar(interp, "cmdsym_buffer", tmp9, compiledLocals, 7);
                        } // End Invoke: set
                    }
                } // End Invoke: if
                { // Invoke: if {$cmdsym != {}} ...
                    // Binary operator: $cmdsym != ""
                    TclObject tmp12 = getVarScalar(interp, "cmdsym", compiledLocals, 6);
                    ExprValue tmp13 = evs0;
                    TJC.exprEqualsEmptyString(tmp13, tmp12, true);
                    // End Binary operator: !=
                    boolean tmp14 = ( tmp13.getIntValue() != 0 );
                    if ( tmp14 ) {
                        { // Invoke: append buffer [...]
                            TclObject[] objv15 = TJC.grabObjv(interp, 1);
                            TclObject tmp16;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: ...
                                    TclObject[] objv17 = TJC.grabObjv(interp, 1);
                                    try {
                                        // Arg 0 constant: ...
                                        objv17[0] = const3;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                            ? cmdcache3.cmd : null), objv17, 0);
                                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                            updateCmdCache(interp, 3);
                                        }
                                    } finally {
                                        TJC.releaseObjv(interp, objv17, 1);
                                    }
                                } // End Invoke: ...
                                tmp16 = interp.getResult();
                                tmp16.preserve();
                                objv15[0] = tmp16;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv15, compiledLocals, 5);
                            } finally {
                                TJC.releaseObjvElems(interp, objv15, 1);
                            }
                        } // End Invoke: append
                    }
                } // End Invoke: if
                { // Invoke: append buffer [...]
                    TclObject[] objv18 = TJC.grabObjv(interp, 1);
                    TclObject tmp19;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: ... $arraysym $cmdsym_buffer 0
                            TclObject[] objv20 = TJC.grabObjv(interp, 4);
                            TclObject tmp21;
                            try {
                                // Arg 0 constant: ...
                                objv20[0] = const4;
                                // Arg 1 variable: $arraysym
                                tmp21 = getVarScalar(interp, "arraysym", compiledLocals, 1);
                                tmp21.preserve();
                                objv20[1] = tmp21;
                                // Arg 2 variable: $cmdsym_buffer
                                tmp21 = getVarScalar(interp, "cmdsym_buffer", compiledLocals, 7);
                                tmp21.preserve();
                                objv20[2] = tmp21;
                                // Arg 3 constant: 0
                                objv20[3] = const5;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                    ? cmdcache4.cmd : null), objv20, 0);
                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                    updateCmdCache(interp, 4);
                                }
                            } finally {
                                tmp21 = objv20[1];
                                if ( tmp21 != null ) {
                                    tmp21.release();
                                }
                                tmp21 = objv20[2];
                                if ( tmp21 != null ) {
                                    tmp21.release();
                                }
                                TJC.releaseObjv(interp, objv20, 4);
                            }
                        } // End Invoke: ...
                        tmp19 = interp.getResult();
                        tmp19.preserve();
                        objv18[0] = tmp19;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv18, compiledLocals, 5);
                    } finally {
                        TJC.releaseObjvElems(interp, objv18, 1);
                    }
                } // End Invoke: append
                { // Invoke: if {$cmdsym != {}} ...
                    // Binary operator: $cmdsym != ""
                    TclObject tmp22 = getVarScalar(interp, "cmdsym", compiledLocals, 6);
                    ExprValue tmp23 = evs0;
                    TJC.exprEqualsEmptyString(tmp23, tmp22, true);
                    // End Binary operator: !=
                    boolean tmp24 = ( tmp23.getIntValue() != 0 );
                    if ( tmp24 ) {
                        { // Invoke: append buffer [...]
                            TclObject[] objv25 = TJC.grabObjv(interp, 1);
                            TclObject tmp26;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: ... $cmdsym
                                    TclObject[] objv27 = TJC.grabObjv(interp, 2);
                                    TclObject tmp28;
                                    try {
                                        // Arg 0 constant: ...
                                        objv27[0] = const6;
                                        // Arg 1 variable: $cmdsym
                                        tmp28 = getVarScalar(interp, "cmdsym", compiledLocals, 6);
                                        tmp28.preserve();
                                        objv27[1] = tmp28;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                            ? cmdcache5.cmd : null), objv27, 0);
                                        if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                            updateCmdCache(interp, 5);
                                        }
                                    } finally {
                                        tmp28 = objv27[1];
                                        if ( tmp28 != null ) {
                                            tmp28.release();
                                        }
                                        TJC.releaseObjv(interp, objv27, 2);
                                    }
                                } // End Invoke: ...
                                tmp26 = interp.getResult();
                                tmp26.preserve();
                                objv25[0] = tmp26;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv25, compiledLocals, 5);
                            } finally {
                                TJC.releaseObjvElems(interp, objv25, 1);
                            }
                        } // End Invoke: append
                    }
                } // End Invoke: if
            } else {
                { // Invoke: append buffer [...]
                    TclObject[] objv29 = TJC.grabObjv(interp, 1);
                    TclObject tmp30;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: ... $arraysym {} 0
                            TclObject[] objv31 = TJC.grabObjv(interp, 4);
                            TclObject tmp32;
                            try {
                                // Arg 0 constant: ...
                                objv31[0] = const4;
                                // Arg 1 variable: $arraysym
                                tmp32 = getVarScalar(interp, "arraysym", compiledLocals, 1);
                                tmp32.preserve();
                                objv31[1] = tmp32;
                                // Arg 2 constant: {}
                                objv31[2] = const0;
                                // Arg 3 constant: 0
                                objv31[3] = const5;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                    ? cmdcache4.cmd : null), objv31, 0);
                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                    updateCmdCache(interp, 4);
                                }
                            } finally {
                                tmp32 = objv31[1];
                                if ( tmp32 != null ) {
                                    tmp32.release();
                                }
                                TJC.releaseObjv(interp, objv31, 4);
                            }
                        } // End Invoke: ...
                        tmp30 = interp.getResult();
                        tmp30.preserve();
                        objv29[0] = tmp30;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv29, compiledLocals, 5);
                    } finally {
                        TJC.releaseObjvElems(interp, objv29, 1);
                    }
                } // End Invoke: append
            }
        } // End Invoke: if
        { // Invoke: return $buffer
            TclObject tmp33 = getVarScalar(interp, "buffer", compiledLocals, 5);
            interp.resetResult();
            interp.setResult(tmp33);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_emit_invoke_call_impl");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("compileproc_command_cache_lookup");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("compileproc_command_cache_epoch_check");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("compileproc_command_cache_this_check");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("emitter_invoke_command_call");
        const4.preserve(); const4.preserve();
        const5 = TclInteger.newInstance(0);
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("compileproc_command_cache_update");
        const6.preserve(); const6.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "compileproc_command_cache_lookup";
                break;
            }
            case 2: {
                cmdName = "compileproc_command_cache_epoch_check";
                break;
            }
            case 3: {
                cmdName = "compileproc_command_cache_this_check";
                break;
            }
            case 4: {
                cmdName = "emitter_invoke_command_call";
                break;
            }
            case 5: {
                cmdName = "compileproc_command_cache_update";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "arraysym",
        "tmpsymbol",
        "userdata",
        "_compileproc",
        "buffer",
        "cmdsym",
        "cmdsym_buffer"
    };
} // end class CompileprocEmitInvokeCallImplCmd

