// TJC implementation of procedure compileproc_emit_objv_assignment
package tjc;
import tcl.lang.*;

public class CompileprocEmitObjvAssignmentCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 28, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 8) {
            throw new TclNumArgsException(interp, 1, objv, "key starti endi tmpsymbol force_decl_tmpsymbol callback userdata");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        setVarScalar(interp, "starti", objv[2], compiledLocals, 1);
        setVarScalar(interp, "endi", objv[3], compiledLocals, 2);
        setVarScalar(interp, "tmpsymbol", objv[4], compiledLocals, 3);
        setVarScalar(interp, "force_decl_tmpsymbol", objv[5], compiledLocals, 4);
        setVarScalar(interp, "callback", objv[6], compiledLocals, 5);
        setVarScalar(interp, "userdata", objv[7], compiledLocals, 6);
        { // Invoke: global _compileproc
            TJC.makeGlobalLinkVar(interp, "_compileproc", "_compileproc", 7);
        } // End Invoke: global
        { // Invoke: global ...
            TJC.makeGlobalLinkVar(interp, "_compileproc_key_info", "_compileproc_key_info", 8);
        } // End Invoke: global
        { // Invoke: set num_args $...
            TclObject tmp0;
            StringBuffer sbtmp1 = new StringBuffer(64);
            tmp0 = getVarScalar(interp, "key", compiledLocals, 0);
            sbtmp1.append(tmp0.toString());
            sbtmp1.append(",num_args");
            tmp0 = getVarArray(interp, "_compileproc_key_info", sbtmp1.toString(), compiledLocals, 8);
            setVarScalar(interp, "num_args", tmp0, compiledLocals, 9);
        } // End Invoke: set
        { // Invoke: if {$endi == "end"} ...
            // Binary operator: $endi == "end"
            TclObject tmp2 = getVarScalar(interp, "endi", compiledLocals, 2);
            boolean tmp3 = tmp2.toString().equals("end");
            ExprValue tmp4 = evs0;
            tmp4.setIntValue(tmp3);
            // End Binary operator: ==
            boolean tmp5 = ( tmp4.getIntValue() != 0 );
            if ( tmp5 ) {
                { // Invoke: set endi $num_args
                    TclObject tmp6;
                    tmp6 = getVarScalar(interp, "num_args", compiledLocals, 9);
                    setVarScalar(interp, "endi", tmp6, compiledLocals, 2);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const0, compiledLocals, 10);
        } // End Invoke: set
        { // Invoke: set arraysym [...]
            TclObject tmp7;
            { // Invoke: ... objv
                TclObject[] objv8 = TJC.grabObjv(interp, 2);
                try {
                    // Arg 0 constant: ...
                    objv8[0] = const1;
                    // Arg 1 constant: objv
                    objv8[1] = const2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv8, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv8, 2);
                }
            } // End Invoke: ...
            tmp7 = interp.getResult();
            setVarScalar(interp, "arraysym", tmp7, compiledLocals, 11);
        } // End Invoke: set
        { // Invoke: set objv_size [...]
            TclObject tmp9;
            { // Invoke: expr ...
                // Binary operator: $num_args - $starti
                TclObject tmp10 = getVarScalar(interp, "num_args", compiledLocals, 9);
                ExprValue tmp11 = evs0;
                TJC.exprInitValue(interp, tmp11, tmp10);
                TclObject tmp12 = getVarScalar(interp, "starti", compiledLocals, 1);
                ExprValue tmp13 = evs1;
                TJC.exprInitValue(interp, tmp13, tmp12);
                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MINUS, tmp11, tmp13);
                // End Binary operator: -
                TJC.exprSetResult(interp, tmp11);
            } // End Invoke: expr
            tmp9 = interp.getResult();
            setVarScalar(interp, "objv_size", tmp9, compiledLocals, 12);
        } // End Invoke: set
        { // Invoke: append buffer [...]
            TclObject[] objv14 = TJC.grabObjv(interp, 1);
            TclObject tmp15;
            try {
                // Arg 2 command: [...]
                { // Invoke: ... $arraysym $objv_size
                    TclObject[] objv16 = TJC.grabObjv(interp, 3);
                    TclObject tmp17;
                    try {
                        // Arg 0 constant: ...
                        objv16[0] = const3;
                        // Arg 1 variable: $arraysym
                        tmp17 = getVarScalar(interp, "arraysym", compiledLocals, 11);
                        tmp17.preserve();
                        objv16[1] = tmp17;
                        // Arg 2 variable: $objv_size
                        tmp17 = getVarScalar(interp, "objv_size", compiledLocals, 12);
                        tmp17.preserve();
                        objv16[2] = tmp17;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv16, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp17 = objv16[1];
                        if ( tmp17 != null ) {
                            tmp17.release();
                        }
                        tmp17 = objv16[2];
                        if ( tmp17 != null ) {
                            tmp17.release();
                        }
                        TJC.releaseObjv(interp, objv16, 3);
                    }
                } // End Invoke: ...
                tmp15 = interp.getResult();
                tmp15.preserve();
                objv14[0] = tmp15;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv14, compiledLocals, 10);
            } finally {
                TJC.releaseObjvElems(interp, objv14, 1);
            }
        } // End Invoke: append
        { // Invoke: if ... ... else ...
            TclObject tmp18 = getVarArray(interp, "_compileproc", "options,skip_constant_increment", compiledLocals, 7);
            ExprValue tmp19 = evs0;
            TJC.exprInitValue(interp, tmp19, tmp18);
            boolean tmp20 = tmp19.getBooleanValue(interp);
            if ( tmp20 ) {
                { // Invoke: set use_tmp_local 0
                    setVarScalar(interp, "use_tmp_local", const4, compiledLocals, 13);
                } // End Invoke: set
                { // Invoke: for {set i $starti} {$i < $endi} {incr i} ...
                    { // Invoke: set i $starti
                        TclObject tmp21;
                        tmp21 = getVarScalar(interp, "starti", compiledLocals, 1);
                        setVarScalar(interp, "i", tmp21, compiledLocals, 14);
                    } // End Invoke: set
                    for ( boolean skip27 = true ; true ; ) {
                        if ( skip27 ) {
                            skip27 = false;
                        } else {
                            try {
                            if ( false ) { throw (TclException) null; }
                            { // Invoke: incr i
                                interp.resetResult();
                                incrVarScalar(interp, "i", 1, compiledLocals, 14);
                            } // End Invoke: incr
                            } catch (TclException ex) {
                                int type = ex.getCompletionCode();
                                if (type == TCL.BREAK) {
                                    break;
                                } else {
                                    throw ex;
                                }
                            }
                        }

                        // Binary operator: $i < $endi
                        TclObject tmp22 = getVarScalar(interp, "i", compiledLocals, 14);
                        ExprValue tmp23 = evs0;
                        TJC.exprInitValue(interp, tmp23, tmp22);
                        TclObject tmp24 = getVarScalar(interp, "endi", compiledLocals, 2);
                        ExprValue tmp25 = evs1;
                        TJC.exprInitValue(interp, tmp25, tmp24);
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp23, tmp25);
                        // End Binary operator: <
                        boolean tmp26 = ( tmp23.getIntValue() != 0 );
                        if ( ! tmp26 ) { break; }

                        try {
                        if ( false ) { throw (TclException) null; }
                        { // Invoke: set tuple [...]
                            TclObject tmp28;
                            { // Invoke: ... $key $i
                                TclObject[] objv29 = TJC.grabObjv(interp, 3);
                                TclObject tmp30;
                                try {
                                    // Arg 0 constant: ...
                                    objv29[0] = const5;
                                    // Arg 1 variable: $key
                                    tmp30 = getVarScalar(interp, "key", compiledLocals, 0);
                                    tmp30.preserve();
                                    objv29[1] = tmp30;
                                    // Arg 2 variable: $i
                                    tmp30 = getVarScalar(interp, "i", compiledLocals, 14);
                                    tmp30.preserve();
                                    objv29[2] = tmp30;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                        ? cmdcache3.cmd : null), objv29, 0);
                                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                        updateCmdCache(interp, 3);
                                    }
                                } finally {
                                    tmp30 = objv29[1];
                                    if ( tmp30 != null ) {
                                        tmp30.release();
                                    }
                                    tmp30 = objv29[2];
                                    if ( tmp30 != null ) {
                                        tmp30.release();
                                    }
                                    TJC.releaseObjv(interp, objv29, 3);
                                }
                            } // End Invoke: ...
                            tmp28 = interp.getResult();
                            setVarScalar(interp, "tuple", tmp28, compiledLocals, 15);
                        } // End Invoke: set
                        { // Invoke: set type [...]
                            TclObject tmp31;
                            { // Invoke: lindex $tuple 0
                                TclObject tmp32 = getVarScalar(interp, "tuple", compiledLocals, 15);
                                tmp32 = TclList.index(interp, tmp32, 0);
                                if ( tmp32 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp32);
                                }
                            } // End Invoke: lindex
                            tmp31 = interp.getResult();
                            setVarScalar(interp, "type", tmp31, compiledLocals, 16);
                        } // End Invoke: set
                        { // Invoke: if ... ...
                            // Binary operator: $type != "constant"
                            TclObject tmp33 = getVarScalar(interp, "type", compiledLocals, 16);
                            boolean tmp34 = ! tmp33.toString().equals("constant");
                            ExprValue tmp35 = evs0;
                            tmp35.setIntValue(tmp34);
                            // End Binary operator: !=
                            boolean tmp36 = ( tmp35.getIntValue() != 0 );
                            if ( tmp36 ) {
                                { // Invoke: set use_tmp_local 1
                                    setVarScalar(interp, "use_tmp_local", const6, compiledLocals, 13);
                                } // End Invoke: set
                            }
                        } // End Invoke: if
                        } catch (TclException ex) {
                            int type = ex.getCompletionCode();
                            if (type == TCL.BREAK) {
                                break;
                            } else if (type == TCL.CONTINUE) {
                                continue;
                            } else {
                                throw ex;
                            }
                        }
                    }
                } // End Invoke: for
            } else {
                { // Invoke: set use_tmp_local 1
                    setVarScalar(interp, "use_tmp_local", const6, compiledLocals, 13);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            // Binary operator: () && $force_decl_tmpsymbol
            // Unary operator: ! $use_tmp_local
            TclObject tmp37 = getVarScalar(interp, "use_tmp_local", compiledLocals, 13);
            ExprValue tmp38 = evs0;
            if ( tmp37.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp38, tmp37);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp38, tmp37);
            }
            // End Unary operator: !
            if (tmp38.getBooleanValue(interp)) {
            TclObject tmp39 = getVarScalar(interp, "force_decl_tmpsymbol", compiledLocals, 4);
            ExprValue tmp40 = evs1;
            TJC.exprInitValue(interp, tmp40, tmp39);
            tmp38.setIntValue(tmp40.getBooleanValue(interp));
            } else {
            tmp38.setIntValue(0);
            } // End if: ()
            // End Binary operator: &&
            boolean tmp41 = ( tmp38.getIntValue() != 0 );
            if ( tmp41 ) {
                { // Invoke: set use_tmp_local 1
                    setVarScalar(interp, "use_tmp_local", const6, compiledLocals, 13);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            // Unary operator: ! $_compileproc(...)
            TclObject tmp42 = getVarArray(interp, "_compileproc", "options,skip_constant_increment", compiledLocals, 7);
            ExprValue tmp43 = evs0;
            if ( tmp42.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp43, tmp42);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp43, tmp42);
            }
            // End Unary operator: !
            boolean tmp44 = ( tmp43.getIntValue() != 0 );
            if ( tmp44 ) {
                { // Invoke: append buffer [...]
                    TclObject[] objv45 = TJC.grabObjv(interp, 1);
                    TclObject tmp46;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: ...
                            TclObject[] objv47 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: ...
                                objv47[0] = const7;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                    ? cmdcache4.cmd : null), objv47, 0);
                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                    updateCmdCache(interp, 4);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv47, 1);
                            }
                        } // End Invoke: ...
                        tmp46 = interp.getResult();
                        tmp46.preserve();
                        objv45[0] = tmp46;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv45, compiledLocals, 10);
                    } finally {
                        TJC.releaseObjvElems(interp, objv45, 1);
                    }
                } // End Invoke: append
            }
        } // End Invoke: if
        { // Invoke: if {$tmpsymbol != {}} ... elseif {$use_tmp_local} ...
            // Binary operator: $tmpsymbol != ""
            TclObject tmp48 = getVarScalar(interp, "tmpsymbol", compiledLocals, 3);
            ExprValue tmp49 = evs0;
            TJC.exprEqualsEmptyString(tmp49, tmp48, true);
            // End Binary operator: !=
            boolean tmp50 = ( tmp49.getIntValue() != 0 );
            if ( tmp50 ) {
            } else {
                TclObject tmp51 = getVarScalar(interp, "use_tmp_local", compiledLocals, 13);
                boolean tmp52 = TJC.getBoolean(interp, tmp51);
                if ( tmp52 ) {
                    { // Invoke: set tmpsymbol [...]
                        TclObject tmp53;
                        { // Invoke: ...
                            TclObject[] objv54 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: ...
                                objv54[0] = const1;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                    ? cmdcache1.cmd : null), objv54, 0);
                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                    updateCmdCache(interp, 1);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv54, 1);
                            }
                        } // End Invoke: ...
                        tmp53 = interp.getResult();
                        setVarScalar(interp, "tmpsymbol", tmp53, compiledLocals, 3);
                    } // End Invoke: set
                    { // Invoke: append buffer [...] "TclObject " $tmpsymbol ...
                        TclObject[] objv55 = TJC.grabObjv(interp, 4);
                        TclObject tmp56;
                        try {
                            // Arg 2 command: [...]
                            { // Invoke: emitter_indent
                                TclObject[] objv57 = TJC.grabObjv(interp, 1);
                                try {
                                    // Arg 0 constant: emitter_indent
                                    objv57[0] = const8;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                        ? cmdcache5.cmd : null), objv57, 0);
                                    if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                        updateCmdCache(interp, 5);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv57, 1);
                                }
                            } // End Invoke: emitter_indent
                            tmp56 = interp.getResult();
                            tmp56.preserve();
                            objv55[0] = tmp56;
                            // Arg 3 constant: "TclObject "
                            objv55[1] = const9;
                            // Arg 4 variable: $tmpsymbol
                            tmp56 = getVarScalar(interp, "tmpsymbol", compiledLocals, 3);
                            tmp56.preserve();
                            objv55[2] = tmp56;
                            // Arg 5 constant: ...
                            objv55[3] = const10;
                            interp.resetResult();
                            appendVarScalar(interp, "buffer", objv55, compiledLocals, 10);
                        } finally {
                            tmp56 = objv55[0];
                            if ( tmp56 != null ) {
                                tmp56.release();
                            }
                            tmp56 = objv55[2];
                            if ( tmp56 != null ) {
                                tmp56.release();
                            }
                            TJC.releaseObjv(interp, objv55, 4);
                        }
                    } // End Invoke: append
                }
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            TclObject tmp58 = getVarArray(interp, "_compileproc", "options,skip_constant_increment", compiledLocals, 7);
            ExprValue tmp59 = evs0;
            TJC.exprInitValue(interp, tmp59, tmp58);
            boolean tmp60 = tmp59.getBooleanValue(interp);
            if ( tmp60 ) {
                { // Invoke: append buffer [...]
                    TclObject[] objv61 = TJC.grabObjv(interp, 1);
                    TclObject tmp62;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: ...
                            TclObject[] objv63 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: ...
                                objv63[0] = const7;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                    ? cmdcache4.cmd : null), objv63, 0);
                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                    updateCmdCache(interp, 4);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv63, 1);
                            }
                        } // End Invoke: ...
                        tmp62 = interp.getResult();
                        tmp62.preserve();
                        objv61[0] = tmp62;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv61, compiledLocals, 10);
                    } finally {
                        TJC.releaseObjvElems(interp, objv61, 1);
                    }
                } // End Invoke: append
            }
        } // End Invoke: if
        { // Invoke: set ... [...]
            TclObject tmp64;
            { // Invoke: list
                TclObject tmp65 = TclList.newInstance();
                interp.setResult(tmp65);
            } // End Invoke: list
            tmp64 = interp.getResult();
            setVarScalar(interp, "const_unincremented_indexes", tmp64, compiledLocals, 17);
        } // End Invoke: set
        { // Invoke: for {set i $starti} {$i < $endi} {incr i} ...
            { // Invoke: set i $starti
                TclObject tmp66;
                tmp66 = getVarScalar(interp, "starti", compiledLocals, 1);
                setVarScalar(interp, "i", tmp66, compiledLocals, 14);
            } // End Invoke: set
            for ( boolean skip72 = true ; true ; ) {
                if ( skip72 ) {
                    skip72 = false;
                } else {
                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: incr i
                        interp.resetResult();
                        incrVarScalar(interp, "i", 1, compiledLocals, 14);
                    } // End Invoke: incr
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else {
                            throw ex;
                        }
                    }
                }

                // Binary operator: $i < $endi
                TclObject tmp67 = getVarScalar(interp, "i", compiledLocals, 14);
                ExprValue tmp68 = evs0;
                TJC.exprInitValue(interp, tmp68, tmp67);
                TclObject tmp69 = getVarScalar(interp, "endi", compiledLocals, 2);
                ExprValue tmp70 = evs1;
                TJC.exprInitValue(interp, tmp70, tmp69);
                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp68, tmp70);
                // End Binary operator: <
                boolean tmp71 = ( tmp68.getIntValue() != 0 );
                if ( ! tmp71 ) { break; }

                try {
                if ( false ) { throw (TclException) null; }
                { // Invoke: set tuple [...]
                    TclObject tmp73;
                    { // Invoke: ... $key $i 0 $tmpsymbol
                        TclObject[] objv74 = TJC.grabObjv(interp, 5);
                        TclObject tmp75;
                        try {
                            // Arg 0 constant: ...
                            objv74[0] = const11;
                            // Arg 1 variable: $key
                            tmp75 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp75.preserve();
                            objv74[1] = tmp75;
                            // Arg 2 variable: $i
                            tmp75 = getVarScalar(interp, "i", compiledLocals, 14);
                            tmp75.preserve();
                            objv74[2] = tmp75;
                            // Arg 3 constant: 0
                            objv74[3] = const4;
                            // Arg 4 variable: $tmpsymbol
                            tmp75 = getVarScalar(interp, "tmpsymbol", compiledLocals, 3);
                            tmp75.preserve();
                            objv74[4] = tmp75;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                ? cmdcache6.cmd : null), objv74, 0);
                            if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                updateCmdCache(interp, 6);
                            }
                        } finally {
                            tmp75 = objv74[1];
                            if ( tmp75 != null ) {
                                tmp75.release();
                            }
                            tmp75 = objv74[2];
                            if ( tmp75 != null ) {
                                tmp75.release();
                            }
                            tmp75 = objv74[4];
                            if ( tmp75 != null ) {
                                tmp75.release();
                            }
                            TJC.releaseObjv(interp, objv74, 5);
                        }
                    } // End Invoke: ...
                    tmp73 = interp.getResult();
                    setVarScalar(interp, "tuple", tmp73, compiledLocals, 15);
                } // End Invoke: set
                { // Invoke: set type [...]
                    TclObject tmp76;
                    { // Invoke: lindex $tuple 0
                        TclObject tmp77 = getVarScalar(interp, "tuple", compiledLocals, 15);
                        tmp77 = TclList.index(interp, tmp77, 0);
                        if ( tmp77 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp77);
                        }
                    } // End Invoke: lindex
                    tmp76 = interp.getResult();
                    setVarScalar(interp, "type", tmp76, compiledLocals, 16);
                } // End Invoke: set
                { // Invoke: set symbol [...]
                    TclObject tmp78;
                    { // Invoke: lindex $tuple 1
                        TclObject tmp79 = getVarScalar(interp, "tuple", compiledLocals, 15);
                        tmp79 = TclList.index(interp, tmp79, 1);
                        if ( tmp79 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp79);
                        }
                    } // End Invoke: lindex
                    tmp78 = interp.getResult();
                    setVarScalar(interp, "symbol", tmp78, compiledLocals, 18);
                } // End Invoke: set
                { // Invoke: set symbol_buffer [...]
                    TclObject tmp80;
                    { // Invoke: lindex $tuple 2
                        TclObject tmp81 = getVarScalar(interp, "tuple", compiledLocals, 15);
                        tmp81 = TclList.index(interp, tmp81, 2);
                        if ( tmp81 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp81);
                        }
                    } // End Invoke: lindex
                    tmp80 = interp.getResult();
                    setVarScalar(interp, "symbol_buffer", tmp80, compiledLocals, 19);
                } // End Invoke: set
                { // Invoke: set print_tuple [...]
                    TclObject tmp82;
                    { // Invoke: ... $key $i
                        TclObject[] objv83 = TJC.grabObjv(interp, 3);
                        TclObject tmp84;
                        try {
                            // Arg 0 constant: ...
                            objv83[0] = const12;
                            // Arg 1 variable: $key
                            tmp84 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp84.preserve();
                            objv83[1] = tmp84;
                            // Arg 2 variable: $i
                            tmp84 = getVarScalar(interp, "i", compiledLocals, 14);
                            tmp84.preserve();
                            objv83[2] = tmp84;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                ? cmdcache7.cmd : null), objv83, 0);
                            if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                updateCmdCache(interp, 7);
                            }
                        } finally {
                            tmp84 = objv83[1];
                            if ( tmp84 != null ) {
                                tmp84.release();
                            }
                            tmp84 = objv83[2];
                            if ( tmp84 != null ) {
                                tmp84.release();
                            }
                            TJC.releaseObjv(interp, objv83, 3);
                        }
                    } // End Invoke: ...
                    tmp82 = interp.getResult();
                    setVarScalar(interp, "print_tuple", tmp82, compiledLocals, 20);
                } // End Invoke: set
                { // Invoke: set print_type [...]
                    TclObject tmp85;
                    { // Invoke: lindex $print_tuple 0
                        TclObject tmp86 = getVarScalar(interp, "print_tuple", compiledLocals, 20);
                        tmp86 = TclList.index(interp, tmp86, 0);
                        if ( tmp86 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp86);
                        }
                    } // End Invoke: lindex
                    tmp85 = interp.getResult();
                    setVarScalar(interp, "print_type", tmp85, compiledLocals, 21);
                } // End Invoke: set
                { // Invoke: set print_str [...]
                    TclObject tmp87;
                    { // Invoke: lindex $print_tuple 1
                        TclObject tmp88 = getVarScalar(interp, "print_tuple", compiledLocals, 20);
                        tmp88 = TclList.index(interp, tmp88, 1);
                        if ( tmp88 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp88);
                        }
                    } // End Invoke: lindex
                    tmp87 = interp.getResult();
                    setVarScalar(interp, "print_str", tmp87, compiledLocals, 22);
                } // End Invoke: set
                { // Invoke: append buffer [...]
                    TclObject[] objv89 = TJC.grabObjv(interp, 1);
                    TclObject tmp90;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: emitter_comment "..."
                            TclObject[] objv91 = TJC.grabObjv(interp, 2);
                            TclObject tmp92;
                            try {
                                // Arg 0 constant: emitter_comment
                                objv91[0] = const13;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp93 = new StringBuffer(64);
                                sbtmp93.append("Arg ");
                                tmp92 = getVarScalar(interp, "i", compiledLocals, 14);
                                sbtmp93.append(tmp92.toString());
                                sbtmp93.append(" ");
                                tmp92 = getVarScalar(interp, "print_type", compiledLocals, 21);
                                sbtmp93.append(tmp92.toString());
                                sbtmp93.append(": ");
                                tmp92 = getVarScalar(interp, "print_str", compiledLocals, 22);
                                sbtmp93.append(tmp92.toString());
                                tmp92 = TclString.newInstance(sbtmp93);
                                tmp92.preserve();
                                objv91[1] = tmp92;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                    ? cmdcache8.cmd : null), objv91, 0);
                                if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                    updateCmdCache(interp, 8);
                                }
                            } finally {
                                tmp92 = objv91[1];
                                if ( tmp92 != null ) {
                                    tmp92.release();
                                }
                                TJC.releaseObjv(interp, objv91, 2);
                            }
                        } // End Invoke: emitter_comment
                        tmp90 = interp.getResult();
                        tmp90.preserve();
                        objv89[0] = tmp90;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv89, compiledLocals, 10);
                    } finally {
                        TJC.releaseObjvElems(interp, objv89, 1);
                    }
                } // End Invoke: append
                { // Invoke: set array_i [...]
                    TclObject tmp94;
                    { // Invoke: expr {$i - $starti}
                        // Binary operator: $i - $starti
                        TclObject tmp95 = getVarScalar(interp, "i", compiledLocals, 14);
                        ExprValue tmp96 = evs0;
                        TJC.exprInitValue(interp, tmp96, tmp95);
                        TclObject tmp97 = getVarScalar(interp, "starti", compiledLocals, 1);
                        ExprValue tmp98 = evs1;
                        TJC.exprInitValue(interp, tmp98, tmp97);
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MINUS, tmp96, tmp98);
                        // End Binary operator: -
                        TJC.exprSetResult(interp, tmp96);
                    } // End Invoke: expr
                    tmp94 = interp.getResult();
                    setVarScalar(interp, "array_i", tmp94, compiledLocals, 23);
                } // End Invoke: set
                { // Invoke: if ... ... else ...
                    // Binary operator: $_compileproc(...) && ()
                    TclObject tmp99 = getVarArray(interp, "_compileproc", "options,skip_constant_increment", compiledLocals, 7);
                    ExprValue tmp100 = evs0;
                    TJC.exprInitValue(interp, tmp100, tmp99);
                    if (tmp100.getBooleanValue(interp)) {
                    // Binary operator: $type == "constant"
                    TclObject tmp101 = getVarScalar(interp, "type", compiledLocals, 16);
                    boolean tmp102 = tmp101.toString().equals("constant");
                    ExprValue tmp103 = evs1;
                    tmp103.setIntValue(tmp102);
                    // End Binary operator: ==
                    tmp100.setIntValue(tmp103.getBooleanValue(interp));
                    } else {
                    tmp100.setIntValue(0);
                    } // End if: $_compileproc(...)
                    // End Binary operator: &&
                    boolean tmp104 = ( tmp100.getIntValue() != 0 );
                    if ( tmp104 ) {
                        { // Invoke: append buffer [...]
                            TclObject[] objv105 = TJC.grabObjv(interp, 1);
                            TclObject tmp106;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: emitter_array_assign $arraysym $array_i $symbol
                                    TclObject[] objv107 = TJC.grabObjv(interp, 4);
                                    TclObject tmp108;
                                    try {
                                        // Arg 0 constant: emitter_array_assign
                                        objv107[0] = const14;
                                        // Arg 1 variable: $arraysym
                                        tmp108 = getVarScalar(interp, "arraysym", compiledLocals, 11);
                                        tmp108.preserve();
                                        objv107[1] = tmp108;
                                        // Arg 2 variable: $array_i
                                        tmp108 = getVarScalar(interp, "array_i", compiledLocals, 23);
                                        tmp108.preserve();
                                        objv107[2] = tmp108;
                                        // Arg 3 variable: $symbol
                                        tmp108 = getVarScalar(interp, "symbol", compiledLocals, 18);
                                        tmp108.preserve();
                                        objv107[3] = tmp108;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                                            ? cmdcache9.cmd : null), objv107, 0);
                                        if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                                            updateCmdCache(interp, 9);
                                        }
                                    } finally {
                                        tmp108 = objv107[1];
                                        if ( tmp108 != null ) {
                                            tmp108.release();
                                        }
                                        tmp108 = objv107[2];
                                        if ( tmp108 != null ) {
                                            tmp108.release();
                                        }
                                        tmp108 = objv107[3];
                                        if ( tmp108 != null ) {
                                            tmp108.release();
                                        }
                                        TJC.releaseObjv(interp, objv107, 4);
                                    }
                                } // End Invoke: emitter_array_assign
                                tmp106 = interp.getResult();
                                tmp106.preserve();
                                objv105[0] = tmp106;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv105, compiledLocals, 10);
                            } finally {
                                TJC.releaseObjvElems(interp, objv105, 1);
                            }
                        } // End Invoke: append
                        { // Invoke: lappend ... $array_i
                            TclObject[] objv109 = TJC.grabObjv(interp, 1);
                            TclObject tmp110;
                            try {
                                // Arg 2 variable: $array_i
                                tmp110 = getVarScalar(interp, "array_i", compiledLocals, 23);
                                tmp110.preserve();
                                objv109[0] = tmp110;
                                interp.resetResult();
                                lappendVarScalar(interp, "const_unincremented_indexes", objv109, compiledLocals, 17);
                            } finally {
                                TJC.releaseObjvElems(interp, objv109, 1);
                            }
                        } // End Invoke: lappend
                    } else {
                        { // Invoke: append buffer $symbol_buffer [...]
                            TclObject[] objv111 = TJC.grabObjv(interp, 2);
                            TclObject tmp112;
                            try {
                                // Arg 2 variable: $symbol_buffer
                                tmp112 = getVarScalar(interp, "symbol_buffer", compiledLocals, 19);
                                tmp112.preserve();
                                objv111[0] = tmp112;
                                // Arg 3 command: [...]
                                { // Invoke: ... $arraysym $array_i $tmpsymbol $symbol
                                    TclObject[] objv113 = TJC.grabObjv(interp, 5);
                                    TclObject tmp114;
                                    try {
                                        // Arg 0 constant: ...
                                        objv113[0] = const15;
                                        // Arg 1 variable: $arraysym
                                        tmp114 = getVarScalar(interp, "arraysym", compiledLocals, 11);
                                        tmp114.preserve();
                                        objv113[1] = tmp114;
                                        // Arg 2 variable: $array_i
                                        tmp114 = getVarScalar(interp, "array_i", compiledLocals, 23);
                                        tmp114.preserve();
                                        objv113[2] = tmp114;
                                        // Arg 3 variable: $tmpsymbol
                                        tmp114 = getVarScalar(interp, "tmpsymbol", compiledLocals, 3);
                                        tmp114.preserve();
                                        objv113[3] = tmp114;
                                        // Arg 4 variable: $symbol
                                        tmp114 = getVarScalar(interp, "symbol", compiledLocals, 18);
                                        tmp114.preserve();
                                        objv113[4] = tmp114;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                                            ? cmdcache10.cmd : null), objv113, 0);
                                        if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                                            updateCmdCache(interp, 10);
                                        }
                                    } finally {
                                        tmp114 = objv113[1];
                                        if ( tmp114 != null ) {
                                            tmp114.release();
                                        }
                                        tmp114 = objv113[2];
                                        if ( tmp114 != null ) {
                                            tmp114.release();
                                        }
                                        tmp114 = objv113[3];
                                        if ( tmp114 != null ) {
                                            tmp114.release();
                                        }
                                        tmp114 = objv113[4];
                                        if ( tmp114 != null ) {
                                            tmp114.release();
                                        }
                                        TJC.releaseObjv(interp, objv113, 5);
                                    }
                                } // End Invoke: ...
                                tmp112 = interp.getResult();
                                tmp112.preserve();
                                objv111[1] = tmp112;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv111, compiledLocals, 10);
                            } finally {
                                TJC.releaseObjvElems(interp, objv111, 2);
                            }
                        } // End Invoke: append
                    }
                } // End Invoke: if
                } catch (TclException ex) {
                    int type = ex.getCompletionCode();
                    if (type == TCL.BREAK) {
                        break;
                    } else if (type == TCL.CONTINUE) {
                        continue;
                    } else {
                        throw ex;
                    }
                }
            }
        } // End Invoke: for
        { // Invoke: append buffer [...]
            TclObject[] objv115 = TJC.grabObjv(interp, 1);
            TclObject tmp116;
            try {
                // Arg 2 command: [...]
                { // Invoke: $callback $key $arraysym $tmpsymbol $userdata
                    TclObject[] objv117 = TJC.grabObjv(interp, 5);
                    TclObject tmp118;
                    try {
                        // Arg 0 variable: $callback
                        tmp118 = getVarScalar(interp, "callback", compiledLocals, 5);
                        tmp118.preserve();
                        objv117[0] = tmp118;
                        // Arg 1 variable: $key
                        tmp118 = getVarScalar(interp, "key", compiledLocals, 0);
                        tmp118.preserve();
                        objv117[1] = tmp118;
                        // Arg 2 variable: $arraysym
                        tmp118 = getVarScalar(interp, "arraysym", compiledLocals, 11);
                        tmp118.preserve();
                        objv117[2] = tmp118;
                        // Arg 3 variable: $tmpsymbol
                        tmp118 = getVarScalar(interp, "tmpsymbol", compiledLocals, 3);
                        tmp118.preserve();
                        objv117[3] = tmp118;
                        // Arg 4 variable: $userdata
                        tmp118 = getVarScalar(interp, "userdata", compiledLocals, 6);
                        tmp118.preserve();
                        objv117[4] = tmp118;
                        TJC.invoke(interp, null, objv117, 0);
                    } finally {
                        TJC.releaseObjvElems(interp, objv117, 5);
                    }
                } // End Invoke: ...
                tmp116 = interp.getResult();
                tmp116.preserve();
                objv115[0] = tmp116;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv115, compiledLocals, 10);
            } finally {
                TJC.releaseObjvElems(interp, objv115, 1);
            }
        } // End Invoke: append
        { // Invoke: append buffer [...]
            TclObject[] objv119 = TJC.grabObjv(interp, 1);
            TclObject tmp120;
            try {
                // Arg 2 command: [...]
                { // Invoke: ...
                    TclObject[] objv121 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: ...
                        objv121[0] = const16;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache11_cmdEpoch == cmdcache11.cmdEpoch)
                            ? cmdcache11.cmd : null), objv121, 0);
                        if ( cmdcache11_cmdEpoch != cmdcache11.cmdEpoch ) {
                            updateCmdCache(interp, 11);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv121, 1);
                    }
                } // End Invoke: ...
                tmp120 = interp.getResult();
                tmp120.preserve();
                objv119[0] = tmp120;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv119, compiledLocals, 10);
            } finally {
                TJC.releaseObjvElems(interp, objv119, 1);
            }
        } // End Invoke: append
        { // Invoke: set release_none_flag false
            setVarScalar(interp, "release_none_flag", const17, compiledLocals, 24);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: $const_unincremented_indexes != ""
            TclObject tmp122 = getVarScalar(interp, "const_unincremented_indexes", compiledLocals, 17);
            ExprValue tmp123 = evs0;
            TJC.exprEqualsEmptyString(tmp123, tmp122, true);
            // End Binary operator: !=
            boolean tmp124 = ( tmp123.getIntValue() != 0 );
            if ( tmp124 ) {
                { // Invoke: if ... ... else ...
                    // Binary operator: [...] == $objv_size
                    { // Invoke: llength $...
                        TclObject tmp125 = getVarScalar(interp, "const_unincremented_indexes", compiledLocals, 17);
                        int tmp126 = TclList.getLength(interp, tmp125);
                        interp.setResult(tmp126);
                    } // End Invoke: llength
                    TclObject tmp127 = interp.getResult();
                    ExprValue tmp128 = evs0;
                    TJC.exprInitValue(interp, tmp128, tmp127);
                    TclObject tmp129 = getVarScalar(interp, "objv_size", compiledLocals, 12);
                    ExprValue tmp130 = evs1;
                    TJC.exprInitValue(interp, tmp130, tmp129);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp128, tmp130);
                    // End Binary operator: ==
                    boolean tmp131 = ( tmp128.getIntValue() != 0 );
                    if ( tmp131 ) {
                        { // Invoke: set release_none_flag 1
                            setVarScalar(interp, "release_none_flag", const6, compiledLocals, 24);
                        } // End Invoke: set
                    } else {
                        { // Invoke: if ... ... else ...
                            // Binary operator: () <= 4
                            // Binary operator: $objv_size - [...]
                            TclObject tmp132 = getVarScalar(interp, "objv_size", compiledLocals, 12);
                            ExprValue tmp133 = evs0;
                            TJC.exprInitValue(interp, tmp133, tmp132);
                            { // Invoke: llength $...
                                TclObject tmp134 = getVarScalar(interp, "const_unincremented_indexes", compiledLocals, 17);
                                int tmp135 = TclList.getLength(interp, tmp134);
                                interp.setResult(tmp135);
                            } // End Invoke: llength
                            TclObject tmp136 = interp.getResult();
                            ExprValue tmp137 = evs1;
                            TJC.exprInitValue(interp, tmp137, tmp136);
                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MINUS, tmp133, tmp137);
                            // End Binary operator: -
                            ExprValue tmp138 = evs1;
                            tmp138.setIntValue(4);
                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LEQ, tmp133, tmp138);
                            // End Binary operator: <=
                            boolean tmp139 = ( tmp133.getIntValue() != 0 );
                            if ( tmp139 ) {
                                { // Invoke: if {$tmpsymbol == ""} ...
                                    // Binary operator: $tmpsymbol == ""
                                    TclObject tmp140 = getVarScalar(interp, "tmpsymbol", compiledLocals, 3);
                                    ExprValue tmp141 = evs0;
                                    TJC.exprEqualsEmptyString(tmp141, tmp140, false);
                                    // End Binary operator: ==
                                    boolean tmp142 = ( tmp141.getIntValue() != 0 );
                                    if ( tmp142 ) {
                                        { // Invoke: error ...
                                            TclObject[] objv143 = TJC.grabObjv(interp, 2);
                                            try {
                                                // Arg 0 constant: error
                                                objv143[0] = const18;
                                                // Arg 1 constant: ...
                                                objv143[1] = const19;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache12_cmdEpoch == cmdcache12.cmdEpoch)
                                                    ? cmdcache12.cmd : null), objv143, 0);
                                                if ( cmdcache12_cmdEpoch != cmdcache12.cmdEpoch ) {
                                                    updateCmdCache(interp, 12);
                                                }
                                            } finally {
                                                TJC.releaseObjv(interp, objv143, 2);
                                            }
                                        } // End Invoke: error
                                    }
                                } // End Invoke: if
                                { // Invoke: set tmpsymbol_if_block ""
                                    setVarScalar(interp, "tmpsymbol_if_block", const0, compiledLocals, 25);
                                } // End Invoke: set
                                { // Invoke: append tmpsymbol_if_block [...] [...] [...]
                                    TclObject[] objv144 = TJC.grabObjv(interp, 3);
                                    TclObject tmp145;
                                    try {
                                        // Arg 2 command: [...]
                                        { // Invoke: ... "$tmpsymbol != null"
                                            TclObject[] objv146 = TJC.grabObjv(interp, 2);
                                            TclObject tmp147;
                                            try {
                                                // Arg 0 constant: ...
                                                objv146[0] = const20;
                                                // Arg 1 word: "$tmpsymbol != null"
                                                StringBuffer sbtmp148 = new StringBuffer(64);
                                                tmp147 = getVarScalar(interp, "tmpsymbol", compiledLocals, 3);
                                                sbtmp148.append(tmp147.toString());
                                                sbtmp148.append(" != null");
                                                tmp147 = TclString.newInstance(sbtmp148);
                                                tmp147.preserve();
                                                objv146[1] = tmp147;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache13_cmdEpoch == cmdcache13.cmdEpoch)
                                                    ? cmdcache13.cmd : null), objv146, 0);
                                                if ( cmdcache13_cmdEpoch != cmdcache13.cmdEpoch ) {
                                                    updateCmdCache(interp, 13);
                                                }
                                            } finally {
                                                tmp147 = objv146[1];
                                                if ( tmp147 != null ) {
                                                    tmp147.release();
                                                }
                                                TJC.releaseObjv(interp, objv146, 2);
                                            }
                                        } // End Invoke: ...
                                        tmp145 = interp.getResult();
                                        tmp145.preserve();
                                        objv144[0] = tmp145;
                                        // Arg 3 command: [...]
                                        { // Invoke: ... $tmpsymbol
                                            TclObject[] objv149 = TJC.grabObjv(interp, 2);
                                            TclObject tmp150;
                                            try {
                                                // Arg 0 constant: ...
                                                objv149[0] = const21;
                                                // Arg 1 variable: $tmpsymbol
                                                tmp150 = getVarScalar(interp, "tmpsymbol", compiledLocals, 3);
                                                tmp150.preserve();
                                                objv149[1] = tmp150;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache14_cmdEpoch == cmdcache14.cmdEpoch)
                                                    ? cmdcache14.cmd : null), objv149, 0);
                                                if ( cmdcache14_cmdEpoch != cmdcache14.cmdEpoch ) {
                                                    updateCmdCache(interp, 14);
                                                }
                                            } finally {
                                                tmp150 = objv149[1];
                                                if ( tmp150 != null ) {
                                                    tmp150.release();
                                                }
                                                TJC.releaseObjv(interp, objv149, 2);
                                            }
                                        } // End Invoke: ...
                                        tmp145 = interp.getResult();
                                        tmp145.preserve();
                                        objv144[1] = tmp145;
                                        // Arg 4 command: [...]
                                        { // Invoke: ...
                                            TclObject[] objv151 = TJC.grabObjv(interp, 1);
                                            try {
                                                // Arg 0 constant: ...
                                                objv151[0] = const22;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache15_cmdEpoch == cmdcache15.cmdEpoch)
                                                    ? cmdcache15.cmd : null), objv151, 0);
                                                if ( cmdcache15_cmdEpoch != cmdcache15.cmdEpoch ) {
                                                    updateCmdCache(interp, 15);
                                                }
                                            } finally {
                                                TJC.releaseObjv(interp, objv151, 1);
                                            }
                                        } // End Invoke: ...
                                        tmp145 = interp.getResult();
                                        tmp145.preserve();
                                        objv144[2] = tmp145;
                                        interp.resetResult();
                                        appendVarScalar(interp, "tmpsymbol_if_block", objv144, compiledLocals, 25);
                                    } finally {
                                        TJC.releaseObjvElems(interp, objv144, 3);
                                    }
                                } // End Invoke: append
                                { // Invoke: for {set i 0} {$i < $objv_size} {incr i} ...
                                    { // Invoke: set i 0
                                        setVarScalar(interp, "i", const4, compiledLocals, 14);
                                    } // End Invoke: set
                                    for ( boolean skip157 = true ; true ; ) {
                                        if ( skip157 ) {
                                            skip157 = false;
                                        } else {
                                            try {
                                            if ( false ) { throw (TclException) null; }
                                            { // Invoke: incr i
                                                interp.resetResult();
                                                incrVarScalar(interp, "i", 1, compiledLocals, 14);
                                            } // End Invoke: incr
                                            } catch (TclException ex) {
                                                int type = ex.getCompletionCode();
                                                if (type == TCL.BREAK) {
                                                    break;
                                                } else {
                                                    throw ex;
                                                }
                                            }
                                        }

                                        // Binary operator: $i < $objv_size
                                        TclObject tmp152 = getVarScalar(interp, "i", compiledLocals, 14);
                                        ExprValue tmp153 = evs0;
                                        TJC.exprInitValue(interp, tmp153, tmp152);
                                        TclObject tmp154 = getVarScalar(interp, "objv_size", compiledLocals, 12);
                                        ExprValue tmp155 = evs1;
                                        TJC.exprInitValue(interp, tmp155, tmp154);
                                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp153, tmp155);
                                        // End Binary operator: <
                                        boolean tmp156 = ( tmp153.getIntValue() != 0 );
                                        if ( ! tmp156 ) { break; }

                                        try {
                                        if ( false ) { throw (TclException) null; }
                                        { // Invoke: set is_non_constant 1
                                            setVarScalar(interp, "is_non_constant", const6, compiledLocals, 26);
                                        } // End Invoke: set
                                        { // Invoke: foreach cui $... ...
                                            TclObject tmp158 = null;
                                            try {
                                                tmp158 = getVarScalar(interp, "const_unincremented_indexes", compiledLocals, 17);
                                                tmp158.preserve();
                                                final int tmp158_length = TclList.getLength(interp, tmp158);

                                                for ( int index159 = 0 ; index159 < tmp158_length ; index159++ ) {
                                                    TclObject tmp160 = TclList.index(interp, tmp158, index159);
                                                    try {
                                                        setVarScalar(interp, "cui", tmp160, compiledLocals, 27);
                                                    } catch (TclException ex) {
                                                        TJC.foreachVarErr(interp, "cui");
                                                    }

                                                    try {
                                                    if ( false ) { throw (TclException) null; }
                                                    { // Invoke: if {$i == $cui} ...
                                                        // Binary operator: $i == $cui
                                                        TclObject tmp161 = getVarScalar(interp, "i", compiledLocals, 14);
                                                        ExprValue tmp162 = evs0;
                                                        TJC.exprInitValue(interp, tmp162, tmp161);
                                                        TclObject tmp163 = getVarScalar(interp, "cui", compiledLocals, 27);
                                                        ExprValue tmp164 = evs1;
                                                        TJC.exprInitValue(interp, tmp164, tmp163);
                                                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp162, tmp164);
                                                        // End Binary operator: ==
                                                        boolean tmp165 = ( tmp162.getIntValue() != 0 );
                                                        if ( tmp165 ) {
                                                            { // Invoke: set is_non_constant 0
                                                                setVarScalar(interp, "is_non_constant", const4, compiledLocals, 26);
                                                            } // End Invoke: set
                                                        }
                                                    } // End Invoke: if
                                                    } catch (TclException ex) {
                                                        int type = ex.getCompletionCode();
                                                        if (type == TCL.BREAK) {
                                                            break;
                                                        } else if (type == TCL.CONTINUE) {
                                                            continue;
                                                        } else {
                                                            throw ex;
                                                        }
                                                    }
                                                }
                                            } finally {
                                                if ( tmp158 != null ) {
                                                    tmp158.release();
                                                }
                                            }
                                        } // End Invoke: foreach
                                        { // Invoke: if {$is_non_constant} ...
                                            TclObject tmp166 = getVarScalar(interp, "is_non_constant", compiledLocals, 26);
                                            boolean tmp167 = TJC.getBoolean(interp, tmp166);
                                            if ( tmp167 ) {
                                                { // Invoke: append buffer [...] $tmpsymbol " = " $arraysym ... $i ... ... $tmpsymbol_if_block
                                                    TclObject[] objv168 = TJC.grabObjv(interp, 9);
                                                    TclObject tmp169;
                                                    try {
                                                        // Arg 2 command: [...]
                                                        { // Invoke: emitter_indent
                                                            TclObject[] objv170 = TJC.grabObjv(interp, 1);
                                                            try {
                                                                // Arg 0 constant: emitter_indent
                                                                objv170[0] = const8;
                                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                                    updateCmdCache(interp, 0);
                                                                }
                                                                TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                                                    ? cmdcache5.cmd : null), objv170, 0);
                                                                if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                                                    updateCmdCache(interp, 5);
                                                                }
                                                            } finally {
                                                                TJC.releaseObjv(interp, objv170, 1);
                                                            }
                                                        } // End Invoke: emitter_indent
                                                        tmp169 = interp.getResult();
                                                        tmp169.preserve();
                                                        objv168[0] = tmp169;
                                                        // Arg 3 variable: $tmpsymbol
                                                        tmp169 = getVarScalar(interp, "tmpsymbol", compiledLocals, 3);
                                                        tmp169.preserve();
                                                        objv168[1] = tmp169;
                                                        // Arg 4 constant: " = "
                                                        objv168[2] = const23;
                                                        // Arg 5 variable: $arraysym
                                                        tmp169 = getVarScalar(interp, "arraysym", compiledLocals, 11);
                                                        tmp169.preserve();
                                                        objv168[3] = tmp169;
                                                        // Arg 6 constant: ...
                                                        objv168[4] = const24;
                                                        // Arg 7 variable: $i
                                                        tmp169 = getVarScalar(interp, "i", compiledLocals, 14);
                                                        tmp169.preserve();
                                                        objv168[5] = tmp169;
                                                        // Arg 8 constant: ...
                                                        objv168[6] = const25;
                                                        // Arg 9 constant: ...
                                                        objv168[7] = const10;
                                                        // Arg 10 variable: $tmpsymbol_if_block
                                                        tmp169 = getVarScalar(interp, "tmpsymbol_if_block", compiledLocals, 25);
                                                        tmp169.preserve();
                                                        objv168[8] = tmp169;
                                                        interp.resetResult();
                                                        appendVarScalar(interp, "buffer", objv168, compiledLocals, 10);
                                                    } finally {
                                                        objv168[2] = null;
                                                        objv168[4] = null;
                                                        objv168[6] = null;
                                                        objv168[7] = null;
                                                        TJC.releaseObjvElems(interp, objv168, 9);
                                                    }
                                                } // End Invoke: append
                                            }
                                        } // End Invoke: if
                                        } catch (TclException ex) {
                                            int type = ex.getCompletionCode();
                                            if (type == TCL.BREAK) {
                                                break;
                                            } else if (type == TCL.CONTINUE) {
                                                continue;
                                            } else {
                                                throw ex;
                                            }
                                        }
                                    }
                                } // End Invoke: for
                                { // Invoke: set release_none_flag 1
                                    setVarScalar(interp, "release_none_flag", const6, compiledLocals, 24);
                                } // End Invoke: set
                            } else {
                                { // Invoke: foreach i $... ...
                                    TclObject tmp171 = null;
                                    try {
                                        tmp171 = getVarScalar(interp, "const_unincremented_indexes", compiledLocals, 17);
                                        tmp171.preserve();
                                        final int tmp171_length = TclList.getLength(interp, tmp171);

                                        for ( int index172 = 0 ; index172 < tmp171_length ; index172++ ) {
                                            TclObject tmp173 = TclList.index(interp, tmp171, index172);
                                            try {
                                                setVarScalar(interp, "i", tmp173, compiledLocals, 14);
                                            } catch (TclException ex) {
                                                TJC.foreachVarErr(interp, "i");
                                            }

                                            try {
                                            if ( false ) { throw (TclException) null; }
                                            { // Invoke: append buffer [...]
                                                TclObject[] objv174 = TJC.grabObjv(interp, 1);
                                                TclObject tmp175;
                                                try {
                                                    // Arg 2 command: [...]
                                                    { // Invoke: emitter_array_assign $arraysym $i null
                                                        TclObject[] objv176 = TJC.grabObjv(interp, 4);
                                                        TclObject tmp177;
                                                        try {
                                                            // Arg 0 constant: emitter_array_assign
                                                            objv176[0] = const14;
                                                            // Arg 1 variable: $arraysym
                                                            tmp177 = getVarScalar(interp, "arraysym", compiledLocals, 11);
                                                            tmp177.preserve();
                                                            objv176[1] = tmp177;
                                                            // Arg 2 variable: $i
                                                            tmp177 = getVarScalar(interp, "i", compiledLocals, 14);
                                                            tmp177.preserve();
                                                            objv176[2] = tmp177;
                                                            // Arg 3 constant: null
                                                            objv176[3] = const26;
                                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                                updateCmdCache(interp, 0);
                                                            }
                                                            TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                                                                ? cmdcache9.cmd : null), objv176, 0);
                                                            if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                                                                updateCmdCache(interp, 9);
                                                            }
                                                        } finally {
                                                            tmp177 = objv176[1];
                                                            if ( tmp177 != null ) {
                                                                tmp177.release();
                                                            }
                                                            tmp177 = objv176[2];
                                                            if ( tmp177 != null ) {
                                                                tmp177.release();
                                                            }
                                                            TJC.releaseObjv(interp, objv176, 4);
                                                        }
                                                    } // End Invoke: emitter_array_assign
                                                    tmp175 = interp.getResult();
                                                    tmp175.preserve();
                                                    objv174[0] = tmp175;
                                                    interp.resetResult();
                                                    appendVarScalar(interp, "buffer", objv174, compiledLocals, 10);
                                                } finally {
                                                    TJC.releaseObjvElems(interp, objv174, 1);
                                                }
                                            } // End Invoke: append
                                            } catch (TclException ex) {
                                                int type = ex.getCompletionCode();
                                                if (type == TCL.BREAK) {
                                                    break;
                                                } else if (type == TCL.CONTINUE) {
                                                    continue;
                                                } else {
                                                    throw ex;
                                                }
                                            }
                                        }
                                    } finally {
                                        if ( tmp171 != null ) {
                                            tmp171.release();
                                        }
                                    }
                                } // End Invoke: foreach
                            }
                        } // End Invoke: if
                    }
                } // End Invoke: if
            }
        } // End Invoke: if
        { // Invoke: append buffer [...]
            TclObject[] objv178 = TJC.grabObjv(interp, 1);
            TclObject tmp179;
            try {
                // Arg 2 command: [...]
                { // Invoke: ... $arraysym $objv_size $release_none_flag
                    TclObject[] objv180 = TJC.grabObjv(interp, 4);
                    TclObject tmp181;
                    try {
                        // Arg 0 constant: ...
                        objv180[0] = const27;
                        // Arg 1 variable: $arraysym
                        tmp181 = getVarScalar(interp, "arraysym", compiledLocals, 11);
                        tmp181.preserve();
                        objv180[1] = tmp181;
                        // Arg 2 variable: $objv_size
                        tmp181 = getVarScalar(interp, "objv_size", compiledLocals, 12);
                        tmp181.preserve();
                        objv180[2] = tmp181;
                        // Arg 3 variable: $release_none_flag
                        tmp181 = getVarScalar(interp, "release_none_flag", compiledLocals, 24);
                        tmp181.preserve();
                        objv180[3] = tmp181;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache16_cmdEpoch == cmdcache16.cmdEpoch)
                            ? cmdcache16.cmd : null), objv180, 0);
                        if ( cmdcache16_cmdEpoch != cmdcache16.cmdEpoch ) {
                            updateCmdCache(interp, 16);
                        }
                    } finally {
                        tmp181 = objv180[1];
                        if ( tmp181 != null ) {
                            tmp181.release();
                        }
                        tmp181 = objv180[2];
                        if ( tmp181 != null ) {
                            tmp181.release();
                        }
                        tmp181 = objv180[3];
                        if ( tmp181 != null ) {
                            tmp181.release();
                        }
                        TJC.releaseObjv(interp, objv180, 4);
                    }
                } // End Invoke: ...
                tmp179 = interp.getResult();
                tmp179.preserve();
                objv178[0] = tmp179;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv178, compiledLocals, 10);
            } finally {
                TJC.releaseObjvElems(interp, objv178, 1);
            }
        } // End Invoke: append
        { // Invoke: return $buffer
            TclObject tmp182 = getVarScalar(interp, "buffer", compiledLocals, 10);
            interp.resetResult();
            interp.setResult(tmp182);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_emit_objv_assignment");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;
    TclObject const18;
    TclObject const19;
    TclObject const20;
    TclObject const21;
    TclObject const22;
    TclObject const23;
    TclObject const24;
    TclObject const25;
    TclObject const26;
    TclObject const27;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("compileproc_tmpvar_next");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("objv");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("emitter_invoke_command_start");
        const3.preserve(); const3.preserve();
        const4 = TclInteger.newInstance(0);
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("compileproc_get_argument_tuple");
        const5.preserve(); const5.preserve();
        const6 = TclInteger.newInstance(1);
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("emitter_container_try_start");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("emitter_indent");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("TclObject ");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance(";\n");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("compileproc_emit_argument");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("compileproc_argument_printable");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("emitter_comment");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("emitter_array_assign");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("emitter_invoke_command_assign");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance("emitter_invoke_command_finally");
        const16.preserve(); const16.preserve();
        const17 = TclString.newInstance("false");
        TclBoolean.get(interp, const17);
        const17.preserve(); const17.preserve();
        const18 = TclString.newInstance("error");
        const18.preserve(); const18.preserve();
        const19 = TclString.newInstance("tmp local should have been declared");
        const19.preserve(); const19.preserve();
        const20 = TclString.newInstance("emitter_container_if_start");
        const20.preserve(); const20.preserve();
        const21 = TclString.newInstance("emitter_tclobject_release");
        const21.preserve(); const21.preserve();
        const22 = TclString.newInstance("emitter_container_if_end");
        const22.preserve(); const22.preserve();
        const23 = TclString.newInstance(" = ");
        const23.preserve(); const23.preserve();
        const24 = TclString.newInstance("[");
        const24.preserve(); const24.preserve();
        const25 = TclString.newInstance("]");
        const25.preserve(); const25.preserve();
        const26 = TclString.newInstance("null");
        const26.preserve(); const26.preserve();
        const27 = TclString.newInstance("emitter_invoke_command_end");
        const27.preserve(); const27.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;
    WrappedCommand cmdcache8;
    int cmdcache8_cmdEpoch;
    WrappedCommand cmdcache9;
    int cmdcache9_cmdEpoch;
    WrappedCommand cmdcache10;
    int cmdcache10_cmdEpoch;
    WrappedCommand cmdcache11;
    int cmdcache11_cmdEpoch;
    WrappedCommand cmdcache12;
    int cmdcache12_cmdEpoch;
    WrappedCommand cmdcache13;
    int cmdcache13_cmdEpoch;
    WrappedCommand cmdcache14;
    int cmdcache14_cmdEpoch;
    WrappedCommand cmdcache15;
    int cmdcache15_cmdEpoch;
    WrappedCommand cmdcache16;
    int cmdcache16_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                cmdcache8 = TJC.INVALID_COMMAND_CACHE;
                cmdcache8_cmdEpoch = 0;
                cmdcache9 = TJC.INVALID_COMMAND_CACHE;
                cmdcache9_cmdEpoch = 0;
                cmdcache10 = TJC.INVALID_COMMAND_CACHE;
                cmdcache10_cmdEpoch = 0;
                cmdcache11 = TJC.INVALID_COMMAND_CACHE;
                cmdcache11_cmdEpoch = 0;
                cmdcache12 = TJC.INVALID_COMMAND_CACHE;
                cmdcache12_cmdEpoch = 0;
                cmdcache13 = TJC.INVALID_COMMAND_CACHE;
                cmdcache13_cmdEpoch = 0;
                cmdcache14 = TJC.INVALID_COMMAND_CACHE;
                cmdcache14_cmdEpoch = 0;
                cmdcache15 = TJC.INVALID_COMMAND_CACHE;
                cmdcache15_cmdEpoch = 0;
                cmdcache16 = TJC.INVALID_COMMAND_CACHE;
                cmdcache16_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "compileproc_tmpvar_next";
                break;
            }
            case 2: {
                cmdName = "emitter_invoke_command_start";
                break;
            }
            case 3: {
                cmdName = "compileproc_get_argument_tuple";
                break;
            }
            case 4: {
                cmdName = "emitter_container_try_start";
                break;
            }
            case 5: {
                cmdName = "emitter_indent";
                break;
            }
            case 6: {
                cmdName = "compileproc_emit_argument";
                break;
            }
            case 7: {
                cmdName = "compileproc_argument_printable";
                break;
            }
            case 8: {
                cmdName = "emitter_comment";
                break;
            }
            case 9: {
                cmdName = "emitter_array_assign";
                break;
            }
            case 10: {
                cmdName = "emitter_invoke_command_assign";
                break;
            }
            case 11: {
                cmdName = "emitter_invoke_command_finally";
                break;
            }
            case 12: {
                cmdName = "error";
                break;
            }
            case 13: {
                cmdName = "emitter_container_if_start";
                break;
            }
            case 14: {
                cmdName = "emitter_tclobject_release";
                break;
            }
            case 15: {
                cmdName = "emitter_container_if_end";
                break;
            }
            case 16: {
                cmdName = "emitter_invoke_command_end";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
            case 8: {
                cmdcache8 = lwcmd;
                cmdcache8_cmdEpoch = cmdEpoch;
                break;
            }
            case 9: {
                cmdcache9 = lwcmd;
                cmdcache9_cmdEpoch = cmdEpoch;
                break;
            }
            case 10: {
                cmdcache10 = lwcmd;
                cmdcache10_cmdEpoch = cmdEpoch;
                break;
            }
            case 11: {
                cmdcache11 = lwcmd;
                cmdcache11_cmdEpoch = cmdEpoch;
                break;
            }
            case 12: {
                cmdcache12 = lwcmd;
                cmdcache12_cmdEpoch = cmdEpoch;
                break;
            }
            case 13: {
                cmdcache13 = lwcmd;
                cmdcache13_cmdEpoch = cmdEpoch;
                break;
            }
            case 14: {
                cmdcache14 = lwcmd;
                cmdcache14_cmdEpoch = cmdEpoch;
                break;
            }
            case 15: {
                cmdcache15 = lwcmd;
                cmdcache15_cmdEpoch = cmdEpoch;
                break;
            }
            case 16: {
                cmdcache16 = lwcmd;
                cmdcache16_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "starti",
        "endi",
        "tmpsymbol",
        "force_decl_tmpsymbol",
        "callback",
        "userdata",
        "_compileproc",
        "_compileproc_key_info",
        "num_args",
        "buffer",
        "arraysym",
        "objv_size",
        "use_tmp_local",
        "i",
        "tuple",
        "type",
        "const_unincremented_indexes",
        "symbol",
        "symbol_buffer",
        "print_tuple",
        "print_type",
        "print_str",
        "array_i",
        "release_none_flag",
        "tmpsymbol_if_block",
        "is_non_constant",
        "cui"
    };
} // end class CompileprocEmitObjvAssignmentCmd

