// TJC implementation of procedure compileproc_expr_evaluate
package tjc;
import tcl.lang.*;

public class CompileprocExprEvaluateCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 26, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 3) {
            throw new TclNumArgsException(interp, 1, objv, "key expr_index");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        setVarScalar(interp, "expr_index", objv[2], compiledLocals, 1);
        { // Invoke: global _compileproc ...
            TJC.makeGlobalLinkVar(interp, "_compileproc", "_compileproc", 2);
            TJC.makeGlobalLinkVar(interp, "_compileproc_key_info", "_compileproc_key_info", 3);
        } // End Invoke: global
        { // Invoke: set types $...
            TclObject tmp0;
            StringBuffer sbtmp1 = new StringBuffer(64);
            tmp0 = getVarScalar(interp, "key", compiledLocals, 0);
            sbtmp1.append(tmp0.toString());
            sbtmp1.append(",types");
            tmp0 = getVarArray(interp, "_compileproc_key_info", sbtmp1.toString(), compiledLocals, 3);
            setVarScalar(interp, "types", tmp0, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set values $...
            TclObject tmp2;
            StringBuffer sbtmp3 = new StringBuffer(64);
            tmp2 = getVarScalar(interp, "key", compiledLocals, 0);
            sbtmp3.append(tmp2.toString());
            sbtmp3.append(",values");
            tmp2 = getVarArray(interp, "_compileproc_key_info", sbtmp3.toString(), compiledLocals, 3);
            setVarScalar(interp, "values", tmp2, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: [...] != "constant"
            { // Invoke: lindex $types $expr_index
                TclObject tmp4 = null;
                TclObject tmp5;
                try {
                    tmp4 = getVarScalar(interp, "types", compiledLocals, 4);
                    tmp4.preserve();
                    tmp5 = getVarScalar(interp, "expr_index", compiledLocals, 1);
                    TJC.lindexNonconst(interp, tmp4, tmp5);
                } finally {
                    if ( tmp4 != null ) {
                        tmp4.release();
                    }
                }
            } // End Invoke: lindex
            TclObject tmp6 = interp.getResult();
            boolean tmp7 = ! tmp6.toString().equals("constant");
            ExprValue tmp8 = evs0;
            tmp8.setIntValue(tmp7);
            // End Binary operator: !=
            boolean tmp9 = ( tmp8.getIntValue() != 0 );
            if ( tmp9 ) {
                { // Invoke: error "..."
                    TclObject[] objv10 = TJC.grabObjv(interp, 2);
                    TclObject tmp11;
                    try {
                        // Arg 0 constant: error
                        objv10[0] = const0;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp12 = new StringBuffer(64);
                        sbtmp12.append("expected constant argument type at expr index ");
                        tmp11 = getVarScalar(interp, "expr_index", compiledLocals, 1);
                        sbtmp12.append(tmp11.toString());
                        sbtmp12.append(" of ");
                        sbtmp12.append("{");
                        tmp11 = getVarScalar(interp, "types", compiledLocals, 4);
                        sbtmp12.append(tmp11.toString());
                        sbtmp12.append("}");
                        tmp11 = TclString.newInstance(sbtmp12);
                        tmp11.preserve();
                        objv10[1] = tmp11;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv10, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp11 = objv10[1];
                        if ( tmp11 != null ) {
                            tmp11.release();
                        }
                        TJC.releaseObjv(interp, objv10, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set expr_str [...]
            TclObject tmp13;
            { // Invoke: lindex $values $expr_index
                TclObject tmp14 = null;
                TclObject tmp15;
                try {
                    tmp14 = getVarScalar(interp, "values", compiledLocals, 5);
                    tmp14.preserve();
                    tmp15 = getVarScalar(interp, "expr_index", compiledLocals, 1);
                    TJC.lindexNonconst(interp, tmp14, tmp15);
                } finally {
                    if ( tmp14 != null ) {
                        tmp14.release();
                    }
                }
            } // End Invoke: lindex
            tmp13 = interp.getResult();
            setVarScalar(interp, "expr_str", tmp13, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: set simple_bool 0
            setVarScalar(interp, "simple_bool", const1, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: if ... ... elseif ... ...
            // Binary operator: () || ()
            // Binary operator: $expr_str eq 1
            TclObject tmp16 = getVarScalar(interp, "expr_str", compiledLocals, 6);
            String tmp17 = tmp16.toString();
            ExprValue tmp18 = evs0;
            tmp18.setIntValue(1);
            boolean tmp19 = tmp17.equals(tmp18.getStringValue());
            tmp18.setIntValue(tmp19);
            // End Binary operator: eq
            if (!tmp18.getBooleanValue(interp)) {
            // Binary operator: $expr_str eq "true"
            TclObject tmp20 = getVarScalar(interp, "expr_str", compiledLocals, 6);
            boolean tmp21 = tmp20.toString().equals("true");
            ExprValue tmp22 = evs1;
            tmp22.setIntValue(tmp21);
            // End Binary operator: eq
            tmp18.setIntValue(tmp22.getBooleanValue(interp));
            } else {
            tmp18.setIntValue(1);
            } // End if: !()
            // End Binary operator: ||
            boolean tmp23 = ( tmp18.getIntValue() != 0 );
            if ( tmp23 ) {
                { // Invoke: set simple_bool 1
                    setVarScalar(interp, "simple_bool", const2, compiledLocals, 7);
                } // End Invoke: set
                { // Invoke: set simple_bool_value "true"
                    setVarScalar(interp, "simple_bool_value", const3, compiledLocals, 8);
                } // End Invoke: set
            } else {
                // Binary operator: () || ()
                // Binary operator: $expr_str eq 0
                TclObject tmp24 = getVarScalar(interp, "expr_str", compiledLocals, 6);
                String tmp25 = tmp24.toString();
                ExprValue tmp26 = evs0;
                tmp26.setIntValue(0);
                boolean tmp27 = tmp25.equals(tmp26.getStringValue());
                tmp26.setIntValue(tmp27);
                // End Binary operator: eq
                if (!tmp26.getBooleanValue(interp)) {
                // Binary operator: $expr_str eq "false"
                TclObject tmp28 = getVarScalar(interp, "expr_str", compiledLocals, 6);
                boolean tmp29 = tmp28.toString().equals("false");
                ExprValue tmp30 = evs1;
                tmp30.setIntValue(tmp29);
                // End Binary operator: eq
                tmp26.setIntValue(tmp30.getBooleanValue(interp));
                } else {
                tmp26.setIntValue(1);
                } // End if: !()
                // End Binary operator: ||
                boolean tmp31 = ( tmp26.getIntValue() != 0 );
                if ( tmp31 ) {
                    { // Invoke: set simple_bool 1
                        setVarScalar(interp, "simple_bool", const2, compiledLocals, 7);
                    } // End Invoke: set
                    { // Invoke: set simple_bool_value "false"
                        setVarScalar(interp, "simple_bool_value", const4, compiledLocals, 8);
                    } // End Invoke: set
                }
            }
        } // End Invoke: if
        { // Invoke: if {$simple_bool} ...
            TclObject tmp32 = getVarScalar(interp, "simple_bool", compiledLocals, 7);
            boolean tmp33 = TJC.getBoolean(interp, tmp32);
            if ( tmp33 ) {
                { // Invoke: return [...]
                    { // Invoke: list {constant boolean} $simple_bool_value $expr_str
                        TclObject tmp34 = TclList.newInstance();
                        TclObject tmp35;
                        try {
                            TclList.append(interp, tmp34, const5);
                            tmp35 = getVarScalar(interp, "simple_bool_value", compiledLocals, 8);
                            TclList.append(interp, tmp34, tmp35);
                            tmp35 = getVarScalar(interp, "expr_str", compiledLocals, 6);
                            TclList.append(interp, tmp34, tmp35);
                        } catch (TclException ex) {
                            tmp34.release();
                            throw ex;
                        }
                        interp.setResult(tmp34);
                    } // End Invoke: list
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: set script [...]
            TclObject tmp36;
            { // Invoke: descend_get_data $key script
                TclObject[] objv37 = TJC.grabObjv(interp, 3);
                TclObject tmp38;
                try {
                    // Arg 0 constant: descend_get_data
                    objv37[0] = const6;
                    // Arg 1 variable: $key
                    tmp38 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp38.preserve();
                    objv37[1] = tmp38;
                    // Arg 2 constant: script
                    objv37[2] = const7;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv37, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp38 = objv37[1];
                    if ( tmp38 != null ) {
                        tmp38.release();
                    }
                    TJC.releaseObjv(interp, objv37, 3);
                }
            } // End Invoke: descend_get_data
            tmp36 = interp.getResult();
            setVarScalar(interp, "script", tmp36, compiledLocals, 9);
        } // End Invoke: set
        { // Invoke: set tree [...]
            TclObject tmp39;
            { // Invoke: descend_get_data $key tree
                TclObject[] objv40 = TJC.grabObjv(interp, 3);
                TclObject tmp41;
                try {
                    // Arg 0 constant: descend_get_data
                    objv40[0] = const6;
                    // Arg 1 variable: $key
                    tmp41 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp41.preserve();
                    objv40[1] = tmp41;
                    // Arg 2 constant: tree
                    objv40[2] = const8;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv40, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp41 = objv40[1];
                    if ( tmp41 != null ) {
                        tmp41.release();
                    }
                    TJC.releaseObjv(interp, objv40, 3);
                }
            } // End Invoke: descend_get_data
            tmp39 = interp.getResult();
            setVarScalar(interp, "tree", tmp39, compiledLocals, 10);
        } // End Invoke: set
        { // Invoke: set stree [...]
            TclObject tmp42;
            { // Invoke: lindex $tree $expr_index
                TclObject tmp43 = null;
                TclObject tmp44;
                try {
                    tmp43 = getVarScalar(interp, "tree", compiledLocals, 10);
                    tmp43.preserve();
                    tmp44 = getVarScalar(interp, "expr_index", compiledLocals, 1);
                    TJC.lindexNonconst(interp, tmp43, tmp44);
                } finally {
                    if ( tmp43 != null ) {
                        tmp43.release();
                    }
                }
            } // End Invoke: lindex
            tmp42 = interp.getResult();
            setVarScalar(interp, "stree", tmp42, compiledLocals, 11);
        } // End Invoke: set
        { // Invoke: set range [...]
            TclObject tmp45;
            { // Invoke: ... $stree text
                TclObject[] objv46 = TJC.grabObjv(interp, 3);
                TclObject tmp47;
                try {
                    // Arg 0 constant: ...
                    objv46[0] = const9;
                    // Arg 1 variable: $stree
                    tmp47 = getVarScalar(interp, "stree", compiledLocals, 11);
                    tmp47.preserve();
                    objv46[1] = tmp47;
                    // Arg 2 constant: text
                    objv46[2] = const10;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                        ? cmdcache3.cmd : null), objv46, 0);
                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                        updateCmdCache(interp, 3);
                    }
                } finally {
                    tmp47 = objv46[1];
                    if ( tmp47 != null ) {
                        tmp47.release();
                    }
                    TJC.releaseObjv(interp, objv46, 3);
                }
            } // End Invoke: ...
            tmp45 = interp.getResult();
            setVarScalar(interp, "range", tmp45, compiledLocals, 12);
        } // End Invoke: set
        { // Invoke: set etree [...]
            TclObject tmp48;
            { // Invoke: parse expr $script $range
                TclObject[] objv49 = TJC.grabObjv(interp, 4);
                TclObject tmp50;
                try {
                    // Arg 0 constant: parse
                    objv49[0] = const11;
                    // Arg 1 constant: expr
                    objv49[1] = const12;
                    // Arg 2 variable: $script
                    tmp50 = getVarScalar(interp, "script", compiledLocals, 9);
                    tmp50.preserve();
                    objv49[2] = tmp50;
                    // Arg 3 variable: $range
                    tmp50 = getVarScalar(interp, "range", compiledLocals, 12);
                    tmp50.preserve();
                    objv49[3] = tmp50;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                        ? cmdcache4.cmd : null), objv49, 0);
                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                        updateCmdCache(interp, 4);
                    }
                } finally {
                    tmp50 = objv49[2];
                    if ( tmp50 != null ) {
                        tmp50.release();
                    }
                    tmp50 = objv49[3];
                    if ( tmp50 != null ) {
                        tmp50.release();
                    }
                    TJC.releaseObjv(interp, objv49, 4);
                }
            } // End Invoke: parse
            tmp48 = interp.getResult();
            setVarScalar(interp, "etree", tmp48, compiledLocals, 13);
        } // End Invoke: set
        { // Invoke: set ccmds [...]
            TclObject tmp51;
            { // Invoke: descend_commands $key container
                TclObject[] objv52 = TJC.grabObjv(interp, 3);
                TclObject tmp53;
                try {
                    // Arg 0 constant: descend_commands
                    objv52[0] = const13;
                    // Arg 1 variable: $key
                    tmp53 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp53.preserve();
                    objv52[1] = tmp53;
                    // Arg 2 constant: container
                    objv52[2] = const14;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                        ? cmdcache5.cmd : null), objv52, 0);
                    if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                        updateCmdCache(interp, 5);
                    }
                } finally {
                    tmp53 = objv52[1];
                    if ( tmp53 != null ) {
                        tmp53.release();
                    }
                    TJC.releaseObjv(interp, objv52, 3);
                }
            } // End Invoke: descend_commands
            tmp51 = interp.getResult();
            setVarScalar(interp, "ccmds", tmp51, compiledLocals, 14);
        } // End Invoke: set
        { // Invoke: set tuple [...]
            TclObject tmp54;
            { // Invoke: ... $key $expr_index
                TclObject[] objv55 = TJC.grabObjv(interp, 3);
                TclObject tmp56;
                try {
                    // Arg 0 constant: ...
                    objv55[0] = const15;
                    // Arg 1 variable: $key
                    tmp56 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp56.preserve();
                    objv55[1] = tmp56;
                    // Arg 2 variable: $expr_index
                    tmp56 = getVarScalar(interp, "expr_index", compiledLocals, 1);
                    tmp56.preserve();
                    objv55[2] = tmp56;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                        ? cmdcache6.cmd : null), objv55, 0);
                    if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                        updateCmdCache(interp, 6);
                    }
                } finally {
                    tmp56 = objv55[1];
                    if ( tmp56 != null ) {
                        tmp56.release();
                    }
                    tmp56 = objv55[2];
                    if ( tmp56 != null ) {
                        tmp56.release();
                    }
                    TJC.releaseObjv(interp, objv55, 3);
                }
            } // End Invoke: ...
            tmp54 = interp.getResult();
            setVarScalar(interp, "tuple", tmp54, compiledLocals, 15);
        } // End Invoke: set
        { // Invoke: if ... ... else ...
            // Binary operator: [...] == "expr"
            { // Invoke: lindex $tuple 0
                TclObject tmp57 = getVarScalar(interp, "tuple", compiledLocals, 15);
                tmp57 = TclList.index(interp, tmp57, 0);
                if ( tmp57 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp57);
                }
            } // End Invoke: lindex
            TclObject tmp58 = interp.getResult();
            boolean tmp59 = tmp58.toString().equals("expr");
            ExprValue tmp60 = evs0;
            tmp60.setIntValue(tmp59);
            // End Binary operator: ==
            boolean tmp61 = ( tmp60.getIntValue() != 0 );
            if ( tmp61 ) {
                { // Invoke: set argument_ccmds $ccmds
                    TclObject tmp62;
                    tmp62 = getVarScalar(interp, "ccmds", compiledLocals, 14);
                    setVarScalar(interp, "argument_ccmds", tmp62, compiledLocals, 16);
                } // End Invoke: set
            } else {
                { // Invoke: set container_index [...]
                    TclObject tmp63;
                    { // Invoke: lindex $tuple 1
                        TclObject tmp64 = getVarScalar(interp, "tuple", compiledLocals, 15);
                        tmp64 = TclList.index(interp, tmp64, 1);
                        if ( tmp64 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp64);
                        }
                    } // End Invoke: lindex
                    tmp63 = interp.getResult();
                    setVarScalar(interp, "container_index", tmp63, compiledLocals, 17);
                } // End Invoke: set
                { // Invoke: set argument_ccmds [...]
                    TclObject tmp65;
                    { // Invoke: lindex $ccmds $container_index
                        TclObject tmp66 = null;
                        TclObject tmp67;
                        try {
                            tmp66 = getVarScalar(interp, "ccmds", compiledLocals, 14);
                            tmp66.preserve();
                            tmp67 = getVarScalar(interp, "container_index", compiledLocals, 17);
                            TJC.lindexNonconst(interp, tmp66, tmp67);
                        } finally {
                            if ( tmp66 != null ) {
                                tmp66.release();
                            }
                        }
                    } // End Invoke: lindex
                    tmp65 = interp.getResult();
                    setVarScalar(interp, "argument_ccmds", tmp65, compiledLocals, 16);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: ... $key $argument_ccmds
            TclObject[] objv68 = TJC.grabObjv(interp, 3);
            TclObject tmp69;
            try {
                // Arg 0 constant: ...
                objv68[0] = const16;
                // Arg 1 variable: $key
                tmp69 = getVarScalar(interp, "key", compiledLocals, 0);
                tmp69.preserve();
                objv68[1] = tmp69;
                // Arg 2 variable: $argument_ccmds
                tmp69 = getVarScalar(interp, "argument_ccmds", compiledLocals, 16);
                tmp69.preserve();
                objv68[2] = tmp69;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                    ? cmdcache7.cmd : null), objv68, 0);
                if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                    updateCmdCache(interp, 7);
                }
            } finally {
                tmp69 = objv68[1];
                if ( tmp69 != null ) {
                    tmp69.release();
                }
                tmp69 = objv68[2];
                if ( tmp69 != null ) {
                    tmp69.release();
                }
                TJC.releaseObjv(interp, objv68, 3);
            }
        } // End Invoke: ...
        { // Invoke: set saved_expr_eval_key $...
            TclObject tmp70;
            tmp70 = getVarArray(interp, "_compileproc", "expr_eval_key", compiledLocals, 2);
            setVarScalar(interp, "saved_expr_eval_key", tmp70, compiledLocals, 18);
        } // End Invoke: set
        { // Invoke: set ... $...
            TclObject tmp71;
            tmp71 = getVarArray(interp, "_compileproc", "expr_eval_buffer", compiledLocals, 2);
            setVarScalar(interp, "saved_expr_eval_buffer", tmp71, compiledLocals, 19);
        } // End Invoke: set
        { // Invoke: set ... $...
            TclObject tmp72;
            tmp72 = getVarArray(interp, "_compileproc", "expr_eval_expressions", compiledLocals, 2);
            setVarScalar(interp, "saved_expr_eval_expressions", tmp72, compiledLocals, 20);
        } // End Invoke: set
        { // Invoke: set ... $key
            TclObject tmp73;
            tmp73 = getVarScalar(interp, "key", compiledLocals, 0);
            setVarArray(interp, "_compileproc", "expr_eval_key", tmp73, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set ... {}
            setVarArray(interp, "_compileproc", "expr_eval_buffer", const17, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set ... 0
            setVarArray(interp, "_compileproc", "expr_eval_expressions", const1, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set type_value [...]
            TclObject tmp74;
            { // Invoke: parse_expr_iterate $script $etree ...
                TclObject[] objv75 = TJC.grabObjv(interp, 4);
                TclObject tmp76;
                try {
                    // Arg 0 constant: parse_expr_iterate
                    objv75[0] = const18;
                    // Arg 1 variable: $script
                    tmp76 = getVarScalar(interp, "script", compiledLocals, 9);
                    tmp76.preserve();
                    objv75[1] = tmp76;
                    // Arg 2 variable: $etree
                    tmp76 = getVarScalar(interp, "etree", compiledLocals, 13);
                    tmp76.preserve();
                    objv75[2] = tmp76;
                    // Arg 3 constant: ...
                    objv75[3] = const19;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                        ? cmdcache8.cmd : null), objv75, 0);
                    if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                        updateCmdCache(interp, 8);
                    }
                } finally {
                    tmp76 = objv75[1];
                    if ( tmp76 != null ) {
                        tmp76.release();
                    }
                    tmp76 = objv75[2];
                    if ( tmp76 != null ) {
                        tmp76.release();
                    }
                    TJC.releaseObjv(interp, objv75, 4);
                }
            } // End Invoke: parse_expr_iterate
            tmp74 = interp.getResult();
            setVarScalar(interp, "type_value", tmp74, compiledLocals, 21);
        } // End Invoke: set
        { // Invoke: set expr_eval_buffer $...
            TclObject tmp77;
            tmp77 = getVarArray(interp, "_compileproc", "expr_eval_buffer", compiledLocals, 2);
            setVarScalar(interp, "expr_eval_buffer", tmp77, compiledLocals, 22);
        } // End Invoke: set
        { // Invoke: set ... $...
            TclObject tmp78;
            tmp78 = getVarArray(interp, "_compileproc", "expr_eval_expressions", compiledLocals, 2);
            setVarScalar(interp, "expr_eval_expressions", tmp78, compiledLocals, 23);
        } // End Invoke: set
        { // Invoke: set ... $saved_expr_eval_key
            TclObject tmp79;
            tmp79 = getVarScalar(interp, "saved_expr_eval_key", compiledLocals, 18);
            setVarArray(interp, "_compileproc", "expr_eval_key", tmp79, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set ... $...
            TclObject tmp80;
            tmp80 = getVarScalar(interp, "saved_expr_eval_buffer", compiledLocals, 19);
            setVarArray(interp, "_compileproc", "expr_eval_buffer", tmp80, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set ... $...
            TclObject tmp81;
            tmp81 = getVarScalar(interp, "saved_expr_eval_expressions", compiledLocals, 20);
            setVarArray(interp, "_compileproc", "expr_eval_expressions", tmp81, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: ... $key
            TclObject[] objv82 = TJC.grabObjv(interp, 2);
            TclObject tmp83;
            try {
                // Arg 0 constant: ...
                objv82[0] = const20;
                // Arg 1 variable: $key
                tmp83 = getVarScalar(interp, "key", compiledLocals, 0);
                tmp83.preserve();
                objv82[1] = tmp83;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                    ? cmdcache9.cmd : null), objv82, 0);
                if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                    updateCmdCache(interp, 9);
                }
            } finally {
                tmp83 = objv82[1];
                if ( tmp83 != null ) {
                    tmp83.release();
                }
                TJC.releaseObjv(interp, objv82, 2);
            }
        } // End Invoke: ...
        { // Invoke: set type [...]
            TclObject tmp84;
            { // Invoke: lindex $type_value 0
                TclObject tmp85 = getVarScalar(interp, "type_value", compiledLocals, 21);
                tmp85 = TclList.index(interp, tmp85, 0);
                if ( tmp85 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp85);
                }
            } // End Invoke: lindex
            tmp84 = interp.getResult();
            setVarScalar(interp, "type", tmp84, compiledLocals, 24);
        } // End Invoke: set
        { // Invoke: set value [...]
            TclObject tmp86;
            { // Invoke: lindex $type_value 1
                TclObject tmp87 = getVarScalar(interp, "type_value", compiledLocals, 21);
                tmp87 = TclList.index(interp, tmp87, 1);
                if ( tmp87 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp87);
                }
            } // End Invoke: lindex
            tmp86 = interp.getResult();
            setVarScalar(interp, "value", tmp86, compiledLocals, 25);
        } // End Invoke: set
        { // Invoke: return $type_value
            TclObject tmp88 = getVarScalar(interp, "type_value", compiledLocals, 21);
            interp.resetResult();
            interp.setResult(tmp88);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_expr_evaluate");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;
    TclObject const18;
    TclObject const19;
    TclObject const20;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("error");
        const0.preserve(); const0.preserve();
        const1 = TclInteger.newInstance(0);
        const1.preserve(); const1.preserve();
        const2 = TclInteger.newInstance(1);
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("true");
        TclBoolean.get(interp, const3);
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("false");
        TclBoolean.get(interp, const4);
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("constant boolean");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("descend_get_data");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("script");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("tree");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("parse_get_simple_text_range");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("text");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("parse");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("expr");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("descend_commands");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("container");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("compileproc_expr_container_index");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance("compileproc_childkey_reset");
        const16.preserve(); const16.preserve();
        const17 = TclString.newInstance("");
        const17.preserve(); const17.preserve();
        const18 = TclString.newInstance("parse_expr_iterate");
        const18.preserve(); const18.preserve();
        const19 = TclString.newInstance("compileproc_expr_evaluate_callback");
        const19.preserve(); const19.preserve();
        const20 = TclString.newInstance("compileproc_childkey_validate");
        const20.preserve(); const20.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;
    WrappedCommand cmdcache8;
    int cmdcache8_cmdEpoch;
    WrappedCommand cmdcache9;
    int cmdcache9_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                cmdcache8 = TJC.INVALID_COMMAND_CACHE;
                cmdcache8_cmdEpoch = 0;
                cmdcache9 = TJC.INVALID_COMMAND_CACHE;
                cmdcache9_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "error";
                break;
            }
            case 2: {
                cmdName = "descend_get_data";
                break;
            }
            case 3: {
                cmdName = "parse_get_simple_text_range";
                break;
            }
            case 4: {
                cmdName = "parse";
                break;
            }
            case 5: {
                cmdName = "descend_commands";
                break;
            }
            case 6: {
                cmdName = "compileproc_expr_container_index";
                break;
            }
            case 7: {
                cmdName = "compileproc_childkey_reset";
                break;
            }
            case 8: {
                cmdName = "parse_expr_iterate";
                break;
            }
            case 9: {
                cmdName = "compileproc_childkey_validate";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
            case 8: {
                cmdcache8 = lwcmd;
                cmdcache8_cmdEpoch = cmdEpoch;
                break;
            }
            case 9: {
                cmdcache9 = lwcmd;
                cmdcache9_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "expr_index",
        "_compileproc",
        "_compileproc_key_info",
        "types",
        "values",
        "expr_str",
        "simple_bool",
        "simple_bool_value",
        "script",
        "tree",
        "stree",
        "range",
        "etree",
        "ccmds",
        "tuple",
        "argument_ccmds",
        "container_index",
        "saved_expr_eval_key",
        "saved_expr_eval_buffer",
        "saved_expr_eval_expressions",
        "type_value",
        "expr_eval_buffer",
        "expr_eval_expressions",
        "type",
        "value"
    };
} // end class CompileprocExprEvaluateCmd

