// TJC implementation of procedure compileproc_expr_evaluate_emit_exprvalue
package tjc;
import tcl.lang.*;

public class CompileprocExprEvaluateEmitExprvalueCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 32, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length < 2 || objv.length > 3) {
            throw new TclNumArgsException(interp, 1, objv, "tuple ?genflags?");
        }
        setVarScalar(interp, "tuple", objv[1], compiledLocals, 0);
        setVarScalar(interp, "genflags", 
            ((objv.length <= 2) ? const0 : objv[2]), compiledLocals, 1);
        { // Invoke: set ... 0
            setVarScalar(interp, "no_exprvalue_for_tclobject", const1, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set no_str_for_exprvalue 0
            setVarScalar(interp, "no_str_for_exprvalue", const1, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set gencode 1
            setVarScalar(interp, "gencode", const2, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: () != 0
            // Binary operator: [...] % 2
            { // Invoke: llength $genflags
                TclObject tmp0 = getVarScalar(interp, "genflags", compiledLocals, 1);
                int tmp1 = TclList.getLength(interp, tmp0);
                interp.setResult(tmp1);
            } // End Invoke: llength
            TclObject tmp2 = interp.getResult();
            ExprValue tmp3 = evs0;
            TJC.exprInitValue(interp, tmp3, tmp2);
            ExprValue tmp4 = evs1;
            tmp4.setIntValue(2);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MOD, tmp3, tmp4);
            // End Binary operator: %
            ExprValue tmp5 = evs1;
            tmp5.setIntValue(0);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp3, tmp5);
            // End Binary operator: !=
            boolean tmp6 = ( tmp3.getIntValue() != 0 );
            if ( tmp6 ) {
                { // Invoke: error "..."
                    TclObject[] objv7 = TJC.grabObjv(interp, 2);
                    TclObject tmp8;
                    try {
                        // Arg 0 constant: error
                        objv7[0] = const3;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp9 = new StringBuffer(64);
                        sbtmp9.append("genflags must have even number of flag value elements : ");
                        sbtmp9.append("{");
                        tmp8 = getVarScalar(interp, "genflags", compiledLocals, 1);
                        sbtmp9.append(tmp8.toString());
                        sbtmp9.append("}");
                        tmp8 = TclString.newInstance(sbtmp9);
                        tmp8.preserve();
                        objv7[1] = tmp8;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv7, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp8 = objv7[1];
                        if ( tmp8 != null ) {
                            tmp8.release();
                        }
                        TJC.releaseObjv(interp, objv7, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: foreach {flag value} $genflags ...
            TclObject tmp10 = null;
            try {
                tmp10 = getVarScalar(interp, "genflags", compiledLocals, 1);
                tmp10.preserve();
                final int tmp10_length = TclList.getLength(interp, tmp10);

                for ( int index11 = 0 ; index11 < tmp10_length ; index11 += 2 ) {
                    TclObject tmp12 = null;
                    if ( index11 < tmp10_length ) {
                        tmp12 = TclList.index(interp, tmp10, index11);
                    }
                    TclObject tmp13 = null;
                    if ( index11 + 1 < tmp10_length ) {
                        tmp13 = TclList.index(interp, tmp10, index11 + 1);
                    }
                    try {
                        if ( tmp12 == null ) {
                            setVarScalar(interp, "flag", "", compiledLocals, 5);
                        } else {
                            setVarScalar(interp, "flag", tmp12, compiledLocals, 5);
                        }
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "flag");
                    }
                    try {
                        if ( tmp13 == null ) {
                            setVarScalar(interp, "value", "", compiledLocals, 6);
                        } else {
                            setVarScalar(interp, "value", tmp13, compiledLocals, 6);
                        }
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "value");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: switch -- $flag {rtype} ... {nostr} ... {peek} ... default ...
                        TclObject tmp14 = getVarScalar(interp, "flag", compiledLocals, 5);
                        String tmp15 = tmp14.toString();
                        int tmp15_length = tmp15.length();
                        char tmp15_first = '\n';
                        if ( tmp15_length > 0 ) {
                            tmp15_first = tmp15.charAt(0);
                        }
                        if ( tmp15_length == 5 && tmp15_first == 'r'
                                && tmp15.compareTo("rtype") == 0 ) {
                            // Pattern {rtype}
                            { // Invoke: if ... ... elseif ... ... else ...
                                // Binary operator: $value == "ExprValue"
                                TclObject tmp16 = getVarScalar(interp, "value", compiledLocals, 6);
                                boolean tmp17 = tmp16.toString().equals("ExprValue");
                                ExprValue tmp18 = evs0;
                                tmp18.setIntValue(tmp17);
                                // End Binary operator: ==
                                boolean tmp19 = ( tmp18.getIntValue() != 0 );
                                if ( tmp19 ) {
                                } else {
                                    // Binary operator: $value == "TclObject"
                                    TclObject tmp20 = getVarScalar(interp, "value", compiledLocals, 6);
                                    boolean tmp21 = tmp20.toString().equals("TclObject");
                                    ExprValue tmp22 = evs0;
                                    tmp22.setIntValue(tmp21);
                                    // End Binary operator: ==
                                    boolean tmp23 = ( tmp22.getIntValue() != 0 );
                                    if ( tmp23 ) {
                                        { // Invoke: set ... 1
                                            setVarScalar(interp, "no_exprvalue_for_tclobject", const2, compiledLocals, 2);
                                        } // End Invoke: set
                                    } else {
                                        { // Invoke: error "..."
                                            TclObject[] objv24 = TJC.grabObjv(interp, 2);
                                            TclObject tmp25;
                                            try {
                                                // Arg 0 constant: error
                                                objv24[0] = const3;
                                                // Arg 1 word: "..."
                                                StringBuffer sbtmp26 = new StringBuffer(64);
                                                sbtmp26.append("unsupported rtype ");
                                                sbtmp26.append("\"");
                                                tmp25 = getVarScalar(interp, "value", compiledLocals, 6);
                                                sbtmp26.append(tmp25.toString());
                                                sbtmp26.append("\"");
                                                tmp25 = TclString.newInstance(sbtmp26);
                                                tmp25.preserve();
                                                objv24[1] = tmp25;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                                    ? cmdcache1.cmd : null), objv24, 0);
                                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                                    updateCmdCache(interp, 1);
                                                }
                                            } finally {
                                                tmp25 = objv24[1];
                                                if ( tmp25 != null ) {
                                                    tmp25.release();
                                                }
                                                TJC.releaseObjv(interp, objv24, 2);
                                            }
                                        } // End Invoke: error
                                    }
                                }
                            } // End Invoke: if
                        } else if ( tmp15_length == 5 && tmp15_first == 'n'
                                && tmp15.compareTo("nostr") == 0 ) {
                            // Pattern {nostr}
                            { // Invoke: if {$value} ...
                                TclObject tmp27 = getVarScalar(interp, "value", compiledLocals, 6);
                                boolean tmp28 = TJC.getBoolean(interp, tmp27);
                                if ( tmp28 ) {
                                    { // Invoke: set no_str_for_exprvalue 1
                                        setVarScalar(interp, "no_str_for_exprvalue", const2, compiledLocals, 3);
                                    } // End Invoke: set
                                }
                            } // End Invoke: if
                        } else if ( tmp15_length == 4 && tmp15_first == 'p'
                                && tmp15.compareTo("peek") == 0 ) {
                            // Pattern {peek}
                            { // Invoke: if {$value} ...
                                TclObject tmp29 = getVarScalar(interp, "value", compiledLocals, 6);
                                boolean tmp30 = TJC.getBoolean(interp, tmp29);
                                if ( tmp30 ) {
                                    { // Invoke: set gencode 0
                                        setVarScalar(interp, "gencode", const1, compiledLocals, 4);
                                    } // End Invoke: set
                                }
                            } // End Invoke: if
                        } else {
                            // Pattern default
                            { // Invoke: error "..."
                                TclObject[] objv31 = TJC.grabObjv(interp, 2);
                                TclObject tmp32;
                                try {
                                    // Arg 0 constant: error
                                    objv31[0] = const3;
                                    // Arg 1 word: "..."
                                    StringBuffer sbtmp33 = new StringBuffer(64);
                                    sbtmp33.append("unsupported flag ");
                                    sbtmp33.append("\"");
                                    tmp32 = getVarScalar(interp, "flag", compiledLocals, 5);
                                    sbtmp33.append(tmp32.toString());
                                    sbtmp33.append("\"");
                                    tmp32 = TclString.newInstance(sbtmp33);
                                    tmp32.preserve();
                                    objv31[1] = tmp32;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                        ? cmdcache1.cmd : null), objv31, 0);
                                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                        updateCmdCache(interp, 1);
                                    }
                                } finally {
                                    tmp32 = objv31[1];
                                    if ( tmp32 != null ) {
                                        tmp32.release();
                                    }
                                    TJC.releaseObjv(interp, objv31, 2);
                                }
                            } // End Invoke: error
                        }
                    } // End Invoke: switch
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
            } finally {
                if ( tmp10 != null ) {
                    tmp10.release();
                }
            }
        } // End Invoke: foreach
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const0, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: set infostr ""
            setVarScalar(interp, "infostr", const0, compiledLocals, 8);
        } // End Invoke: set
        { // Invoke: set result_type ""
            setVarScalar(interp, "result_type", const0, compiledLocals, 9);
        } // End Invoke: set
        { // Invoke: set result_symbol ""
            setVarScalar(interp, "result_symbol", const0, compiledLocals, 10);
        } // End Invoke: set
        { // Invoke: set value_symbol ""
            setVarScalar(interp, "value_symbol", const0, compiledLocals, 11);
        } // End Invoke: set
        { // Invoke: set srep ""
            setVarScalar(interp, "srep", const0, compiledLocals, 12);
        } // End Invoke: set
        { // Invoke: set type [...]
            TclObject tmp34;
            { // Invoke: lindex $tuple 0
                TclObject tmp35 = getVarScalar(interp, "tuple", compiledLocals, 0);
                tmp35 = TclList.index(interp, tmp35, 0);
                if ( tmp35 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp35);
                }
            } // End Invoke: lindex
            tmp34 = interp.getResult();
            setVarScalar(interp, "type", tmp34, compiledLocals, 13);
        } // End Invoke: set
        { // Invoke: set value [...]
            TclObject tmp36;
            { // Invoke: lindex $tuple 1
                TclObject tmp37 = getVarScalar(interp, "tuple", compiledLocals, 0);
                tmp37 = TclList.index(interp, tmp37, 1);
                if ( tmp37 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp37);
                }
            } // End Invoke: lindex
            tmp36 = interp.getResult();
            setVarScalar(interp, "value", tmp36, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: set ev_types {}
            setVarScalar(interp, "ev_types", const0, compiledLocals, 14);
        } // End Invoke: set
        { // Invoke: switch -exact -- $type {constant int} - {constant double} ... {constant boolean} - {constant string} - ... - {constant} ... {variable scalar} - {variable array} ... {unary operator} ... {binary operator} ... {ternary operator} ... {math function} ... {command operand} ... {word operand} ... default ...
            TclObject tmp38 = getVarScalar(interp, "type", compiledLocals, 13);
            String tmp39 = tmp38.toString();
            int tmp39_length = tmp39.length();
            char tmp39_first = '\n';
            if ( tmp39_length > 0 ) {
                tmp39_first = tmp39.charAt(0);
            }
            if ( ( tmp39_length == 12 && tmp39_first == 'c'
                    && tmp39.compareTo("constant int") == 0 ) ||
                ( tmp39_length == 15 && tmp39_first == 'c'
                    && tmp39.compareTo("constant double") == 0 ) ) {
                // Pattern {constant double}
                { // Invoke: if ... ... else ...
                    // Binary operator: $type eq "constant int"
                    TclObject tmp40 = getVarScalar(interp, "type", compiledLocals, 13);
                    boolean tmp41 = tmp40.toString().equals("constant int");
                    ExprValue tmp42 = evs0;
                    tmp42.setIntValue(tmp41);
                    // End Binary operator: eq
                    boolean tmp43 = ( tmp42.getIntValue() != 0 );
                    if ( tmp43 ) {
                        { // Invoke: set result_type "int literal"
                            setVarScalar(interp, "result_type", const4, compiledLocals, 9);
                        } // End Invoke: set
                        { // Invoke: lappend ev_types int
                            TclObject[] objv44 = TJC.grabObjv(interp, 1);
                            TclObject tmp45;
                            try {
                                // Arg 2 constant: int
                                objv44[0] = const5;
                                interp.resetResult();
                                lappendVarScalar(interp, "ev_types", objv44, compiledLocals, 14);
                            } finally {
                                TJC.releaseObjv(interp, objv44, 1);
                            }
                        } // End Invoke: lappend
                    } else {
                        { // Invoke: set result_type "double literal"
                            setVarScalar(interp, "result_type", const6, compiledLocals, 9);
                        } // End Invoke: set
                        { // Invoke: lappend ev_types double
                            TclObject[] objv46 = TJC.grabObjv(interp, 1);
                            TclObject tmp47;
                            try {
                                // Arg 2 constant: double
                                objv46[0] = const7;
                                interp.resetResult();
                                lappendVarScalar(interp, "ev_types", objv46, compiledLocals, 14);
                            } finally {
                                TJC.releaseObjv(interp, objv46, 1);
                            }
                        } // End Invoke: lappend
                    }
                } // End Invoke: if
                { // Invoke: set result_symbol $value
                    TclObject tmp48;
                    tmp48 = getVarScalar(interp, "value", compiledLocals, 6);
                    setVarScalar(interp, "result_symbol", tmp48, compiledLocals, 10);
                } // End Invoke: set
                { // Invoke: set infostr $value
                    TclObject tmp49;
                    tmp49 = getVarScalar(interp, "value", compiledLocals, 6);
                    setVarScalar(interp, "infostr", tmp49, compiledLocals, 8);
                } // End Invoke: set
                { // Invoke: set srep null
                    setVarScalar(interp, "srep", const8, compiledLocals, 12);
                } // End Invoke: set
            } else if ( ( tmp39_length == 16 && tmp39_first == 'c'
                    && tmp39.compareTo("constant boolean") == 0 ) ||
                ( tmp39_length == 15 && tmp39_first == 'c'
                    && tmp39.compareTo("constant string") == 0 ) ||
                ( tmp39_length == 22 && tmp39_first == 'c'
                    && tmp39.compareTo("constant braced string") == 0 ) ||
                ( tmp39_length == 8 && tmp39_first == 'c'
                    && tmp39.compareTo("constant") == 0 ) ) {
                // Pattern {constant}
                { // Invoke: if ... ...
                    // Binary operator: $type == "constant boolean"
                    TclObject tmp50 = getVarScalar(interp, "type", compiledLocals, 13);
                    boolean tmp51 = tmp50.toString().equals("constant boolean");
                    ExprValue tmp52 = evs0;
                    tmp52.setIntValue(tmp51);
                    // End Binary operator: ==
                    boolean tmp53 = ( tmp52.getIntValue() != 0 );
                    if ( tmp53 ) {
                        { // Invoke: set value [...]
                            TclObject tmp54;
                            { // Invoke: lindex $tuple 2
                                TclObject tmp55 = getVarScalar(interp, "tuple", compiledLocals, 0);
                                tmp55 = TclList.index(interp, tmp55, 2);
                                if ( tmp55 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp55);
                                }
                            } // End Invoke: lindex
                            tmp54 = interp.getResult();
                            setVarScalar(interp, "value", tmp54, compiledLocals, 6);
                        } // End Invoke: set
                    }
                } // End Invoke: if
                { // Invoke: set jvalue [...]
                    TclObject tmp56;
                    { // Invoke: ... $value
                        TclObject[] objv57 = TJC.grabObjv(interp, 2);
                        TclObject tmp58;
                        try {
                            // Arg 0 constant: ...
                            objv57[0] = const9;
                            // Arg 1 variable: $value
                            tmp58 = getVarScalar(interp, "value", compiledLocals, 6);
                            tmp58.preserve();
                            objv57[1] = tmp58;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv57, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            tmp58 = objv57[1];
                            if ( tmp58 != null ) {
                                tmp58.release();
                            }
                            TJC.releaseObjv(interp, objv57, 2);
                        }
                    } // End Invoke: ...
                    tmp56 = interp.getResult();
                    setVarScalar(interp, "jvalue", tmp56, compiledLocals, 15);
                } // End Invoke: set
                { // Invoke: if ... ...
                    // Binary operator: $type == "constant string"
                    TclObject tmp59 = getVarScalar(interp, "type", compiledLocals, 13);
                    boolean tmp60 = tmp59.toString().equals("constant string");
                    ExprValue tmp61 = evs0;
                    tmp61.setIntValue(tmp60);
                    // End Binary operator: ==
                    boolean tmp62 = ( tmp61.getIntValue() != 0 );
                    if ( tmp62 ) {
                        { // Invoke: set value [...]
                            TclObject tmp63;
                            { // Invoke: subst -nocommands -novariables $value
                                TclObject[] objv64 = TJC.grabObjv(interp, 4);
                                TclObject tmp65;
                                try {
                                    // Arg 0 constant: subst
                                    objv64[0] = const10;
                                    // Arg 1 constant: -nocommands
                                    objv64[1] = const11;
                                    // Arg 2 constant: -novariables
                                    objv64[2] = const12;
                                    // Arg 3 variable: $value
                                    tmp65 = getVarScalar(interp, "value", compiledLocals, 6);
                                    tmp65.preserve();
                                    objv64[3] = tmp65;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                        ? cmdcache3.cmd : null), objv64, 0);
                                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                        updateCmdCache(interp, 3);
                                    }
                                } finally {
                                    tmp65 = objv64[3];
                                    if ( tmp65 != null ) {
                                        tmp65.release();
                                    }
                                    TJC.releaseObjv(interp, objv64, 4);
                                }
                            } // End Invoke: subst
                            tmp63 = interp.getResult();
                            setVarScalar(interp, "value", tmp63, compiledLocals, 6);
                        } // End Invoke: set
                    }
                } // End Invoke: if
                { // Invoke: set is_integer [...]
                    TclObject tmp66;
                    { // Invoke: ... $value
                        TclObject[] objv67 = TJC.grabObjv(interp, 2);
                        TclObject tmp68;
                        try {
                            // Arg 0 constant: ...
                            objv67[0] = const13;
                            // Arg 1 variable: $value
                            tmp68 = getVarScalar(interp, "value", compiledLocals, 6);
                            tmp68.preserve();
                            objv67[1] = tmp68;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                ? cmdcache4.cmd : null), objv67, 0);
                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                updateCmdCache(interp, 4);
                            }
                        } finally {
                            tmp68 = objv67[1];
                            if ( tmp68 != null ) {
                                tmp68.release();
                            }
                            TJC.releaseObjv(interp, objv67, 2);
                        }
                    } // End Invoke: ...
                    tmp66 = interp.getResult();
                    setVarScalar(interp, "is_integer", tmp66, compiledLocals, 16);
                } // End Invoke: set
                { // Invoke: set is_double [...]
                    TclObject tmp69;
                    { // Invoke: ... $value
                        TclObject[] objv70 = TJC.grabObjv(interp, 2);
                        TclObject tmp71;
                        try {
                            // Arg 0 constant: ...
                            objv70[0] = const14;
                            // Arg 1 variable: $value
                            tmp71 = getVarScalar(interp, "value", compiledLocals, 6);
                            tmp71.preserve();
                            objv70[1] = tmp71;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                ? cmdcache5.cmd : null), objv70, 0);
                            if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                updateCmdCache(interp, 5);
                            }
                        } finally {
                            tmp71 = objv70[1];
                            if ( tmp71 != null ) {
                                tmp71.release();
                            }
                            TJC.releaseObjv(interp, objv70, 2);
                        }
                    } // End Invoke: ...
                    tmp69 = interp.getResult();
                    setVarScalar(interp, "is_double", tmp69, compiledLocals, 17);
                } // End Invoke: set
                { // Invoke: if ... ... else ...
                    // Binary operator: $is_integer || $is_double
                    TclObject tmp72 = getVarScalar(interp, "is_integer", compiledLocals, 16);
                    ExprValue tmp73 = evs0;
                    TJC.exprInitValue(interp, tmp73, tmp72);
                    if (!tmp73.getBooleanValue(interp)) {
                    TclObject tmp74 = getVarScalar(interp, "is_double", compiledLocals, 17);
                    ExprValue tmp75 = evs1;
                    TJC.exprInitValue(interp, tmp75, tmp74);
                    tmp73.setIntValue(tmp75.getBooleanValue(interp));
                    } else {
                    tmp73.setIntValue(1);
                    } // End if: !$is_integer
                    // End Binary operator: ||
                    boolean tmp76 = ( tmp73.getIntValue() != 0 );
                    if ( tmp76 ) {
                        { // Invoke: set tuple [...]
                            TclObject tmp77;
                            { // Invoke: ... $value
                                TclObject[] objv78 = TJC.grabObjv(interp, 2);
                                TclObject tmp79;
                                try {
                                    // Arg 0 constant: ...
                                    objv78[0] = const15;
                                    // Arg 1 variable: $value
                                    tmp79 = getVarScalar(interp, "value", compiledLocals, 6);
                                    tmp79.preserve();
                                    objv78[1] = tmp79;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                        ? cmdcache6.cmd : null), objv78, 0);
                                    if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                        updateCmdCache(interp, 6);
                                    }
                                } finally {
                                    tmp79 = objv78[1];
                                    if ( tmp79 != null ) {
                                        tmp79.release();
                                    }
                                    TJC.releaseObjv(interp, objv78, 2);
                                }
                            } // End Invoke: ...
                            tmp77 = interp.getResult();
                            setVarScalar(interp, "tuple", tmp77, compiledLocals, 0);
                        } // End Invoke: set
                        { // Invoke: set stringrep_matches [...]
                            TclObject tmp80;
                            { // Invoke: lindex $tuple 0
                                TclObject tmp81 = getVarScalar(interp, "tuple", compiledLocals, 0);
                                tmp81 = TclList.index(interp, tmp81, 0);
                                if ( tmp81 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp81);
                                }
                            } // End Invoke: lindex
                            tmp80 = interp.getResult();
                            setVarScalar(interp, "stringrep_matches", tmp80, compiledLocals, 18);
                        } // End Invoke: set
                        { // Invoke: set parsed_number [...]
                            TclObject tmp82;
                            { // Invoke: lindex $tuple 1
                                TclObject tmp83 = getVarScalar(interp, "tuple", compiledLocals, 0);
                                tmp83 = TclList.index(interp, tmp83, 1);
                                if ( tmp83 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp83);
                                }
                            } // End Invoke: lindex
                            tmp82 = interp.getResult();
                            setVarScalar(interp, "parsed_number", tmp82, compiledLocals, 19);
                        } // End Invoke: set
                        { // Invoke: set printed_number [...]
                            TclObject tmp84;
                            { // Invoke: lindex $tuple 2
                                TclObject tmp85 = getVarScalar(interp, "tuple", compiledLocals, 0);
                                tmp85 = TclList.index(interp, tmp85, 2);
                                if ( tmp85 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp85);
                                }
                            } // End Invoke: lindex
                            tmp84 = interp.getResult();
                            setVarScalar(interp, "printed_number", tmp84, compiledLocals, 20);
                        } // End Invoke: set
                        { // Invoke: if {$stringrep_matches} ... else ...
                            TclObject tmp86 = getVarScalar(interp, "stringrep_matches", compiledLocals, 18);
                            boolean tmp87 = TJC.getBoolean(interp, tmp86);
                            if ( tmp87 ) {
                                { // Invoke: set srep null
                                    setVarScalar(interp, "srep", const8, compiledLocals, 12);
                                } // End Invoke: set
                            } else {
                                { // Invoke: set srep ...
                                    TclObject tmp88;
                                    StringBuffer sbtmp89 = new StringBuffer(64);
                                    sbtmp89.append("\"");
                                    tmp88 = getVarScalar(interp, "jvalue", compiledLocals, 15);
                                    sbtmp89.append(tmp88.toString());
                                    sbtmp89.append("\"");
                                    tmp88 = TclString.newInstance(sbtmp89);
                                    setVarScalar(interp, "srep", tmp88, compiledLocals, 12);
                                } // End Invoke: set
                            }
                        } // End Invoke: if
                        { // Invoke: if {$is_integer} ... else ...
                            TclObject tmp90 = getVarScalar(interp, "is_integer", compiledLocals, 16);
                            boolean tmp91 = TJC.getBoolean(interp, tmp90);
                            if ( tmp91 ) {
                                { // Invoke: set result_type "int literal"
                                    setVarScalar(interp, "result_type", const4, compiledLocals, 9);
                                } // End Invoke: set
                            } else {
                                { // Invoke: set result_type "double literal"
                                    setVarScalar(interp, "result_type", const6, compiledLocals, 9);
                                } // End Invoke: set
                            }
                        } // End Invoke: if
                        { // Invoke: set result_symbol $printed_number
                            TclObject tmp92;
                            tmp92 = getVarScalar(interp, "printed_number", compiledLocals, 20);
                            setVarScalar(interp, "result_symbol", tmp92, compiledLocals, 10);
                        } // End Invoke: set
                        { // Invoke: set infostr $printed_number
                            TclObject tmp93;
                            tmp93 = getVarScalar(interp, "printed_number", compiledLocals, 20);
                            setVarScalar(interp, "infostr", tmp93, compiledLocals, 8);
                        } // End Invoke: set
                    } else {
                        { // Invoke: set result_type "String"
                            setVarScalar(interp, "result_type", const16, compiledLocals, 9);
                        } // End Invoke: set
                        { // Invoke: set result_symbol ...
                            TclObject tmp94;
                            StringBuffer sbtmp95 = new StringBuffer(64);
                            sbtmp95.append("\"");
                            tmp94 = getVarScalar(interp, "jvalue", compiledLocals, 15);
                            sbtmp95.append(tmp94.toString());
                            sbtmp95.append("\"");
                            tmp94 = TclString.newInstance(sbtmp95);
                            setVarScalar(interp, "result_symbol", tmp94, compiledLocals, 10);
                        } // End Invoke: set
                        { // Invoke: set infostr $result_symbol
                            TclObject tmp96;
                            tmp96 = getVarScalar(interp, "result_symbol", compiledLocals, 10);
                            setVarScalar(interp, "infostr", tmp96, compiledLocals, 8);
                        } // End Invoke: set
                    }
                } // End Invoke: if
            } else if ( ( tmp39_length == 15 && tmp39_first == 'v'
                    && tmp39.compareTo("variable scalar") == 0 ) ||
                ( tmp39_length == 14 && tmp39_first == 'v'
                    && tmp39.compareTo("variable array") == 0 ) ) {
                // Pattern {variable array}
                { // Invoke: if ... ... else ...
                    // Binary operator: $type == "variable scalar"
                    TclObject tmp97 = getVarScalar(interp, "type", compiledLocals, 13);
                    boolean tmp98 = tmp97.toString().equals("variable scalar");
                    ExprValue tmp99 = evs0;
                    tmp99.setIntValue(tmp98);
                    // End Binary operator: ==
                    boolean tmp100 = ( tmp99.getIntValue() != 0 );
                    if ( tmp100 ) {
                        { // Invoke: set varname $value
                            TclObject tmp101;
                            tmp101 = getVarScalar(interp, "value", compiledLocals, 6);
                            setVarScalar(interp, "varname", tmp101, compiledLocals, 21);
                        } // End Invoke: set
                        { // Invoke: set vinfo [...]
                            TclObject tmp102;
                            { // Invoke: list scalar $value
                                TclObject tmp103 = TclList.newInstance();
                                TclObject tmp104;
                                try {
                                    TclList.append(interp, tmp103, const17);
                                    tmp104 = getVarScalar(interp, "value", compiledLocals, 6);
                                    TclList.append(interp, tmp103, tmp104);
                                } catch (TclException ex) {
                                    tmp103.release();
                                    throw ex;
                                }
                                interp.setResult(tmp103);
                            } // End Invoke: list
                            tmp102 = interp.getResult();
                            setVarScalar(interp, "vinfo", tmp102, compiledLocals, 22);
                        } // End Invoke: set
                    } else {
                        { // Invoke: set varname "..."
                            TclObject tmp105;
                            StringBuffer sbtmp106 = new StringBuffer(64);
                            { // Invoke: lindex $value 1 0
                                TclObject[] objv107 = TJC.grabObjv(interp, 4);
                                TclObject tmp108;
                                try {
                                    // Arg 0 constant: lindex
                                    objv107[0] = const18;
                                    // Arg 1 variable: $value
                                    tmp108 = getVarScalar(interp, "value", compiledLocals, 6);
                                    tmp108.preserve();
                                    objv107[1] = tmp108;
                                    // Arg 2 constant: 1
                                    objv107[2] = const2;
                                    // Arg 3 constant: 0
                                    objv107[3] = const1;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                        ? cmdcache7.cmd : null), objv107, 0);
                                    if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                        updateCmdCache(interp, 7);
                                    }
                                } finally {
                                    tmp108 = objv107[1];
                                    if ( tmp108 != null ) {
                                        tmp108.release();
                                    }
                                    TJC.releaseObjv(interp, objv107, 4);
                                }
                            } // End Invoke: lindex
                            tmp105 = interp.getResult();
                            sbtmp106.append(tmp105.toString());
                            sbtmp106.append("(...)");
                            tmp105 = TclString.newInstance(sbtmp106);
                            setVarScalar(interp, "varname", tmp105, compiledLocals, 21);
                        } // End Invoke: set
                        { // Invoke: set vinfo $value
                            TclObject tmp109;
                            tmp109 = getVarScalar(interp, "value", compiledLocals, 6);
                            setVarScalar(interp, "vinfo", tmp109, compiledLocals, 22);
                        } // End Invoke: set
                    }
                } // End Invoke: if
                { // Invoke: set result_type "TclObject"
                    setVarScalar(interp, "result_type", const19, compiledLocals, 9);
                } // End Invoke: set
                { // Invoke: set infostr ...
                    TclObject tmp110;
                    StringBuffer sbtmp111 = new StringBuffer(64);
                    sbtmp111.append("$");
                    tmp110 = getVarScalar(interp, "varname", compiledLocals, 21);
                    sbtmp111.append(tmp110.toString());
                    tmp110 = TclString.newInstance(sbtmp111);
                    setVarScalar(interp, "infostr", tmp110, compiledLocals, 8);
                } // End Invoke: set
                { // Invoke: if {$gencode} ...
                    TclObject tmp112 = getVarScalar(interp, "gencode", compiledLocals, 4);
                    boolean tmp113 = TJC.getBoolean(interp, tmp112);
                    if ( tmp113 ) {
                        { // Invoke: set tmpsymbol [...]
                            TclObject tmp114;
                            { // Invoke: ...
                                TclObject[] objv115 = TJC.grabObjv(interp, 1);
                                try {
                                    // Arg 0 constant: ...
                                    objv115[0] = const20;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                        ? cmdcache8.cmd : null), objv115, 0);
                                    if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                        updateCmdCache(interp, 8);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv115, 1);
                                }
                            } // End Invoke: ...
                            tmp114 = interp.getResult();
                            setVarScalar(interp, "tmpsymbol", tmp114, compiledLocals, 23);
                        } // End Invoke: set
                        { // Invoke: append buffer [...]
                            TclObject[] objv116 = TJC.grabObjv(interp, 1);
                            TclObject tmp117;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: ... $tmpsymbol $vinfo
                                    TclObject[] objv118 = TJC.grabObjv(interp, 3);
                                    TclObject tmp119;
                                    try {
                                        // Arg 0 constant: ...
                                        objv118[0] = const21;
                                        // Arg 1 variable: $tmpsymbol
                                        tmp119 = getVarScalar(interp, "tmpsymbol", compiledLocals, 23);
                                        tmp119.preserve();
                                        objv118[1] = tmp119;
                                        // Arg 2 variable: $vinfo
                                        tmp119 = getVarScalar(interp, "vinfo", compiledLocals, 22);
                                        tmp119.preserve();
                                        objv118[2] = tmp119;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                                            ? cmdcache9.cmd : null), objv118, 0);
                                        if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                                            updateCmdCache(interp, 9);
                                        }
                                    } finally {
                                        tmp119 = objv118[1];
                                        if ( tmp119 != null ) {
                                            tmp119.release();
                                        }
                                        tmp119 = objv118[2];
                                        if ( tmp119 != null ) {
                                            tmp119.release();
                                        }
                                        TJC.releaseObjv(interp, objv118, 3);
                                    }
                                } // End Invoke: ...
                                tmp117 = interp.getResult();
                                tmp117.preserve();
                                objv116[0] = tmp117;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv116, compiledLocals, 7);
                            } finally {
                                TJC.releaseObjvElems(interp, objv116, 1);
                            }
                        } // End Invoke: append
                        { // Invoke: set result_symbol $tmpsymbol
                            TclObject tmp120;
                            tmp120 = getVarScalar(interp, "tmpsymbol", compiledLocals, 23);
                            setVarScalar(interp, "result_symbol", tmp120, compiledLocals, 10);
                        } // End Invoke: set
                    }
                } // End Invoke: if
            } else if ( tmp39_length == 14 && tmp39_first == 'u'
                    && tmp39.compareTo("unary operator") == 0 ) {
                // Pattern {unary operator}
                { // Invoke: set infostr "()"
                    setVarScalar(interp, "infostr", const22, compiledLocals, 8);
                } // End Invoke: set
                { // Invoke: set result_type "ExprValue"
                    setVarScalar(interp, "result_type", const23, compiledLocals, 9);
                } // End Invoke: set
                { // Invoke: set srep "null"
                    setVarScalar(interp, "srep", const8, compiledLocals, 12);
                } // End Invoke: set
                { // Invoke: if {$gencode} ...
                    TclObject tmp121 = getVarScalar(interp, "gencode", compiledLocals, 4);
                    boolean tmp122 = TJC.getBoolean(interp, tmp121);
                    if ( tmp122 ) {
                        { // Invoke: set eval_tuple [...]
                            TclObject tmp123;
                            { // Invoke: ... $tuple
                                TclObject[] objv124 = TJC.grabObjv(interp, 2);
                                TclObject tmp125;
                                try {
                                    // Arg 0 constant: ...
                                    objv124[0] = const24;
                                    // Arg 1 variable: $tuple
                                    tmp125 = getVarScalar(interp, "tuple", compiledLocals, 0);
                                    tmp125.preserve();
                                    objv124[1] = tmp125;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                                        ? cmdcache10.cmd : null), objv124, 0);
                                    if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                                        updateCmdCache(interp, 10);
                                    }
                                } finally {
                                    tmp125 = objv124[1];
                                    if ( tmp125 != null ) {
                                        tmp125.release();
                                    }
                                    TJC.releaseObjv(interp, objv124, 2);
                                }
                            } // End Invoke: ...
                            tmp123 = interp.getResult();
                            setVarScalar(interp, "eval_tuple", tmp123, compiledLocals, 24);
                        } // End Invoke: set
                        { // Invoke: set result_symbol [...]
                            TclObject tmp126;
                            { // Invoke: lindex $eval_tuple 0
                                TclObject tmp127 = getVarScalar(interp, "eval_tuple", compiledLocals, 24);
                                tmp127 = TclList.index(interp, tmp127, 0);
                                if ( tmp127 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp127);
                                }
                            } // End Invoke: lindex
                            tmp126 = interp.getResult();
                            setVarScalar(interp, "result_symbol", tmp126, compiledLocals, 10);
                        } // End Invoke: set
                        { // Invoke: append buffer [...]
                            TclObject[] objv128 = TJC.grabObjv(interp, 1);
                            TclObject tmp129;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: lindex $eval_tuple 1
                                    TclObject tmp130 = getVarScalar(interp, "eval_tuple", compiledLocals, 24);
                                    tmp130 = TclList.index(interp, tmp130, 1);
                                    if ( tmp130 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp130);
                                    }
                                } // End Invoke: lindex
                                tmp129 = interp.getResult();
                                tmp129.preserve();
                                objv128[0] = tmp129;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv128, compiledLocals, 7);
                            } finally {
                                TJC.releaseObjvElems(interp, objv128, 1);
                            }
                        } // End Invoke: append
                        { // Invoke: set ev_types [...]
                            TclObject tmp131;
                            { // Invoke: lindex $eval_tuple 2
                                TclObject tmp132 = getVarScalar(interp, "eval_tuple", compiledLocals, 24);
                                tmp132 = TclList.index(interp, tmp132, 2);
                                if ( tmp132 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp132);
                                }
                            } // End Invoke: lindex
                            tmp131 = interp.getResult();
                            setVarScalar(interp, "ev_types", tmp131, compiledLocals, 14);
                        } // End Invoke: set
                    }
                } // End Invoke: if
            } else if ( tmp39_length == 15 && tmp39_first == 'b'
                    && tmp39.compareTo("binary operator") == 0 ) {
                // Pattern {binary operator}
                { // Invoke: set infostr "()"
                    setVarScalar(interp, "infostr", const22, compiledLocals, 8);
                } // End Invoke: set
                { // Invoke: set result_type "ExprValue"
                    setVarScalar(interp, "result_type", const23, compiledLocals, 9);
                } // End Invoke: set
                { // Invoke: if {$gencode} ...
                    TclObject tmp133 = getVarScalar(interp, "gencode", compiledLocals, 4);
                    boolean tmp134 = TJC.getBoolean(interp, tmp133);
                    if ( tmp134 ) {
                        { // Invoke: set eval_tuple [...]
                            TclObject tmp135;
                            { // Invoke: ... $tuple
                                TclObject[] objv136 = TJC.grabObjv(interp, 2);
                                TclObject tmp137;
                                try {
                                    // Arg 0 constant: ...
                                    objv136[0] = const25;
                                    // Arg 1 variable: $tuple
                                    tmp137 = getVarScalar(interp, "tuple", compiledLocals, 0);
                                    tmp137.preserve();
                                    objv136[1] = tmp137;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache11_cmdEpoch == cmdcache11.cmdEpoch)
                                        ? cmdcache11.cmd : null), objv136, 0);
                                    if ( cmdcache11_cmdEpoch != cmdcache11.cmdEpoch ) {
                                        updateCmdCache(interp, 11);
                                    }
                                } finally {
                                    tmp137 = objv136[1];
                                    if ( tmp137 != null ) {
                                        tmp137.release();
                                    }
                                    TJC.releaseObjv(interp, objv136, 2);
                                }
                            } // End Invoke: ...
                            tmp135 = interp.getResult();
                            setVarScalar(interp, "eval_tuple", tmp135, compiledLocals, 24);
                        } // End Invoke: set
                        { // Invoke: set result_symbol [...]
                            TclObject tmp138;
                            { // Invoke: lindex $eval_tuple 0
                                TclObject tmp139 = getVarScalar(interp, "eval_tuple", compiledLocals, 24);
                                tmp139 = TclList.index(interp, tmp139, 0);
                                if ( tmp139 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp139);
                                }
                            } // End Invoke: lindex
                            tmp138 = interp.getResult();
                            setVarScalar(interp, "result_symbol", tmp138, compiledLocals, 10);
                        } // End Invoke: set
                        { // Invoke: append buffer [...]
                            TclObject[] objv140 = TJC.grabObjv(interp, 1);
                            TclObject tmp141;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: lindex $eval_tuple 1
                                    TclObject tmp142 = getVarScalar(interp, "eval_tuple", compiledLocals, 24);
                                    tmp142 = TclList.index(interp, tmp142, 1);
                                    if ( tmp142 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp142);
                                    }
                                } // End Invoke: lindex
                                tmp141 = interp.getResult();
                                tmp141.preserve();
                                objv140[0] = tmp141;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv140, compiledLocals, 7);
                            } finally {
                                TJC.releaseObjvElems(interp, objv140, 1);
                            }
                        } // End Invoke: append
                        { // Invoke: set ev_types [...]
                            TclObject tmp143;
                            { // Invoke: lindex $eval_tuple 2
                                TclObject tmp144 = getVarScalar(interp, "eval_tuple", compiledLocals, 24);
                                tmp144 = TclList.index(interp, tmp144, 2);
                                if ( tmp144 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp144);
                                }
                            } // End Invoke: lindex
                            tmp143 = interp.getResult();
                            setVarScalar(interp, "ev_types", tmp143, compiledLocals, 14);
                        } // End Invoke: set
                    }
                } // End Invoke: if
            } else if ( tmp39_length == 16 && tmp39_first == 't'
                    && tmp39.compareTo("ternary operator") == 0 ) {
                // Pattern {ternary operator}
                { // Invoke: set infostr "(?:)"
                    setVarScalar(interp, "infostr", const26, compiledLocals, 8);
                } // End Invoke: set
                { // Invoke: set result_type "ExprValue"
                    setVarScalar(interp, "result_type", const23, compiledLocals, 9);
                } // End Invoke: set
                { // Invoke: if {$gencode} ...
                    TclObject tmp145 = getVarScalar(interp, "gencode", compiledLocals, 4);
                    boolean tmp146 = TJC.getBoolean(interp, tmp145);
                    if ( tmp146 ) {
                        { // Invoke: set eval_tuple [...]
                            TclObject tmp147;
                            { // Invoke: ... $tuple
                                TclObject[] objv148 = TJC.grabObjv(interp, 2);
                                TclObject tmp149;
                                try {
                                    // Arg 0 constant: ...
                                    objv148[0] = const27;
                                    // Arg 1 variable: $tuple
                                    tmp149 = getVarScalar(interp, "tuple", compiledLocals, 0);
                                    tmp149.preserve();
                                    objv148[1] = tmp149;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache12_cmdEpoch == cmdcache12.cmdEpoch)
                                        ? cmdcache12.cmd : null), objv148, 0);
                                    if ( cmdcache12_cmdEpoch != cmdcache12.cmdEpoch ) {
                                        updateCmdCache(interp, 12);
                                    }
                                } finally {
                                    tmp149 = objv148[1];
                                    if ( tmp149 != null ) {
                                        tmp149.release();
                                    }
                                    TJC.releaseObjv(interp, objv148, 2);
                                }
                            } // End Invoke: ...
                            tmp147 = interp.getResult();
                            setVarScalar(interp, "eval_tuple", tmp147, compiledLocals, 24);
                        } // End Invoke: set
                        { // Invoke: set result_symbol [...]
                            TclObject tmp150;
                            { // Invoke: lindex $eval_tuple 0
                                TclObject tmp151 = getVarScalar(interp, "eval_tuple", compiledLocals, 24);
                                tmp151 = TclList.index(interp, tmp151, 0);
                                if ( tmp151 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp151);
                                }
                            } // End Invoke: lindex
                            tmp150 = interp.getResult();
                            setVarScalar(interp, "result_symbol", tmp150, compiledLocals, 10);
                        } // End Invoke: set
                        { // Invoke: append buffer [...]
                            TclObject[] objv152 = TJC.grabObjv(interp, 1);
                            TclObject tmp153;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: lindex $eval_tuple 1
                                    TclObject tmp154 = getVarScalar(interp, "eval_tuple", compiledLocals, 24);
                                    tmp154 = TclList.index(interp, tmp154, 1);
                                    if ( tmp154 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp154);
                                    }
                                } // End Invoke: lindex
                                tmp153 = interp.getResult();
                                tmp153.preserve();
                                objv152[0] = tmp153;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv152, compiledLocals, 7);
                            } finally {
                                TJC.releaseObjvElems(interp, objv152, 1);
                            }
                        } // End Invoke: append
                        { // Invoke: set ev_types [...]
                            TclObject tmp155;
                            { // Invoke: lindex $eval_tuple 2
                                TclObject tmp156 = getVarScalar(interp, "eval_tuple", compiledLocals, 24);
                                tmp156 = TclList.index(interp, tmp156, 2);
                                if ( tmp156 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp156);
                                }
                            } // End Invoke: lindex
                            tmp155 = interp.getResult();
                            setVarScalar(interp, "ev_types", tmp155, compiledLocals, 14);
                        } // End Invoke: set
                    }
                } // End Invoke: if
            } else if ( tmp39_length == 13 && tmp39_first == 'm'
                    && tmp39.compareTo("math function") == 0 ) {
                // Pattern {math function}
                { // Invoke: set infostr "math()"
                    setVarScalar(interp, "infostr", const28, compiledLocals, 8);
                } // End Invoke: set
                { // Invoke: set result_type "ExprValue"
                    setVarScalar(interp, "result_type", const23, compiledLocals, 9);
                } // End Invoke: set
                { // Invoke: if {$gencode} ...
                    TclObject tmp157 = getVarScalar(interp, "gencode", compiledLocals, 4);
                    boolean tmp158 = TJC.getBoolean(interp, tmp157);
                    if ( tmp158 ) {
                        { // Invoke: set eval_tuple [...]
                            TclObject tmp159;
                            { // Invoke: ... $tuple
                                TclObject[] objv160 = TJC.grabObjv(interp, 2);
                                TclObject tmp161;
                                try {
                                    // Arg 0 constant: ...
                                    objv160[0] = const29;
                                    // Arg 1 variable: $tuple
                                    tmp161 = getVarScalar(interp, "tuple", compiledLocals, 0);
                                    tmp161.preserve();
                                    objv160[1] = tmp161;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache13_cmdEpoch == cmdcache13.cmdEpoch)
                                        ? cmdcache13.cmd : null), objv160, 0);
                                    if ( cmdcache13_cmdEpoch != cmdcache13.cmdEpoch ) {
                                        updateCmdCache(interp, 13);
                                    }
                                } finally {
                                    tmp161 = objv160[1];
                                    if ( tmp161 != null ) {
                                        tmp161.release();
                                    }
                                    TJC.releaseObjv(interp, objv160, 2);
                                }
                            } // End Invoke: ...
                            tmp159 = interp.getResult();
                            setVarScalar(interp, "eval_tuple", tmp159, compiledLocals, 24);
                        } // End Invoke: set
                        { // Invoke: set result_symbol [...]
                            TclObject tmp162;
                            { // Invoke: lindex $eval_tuple 0
                                TclObject tmp163 = getVarScalar(interp, "eval_tuple", compiledLocals, 24);
                                tmp163 = TclList.index(interp, tmp163, 0);
                                if ( tmp163 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp163);
                                }
                            } // End Invoke: lindex
                            tmp162 = interp.getResult();
                            setVarScalar(interp, "result_symbol", tmp162, compiledLocals, 10);
                        } // End Invoke: set
                        { // Invoke: append buffer [...]
                            TclObject[] objv164 = TJC.grabObjv(interp, 1);
                            TclObject tmp165;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: lindex $eval_tuple 1
                                    TclObject tmp166 = getVarScalar(interp, "eval_tuple", compiledLocals, 24);
                                    tmp166 = TclList.index(interp, tmp166, 1);
                                    if ( tmp166 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp166);
                                    }
                                } // End Invoke: lindex
                                tmp165 = interp.getResult();
                                tmp165.preserve();
                                objv164[0] = tmp165;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv164, compiledLocals, 7);
                            } finally {
                                TJC.releaseObjvElems(interp, objv164, 1);
                            }
                        } // End Invoke: append
                        { // Invoke: set ev_types [...]
                            TclObject tmp167;
                            { // Invoke: lindex $eval_tuple 2
                                TclObject tmp168 = getVarScalar(interp, "eval_tuple", compiledLocals, 24);
                                tmp168 = TclList.index(interp, tmp168, 2);
                                if ( tmp168 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp168);
                                }
                            } // End Invoke: lindex
                            tmp167 = interp.getResult();
                            setVarScalar(interp, "ev_types", tmp167, compiledLocals, 14);
                        } // End Invoke: set
                    }
                } // End Invoke: if
            } else if ( tmp39_length == 15 && tmp39_first == 'c'
                    && tmp39.compareTo("command operand") == 0 ) {
                // Pattern {command operand}
                { // Invoke: set ccmds $value
                    TclObject tmp169;
                    tmp169 = getVarScalar(interp, "value", compiledLocals, 6);
                    setVarScalar(interp, "ccmds", tmp169, compiledLocals, 25);
                } // End Invoke: set
                { // Invoke: if {$ccmds == {}} ... else ...
                    // Binary operator: $ccmds == ""
                    TclObject tmp170 = getVarScalar(interp, "ccmds", compiledLocals, 25);
                    ExprValue tmp171 = evs0;
                    TJC.exprEqualsEmptyString(tmp171, tmp170, false);
                    // End Binary operator: ==
                    boolean tmp172 = ( tmp171.getIntValue() != 0 );
                    if ( tmp172 ) {
                        { // Invoke: set infostr ...
                            setVarScalar(interp, "infostr", const30, compiledLocals, 8);
                        } // End Invoke: set
                        { // Invoke: set result_type "String"
                            setVarScalar(interp, "result_type", const16, compiledLocals, 9);
                        } // End Invoke: set
                        { // Invoke: set result_symbol ...
                            setVarScalar(interp, "result_symbol", const31, compiledLocals, 10);
                        } // End Invoke: set
                    } else {
                        { // Invoke: set infostr ...
                            setVarScalar(interp, "infostr", const32, compiledLocals, 8);
                        } // End Invoke: set
                        { // Invoke: set result_type "TclObject"
                            setVarScalar(interp, "result_type", const19, compiledLocals, 9);
                        } // End Invoke: set
                        { // Invoke: if {$gencode} ...
                            TclObject tmp173 = getVarScalar(interp, "gencode", compiledLocals, 4);
                            boolean tmp174 = TJC.getBoolean(interp, tmp173);
                            if ( tmp174 ) {
                                { // Invoke: foreach ckey $ccmds ...
                                    TclObject tmp175 = null;
                                    try {
                                        tmp175 = getVarScalar(interp, "ccmds", compiledLocals, 25);
                                        tmp175.preserve();
                                        final int tmp175_length = TclList.getLength(interp, tmp175);

                                        for ( int index176 = 0 ; index176 < tmp175_length ; index176++ ) {
                                            TclObject tmp177 = TclList.index(interp, tmp175, index176);
                                            try {
                                                setVarScalar(interp, "ckey", tmp177, compiledLocals, 26);
                                            } catch (TclException ex) {
                                                TJC.foreachVarErr(interp, "ckey");
                                            }

                                            try {
                                            if ( false ) { throw (TclException) null; }
                                            { // Invoke: append buffer [...]
                                                TclObject[] objv178 = TJC.grabObjv(interp, 1);
                                                TclObject tmp179;
                                                try {
                                                    // Arg 2 command: [...]
                                                    { // Invoke: ... $ckey
                                                        TclObject[] objv180 = TJC.grabObjv(interp, 2);
                                                        TclObject tmp181;
                                                        try {
                                                            // Arg 0 constant: ...
                                                            objv180[0] = const33;
                                                            // Arg 1 variable: $ckey
                                                            tmp181 = getVarScalar(interp, "ckey", compiledLocals, 26);
                                                            tmp181.preserve();
                                                            objv180[1] = tmp181;
                                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                                updateCmdCache(interp, 0);
                                                            }
                                                            TJC.invoke(interp, ((cmdcache14_cmdEpoch == cmdcache14.cmdEpoch)
                                                                ? cmdcache14.cmd : null), objv180, 0);
                                                            if ( cmdcache14_cmdEpoch != cmdcache14.cmdEpoch ) {
                                                                updateCmdCache(interp, 14);
                                                            }
                                                        } finally {
                                                            tmp181 = objv180[1];
                                                            if ( tmp181 != null ) {
                                                                tmp181.release();
                                                            }
                                                            TJC.releaseObjv(interp, objv180, 2);
                                                        }
                                                    } // End Invoke: ...
                                                    tmp179 = interp.getResult();
                                                    tmp179.preserve();
                                                    objv178[0] = tmp179;
                                                    interp.resetResult();
                                                    appendVarScalar(interp, "buffer", objv178, compiledLocals, 7);
                                                } finally {
                                                    TJC.releaseObjvElems(interp, objv178, 1);
                                                }
                                            } // End Invoke: append
                                            } catch (TclException ex) {
                                                int type = ex.getCompletionCode();
                                                if (type == TCL.BREAK) {
                                                    break;
                                                } else if (type == TCL.CONTINUE) {
                                                    continue;
                                                } else {
                                                    throw ex;
                                                }
                                            }
                                        }
                                    } finally {
                                        if ( tmp175 != null ) {
                                            tmp175.release();
                                        }
                                    }
                                } // End Invoke: foreach
                                { // Invoke: set tmpsymbol [...]
                                    TclObject tmp182;
                                    { // Invoke: ...
                                        TclObject[] objv183 = TJC.grabObjv(interp, 1);
                                        try {
                                            // Arg 0 constant: ...
                                            objv183[0] = const20;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                                ? cmdcache8.cmd : null), objv183, 0);
                                            if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                                updateCmdCache(interp, 8);
                                            }
                                        } finally {
                                            TJC.releaseObjv(interp, objv183, 1);
                                        }
                                    } // End Invoke: ...
                                    tmp182 = interp.getResult();
                                    setVarScalar(interp, "tmpsymbol", tmp182, compiledLocals, 23);
                                } // End Invoke: set
                                { // Invoke: append buffer [...] "TclObject " $tmpsymbol ...
                                    TclObject[] objv184 = TJC.grabObjv(interp, 4);
                                    TclObject tmp185;
                                    try {
                                        // Arg 2 command: [...]
                                        { // Invoke: emitter_indent
                                            TclObject[] objv186 = TJC.grabObjv(interp, 1);
                                            try {
                                                // Arg 0 constant: emitter_indent
                                                objv186[0] = const34;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache15_cmdEpoch == cmdcache15.cmdEpoch)
                                                    ? cmdcache15.cmd : null), objv186, 0);
                                                if ( cmdcache15_cmdEpoch != cmdcache15.cmdEpoch ) {
                                                    updateCmdCache(interp, 15);
                                                }
                                            } finally {
                                                TJC.releaseObjv(interp, objv186, 1);
                                            }
                                        } // End Invoke: emitter_indent
                                        tmp185 = interp.getResult();
                                        tmp185.preserve();
                                        objv184[0] = tmp185;
                                        // Arg 3 constant: "TclObject "
                                        objv184[1] = const35;
                                        // Arg 4 variable: $tmpsymbol
                                        tmp185 = getVarScalar(interp, "tmpsymbol", compiledLocals, 23);
                                        tmp185.preserve();
                                        objv184[2] = tmp185;
                                        // Arg 5 constant: ...
                                        objv184[3] = const36;
                                        interp.resetResult();
                                        appendVarScalar(interp, "buffer", objv184, compiledLocals, 7);
                                    } finally {
                                        tmp185 = objv184[0];
                                        if ( tmp185 != null ) {
                                            tmp185.release();
                                        }
                                        tmp185 = objv184[2];
                                        if ( tmp185 != null ) {
                                            tmp185.release();
                                        }
                                        TJC.releaseObjv(interp, objv184, 4);
                                    }
                                } // End Invoke: append
                                { // Invoke: set result_symbol $tmpsymbol
                                    TclObject tmp187;
                                    tmp187 = getVarScalar(interp, "tmpsymbol", compiledLocals, 23);
                                    setVarScalar(interp, "result_symbol", tmp187, compiledLocals, 10);
                                } // End Invoke: set
                            }
                        } // End Invoke: if
                    }
                } // End Invoke: if
            } else if ( tmp39_length == 12 && tmp39_first == 'w'
                    && tmp39.compareTo("word operand") == 0 ) {
                // Pattern {word operand}
                { // Invoke: set types [...]
                    TclObject tmp188;
                    { // Invoke: lindex $value 0
                        TclObject tmp189 = getVarScalar(interp, "value", compiledLocals, 6);
                        tmp189 = TclList.index(interp, tmp189, 0);
                        if ( tmp189 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp189);
                        }
                    } // End Invoke: lindex
                    tmp188 = interp.getResult();
                    setVarScalar(interp, "types", tmp188, compiledLocals, 27);
                } // End Invoke: set
                { // Invoke: set values [...]
                    TclObject tmp190;
                    { // Invoke: lindex $value 1
                        TclObject tmp191 = getVarScalar(interp, "value", compiledLocals, 6);
                        tmp191 = TclList.index(interp, tmp191, 1);
                        if ( tmp191 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp191);
                        }
                    } // End Invoke: lindex
                    tmp190 = interp.getResult();
                    setVarScalar(interp, "values", tmp190, compiledLocals, 28);
                } // End Invoke: set
                { // Invoke: set cmap [...]
                    TclObject tmp192;
                    { // Invoke: lindex $value 2
                        TclObject tmp193 = getVarScalar(interp, "value", compiledLocals, 6);
                        tmp193 = TclList.index(interp, tmp193, 2);
                        if ( tmp193 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp193);
                        }
                    } // End Invoke: lindex
                    tmp192 = interp.getResult();
                    setVarScalar(interp, "cmap", tmp192, compiledLocals, 29);
                } // End Invoke: set
                { // Invoke: set winfo $values
                    TclObject tmp194;
                    tmp194 = getVarScalar(interp, "values", compiledLocals, 28);
                    setVarScalar(interp, "winfo", tmp194, compiledLocals, 30);
                } // End Invoke: set
                { // Invoke: set result_type "TclObject"
                    setVarScalar(interp, "result_type", const19, compiledLocals, 9);
                } // End Invoke: set
                { // Invoke: set infostr ...
                    setVarScalar(interp, "infostr", const37, compiledLocals, 8);
                } // End Invoke: set
                { // Invoke: if {$gencode} ...
                    TclObject tmp195 = getVarScalar(interp, "gencode", compiledLocals, 4);
                    boolean tmp196 = TJC.getBoolean(interp, tmp195);
                    if ( tmp196 ) {
                        { // Invoke: set tmpsymbol [...]
                            TclObject tmp197;
                            { // Invoke: ...
                                TclObject[] objv198 = TJC.grabObjv(interp, 1);
                                try {
                                    // Arg 0 constant: ...
                                    objv198[0] = const20;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                        ? cmdcache8.cmd : null), objv198, 0);
                                    if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                        updateCmdCache(interp, 8);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv198, 1);
                                }
                            } // End Invoke: ...
                            tmp197 = interp.getResult();
                            setVarScalar(interp, "tmpsymbol", tmp197, compiledLocals, 23);
                        } // End Invoke: set
                        { // Invoke: append buffer [...]
                            TclObject[] objv199 = TJC.grabObjv(interp, 1);
                            TclObject tmp200;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: ... $tmpsymbol $winfo true
                                    TclObject[] objv201 = TJC.grabObjv(interp, 4);
                                    TclObject tmp202;
                                    try {
                                        // Arg 0 constant: ...
                                        objv201[0] = const38;
                                        // Arg 1 variable: $tmpsymbol
                                        tmp202 = getVarScalar(interp, "tmpsymbol", compiledLocals, 23);
                                        tmp202.preserve();
                                        objv201[1] = tmp202;
                                        // Arg 2 variable: $winfo
                                        tmp202 = getVarScalar(interp, "winfo", compiledLocals, 30);
                                        tmp202.preserve();
                                        objv201[2] = tmp202;
                                        // Arg 3 constant: true
                                        objv201[3] = const39;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache16_cmdEpoch == cmdcache16.cmdEpoch)
                                            ? cmdcache16.cmd : null), objv201, 0);
                                        if ( cmdcache16_cmdEpoch != cmdcache16.cmdEpoch ) {
                                            updateCmdCache(interp, 16);
                                        }
                                    } finally {
                                        tmp202 = objv201[1];
                                        if ( tmp202 != null ) {
                                            tmp202.release();
                                        }
                                        tmp202 = objv201[2];
                                        if ( tmp202 != null ) {
                                            tmp202.release();
                                        }
                                        TJC.releaseObjv(interp, objv201, 4);
                                    }
                                } // End Invoke: ...
                                tmp200 = interp.getResult();
                                tmp200.preserve();
                                objv199[0] = tmp200;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv199, compiledLocals, 7);
                            } finally {
                                TJC.releaseObjvElems(interp, objv199, 1);
                            }
                        } // End Invoke: append
                        { // Invoke: set result_symbol $tmpsymbol
                            TclObject tmp203;
                            tmp203 = getVarScalar(interp, "tmpsymbol", compiledLocals, 23);
                            setVarScalar(interp, "result_symbol", tmp203, compiledLocals, 10);
                        } // End Invoke: set
                    }
                } // End Invoke: if
            } else {
                // Pattern default
                { // Invoke: error "..."
                    TclObject[] objv204 = TJC.grabObjv(interp, 2);
                    TclObject tmp205;
                    try {
                        // Arg 0 constant: error
                        objv204[0] = const3;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp206 = new StringBuffer(64);
                        sbtmp206.append("unhandled type ");
                        sbtmp206.append("\"");
                        tmp205 = getVarScalar(interp, "type", compiledLocals, 13);
                        sbtmp206.append(tmp205.toString());
                        sbtmp206.append("\"");
                        tmp205 = TclString.newInstance(sbtmp206);
                        tmp205.preserve();
                        objv204[1] = tmp205;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv204, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp205 = objv204[1];
                        if ( tmp205 != null ) {
                            tmp205.release();
                        }
                        TJC.releaseObjv(interp, objv204, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: switch
        { // Invoke: if ... ... elseif ... ... else ...
            // Binary operator: $no_exprvalue_for_tclobject && ()
            TclObject tmp207 = getVarScalar(interp, "no_exprvalue_for_tclobject", compiledLocals, 2);
            ExprValue tmp208 = evs0;
            TJC.exprInitValue(interp, tmp208, tmp207);
            if (tmp208.getBooleanValue(interp)) {
            // Binary operator: $result_type == "TclObject"
            TclObject tmp209 = getVarScalar(interp, "result_type", compiledLocals, 9);
            boolean tmp210 = tmp209.toString().equals("TclObject");
            ExprValue tmp211 = evs1;
            tmp211.setIntValue(tmp210);
            // End Binary operator: ==
            tmp208.setIntValue(tmp211.getBooleanValue(interp));
            } else {
            tmp208.setIntValue(0);
            } // End if: $no_exprvalue_for_tclobject
            // End Binary operator: &&
            boolean tmp212 = ( tmp208.getIntValue() != 0 );
            if ( tmp212 ) {
                { // Invoke: set value_symbol $result_symbol
                    TclObject tmp213;
                    tmp213 = getVarScalar(interp, "result_symbol", compiledLocals, 10);
                    setVarScalar(interp, "value_symbol", tmp213, compiledLocals, 11);
                } // End Invoke: set
            } else {
                // Binary operator: $result_type != "ExprValue"
                TclObject tmp214 = getVarScalar(interp, "result_type", compiledLocals, 9);
                boolean tmp215 = ! tmp214.toString().equals("ExprValue");
                ExprValue tmp216 = evs0;
                tmp216.setIntValue(tmp215);
                // End Binary operator: !=
                boolean tmp217 = ( tmp216.getIntValue() != 0 );
                if ( tmp217 ) {
                    { // Invoke: if {$gencode} ...
                        TclObject tmp218 = getVarScalar(interp, "gencode", compiledLocals, 4);
                        boolean tmp219 = TJC.getBoolean(interp, tmp218);
                        if ( tmp219 ) {
                            { // Invoke: set tmpsymbol [...]
                                TclObject tmp220;
                                { // Invoke: ...
                                    TclObject[] objv221 = TJC.grabObjv(interp, 1);
                                    try {
                                        // Arg 0 constant: ...
                                        objv221[0] = const20;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                            ? cmdcache8.cmd : null), objv221, 0);
                                        if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                            updateCmdCache(interp, 8);
                                        }
                                    } finally {
                                        TJC.releaseObjv(interp, objv221, 1);
                                    }
                                } // End Invoke: ...
                                tmp220 = interp.getResult();
                                setVarScalar(interp, "tmpsymbol", tmp220, compiledLocals, 23);
                            } // End Invoke: set
                            { // Invoke: set value_symbol $tmpsymbol
                                TclObject tmp222;
                                tmp222 = getVarScalar(interp, "tmpsymbol", compiledLocals, 23);
                                setVarScalar(interp, "value_symbol", tmp222, compiledLocals, 11);
                            } // End Invoke: set
                        }
                    } // End Invoke: if
                } else {
                    { // Invoke: set value_symbol $result_symbol
                        TclObject tmp223;
                        tmp223 = getVarScalar(interp, "result_symbol", compiledLocals, 10);
                        setVarScalar(interp, "value_symbol", tmp223, compiledLocals, 11);
                    } // End Invoke: set
                }
            }
        } // End Invoke: if
        { // Invoke: if ... ... elseif ... ... elseif ... ... elseif ... ... else ...
            // Binary operator: $no_exprvalue_for_tclobject && ()
            TclObject tmp224 = getVarScalar(interp, "no_exprvalue_for_tclobject", compiledLocals, 2);
            ExprValue tmp225 = evs0;
            TJC.exprInitValue(interp, tmp225, tmp224);
            if (tmp225.getBooleanValue(interp)) {
            // Binary operator: $result_type == "TclObject"
            TclObject tmp226 = getVarScalar(interp, "result_type", compiledLocals, 9);
            boolean tmp227 = tmp226.toString().equals("TclObject");
            ExprValue tmp228 = evs1;
            tmp228.setIntValue(tmp227);
            // End Binary operator: ==
            tmp225.setIntValue(tmp228.getBooleanValue(interp));
            } else {
            tmp225.setIntValue(0);
            } // End if: $no_exprvalue_for_tclobject
            // End Binary operator: &&
            boolean tmp229 = ( tmp225.getIntValue() != 0 );
            if ( tmp229 ) {
            } else {
                // Binary operator: () || ()
                // Binary operator: $result_type == "int literal"
                TclObject tmp230 = getVarScalar(interp, "result_type", compiledLocals, 9);
                boolean tmp231 = tmp230.toString().equals("int literal");
                ExprValue tmp232 = evs0;
                tmp232.setIntValue(tmp231);
                // End Binary operator: ==
                if (!tmp232.getBooleanValue(interp)) {
                // Binary operator: $result_type == "double literal"
                TclObject tmp233 = getVarScalar(interp, "result_type", compiledLocals, 9);
                boolean tmp234 = tmp233.toString().equals("double literal");
                ExprValue tmp235 = evs1;
                tmp235.setIntValue(tmp234);
                // End Binary operator: ==
                tmp232.setIntValue(tmp235.getBooleanValue(interp));
                } else {
                tmp232.setIntValue(1);
                } // End if: !()
                // End Binary operator: ||
                boolean tmp236 = ( tmp232.getIntValue() != 0 );
                if ( tmp236 ) {
                    { // Invoke: set type "int"
                        setVarScalar(interp, "type", const5, compiledLocals, 13);
                    } // End Invoke: set
                    { // Invoke: if ... ...
                        // Binary operator: $result_type == "double literal"
                        TclObject tmp237 = getVarScalar(interp, "result_type", compiledLocals, 9);
                        boolean tmp238 = tmp237.toString().equals("double literal");
                        ExprValue tmp239 = evs0;
                        tmp239.setIntValue(tmp238);
                        // End Binary operator: ==
                        boolean tmp240 = ( tmp239.getIntValue() != 0 );
                        if ( tmp240 ) {
                            { // Invoke: set type "double"
                                setVarScalar(interp, "type", const7, compiledLocals, 13);
                            } // End Invoke: set
                        }
                    } // End Invoke: if
                    { // Invoke: lappend ev_types $type
                        TclObject[] objv241 = TJC.grabObjv(interp, 1);
                        TclObject tmp242;
                        try {
                            // Arg 2 variable: $type
                            tmp242 = getVarScalar(interp, "type", compiledLocals, 13);
                            tmp242.preserve();
                            objv241[0] = tmp242;
                            interp.resetResult();
                            lappendVarScalar(interp, "ev_types", objv241, compiledLocals, 14);
                        } finally {
                            TJC.releaseObjvElems(interp, objv241, 1);
                        }
                    } // End Invoke: lappend
                    { // Invoke: if ... ...
                        TclObject tmp243 = getVarScalar(interp, "no_str_for_exprvalue", compiledLocals, 3);
                        boolean tmp244 = TJC.getBoolean(interp, tmp243);
                        if ( tmp244 ) {
                            { // Invoke: set srep "null"
                                setVarScalar(interp, "srep", const8, compiledLocals, 12);
                            } // End Invoke: set
                        }
                    } // End Invoke: if
                    { // Invoke: if {$gencode} ...
                        TclObject tmp245 = getVarScalar(interp, "gencode", compiledLocals, 4);
                        boolean tmp246 = TJC.getBoolean(interp, tmp245);
                        if ( tmp246 ) {
                            { // Invoke: append buffer [...]
                                TclObject[] objv247 = TJC.grabObjv(interp, 1);
                                TclObject tmp248;
                                try {
                                    // Arg 2 command: [...]
                                    { // Invoke: ... $tmpsymbol $type $result_symbol $srep
                                        TclObject[] objv249 = TJC.grabObjv(interp, 5);
                                        TclObject tmp250;
                                        try {
                                            // Arg 0 constant: ...
                                            objv249[0] = const40;
                                            // Arg 1 variable: $tmpsymbol
                                            tmp250 = getVarScalar(interp, "tmpsymbol", compiledLocals, 23);
                                            tmp250.preserve();
                                            objv249[1] = tmp250;
                                            // Arg 2 variable: $type
                                            tmp250 = getVarScalar(interp, "type", compiledLocals, 13);
                                            tmp250.preserve();
                                            objv249[2] = tmp250;
                                            // Arg 3 variable: $result_symbol
                                            tmp250 = getVarScalar(interp, "result_symbol", compiledLocals, 10);
                                            tmp250.preserve();
                                            objv249[3] = tmp250;
                                            // Arg 4 variable: $srep
                                            tmp250 = getVarScalar(interp, "srep", compiledLocals, 12);
                                            tmp250.preserve();
                                            objv249[4] = tmp250;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache17_cmdEpoch == cmdcache17.cmdEpoch)
                                                ? cmdcache17.cmd : null), objv249, 0);
                                            if ( cmdcache17_cmdEpoch != cmdcache17.cmdEpoch ) {
                                                updateCmdCache(interp, 17);
                                            }
                                        } finally {
                                            tmp250 = objv249[1];
                                            if ( tmp250 != null ) {
                                                tmp250.release();
                                            }
                                            tmp250 = objv249[2];
                                            if ( tmp250 != null ) {
                                                tmp250.release();
                                            }
                                            tmp250 = objv249[3];
                                            if ( tmp250 != null ) {
                                                tmp250.release();
                                            }
                                            tmp250 = objv249[4];
                                            if ( tmp250 != null ) {
                                                tmp250.release();
                                            }
                                            TJC.releaseObjv(interp, objv249, 5);
                                        }
                                    } // End Invoke: ...
                                    tmp248 = interp.getResult();
                                    tmp248.preserve();
                                    objv247[0] = tmp248;
                                    interp.resetResult();
                                    appendVarScalar(interp, "buffer", objv247, compiledLocals, 7);
                                } finally {
                                    TJC.releaseObjvElems(interp, objv247, 1);
                                }
                            } // End Invoke: append
                        }
                    } // End Invoke: if
                } else {
                    // Binary operator: () || ()
                    // Binary operator: $result_type == "String"
                    TclObject tmp251 = getVarScalar(interp, "result_type", compiledLocals, 9);
                    boolean tmp252 = tmp251.toString().equals("String");
                    ExprValue tmp253 = evs0;
                    tmp253.setIntValue(tmp252);
                    // End Binary operator: ==
                    if (!tmp253.getBooleanValue(interp)) {
                    // Binary operator: $result_type == "TclObject"
                    TclObject tmp254 = getVarScalar(interp, "result_type", compiledLocals, 9);
                    boolean tmp255 = tmp254.toString().equals("TclObject");
                    ExprValue tmp256 = evs1;
                    tmp256.setIntValue(tmp255);
                    // End Binary operator: ==
                    tmp253.setIntValue(tmp256.getBooleanValue(interp));
                    } else {
                    tmp253.setIntValue(1);
                    } // End if: !()
                    // End Binary operator: ||
                    boolean tmp257 = ( tmp253.getIntValue() != 0 );
                    if ( tmp257 ) {
                        { // Invoke: if ... ...
                            // Binary operator: $result_type == "String"
                            TclObject tmp258 = getVarScalar(interp, "result_type", compiledLocals, 9);
                            boolean tmp259 = tmp258.toString().equals("String");
                            ExprValue tmp260 = evs0;
                            tmp260.setIntValue(tmp259);
                            // End Binary operator: ==
                            boolean tmp261 = ( tmp260.getIntValue() != 0 );
                            if ( tmp261 ) {
                                { // Invoke: lappend ev_types "String"
                                    TclObject[] objv262 = TJC.grabObjv(interp, 1);
                                    TclObject tmp263;
                                    try {
                                        // Arg 2 constant: "String"
                                        objv262[0] = const16;
                                        interp.resetResult();
                                        lappendVarScalar(interp, "ev_types", objv262, compiledLocals, 14);
                                    } finally {
                                        TJC.releaseObjv(interp, objv262, 1);
                                    }
                                } // End Invoke: lappend
                            }
                        } // End Invoke: if
                        { // Invoke: if {$gencode} ...
                            TclObject tmp264 = getVarScalar(interp, "gencode", compiledLocals, 4);
                            boolean tmp265 = TJC.getBoolean(interp, tmp264);
                            if ( tmp265 ) {
                                { // Invoke: append buffer [...]
                                    TclObject[] objv266 = TJC.grabObjv(interp, 1);
                                    TclObject tmp267;
                                    try {
                                        // Arg 2 command: [...]
                                        { // Invoke: ... $tmpsymbol $result_type $result_symbol
                                            TclObject[] objv268 = TJC.grabObjv(interp, 4);
                                            TclObject tmp269;
                                            try {
                                                // Arg 0 constant: ...
                                                objv268[0] = const40;
                                                // Arg 1 variable: $tmpsymbol
                                                tmp269 = getVarScalar(interp, "tmpsymbol", compiledLocals, 23);
                                                tmp269.preserve();
                                                objv268[1] = tmp269;
                                                // Arg 2 variable: $result_type
                                                tmp269 = getVarScalar(interp, "result_type", compiledLocals, 9);
                                                tmp269.preserve();
                                                objv268[2] = tmp269;
                                                // Arg 3 variable: $result_symbol
                                                tmp269 = getVarScalar(interp, "result_symbol", compiledLocals, 10);
                                                tmp269.preserve();
                                                objv268[3] = tmp269;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache17_cmdEpoch == cmdcache17.cmdEpoch)
                                                    ? cmdcache17.cmd : null), objv268, 0);
                                                if ( cmdcache17_cmdEpoch != cmdcache17.cmdEpoch ) {
                                                    updateCmdCache(interp, 17);
                                                }
                                            } finally {
                                                tmp269 = objv268[1];
                                                if ( tmp269 != null ) {
                                                    tmp269.release();
                                                }
                                                tmp269 = objv268[2];
                                                if ( tmp269 != null ) {
                                                    tmp269.release();
                                                }
                                                tmp269 = objv268[3];
                                                if ( tmp269 != null ) {
                                                    tmp269.release();
                                                }
                                                TJC.releaseObjv(interp, objv268, 4);
                                            }
                                        } // End Invoke: ...
                                        tmp267 = interp.getResult();
                                        tmp267.preserve();
                                        objv266[0] = tmp267;
                                        interp.resetResult();
                                        appendVarScalar(interp, "buffer", objv266, compiledLocals, 7);
                                    } finally {
                                        TJC.releaseObjvElems(interp, objv266, 1);
                                    }
                                } // End Invoke: append
                            }
                        } // End Invoke: if
                    } else {
                        // Binary operator: $result_type == "ExprValue"
                        TclObject tmp270 = getVarScalar(interp, "result_type", compiledLocals, 9);
                        boolean tmp271 = tmp270.toString().equals("ExprValue");
                        ExprValue tmp272 = evs0;
                        tmp272.setIntValue(tmp271);
                        // End Binary operator: ==
                        boolean tmp273 = ( tmp272.getIntValue() != 0 );
                        if ( tmp273 ) {
                        } else {
                            { // Invoke: error "..."
                                TclObject[] objv274 = TJC.grabObjv(interp, 2);
                                TclObject tmp275;
                                try {
                                    // Arg 0 constant: error
                                    objv274[0] = const3;
                                    // Arg 1 word: "..."
                                    StringBuffer sbtmp276 = new StringBuffer(64);
                                    sbtmp276.append("unknown result type ");
                                    sbtmp276.append("\"");
                                    tmp275 = getVarScalar(interp, "result_type", compiledLocals, 9);
                                    sbtmp276.append(tmp275.toString());
                                    sbtmp276.append("\"");
                                    tmp275 = TclString.newInstance(sbtmp276);
                                    tmp275.preserve();
                                    objv274[1] = tmp275;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                        ? cmdcache1.cmd : null), objv274, 0);
                                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                        updateCmdCache(interp, 1);
                                    }
                                } finally {
                                    tmp275 = objv274[1];
                                    if ( tmp275 != null ) {
                                        tmp275.release();
                                    }
                                    TJC.releaseObjv(interp, objv274, 2);
                                }
                            } // End Invoke: error
                        }
                    }
                }
            }
        } // End Invoke: if
        { // Invoke: set result_info [...]
            TclObject tmp277;
            { // Invoke: list $result_type $result_symbol [...] $ev_types
                TclObject tmp278 = TclList.newInstance();
                TclObject tmp279;
                try {
                    tmp279 = getVarScalar(interp, "result_type", compiledLocals, 9);
                    TclList.append(interp, tmp278, tmp279);
                    tmp279 = getVarScalar(interp, "result_symbol", compiledLocals, 10);
                    TclList.append(interp, tmp278, tmp279);
                    { // Invoke: expr {$srep == "null"}
                        // Binary operator: $srep == "null"
                        TclObject tmp280 = getVarScalar(interp, "srep", compiledLocals, 12);
                        boolean tmp281 = tmp280.toString().equals("null");
                        ExprValue tmp282 = evs0;
                        tmp282.setIntValue(tmp281);
                        // End Binary operator: ==
                        interp.setResult( tmp282.getIntValue() != 0 );
                    } // End Invoke: expr
                    tmp279 = interp.getResult();
                    TclList.append(interp, tmp278, tmp279);
                    tmp279 = getVarScalar(interp, "ev_types", compiledLocals, 14);
                    TclList.append(interp, tmp278, tmp279);
                } catch (TclException ex) {
                    tmp278.release();
                    throw ex;
                }
                interp.setResult(tmp278);
            } // End Invoke: list
            tmp277 = interp.getResult();
            setVarScalar(interp, "result_info", tmp277, compiledLocals, 31);
        } // End Invoke: set
        { // Invoke: return [...]
            { // Invoke: list $infostr $value_symbol $buffer $result_info
                TclObject tmp283 = TclList.newInstance();
                TclObject tmp284;
                try {
                    tmp284 = getVarScalar(interp, "infostr", compiledLocals, 8);
                    TclList.append(interp, tmp283, tmp284);
                    tmp284 = getVarScalar(interp, "value_symbol", compiledLocals, 11);
                    TclList.append(interp, tmp283, tmp284);
                    tmp284 = getVarScalar(interp, "buffer", compiledLocals, 7);
                    TclList.append(interp, tmp283, tmp284);
                    tmp284 = getVarScalar(interp, "result_info", compiledLocals, 31);
                    TclList.append(interp, tmp283, tmp284);
                } catch (TclException ex) {
                    tmp283.release();
                    throw ex;
                }
                interp.setResult(tmp283);
            } // End Invoke: list
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_expr_evaluate_emit_exprvalue");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;
    TclObject const18;
    TclObject const19;
    TclObject const20;
    TclObject const21;
    TclObject const22;
    TclObject const23;
    TclObject const24;
    TclObject const25;
    TclObject const26;
    TclObject const27;
    TclObject const28;
    TclObject const29;
    TclObject const30;
    TclObject const31;
    TclObject const32;
    TclObject const33;
    TclObject const34;
    TclObject const35;
    TclObject const36;
    TclObject const37;
    TclObject const38;
    TclObject const39;
    TclObject const40;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclInteger.newInstance(0);
        const1.preserve(); const1.preserve();
        const2 = TclInteger.newInstance(1);
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("error");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("int literal");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("int");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("double literal");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("double");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("null");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("emitter_backslash_tcl_string");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("subst");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("-nocommands");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("-novariables");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("compileproc_string_is_java_integer");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("compileproc_string_is_java_double");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("compileproc_parse_value");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance("String");
        const16.preserve(); const16.preserve();
        const17 = TclString.newInstance("scalar");
        const17.preserve(); const17.preserve();
        const18 = TclString.newInstance("lindex");
        const18.preserve(); const18.preserve();
        const19 = TclString.newInstance("TclObject");
        const19.preserve(); const19.preserve();
        const20 = TclString.newInstance("compileproc_tmpvar_next");
        const20.preserve(); const20.preserve();
        const21 = TclString.newInstance("compileproc_emit_variable");
        const21.preserve(); const21.preserve();
        const22 = TclString.newInstance("()");
        const22.preserve(); const22.preserve();
        const23 = TclString.newInstance("ExprValue");
        const23.preserve(); const23.preserve();
        const24 = TclString.newInstance("compileproc_expr_evaluate_emit_unary_operator");
        const24.preserve(); const24.preserve();
        const25 = TclString.newInstance("compileproc_expr_evaluate_emit_binary_operator");
        const25.preserve(); const25.preserve();
        const26 = TclString.newInstance("(?:)");
        const26.preserve(); const26.preserve();
        const27 = TclString.newInstance("compileproc_expr_evaluate_emit_ternary_operator");
        const27.preserve(); const27.preserve();
        const28 = TclString.newInstance("math()");
        const28.preserve(); const28.preserve();
        const29 = TclString.newInstance("compileproc_expr_evaluate_emit_math_function");
        const29.preserve(); const29.preserve();
        const30 = TclString.newInstance("[]");
        const30.preserve(); const30.preserve();
        const31 = TclString.newInstance("\"\"");
        const31.preserve(); const31.preserve();
        const32 = TclString.newInstance("[...]");
        const32.preserve(); const32.preserve();
        const33 = TclString.newInstance("compileproc_emit_invoke");
        const33.preserve(); const33.preserve();
        const34 = TclString.newInstance("emitter_indent");
        const34.preserve(); const34.preserve();
        const35 = TclString.newInstance("TclObject ");
        const35.preserve(); const35.preserve();
        const36 = TclString.newInstance(" = interp.getResult();\n");
        const36.preserve(); const36.preserve();
        const37 = TclString.newInstance("\"...\"");
        const37.preserve(); const37.preserve();
        const38 = TclString.newInstance("compileproc_emit_word");
        const38.preserve(); const38.preserve();
        const39 = TclString.newInstance("true");
        TclBoolean.get(interp, const39);
        const39.preserve(); const39.preserve();
        const40 = TclString.newInstance("compileproc_emit_exprvalue_get");
        const40.preserve(); const40.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;
    WrappedCommand cmdcache8;
    int cmdcache8_cmdEpoch;
    WrappedCommand cmdcache9;
    int cmdcache9_cmdEpoch;
    WrappedCommand cmdcache10;
    int cmdcache10_cmdEpoch;
    WrappedCommand cmdcache11;
    int cmdcache11_cmdEpoch;
    WrappedCommand cmdcache12;
    int cmdcache12_cmdEpoch;
    WrappedCommand cmdcache13;
    int cmdcache13_cmdEpoch;
    WrappedCommand cmdcache14;
    int cmdcache14_cmdEpoch;
    WrappedCommand cmdcache15;
    int cmdcache15_cmdEpoch;
    WrappedCommand cmdcache16;
    int cmdcache16_cmdEpoch;
    WrappedCommand cmdcache17;
    int cmdcache17_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                cmdcache8 = TJC.INVALID_COMMAND_CACHE;
                cmdcache8_cmdEpoch = 0;
                cmdcache9 = TJC.INVALID_COMMAND_CACHE;
                cmdcache9_cmdEpoch = 0;
                cmdcache10 = TJC.INVALID_COMMAND_CACHE;
                cmdcache10_cmdEpoch = 0;
                cmdcache11 = TJC.INVALID_COMMAND_CACHE;
                cmdcache11_cmdEpoch = 0;
                cmdcache12 = TJC.INVALID_COMMAND_CACHE;
                cmdcache12_cmdEpoch = 0;
                cmdcache13 = TJC.INVALID_COMMAND_CACHE;
                cmdcache13_cmdEpoch = 0;
                cmdcache14 = TJC.INVALID_COMMAND_CACHE;
                cmdcache14_cmdEpoch = 0;
                cmdcache15 = TJC.INVALID_COMMAND_CACHE;
                cmdcache15_cmdEpoch = 0;
                cmdcache16 = TJC.INVALID_COMMAND_CACHE;
                cmdcache16_cmdEpoch = 0;
                cmdcache17 = TJC.INVALID_COMMAND_CACHE;
                cmdcache17_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "error";
                break;
            }
            case 2: {
                cmdName = "emitter_backslash_tcl_string";
                break;
            }
            case 3: {
                cmdName = "subst";
                break;
            }
            case 4: {
                cmdName = "compileproc_string_is_java_integer";
                break;
            }
            case 5: {
                cmdName = "compileproc_string_is_java_double";
                break;
            }
            case 6: {
                cmdName = "compileproc_parse_value";
                break;
            }
            case 7: {
                cmdName = "lindex";
                break;
            }
            case 8: {
                cmdName = "compileproc_tmpvar_next";
                break;
            }
            case 9: {
                cmdName = "compileproc_emit_variable";
                break;
            }
            case 10: {
                cmdName = "compileproc_expr_evaluate_emit_unary_operator";
                break;
            }
            case 11: {
                cmdName = "compileproc_expr_evaluate_emit_binary_operator";
                break;
            }
            case 12: {
                cmdName = "compileproc_expr_evaluate_emit_ternary_operator";
                break;
            }
            case 13: {
                cmdName = "compileproc_expr_evaluate_emit_math_function";
                break;
            }
            case 14: {
                cmdName = "compileproc_emit_invoke";
                break;
            }
            case 15: {
                cmdName = "emitter_indent";
                break;
            }
            case 16: {
                cmdName = "compileproc_emit_word";
                break;
            }
            case 17: {
                cmdName = "compileproc_emit_exprvalue_get";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
            case 8: {
                cmdcache8 = lwcmd;
                cmdcache8_cmdEpoch = cmdEpoch;
                break;
            }
            case 9: {
                cmdcache9 = lwcmd;
                cmdcache9_cmdEpoch = cmdEpoch;
                break;
            }
            case 10: {
                cmdcache10 = lwcmd;
                cmdcache10_cmdEpoch = cmdEpoch;
                break;
            }
            case 11: {
                cmdcache11 = lwcmd;
                cmdcache11_cmdEpoch = cmdEpoch;
                break;
            }
            case 12: {
                cmdcache12 = lwcmd;
                cmdcache12_cmdEpoch = cmdEpoch;
                break;
            }
            case 13: {
                cmdcache13 = lwcmd;
                cmdcache13_cmdEpoch = cmdEpoch;
                break;
            }
            case 14: {
                cmdcache14 = lwcmd;
                cmdcache14_cmdEpoch = cmdEpoch;
                break;
            }
            case 15: {
                cmdcache15 = lwcmd;
                cmdcache15_cmdEpoch = cmdEpoch;
                break;
            }
            case 16: {
                cmdcache16 = lwcmd;
                cmdcache16_cmdEpoch = cmdEpoch;
                break;
            }
            case 17: {
                cmdcache17 = lwcmd;
                cmdcache17_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "tuple",
        "genflags",
        "no_exprvalue_for_tclobject",
        "no_str_for_exprvalue",
        "gencode",
        "flag",
        "value",
        "buffer",
        "infostr",
        "result_type",
        "result_symbol",
        "value_symbol",
        "srep",
        "type",
        "ev_types",
        "jvalue",
        "is_integer",
        "is_double",
        "stringrep_matches",
        "parsed_number",
        "printed_number",
        "varname",
        "vinfo",
        "tmpsymbol",
        "eval_tuple",
        "ccmds",
        "ckey",
        "types",
        "values",
        "cmap",
        "winfo",
        "result_info"
    };
} // end class CompileprocExprEvaluateEmitExprvalueCmd

