// TJC implementation of procedure compileproc_expr_evaluate_emit_unary_operator
package tjc;
import tcl.lang.*;

public class CompileprocExprEvaluateEmitUnaryOperatorCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 33, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        ExprValue evs2 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "op_tuple");
        }
        setVarScalar(interp, "op_tuple", objv[1], compiledLocals, 0);
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const0, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: set op_buffer ""
            setVarScalar(interp, "op_buffer", const0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set operand_ev_types {}
            setVarScalar(interp, "operand_ev_types", const0, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set type [...]
            TclObject tmp0;
            { // Invoke: lindex $op_tuple 0
                TclObject tmp1 = getVarScalar(interp, "op_tuple", compiledLocals, 0);
                tmp1 = TclList.index(interp, tmp1, 0);
                if ( tmp1 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp1);
                }
            } // End Invoke: lindex
            tmp0 = interp.getResult();
            setVarScalar(interp, "type", tmp0, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: $type != "unary operator"
            TclObject tmp2 = getVarScalar(interp, "type", compiledLocals, 4);
            boolean tmp3 = ! tmp2.toString().equals("unary operator");
            ExprValue tmp4 = evs0;
            tmp4.setIntValue(tmp3);
            // End Binary operator: !=
            boolean tmp5 = ( tmp4.getIntValue() != 0 );
            if ( tmp5 ) {
                { // Invoke: error "..."
                    TclObject[] objv6 = TJC.grabObjv(interp, 2);
                    TclObject tmp7;
                    try {
                        // Arg 0 constant: error
                        objv6[0] = const1;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp8 = new StringBuffer(64);
                        sbtmp8.append("expected ");
                        sbtmp8.append("{");
                        sbtmp8.append("unary operator");
                        sbtmp8.append("}");
                        sbtmp8.append(" but got type ");
                        sbtmp8.append("{");
                        tmp7 = getVarScalar(interp, "type", compiledLocals, 4);
                        sbtmp8.append(tmp7.toString());
                        sbtmp8.append("}");
                        tmp7 = TclString.newInstance(sbtmp8);
                        tmp7.preserve();
                        objv6[1] = tmp7;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv6, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp7 = objv6[1];
                        if ( tmp7 != null ) {
                            tmp7.release();
                        }
                        TJC.releaseObjv(interp, objv6, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set vtuple [...]
            TclObject tmp9;
            { // Invoke: lindex $op_tuple 1
                TclObject tmp10 = getVarScalar(interp, "op_tuple", compiledLocals, 0);
                tmp10 = TclList.index(interp, tmp10, 1);
                if ( tmp10 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp10);
                }
            } // End Invoke: lindex
            tmp9 = interp.getResult();
            setVarScalar(interp, "vtuple", tmp9, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: set op [...]
            TclObject tmp11;
            { // Invoke: lindex $vtuple 0
                TclObject tmp12 = getVarScalar(interp, "vtuple", compiledLocals, 5);
                tmp12 = TclList.index(interp, tmp12, 0);
                if ( tmp12 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp12);
                }
            } // End Invoke: lindex
            tmp11 = interp.getResult();
            setVarScalar(interp, "op", tmp11, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: set values [...]
            TclObject tmp13;
            { // Invoke: lindex $vtuple 1
                TclObject tmp14 = getVarScalar(interp, "vtuple", compiledLocals, 5);
                tmp14 = TclList.index(interp, tmp14, 1);
                if ( tmp14 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp14);
                }
            } // End Invoke: lindex
            tmp13 = interp.getResult();
            setVarScalar(interp, "values", tmp13, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: [...] != 1
            { // Invoke: llength $values
                TclObject tmp15 = getVarScalar(interp, "values", compiledLocals, 7);
                int tmp16 = TclList.getLength(interp, tmp15);
                interp.setResult(tmp16);
            } // End Invoke: llength
            TclObject tmp17 = interp.getResult();
            ExprValue tmp18 = evs0;
            TJC.exprInitValue(interp, tmp18, tmp17);
            ExprValue tmp19 = evs1;
            tmp19.setIntValue(1);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp18, tmp19);
            // End Binary operator: !=
            boolean tmp20 = ( tmp18.getIntValue() != 0 );
            if ( tmp20 ) {
                { // Invoke: error "..."
                    TclObject[] objv21 = TJC.grabObjv(interp, 2);
                    TclObject tmp22;
                    try {
                        // Arg 0 constant: error
                        objv21[0] = const1;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp23 = new StringBuffer(64);
                        sbtmp23.append("values length should be 1, not ");
                        { // Invoke: llength $values
                            TclObject tmp24 = getVarScalar(interp, "values", compiledLocals, 7);
                            int tmp25 = TclList.getLength(interp, tmp24);
                            interp.setResult(tmp25);
                        } // End Invoke: llength
                        tmp22 = interp.getResult();
                        sbtmp23.append(tmp22.toString());
                        sbtmp23.append(", values_list was ");
                        sbtmp23.append("{");
                        tmp22 = getVarScalar(interp, "values", compiledLocals, 7);
                        sbtmp23.append(tmp22.toString());
                        sbtmp23.append("}");
                        tmp22 = TclString.newInstance(sbtmp23);
                        tmp22.preserve();
                        objv21[1] = tmp22;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv21, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp22 = objv21[1];
                        if ( tmp22 != null ) {
                            tmp22.release();
                        }
                        TJC.releaseObjv(interp, objv21, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set tuple [...]
            TclObject tmp26;
            { // Invoke: lindex $values 0
                TclObject tmp27 = getVarScalar(interp, "values", compiledLocals, 7);
                tmp27 = TclList.index(interp, tmp27, 0);
                if ( tmp27 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp27);
                }
            } // End Invoke: lindex
            tmp26 = interp.getResult();
            setVarScalar(interp, "tuple", tmp26, compiledLocals, 8);
        } // End Invoke: set
        { // Invoke: set peek_tuple [...]
            TclObject tmp28;
            { // Invoke: ... $tuple
                TclObject[] objv29 = TJC.grabObjv(interp, 2);
                TclObject tmp30;
                try {
                    // Arg 0 constant: ...
                    objv29[0] = const2;
                    // Arg 1 variable: $tuple
                    tmp30 = getVarScalar(interp, "tuple", compiledLocals, 8);
                    tmp30.preserve();
                    objv29[1] = tmp30;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv29, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp30 = objv29[1];
                    if ( tmp30 != null ) {
                        tmp30.release();
                    }
                    TJC.releaseObjv(interp, objv29, 2);
                }
            } // End Invoke: ...
            tmp28 = interp.getResult();
            setVarScalar(interp, "peek_tuple", tmp28, compiledLocals, 9);
        } // End Invoke: set
        { // Invoke: set value_info_type [...]
            TclObject tmp31;
            { // Invoke: lindex $peek_tuple 0
                TclObject tmp32 = getVarScalar(interp, "peek_tuple", compiledLocals, 9);
                tmp32 = TclList.index(interp, tmp32, 0);
                if ( tmp32 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp32);
                }
            } // End Invoke: lindex
            tmp31 = interp.getResult();
            setVarScalar(interp, "value_info_type", tmp31, compiledLocals, 10);
        } // End Invoke: set
        { // Invoke: set value_info_value [...]
            TclObject tmp33;
            { // Invoke: lindex $peek_tuple 1
                TclObject tmp34 = getVarScalar(interp, "peek_tuple", compiledLocals, 9);
                tmp34 = TclList.index(interp, tmp34, 1);
                if ( tmp34 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp34);
                }
            } // End Invoke: lindex
            tmp33 = interp.getResult();
            setVarScalar(interp, "value_info_value", tmp33, compiledLocals, 11);
        } // End Invoke: set
        { // Invoke: set ... [...]
            TclObject tmp35;
            { // Invoke: lindex $peek_tuple 2
                TclObject tmp36 = getVarScalar(interp, "peek_tuple", compiledLocals, 9);
                tmp36 = TclList.index(interp, tmp36, 2);
                if ( tmp36 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp36);
                }
            } // End Invoke: lindex
            tmp35 = interp.getResult();
            setVarScalar(interp, "value_info_has_null_string", tmp35, compiledLocals, 12);
        } // End Invoke: set
        { // Invoke: set infostr [...]
            TclObject tmp37;
            { // Invoke: lindex $peek_tuple 3
                TclObject tmp38 = getVarScalar(interp, "peek_tuple", compiledLocals, 9);
                tmp38 = TclList.index(interp, tmp38, 3);
                if ( tmp38 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp38);
                }
            } // End Invoke: lindex
            tmp37 = interp.getResult();
            setVarScalar(interp, "infostr", tmp37, compiledLocals, 13);
        } // End Invoke: set
        { // Invoke: set is_numeric_literal 0
            setVarScalar(interp, "is_numeric_literal", const3, compiledLocals, 14);
        } // End Invoke: set
        { // Invoke: set ... 0
            setVarScalar(interp, "is_numeric_literal_int", const3, compiledLocals, 15);
        } // End Invoke: set
        { // Invoke: set ... 0
            setVarScalar(interp, "is_numeric_literal_double", const3, compiledLocals, 16);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: () || ()
            // Binary operator: $value_info_type == "int literal"
            TclObject tmp39 = getVarScalar(interp, "value_info_type", compiledLocals, 10);
            boolean tmp40 = tmp39.toString().equals("int literal");
            ExprValue tmp41 = evs0;
            tmp41.setIntValue(tmp40);
            // End Binary operator: ==
            if (!tmp41.getBooleanValue(interp)) {
            // Binary operator: $value_info_type == "double literal"
            TclObject tmp42 = getVarScalar(interp, "value_info_type", compiledLocals, 10);
            boolean tmp43 = tmp42.toString().equals("double literal");
            ExprValue tmp44 = evs1;
            tmp44.setIntValue(tmp43);
            // End Binary operator: ==
            tmp41.setIntValue(tmp44.getBooleanValue(interp));
            } else {
            tmp41.setIntValue(1);
            } // End if: !()
            // End Binary operator: ||
            boolean tmp45 = ( tmp41.getIntValue() != 0 );
            if ( tmp45 ) {
                { // Invoke: set is_numeric_literal 1
                    setVarScalar(interp, "is_numeric_literal", const4, compiledLocals, 14);
                } // End Invoke: set
                { // Invoke: set numeric_literal $value_info_value
                    TclObject tmp46;
                    tmp46 = getVarScalar(interp, "value_info_value", compiledLocals, 11);
                    setVarScalar(interp, "numeric_literal", tmp46, compiledLocals, 17);
                } // End Invoke: set
                { // Invoke: set ... [...]
                    TclObject tmp47;
                    { // Invoke: string equal $value_info_type {int literal}
                        TclObject tmp48 = getVarScalar(interp, "value_info_type", compiledLocals, 10);
                        String tmp49 = tmp48.toString();
                        String tmp50 = const5.toString();
                        boolean tmp51 = tmp49.equals(tmp50);
                        interp.setResult(tmp51);
                    } // End Invoke: string
                    tmp47 = interp.getResult();
                    setVarScalar(interp, "is_numeric_literal_int", tmp47, compiledLocals, 15);
                } // End Invoke: set
                { // Invoke: set ... [...]
                    TclObject tmp52;
                    { // Invoke: string equal $value_info_type {double literal}
                        TclObject tmp53 = getVarScalar(interp, "value_info_type", compiledLocals, 10);
                        String tmp54 = tmp53.toString();
                        String tmp55 = const6.toString();
                        boolean tmp56 = tmp54.equals(tmp55);
                        interp.setResult(tmp56);
                    } // End Invoke: string
                    tmp52 = interp.getResult();
                    setVarScalar(interp, "is_numeric_literal_double", tmp52, compiledLocals, 16);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: set skip_unary_op_call 0
            setVarScalar(interp, "skip_unary_op_call", const3, compiledLocals, 18);
        } // End Invoke: set
        { // Invoke: set plus_number 0
            setVarScalar(interp, "plus_number", const3, compiledLocals, 19);
        } // End Invoke: set
        { // Invoke: set negate_number 0
            setVarScalar(interp, "negate_number", const3, compiledLocals, 20);
        } // End Invoke: set
        { // Invoke: set ... 0
            setVarScalar(interp, "bitwise_negate_number", const3, compiledLocals, 21);
        } // End Invoke: set
        { // Invoke: if ... ... elseif ... ... elseif ... ... elseif ... ...
            // Binary operator: () && ()
            // Binary operator: $op == "-"
            TclObject tmp57 = getVarScalar(interp, "op", compiledLocals, 6);
            boolean tmp58 = tmp57.toString().equals("-");
            ExprValue tmp59 = evs0;
            tmp59.setIntValue(tmp58);
            // End Binary operator: ==
            if (tmp59.getBooleanValue(interp)) {
            // Binary operator: $value_info_type == "String"
            TclObject tmp60 = getVarScalar(interp, "value_info_type", compiledLocals, 10);
            boolean tmp61 = tmp60.toString().equals("String");
            ExprValue tmp62 = evs1;
            tmp62.setIntValue(tmp61);
            // End Binary operator: ==
            tmp59.setIntValue(tmp62.getBooleanValue(interp));
            } else {
            tmp59.setIntValue(0);
            } // End if: ()
            // End Binary operator: &&
            boolean tmp63 = ( tmp59.getIntValue() != 0 );
            if ( tmp63 ) {
                { // Invoke: set numeric_literal [...]
                    TclObject tmp64;
                    { // Invoke: string range $value_info_value 1 end-1
                        TclObject tmp65 = getVarScalar(interp, "value_info_value", compiledLocals, 11);
                        String tmp66 = tmp65.toString();
                        TclObject tmp67 = const4;
                        tmp67.preserve();
                        TclObject tmp68 = const7;
                        TclObject tmp69 = TJC.stringRange(interp, tmp66, tmp67, tmp68);
                        interp.setResult(tmp69);
                    } // End Invoke: string
                    tmp64 = interp.getResult();
                    setVarScalar(interp, "numeric_literal", tmp64, compiledLocals, 17);
                } // End Invoke: set
                { // Invoke: set numeric_literal [...]
                    TclObject tmp70;
                    { // Invoke: string trim $numeric_literal
                        TclObject[] objv71 = TJC.grabObjv(interp, 3);
                        TclObject tmp72;
                        try {
                            // Arg 0 constant: string
                            objv71[0] = const8;
                            // Arg 1 constant: trim
                            objv71[1] = const9;
                            // Arg 2 variable: $numeric_literal
                            tmp72 = getVarScalar(interp, "numeric_literal", compiledLocals, 17);
                            tmp72.preserve();
                            objv71[2] = tmp72;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv71, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            tmp72 = objv71[2];
                            if ( tmp72 != null ) {
                                tmp72.release();
                            }
                            TJC.releaseObjv(interp, objv71, 3);
                        }
                    } // End Invoke: string
                    tmp70 = interp.getResult();
                    setVarScalar(interp, "numeric_literal", tmp70, compiledLocals, 17);
                } // End Invoke: set
                { // Invoke: set first [...]
                    TclObject tmp73;
                    { // Invoke: string index $numeric_literal 0
                        TclObject tmp74 = getVarScalar(interp, "numeric_literal", compiledLocals, 17);
                        String tmp75 = tmp74.toString();
                        TclObject tmp76 = TJC.stringIndex(interp, tmp75, const3);
                        interp.setResult(tmp76);
                    } // End Invoke: string
                    tmp73 = interp.getResult();
                    setVarScalar(interp, "first", tmp73, compiledLocals, 22);
                } // End Invoke: set
                { // Invoke: if {$first == "-"} ... else ...
                    // Binary operator: $first == "-"
                    TclObject tmp77 = getVarScalar(interp, "first", compiledLocals, 22);
                    boolean tmp78 = tmp77.toString().equals("-");
                    ExprValue tmp79 = evs0;
                    tmp79.setIntValue(tmp78);
                    // End Binary operator: ==
                    boolean tmp80 = ( tmp79.getIntValue() != 0 );
                    if ( tmp80 ) {
                        { // Invoke: set is_already_negative 1
                            setVarScalar(interp, "is_already_negative", const4, compiledLocals, 23);
                        } // End Invoke: set
                    } else {
                        { // Invoke: set is_already_negative 0
                            setVarScalar(interp, "is_already_negative", const3, compiledLocals, 23);
                        } // End Invoke: set
                    }
                } // End Invoke: if
                { // Invoke: set min "-0x80000000"
                    setVarScalar(interp, "min", const10, compiledLocals, 24);
                } // End Invoke: set
                { // Invoke: set wneg "..."
                    TclObject tmp81;
                    StringBuffer sbtmp82 = new StringBuffer(64);
                    sbtmp82.append("-");
                    tmp81 = getVarScalar(interp, "numeric_literal", compiledLocals, 17);
                    sbtmp82.append(tmp81.toString());
                    tmp81 = TclString.newInstance(sbtmp82);
                    setVarScalar(interp, "wneg", tmp81, compiledLocals, 25);
                } // End Invoke: set
                { // Invoke: set is_jint [...]
                    TclObject tmp83;
                    { // Invoke: ... $wneg
                        TclObject[] objv84 = TJC.grabObjv(interp, 2);
                        TclObject tmp85;
                        try {
                            // Arg 0 constant: ...
                            objv84[0] = const11;
                            // Arg 1 variable: $wneg
                            tmp85 = getVarScalar(interp, "wneg", compiledLocals, 25);
                            tmp85.preserve();
                            objv84[1] = tmp85;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                ? cmdcache4.cmd : null), objv84, 0);
                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                updateCmdCache(interp, 4);
                            }
                        } finally {
                            tmp85 = objv84[1];
                            if ( tmp85 != null ) {
                                tmp85.release();
                            }
                            TJC.releaseObjv(interp, objv84, 2);
                        }
                    } // End Invoke: ...
                    tmp83 = interp.getResult();
                    setVarScalar(interp, "is_jint", tmp83, compiledLocals, 26);
                } // End Invoke: set
                { // Invoke: if ... ... else ...
                    // Binary operator: () && ()
                    // Binary operator: () && $is_jint
                    // Unary operator: ! $is_already_negative
                    TclObject tmp86 = getVarScalar(interp, "is_already_negative", compiledLocals, 23);
                    ExprValue tmp87 = evs0;
                    if ( tmp86.isIntType() ) {
                        TJC.exprUnaryNotOperatorKnownInt(tmp87, tmp86);
                    } else {
                        TJC.exprUnaryNotOperator(interp, tmp87, tmp86);
                    }
                    // End Unary operator: !
                    if (tmp87.getBooleanValue(interp)) {
                    TclObject tmp88 = getVarScalar(interp, "is_jint", compiledLocals, 26);
                    ExprValue tmp89 = evs1;
                    TJC.exprInitValue(interp, tmp89, tmp88);
                    tmp87.setIntValue(tmp89.getBooleanValue(interp));
                    } else {
                    tmp87.setIntValue(0);
                    } // End if: ()
                    // End Binary operator: &&
                    if (tmp87.getBooleanValue(interp)) {
                    // Binary operator: $wneg == $min
                    TclObject tmp90 = getVarScalar(interp, "wneg", compiledLocals, 25);
                    ExprValue tmp91 = evs1;
                    TJC.exprInitValue(interp, tmp91, tmp90);
                    TclObject tmp92 = getVarScalar(interp, "min", compiledLocals, 24);
                    ExprValue tmp93 = evs2;
                    TJC.exprInitValue(interp, tmp93, tmp92);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp91, tmp93);
                    // End Binary operator: ==
                    tmp87.setIntValue(tmp91.getBooleanValue(interp));
                    } else {
                    tmp87.setIntValue(0);
                    } // End if: ()
                    // End Binary operator: &&
                    boolean tmp94 = ( tmp87.getIntValue() != 0 );
                    if ( tmp94 ) {
                        { // Invoke: set negate_number 1
                            setVarScalar(interp, "negate_number", const4, compiledLocals, 20);
                        } // End Invoke: set
                    } else {
                        { // Invoke: set negate_number 0
                            setVarScalar(interp, "negate_number", const3, compiledLocals, 20);
                        } // End Invoke: set
                    }
                } // End Invoke: if
            } else {
                // Binary operator: () && ()
                // Binary operator: () && $is_numeric_literal
                // Binary operator: $op == "-"
                TclObject tmp95 = getVarScalar(interp, "op", compiledLocals, 6);
                boolean tmp96 = tmp95.toString().equals("-");
                ExprValue tmp97 = evs0;
                tmp97.setIntValue(tmp96);
                // End Binary operator: ==
                if (tmp97.getBooleanValue(interp)) {
                TclObject tmp98 = getVarScalar(interp, "is_numeric_literal", compiledLocals, 14);
                ExprValue tmp99 = evs1;
                TJC.exprInitValue(interp, tmp99, tmp98);
                tmp97.setIntValue(tmp99.getBooleanValue(interp));
                } else {
                tmp97.setIntValue(0);
                } // End if: ()
                // End Binary operator: &&
                if (tmp97.getBooleanValue(interp)) {
                // Binary operator: $numeric_literal > 0
                TclObject tmp100 = getVarScalar(interp, "numeric_literal", compiledLocals, 17);
                ExprValue tmp101 = evs1;
                TJC.exprInitValue(interp, tmp101, tmp100);
                ExprValue tmp102 = evs2;
                tmp102.setIntValue(0);
                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GREATER, tmp101, tmp102);
                // End Binary operator: >
                tmp97.setIntValue(tmp101.getBooleanValue(interp));
                } else {
                tmp97.setIntValue(0);
                } // End if: ()
                // End Binary operator: &&
                boolean tmp103 = ( tmp97.getIntValue() != 0 );
                if ( tmp103 ) {
                    { // Invoke: set negate_number 1
                        setVarScalar(interp, "negate_number", const4, compiledLocals, 20);
                    } // End Invoke: set
                } else {
                    // Binary operator: () && $is_numeric_literal
                    // Binary operator: $op == "+"
                    TclObject tmp104 = getVarScalar(interp, "op", compiledLocals, 6);
                    boolean tmp105 = tmp104.toString().equals("+");
                    ExprValue tmp106 = evs0;
                    tmp106.setIntValue(tmp105);
                    // End Binary operator: ==
                    if (tmp106.getBooleanValue(interp)) {
                    TclObject tmp107 = getVarScalar(interp, "is_numeric_literal", compiledLocals, 14);
                    ExprValue tmp108 = evs1;
                    TJC.exprInitValue(interp, tmp108, tmp107);
                    tmp106.setIntValue(tmp108.getBooleanValue(interp));
                    } else {
                    tmp106.setIntValue(0);
                    } // End if: ()
                    // End Binary operator: &&
                    boolean tmp109 = ( tmp106.getIntValue() != 0 );
                    if ( tmp109 ) {
                        { // Invoke: set plus_number 1
                            setVarScalar(interp, "plus_number", const4, compiledLocals, 19);
                        } // End Invoke: set
                    } else {
                        // Binary operator: () && $is_numeric_literal_int
                        // Binary operator: () && $is_numeric_literal
                        // Binary operator: $op == "~"
                        TclObject tmp110 = getVarScalar(interp, "op", compiledLocals, 6);
                        boolean tmp111 = tmp110.toString().equals("~");
                        ExprValue tmp112 = evs0;
                        tmp112.setIntValue(tmp111);
                        // End Binary operator: ==
                        if (tmp112.getBooleanValue(interp)) {
                        TclObject tmp113 = getVarScalar(interp, "is_numeric_literal", compiledLocals, 14);
                        ExprValue tmp114 = evs1;
                        TJC.exprInitValue(interp, tmp114, tmp113);
                        tmp112.setIntValue(tmp114.getBooleanValue(interp));
                        } else {
                        tmp112.setIntValue(0);
                        } // End if: ()
                        // End Binary operator: &&
                        if (tmp112.getBooleanValue(interp)) {
                        TclObject tmp115 = getVarScalar(interp, "is_numeric_literal_int", compiledLocals, 15);
                        ExprValue tmp116 = evs1;
                        TJC.exprInitValue(interp, tmp116, tmp115);
                        tmp112.setIntValue(tmp116.getBooleanValue(interp));
                        } else {
                        tmp112.setIntValue(0);
                        } // End if: ()
                        // End Binary operator: &&
                        boolean tmp117 = ( tmp112.getIntValue() != 0 );
                        if ( tmp117 ) {
                            { // Invoke: set ... 1
                                setVarScalar(interp, "bitwise_negate_number", const4, compiledLocals, 21);
                            } // End Invoke: set
                        }
                    }
                }
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            // Binary operator: () || $plus_number
            // Binary operator: $negate_number || $bitwise_negate_number
            TclObject tmp118 = getVarScalar(interp, "negate_number", compiledLocals, 20);
            ExprValue tmp119 = evs0;
            TJC.exprInitValue(interp, tmp119, tmp118);
            if (!tmp119.getBooleanValue(interp)) {
            TclObject tmp120 = getVarScalar(interp, "bitwise_negate_number", compiledLocals, 21);
            ExprValue tmp121 = evs1;
            TJC.exprInitValue(interp, tmp121, tmp120);
            tmp119.setIntValue(tmp121.getBooleanValue(interp));
            } else {
            tmp119.setIntValue(1);
            } // End if: !$negate_number
            // End Binary operator: ||
            if (!tmp119.getBooleanValue(interp)) {
            TclObject tmp122 = getVarScalar(interp, "plus_number", compiledLocals, 19);
            ExprValue tmp123 = evs1;
            TJC.exprInitValue(interp, tmp123, tmp122);
            tmp119.setIntValue(tmp123.getBooleanValue(interp));
            } else {
            tmp119.setIntValue(1);
            } // End if: !()
            // End Binary operator: ||
            boolean tmp124 = ( tmp119.getIntValue() != 0 );
            if ( tmp124 ) {
                { // Invoke: if ... ... elseif {$plus_number} ... elseif {$negate_number} ... else ...
                    TclObject tmp125 = getVarScalar(interp, "bitwise_negate_number", compiledLocals, 21);
                    boolean tmp126 = TJC.getBoolean(interp, tmp125);
                    if ( tmp126 ) {
                        { // Invoke: set tuple [...]
                            TclObject tmp127;
                            { // Invoke: list {constant int} "..."
                                TclObject tmp128 = TclList.newInstance();
                                TclObject tmp129;
                                try {
                                    TclList.append(interp, tmp128, const12);
                                    StringBuffer sbtmp130 = new StringBuffer(64);
                                    sbtmp130.append("~");
                                    tmp129 = getVarScalar(interp, "numeric_literal", compiledLocals, 17);
                                    sbtmp130.append(tmp129.toString());
                                    tmp129 = TclString.newInstance(sbtmp130);
                                    TclList.append(interp, tmp128, tmp129);
                                } catch (TclException ex) {
                                    tmp128.release();
                                    throw ex;
                                }
                                interp.setResult(tmp128);
                            } // End Invoke: list
                            tmp127 = interp.getResult();
                            setVarScalar(interp, "tuple", tmp127, compiledLocals, 8);
                        } // End Invoke: set
                        { // Invoke: set operand_ev_types int
                            setVarScalar(interp, "operand_ev_types", const13, compiledLocals, 3);
                        } // End Invoke: set
                    } else {
                        TclObject tmp131 = getVarScalar(interp, "plus_number", compiledLocals, 19);
                        boolean tmp132 = TJC.getBoolean(interp, tmp131);
                        if ( tmp132 ) {
                            { // Invoke: if ... ... elseif ... ... else ...
                                TclObject tmp133 = getVarScalar(interp, "is_numeric_literal_int", compiledLocals, 15);
                                boolean tmp134 = TJC.getBoolean(interp, tmp133);
                                if ( tmp134 ) {
                                    { // Invoke: set tuple [...]
                                        TclObject tmp135;
                                        { // Invoke: list {constant int} $numeric_literal
                                            TclObject tmp136 = TclList.newInstance();
                                            TclObject tmp137;
                                            try {
                                                TclList.append(interp, tmp136, const12);
                                                tmp137 = getVarScalar(interp, "numeric_literal", compiledLocals, 17);
                                                TclList.append(interp, tmp136, tmp137);
                                            } catch (TclException ex) {
                                                tmp136.release();
                                                throw ex;
                                            }
                                            interp.setResult(tmp136);
                                        } // End Invoke: list
                                        tmp135 = interp.getResult();
                                        setVarScalar(interp, "tuple", tmp135, compiledLocals, 8);
                                    } // End Invoke: set
                                    { // Invoke: set operand_ev_types int
                                        setVarScalar(interp, "operand_ev_types", const13, compiledLocals, 3);
                                    } // End Invoke: set
                                } else {
                                    TclObject tmp138 = getVarScalar(interp, "is_numeric_literal_double", compiledLocals, 16);
                                    boolean tmp139 = TJC.getBoolean(interp, tmp138);
                                    if ( tmp139 ) {
                                        { // Invoke: set tuple [...]
                                            TclObject tmp140;
                                            { // Invoke: list {constant double} $numeric_literal
                                                TclObject tmp141 = TclList.newInstance();
                                                TclObject tmp142;
                                                try {
                                                    TclList.append(interp, tmp141, const14);
                                                    tmp142 = getVarScalar(interp, "numeric_literal", compiledLocals, 17);
                                                    TclList.append(interp, tmp141, tmp142);
                                                } catch (TclException ex) {
                                                    tmp141.release();
                                                    throw ex;
                                                }
                                                interp.setResult(tmp141);
                                            } // End Invoke: list
                                            tmp140 = interp.getResult();
                                            setVarScalar(interp, "tuple", tmp140, compiledLocals, 8);
                                        } // End Invoke: set
                                        { // Invoke: set operand_ev_types double
                                            setVarScalar(interp, "operand_ev_types", const15, compiledLocals, 3);
                                        } // End Invoke: set
                                    } else {
                                        { // Invoke: error ...
                                            TclObject[] objv143 = TJC.grabObjv(interp, 2);
                                            try {
                                                // Arg 0 constant: error
                                                objv143[0] = const1;
                                                // Arg 1 constant: ...
                                                objv143[1] = const16;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                                    ? cmdcache1.cmd : null), objv143, 0);
                                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                                    updateCmdCache(interp, 1);
                                                }
                                            } finally {
                                                TJC.releaseObjv(interp, objv143, 2);
                                            }
                                        } // End Invoke: error
                                    }
                                }
                            } // End Invoke: if
                        } else {
                            TclObject tmp144 = getVarScalar(interp, "negate_number", compiledLocals, 20);
                            boolean tmp145 = TJC.getBoolean(interp, tmp144);
                            if ( tmp145 ) {
                                { // Invoke: set tuple [...]
                                    TclObject tmp146;
                                    { // Invoke: list [...] "..."
                                        TclObject tmp147 = TclList.newInstance();
                                        TclObject tmp148;
                                        try {
                                            { // Invoke: lindex $tuple 0
                                                TclObject tmp149 = getVarScalar(interp, "tuple", compiledLocals, 8);
                                                tmp149 = TclList.index(interp, tmp149, 0);
                                                if ( tmp149 == null ) {
                                                    interp.resetResult();
                                                } else {
                                                    interp.setResult(tmp149);
                                                }
                                            } // End Invoke: lindex
                                            tmp148 = interp.getResult();
                                            TclList.append(interp, tmp147, tmp148);
                                            StringBuffer sbtmp150 = new StringBuffer(64);
                                            sbtmp150.append("-");
                                            tmp148 = getVarScalar(interp, "numeric_literal", compiledLocals, 17);
                                            sbtmp150.append(tmp148.toString());
                                            tmp148 = TclString.newInstance(sbtmp150);
                                            TclList.append(interp, tmp147, tmp148);
                                        } catch (TclException ex) {
                                            tmp147.release();
                                            throw ex;
                                        }
                                        interp.setResult(tmp147);
                                    } // End Invoke: list
                                    tmp146 = interp.getResult();
                                    setVarScalar(interp, "tuple", tmp146, compiledLocals, 8);
                                } // End Invoke: set
                                { // Invoke: if ... ... elseif ... ...
                                    TclObject tmp151 = getVarScalar(interp, "is_numeric_literal_int", compiledLocals, 15);
                                    boolean tmp152 = TJC.getBoolean(interp, tmp151);
                                    if ( tmp152 ) {
                                        { // Invoke: set operand_ev_types int
                                            setVarScalar(interp, "operand_ev_types", const13, compiledLocals, 3);
                                        } // End Invoke: set
                                    } else {
                                        TclObject tmp153 = getVarScalar(interp, "is_numeric_literal_double", compiledLocals, 16);
                                        boolean tmp154 = TJC.getBoolean(interp, tmp153);
                                        if ( tmp154 ) {
                                            { // Invoke: set operand_ev_types double
                                                setVarScalar(interp, "operand_ev_types", const15, compiledLocals, 3);
                                            } // End Invoke: set
                                        }
                                    }
                                } // End Invoke: if
                            } else {
                                { // Invoke: error "unknown operation"
                                    TclObject[] objv155 = TJC.grabObjv(interp, 2);
                                    try {
                                        // Arg 0 constant: error
                                        objv155[0] = const1;
                                        // Arg 1 constant: "unknown operation"
                                        objv155[1] = const17;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                            ? cmdcache1.cmd : null), objv155, 0);
                                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                            updateCmdCache(interp, 1);
                                        }
                                    } finally {
                                        TJC.releaseObjv(interp, objv155, 2);
                                    }
                                } // End Invoke: error
                            }
                        }
                    }
                } // End Invoke: if
                { // Invoke: set eval_tuple [...]
                    TclObject tmp156;
                    { // Invoke: ... $tuple
                        TclObject[] objv157 = TJC.grabObjv(interp, 2);
                        TclObject tmp158;
                        try {
                            // Arg 0 constant: ...
                            objv157[0] = const18;
                            // Arg 1 variable: $tuple
                            tmp158 = getVarScalar(interp, "tuple", compiledLocals, 8);
                            tmp158.preserve();
                            objv157[1] = tmp158;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                ? cmdcache5.cmd : null), objv157, 0);
                            if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                updateCmdCache(interp, 5);
                            }
                        } finally {
                            tmp158 = objv157[1];
                            if ( tmp158 != null ) {
                                tmp158.release();
                            }
                            TJC.releaseObjv(interp, objv157, 2);
                        }
                    } // End Invoke: ...
                    tmp156 = interp.getResult();
                    setVarScalar(interp, "eval_tuple", tmp156, compiledLocals, 27);
                } // End Invoke: set
                { // Invoke: set ev [...]
                    TclObject tmp159;
                    { // Invoke: lindex $eval_tuple 1
                        TclObject tmp160 = getVarScalar(interp, "eval_tuple", compiledLocals, 27);
                        tmp160 = TclList.index(interp, tmp160, 1);
                        if ( tmp160 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp160);
                        }
                    } // End Invoke: lindex
                    tmp159 = interp.getResult();
                    setVarScalar(interp, "ev", tmp159, compiledLocals, 28);
                } // End Invoke: set
                { // Invoke: set op_buffer [...]
                    TclObject tmp161;
                    { // Invoke: lindex $eval_tuple 2
                        TclObject tmp162 = getVarScalar(interp, "eval_tuple", compiledLocals, 27);
                        tmp162 = TclList.index(interp, tmp162, 2);
                        if ( tmp162 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp162);
                        }
                    } // End Invoke: lindex
                    tmp161 = interp.getResult();
                    setVarScalar(interp, "op_buffer", tmp161, compiledLocals, 2);
                } // End Invoke: set
                { // Invoke: set skip_unary_op_call 1
                    setVarScalar(interp, "skip_unary_op_call", const4, compiledLocals, 18);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: set inline_op 0
            setVarScalar(interp, "inline_op", const3, compiledLocals, 29);
        } // End Invoke: set
        { // Invoke: switch -exact -- $op {+} ... {-} ... {!} ... {~} ... default ...
            TclObject tmp163 = getVarScalar(interp, "op", compiledLocals, 6);
            String tmp164 = tmp163.toString();
            int tmp164_length = tmp164.length();
            char tmp164_first = '\n';
            if ( tmp164_length > 0 ) {
                tmp164_first = tmp164.charAt(0);
            }
            if ( tmp164_length == 1 && tmp164_first == '+' ) {
                // Pattern {+}
                { // Invoke: set opval ...
                    setVarScalar(interp, "opval", const19, compiledLocals, 30);
                } // End Invoke: set
            } else if ( tmp164_length == 1 && tmp164_first == '-' ) {
                // Pattern {-}
                { // Invoke: set opval ...
                    setVarScalar(interp, "opval", const20, compiledLocals, 30);
                } // End Invoke: set
            } else if ( tmp164_length == 1 && tmp164_first == '!' ) {
                // Pattern {!}
                { // Invoke: set opval ...
                    setVarScalar(interp, "opval", const21, compiledLocals, 30);
                } // End Invoke: set
                { // Invoke: if ... ...
                    initVarScoped(interp, "::_compileproc", compiledLocals, 31);
                    TclObject tmp165 = getVarArray(interp, "::_compileproc", "options,expr_inline_operators", compiledLocals, 31);
                    ExprValue tmp166 = evs0;
                    TJC.exprInitValue(interp, tmp166, tmp165);
                    boolean tmp167 = tmp166.getBooleanValue(interp);
                    if ( tmp167 ) {
                        { // Invoke: set inline_op 1
                            setVarScalar(interp, "inline_op", const4, compiledLocals, 29);
                        } // End Invoke: set
                    }
                } // End Invoke: if
            } else if ( tmp164_length == 1 && tmp164_first == '~' ) {
                // Pattern {~}
                { // Invoke: set opval ...
                    setVarScalar(interp, "opval", const22, compiledLocals, 30);
                } // End Invoke: set
            } else {
                // Pattern default
                { // Invoke: error "..."
                    TclObject[] objv168 = TJC.grabObjv(interp, 2);
                    TclObject tmp169;
                    try {
                        // Arg 0 constant: error
                        objv168[0] = const1;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp170 = new StringBuffer(64);
                        sbtmp170.append("unsupported unary operator ");
                        sbtmp170.append("\"");
                        tmp169 = getVarScalar(interp, "op", compiledLocals, 6);
                        sbtmp170.append(tmp169.toString());
                        sbtmp170.append("\"");
                        tmp169 = TclString.newInstance(sbtmp170);
                        tmp169.preserve();
                        objv168[1] = tmp169;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv168, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp169 = objv168[1];
                        if ( tmp169 != null ) {
                            tmp169.release();
                        }
                        TJC.releaseObjv(interp, objv168, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: switch
        { // Invoke: if ... ... elseif {$inline_op} ... else ...
            TclObject tmp171 = getVarScalar(interp, "skip_unary_op_call", compiledLocals, 18);
            boolean tmp172 = TJC.getBoolean(interp, tmp171);
            if ( tmp172 ) {
            } else {
                TclObject tmp173 = getVarScalar(interp, "inline_op", compiledLocals, 29);
                boolean tmp174 = TJC.getBoolean(interp, tmp173);
                if ( tmp174 ) {
                    { // Invoke: switch -exact -- $op {+} ... {-} ... {!} ... {~} ...
                        TclObject tmp175 = getVarScalar(interp, "op", compiledLocals, 6);
                        String tmp176 = tmp175.toString();
                        int tmp176_length = tmp176.length();
                        char tmp176_first = '\n';
                        if ( tmp176_length > 0 ) {
                            tmp176_first = tmp176.charAt(0);
                        }
                        if ( tmp176_length == 1 && tmp176_first == '+' ) {
                            // Pattern {+}
                            { // Invoke: error ...
                                TclObject[] objv177 = TJC.grabObjv(interp, 2);
                                try {
                                    // Arg 0 constant: error
                                    objv177[0] = const1;
                                    // Arg 1 constant: ...
                                    objv177[1] = const23;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                        ? cmdcache1.cmd : null), objv177, 0);
                                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                        updateCmdCache(interp, 1);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv177, 2);
                                }
                            } // End Invoke: error
                        } else if ( tmp176_length == 1 && tmp176_first == '-' ) {
                            // Pattern {-}
                            { // Invoke: error ...
                                TclObject[] objv178 = TJC.grabObjv(interp, 2);
                                try {
                                    // Arg 0 constant: error
                                    objv178[0] = const1;
                                    // Arg 1 constant: ...
                                    objv178[1] = const24;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                        ? cmdcache1.cmd : null), objv178, 0);
                                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                        updateCmdCache(interp, 1);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv178, 2);
                                }
                            } // End Invoke: error
                        } else if ( tmp176_length == 1 && tmp176_first == '!' ) {
                            // Pattern {!}
                            { // Invoke: set op_tuple [...]
                                TclObject tmp179;
                                { // Invoke: ... $tuple $value_info_type $value_info_value $...
                                    TclObject[] objv180 = TJC.grabObjv(interp, 5);
                                    TclObject tmp181;
                                    try {
                                        // Arg 0 constant: ...
                                        objv180[0] = const25;
                                        // Arg 1 variable: $tuple
                                        tmp181 = getVarScalar(interp, "tuple", compiledLocals, 8);
                                        tmp181.preserve();
                                        objv180[1] = tmp181;
                                        // Arg 2 variable: $value_info_type
                                        tmp181 = getVarScalar(interp, "value_info_type", compiledLocals, 10);
                                        tmp181.preserve();
                                        objv180[2] = tmp181;
                                        // Arg 3 variable: $value_info_value
                                        tmp181 = getVarScalar(interp, "value_info_value", compiledLocals, 11);
                                        tmp181.preserve();
                                        objv180[3] = tmp181;
                                        // Arg 4 variable: $...
                                        tmp181 = getVarScalar(interp, "value_info_has_null_string", compiledLocals, 12);
                                        tmp181.preserve();
                                        objv180[4] = tmp181;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                            ? cmdcache6.cmd : null), objv180, 0);
                                        if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                            updateCmdCache(interp, 6);
                                        }
                                    } finally {
                                        tmp181 = objv180[1];
                                        if ( tmp181 != null ) {
                                            tmp181.release();
                                        }
                                        tmp181 = objv180[2];
                                        if ( tmp181 != null ) {
                                            tmp181.release();
                                        }
                                        tmp181 = objv180[3];
                                        if ( tmp181 != null ) {
                                            tmp181.release();
                                        }
                                        tmp181 = objv180[4];
                                        if ( tmp181 != null ) {
                                            tmp181.release();
                                        }
                                        TJC.releaseObjv(interp, objv180, 5);
                                    }
                                } // End Invoke: ...
                                tmp179 = interp.getResult();
                                setVarScalar(interp, "op_tuple", tmp179, compiledLocals, 0);
                            } // End Invoke: set
                        } else if ( tmp176_length == 1 && tmp176_first == '~' ) {
                            // Pattern {~}
                            { // Invoke: error ...
                                TclObject[] objv182 = TJC.grabObjv(interp, 2);
                                try {
                                    // Arg 0 constant: error
                                    objv182[0] = const1;
                                    // Arg 1 constant: ...
                                    objv182[1] = const26;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                        ? cmdcache1.cmd : null), objv182, 0);
                                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                        updateCmdCache(interp, 1);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv182, 2);
                                }
                            } // End Invoke: error
                        }
                    } // End Invoke: switch
                    { // Invoke: set ev [...]
                        TclObject tmp183;
                        { // Invoke: lindex $op_tuple 0
                            TclObject tmp184 = getVarScalar(interp, "op_tuple", compiledLocals, 0);
                            tmp184 = TclList.index(interp, tmp184, 0);
                            if ( tmp184 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp184);
                            }
                        } // End Invoke: lindex
                        tmp183 = interp.getResult();
                        setVarScalar(interp, "ev", tmp183, compiledLocals, 28);
                    } // End Invoke: set
                    { // Invoke: set op_buffer [...]
                        TclObject tmp185;
                        { // Invoke: lindex $op_tuple 1
                            TclObject tmp186 = getVarScalar(interp, "op_tuple", compiledLocals, 0);
                            tmp186 = TclList.index(interp, tmp186, 1);
                            if ( tmp186 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp186);
                            }
                        } // End Invoke: lindex
                        tmp185 = interp.getResult();
                        setVarScalar(interp, "op_buffer", tmp185, compiledLocals, 2);
                    } // End Invoke: set
                    { // Invoke: set operand_ev_types [...]
                        TclObject tmp187;
                        { // Invoke: lindex $op_tuple 2
                            TclObject tmp188 = getVarScalar(interp, "op_tuple", compiledLocals, 0);
                            tmp188 = TclList.index(interp, tmp188, 2);
                            if ( tmp188 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp188);
                            }
                        } // End Invoke: lindex
                        tmp187 = interp.getResult();
                        setVarScalar(interp, "operand_ev_types", tmp187, compiledLocals, 3);
                    } // End Invoke: set
                } else {
                    { // Invoke: set eval_tuple [...]
                        TclObject tmp189;
                        { // Invoke: ... $tuple
                            TclObject[] objv190 = TJC.grabObjv(interp, 2);
                            TclObject tmp191;
                            try {
                                // Arg 0 constant: ...
                                objv190[0] = const18;
                                // Arg 1 variable: $tuple
                                tmp191 = getVarScalar(interp, "tuple", compiledLocals, 8);
                                tmp191.preserve();
                                objv190[1] = tmp191;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                    ? cmdcache5.cmd : null), objv190, 0);
                                if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                    updateCmdCache(interp, 5);
                                }
                            } finally {
                                tmp191 = objv190[1];
                                if ( tmp191 != null ) {
                                    tmp191.release();
                                }
                                TJC.releaseObjv(interp, objv190, 2);
                            }
                        } // End Invoke: ...
                        tmp189 = interp.getResult();
                        setVarScalar(interp, "eval_tuple", tmp189, compiledLocals, 27);
                    } // End Invoke: set
                    { // Invoke: set ev [...]
                        TclObject tmp192;
                        { // Invoke: lindex $eval_tuple 1
                            TclObject tmp193 = getVarScalar(interp, "eval_tuple", compiledLocals, 27);
                            tmp193 = TclList.index(interp, tmp193, 1);
                            if ( tmp193 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp193);
                            }
                        } // End Invoke: lindex
                        tmp192 = interp.getResult();
                        setVarScalar(interp, "ev", tmp192, compiledLocals, 28);
                    } // End Invoke: set
                    { // Invoke: set operand_ev_types [...]
                        TclObject tmp194;
                        { // Invoke: lindex $eval_tuple 3 3
                            TclObject[] objv195 = TJC.grabObjv(interp, 4);
                            TclObject tmp196;
                            try {
                                // Arg 0 constant: lindex
                                objv195[0] = const27;
                                // Arg 1 variable: $eval_tuple
                                tmp196 = getVarScalar(interp, "eval_tuple", compiledLocals, 27);
                                tmp196.preserve();
                                objv195[1] = tmp196;
                                // Arg 2 constant: 3
                                objv195[2] = const28;
                                // Arg 3 constant: 3
                                objv195[3] = const28;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                    ? cmdcache7.cmd : null), objv195, 0);
                                if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                    updateCmdCache(interp, 7);
                                }
                            } finally {
                                tmp196 = objv195[1];
                                if ( tmp196 != null ) {
                                    tmp196.release();
                                }
                                TJC.releaseObjv(interp, objv195, 4);
                            }
                        } // End Invoke: lindex
                        tmp194 = interp.getResult();
                        setVarScalar(interp, "operand_ev_types", tmp194, compiledLocals, 3);
                    } // End Invoke: set
                    { // Invoke: append op_buffer [...] [...] ... $opval ", " $ev ...
                        TclObject[] objv197 = TJC.grabObjv(interp, 7);
                        TclObject tmp198;
                        try {
                            // Arg 2 command: [...]
                            { // Invoke: lindex $eval_tuple 2
                                TclObject tmp199 = getVarScalar(interp, "eval_tuple", compiledLocals, 27);
                                tmp199 = TclList.index(interp, tmp199, 2);
                                if ( tmp199 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp199);
                                }
                            } // End Invoke: lindex
                            tmp198 = interp.getResult();
                            tmp198.preserve();
                            objv197[0] = tmp198;
                            // Arg 3 command: [...]
                            { // Invoke: emitter_indent
                                TclObject[] objv200 = TJC.grabObjv(interp, 1);
                                try {
                                    // Arg 0 constant: emitter_indent
                                    objv200[0] = const29;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                        ? cmdcache8.cmd : null), objv200, 0);
                                    if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                        updateCmdCache(interp, 8);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv200, 1);
                                }
                            } // End Invoke: emitter_indent
                            tmp198 = interp.getResult();
                            tmp198.preserve();
                            objv197[1] = tmp198;
                            // Arg 4 constant: ...
                            objv197[2] = const30;
                            // Arg 5 variable: $opval
                            tmp198 = getVarScalar(interp, "opval", compiledLocals, 30);
                            tmp198.preserve();
                            objv197[3] = tmp198;
                            // Arg 6 constant: ", "
                            objv197[4] = const31;
                            // Arg 7 variable: $ev
                            tmp198 = getVarScalar(interp, "ev", compiledLocals, 28);
                            tmp198.preserve();
                            objv197[5] = tmp198;
                            // Arg 8 constant: ...
                            objv197[6] = const32;
                            interp.resetResult();
                            appendVarScalar(interp, "op_buffer", objv197, compiledLocals, 2);
                        } finally {
                            tmp198 = objv197[0];
                            if ( tmp198 != null ) {
                                tmp198.release();
                            }
                            tmp198 = objv197[1];
                            if ( tmp198 != null ) {
                                tmp198.release();
                            }
                            tmp198 = objv197[3];
                            if ( tmp198 != null ) {
                                tmp198.release();
                            }
                            tmp198 = objv197[5];
                            if ( tmp198 != null ) {
                                tmp198.release();
                            }
                            TJC.releaseObjv(interp, objv197, 7);
                        }
                    } // End Invoke: append
                }
            }
        } // End Invoke: if
        { // Invoke: append buffer [...] ... $op " " $infostr ... $op_buffer [...] ... $op ...
            TclObject[] objv201 = TJC.grabObjv(interp, 11);
            TclObject tmp202;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv203 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv203[0] = const29;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                            ? cmdcache8.cmd : null), objv203, 0);
                        if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                            updateCmdCache(interp, 8);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv203, 1);
                    }
                } // End Invoke: emitter_indent
                tmp202 = interp.getResult();
                tmp202.preserve();
                objv201[0] = tmp202;
                // Arg 3 constant: ...
                objv201[1] = const33;
                // Arg 4 variable: $op
                tmp202 = getVarScalar(interp, "op", compiledLocals, 6);
                tmp202.preserve();
                objv201[2] = tmp202;
                // Arg 5 constant: " "
                objv201[3] = const34;
                // Arg 6 variable: $infostr
                tmp202 = getVarScalar(interp, "infostr", compiledLocals, 13);
                tmp202.preserve();
                objv201[4] = tmp202;
                // Arg 7 constant: ...
                objv201[5] = const35;
                // Arg 8 variable: $op_buffer
                tmp202 = getVarScalar(interp, "op_buffer", compiledLocals, 2);
                tmp202.preserve();
                objv201[6] = tmp202;
                // Arg 9 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv204 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv204[0] = const29;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                            ? cmdcache8.cmd : null), objv204, 0);
                        if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                            updateCmdCache(interp, 8);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv204, 1);
                    }
                } // End Invoke: emitter_indent
                tmp202 = interp.getResult();
                tmp202.preserve();
                objv201[7] = tmp202;
                // Arg 10 constant: ...
                objv201[8] = const36;
                // Arg 11 variable: $op
                tmp202 = getVarScalar(interp, "op", compiledLocals, 6);
                tmp202.preserve();
                objv201[9] = tmp202;
                // Arg 12 constant: ...
                objv201[10] = const35;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv201, compiledLocals, 1);
            } finally {
                objv201[1] = null;
                objv201[3] = null;
                objv201[5] = null;
                objv201[8] = null;
                objv201[10] = null;
                TJC.releaseObjvElems(interp, objv201, 11);
            }
        } // End Invoke: append
        { // Invoke: if {$op == "!"} ... elseif {$op == "~"} ... elseif ... ...
            // Binary operator: $op == "!"
            TclObject tmp205 = getVarScalar(interp, "op", compiledLocals, 6);
            boolean tmp206 = tmp205.toString().equals("!");
            ExprValue tmp207 = evs0;
            tmp207.setIntValue(tmp206);
            // End Binary operator: ==
            boolean tmp208 = ( tmp207.getIntValue() != 0 );
            if ( tmp208 ) {
                { // Invoke: set ev_types boolean
                    setVarScalar(interp, "ev_types", const37, compiledLocals, 32);
                } // End Invoke: set
            } else {
                // Binary operator: $op == "~"
                TclObject tmp209 = getVarScalar(interp, "op", compiledLocals, 6);
                boolean tmp210 = tmp209.toString().equals("~");
                ExprValue tmp211 = evs0;
                tmp211.setIntValue(tmp210);
                // End Binary operator: ==
                boolean tmp212 = ( tmp211.getIntValue() != 0 );
                if ( tmp212 ) {
                    { // Invoke: set ev_types int
                        setVarScalar(interp, "ev_types", const13, compiledLocals, 32);
                    } // End Invoke: set
                } else {
                    // Binary operator: () || ()
                    // Binary operator: $op == "+"
                    TclObject tmp213 = getVarScalar(interp, "op", compiledLocals, 6);
                    boolean tmp214 = tmp213.toString().equals("+");
                    ExprValue tmp215 = evs0;
                    tmp215.setIntValue(tmp214);
                    // End Binary operator: ==
                    if (!tmp215.getBooleanValue(interp)) {
                    // Binary operator: $op == "-"
                    TclObject tmp216 = getVarScalar(interp, "op", compiledLocals, 6);
                    boolean tmp217 = tmp216.toString().equals("-");
                    ExprValue tmp218 = evs1;
                    tmp218.setIntValue(tmp217);
                    // End Binary operator: ==
                    tmp215.setIntValue(tmp218.getBooleanValue(interp));
                    } else {
                    tmp215.setIntValue(1);
                    } // End if: !()
                    // End Binary operator: ||
                    boolean tmp219 = ( tmp215.getIntValue() != 0 );
                    if ( tmp219 ) {
                        { // Invoke: if ... ... elseif ... ... else ...
                            // Binary operator: $operand_ev_types == "int"
                            TclObject tmp220 = getVarScalar(interp, "operand_ev_types", compiledLocals, 3);
                            boolean tmp221 = tmp220.toString().equals("int");
                            ExprValue tmp222 = evs0;
                            tmp222.setIntValue(tmp221);
                            // End Binary operator: ==
                            boolean tmp223 = ( tmp222.getIntValue() != 0 );
                            if ( tmp223 ) {
                                { // Invoke: set ev_types int
                                    setVarScalar(interp, "ev_types", const13, compiledLocals, 32);
                                } // End Invoke: set
                            } else {
                                // Binary operator: $operand_ev_types == "double"
                                TclObject tmp224 = getVarScalar(interp, "operand_ev_types", compiledLocals, 3);
                                boolean tmp225 = tmp224.toString().equals("double");
                                ExprValue tmp226 = evs0;
                                tmp226.setIntValue(tmp225);
                                // End Binary operator: ==
                                boolean tmp227 = ( tmp226.getIntValue() != 0 );
                                if ( tmp227 ) {
                                    { // Invoke: set ev_types double
                                        setVarScalar(interp, "ev_types", const15, compiledLocals, 32);
                                    } // End Invoke: set
                                } else {
                                    { // Invoke: set ev_types {int double}
                                        setVarScalar(interp, "ev_types", const38, compiledLocals, 32);
                                    } // End Invoke: set
                                }
                            }
                        } // End Invoke: if
                    }
                }
            }
        } // End Invoke: if
        { // Invoke: return [...]
            { // Invoke: list $ev $buffer $ev_types
                TclObject tmp228 = TclList.newInstance();
                TclObject tmp229;
                try {
                    tmp229 = getVarScalar(interp, "ev", compiledLocals, 28);
                    TclList.append(interp, tmp228, tmp229);
                    tmp229 = getVarScalar(interp, "buffer", compiledLocals, 1);
                    TclList.append(interp, tmp228, tmp229);
                    tmp229 = getVarScalar(interp, "ev_types", compiledLocals, 32);
                    TclList.append(interp, tmp228, tmp229);
                } catch (TclException ex) {
                    tmp228.release();
                    throw ex;
                }
                interp.setResult(tmp228);
            } // End Invoke: list
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_expr_evaluate_emit_unary_operator");
        } finally {
            TJC.exprReleaseValue(interp, evs2);
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;
    TclObject const18;
    TclObject const19;
    TclObject const20;
    TclObject const21;
    TclObject const22;
    TclObject const23;
    TclObject const24;
    TclObject const25;
    TclObject const26;
    TclObject const27;
    TclObject const28;
    TclObject const29;
    TclObject const30;
    TclObject const31;
    TclObject const32;
    TclObject const33;
    TclObject const34;
    TclObject const35;
    TclObject const36;
    TclObject const37;
    TclObject const38;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("error");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("compileproc_expr_peek_operand");
        const2.preserve(); const2.preserve();
        const3 = TclInteger.newInstance(0);
        const3.preserve(); const3.preserve();
        const4 = TclInteger.newInstance(1);
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("int literal");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("double literal");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("end-1");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("string");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("trim");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("-0x80000000");
        TclInteger.get(interp, const10);
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("compileproc_string_is_java_integer");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("constant int");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("int");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("constant double");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("double");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance("unknown literal type");
        const16.preserve(); const16.preserve();
        const17 = TclString.newInstance("unknown operation");
        const17.preserve(); const17.preserve();
        const18 = TclString.newInstance("compileproc_expr_evaluate_emit_exprvalue");
        const18.preserve(); const18.preserve();
        const19 = TclString.newInstance("TJC.EXPR_OP_UNARY_PLUS");
        const19.preserve(); const19.preserve();
        const20 = TclString.newInstance("TJC.EXPR_OP_UNARY_MINUS");
        const20.preserve(); const20.preserve();
        const21 = TclString.newInstance("TJC.EXPR_OP_UNARY_NOT");
        const21.preserve(); const21.preserve();
        const22 = TclString.newInstance("TJC.EXPR_OP_UNARY_BIT_NOT");
        const22.preserve(); const22.preserve();
        const23 = TclString.newInstance("operator + should not be matched");
        const23.preserve(); const23.preserve();
        const24 = TclString.newInstance("operator - should not be matched");
        const24.preserve(); const24.preserve();
        const25 = TclString.newInstance("compileproc_expr_evaluate_emit_inlined_unary_not_operator");
        const25.preserve(); const25.preserve();
        const26 = TclString.newInstance("operator ! should not be matched");
        const26.preserve(); const26.preserve();
        const27 = TclString.newInstance("lindex");
        const27.preserve(); const27.preserve();
        const28 = TclInteger.newInstance(3);
        const28.preserve(); const28.preserve();
        const29 = TclString.newInstance("emitter_indent");
        const29.preserve(); const29.preserve();
        const30 = TclString.newInstance("TJC.exprUnaryOperator(interp, ");
        const30.preserve(); const30.preserve();
        const31 = TclString.newInstance(", ");
        const31.preserve(); const31.preserve();
        const32 = TclString.newInstance(");\n");
        const32.preserve(); const32.preserve();
        const33 = TclString.newInstance("// Unary operator: ");
        const33.preserve(); const33.preserve();
        const34 = TclString.newInstance(" ");
        const34.preserve(); const34.preserve();
        const35 = TclString.newInstance("\n");
        const35.preserve(); const35.preserve();
        const36 = TclString.newInstance("// End Unary operator: ");
        const36.preserve(); const36.preserve();
        const37 = TclString.newInstance("boolean");
        const37.preserve(); const37.preserve();
        const38 = TclString.newInstance("int double");
        const38.preserve(); const38.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;
    WrappedCommand cmdcache8;
    int cmdcache8_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                cmdcache8 = TJC.INVALID_COMMAND_CACHE;
                cmdcache8_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "error";
                break;
            }
            case 2: {
                cmdName = "compileproc_expr_peek_operand";
                break;
            }
            case 3: {
                cmdName = "string";
                break;
            }
            case 4: {
                cmdName = "compileproc_string_is_java_integer";
                break;
            }
            case 5: {
                cmdName = "compileproc_expr_evaluate_emit_exprvalue";
                break;
            }
            case 6: {
                cmdName = "compileproc_expr_evaluate_emit_inlined_unary_not_operator";
                break;
            }
            case 7: {
                cmdName = "lindex";
                break;
            }
            case 8: {
                cmdName = "emitter_indent";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
            case 8: {
                cmdcache8 = lwcmd;
                cmdcache8_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "op_tuple",
        "buffer",
        "op_buffer",
        "operand_ev_types",
        "type",
        "vtuple",
        "op",
        "values",
        "tuple",
        "peek_tuple",
        "value_info_type",
        "value_info_value",
        "value_info_has_null_string",
        "infostr",
        "is_numeric_literal",
        "is_numeric_literal_int",
        "is_numeric_literal_double",
        "numeric_literal",
        "skip_unary_op_call",
        "plus_number",
        "negate_number",
        "bitwise_negate_number",
        "first",
        "is_already_negative",
        "min",
        "wneg",
        "is_jint",
        "eval_tuple",
        "ev",
        "inline_op",
        "opval",
        "::_compileproc",
        "ev_types"
    };
} // end class CompileprocExprEvaluateEmitUnaryOperatorCmd

