// TJC implementation of procedure compileproc_nocompile
package tjc;
import tcl.lang.*;

public class CompileprocNocompileCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 9, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 3) {
            throw new TclNumArgsException(interp, 1, objv, "proc_list class_name");
        }
        setVarScalar(interp, "proc_list", objv[1], compiledLocals, 0);
        setVarScalar(interp, "class_name", objv[2], compiledLocals, 1);
        { // Invoke: global _compileproc
            TJC.makeGlobalLinkVar(interp, "_compileproc", "_compileproc", 2);
        } // End Invoke: global
        { // Invoke: if ... ...
            // Binary operator: [...] != 3
            { // Invoke: llength $proc_list
                TclObject tmp0 = getVarScalar(interp, "proc_list", compiledLocals, 0);
                int tmp1 = TclList.getLength(interp, tmp0);
                interp.setResult(tmp1);
            } // End Invoke: llength
            TclObject tmp2 = interp.getResult();
            ExprValue tmp3 = evs0;
            TJC.exprInitValue(interp, tmp3, tmp2);
            ExprValue tmp4 = evs1;
            tmp4.setIntValue(3);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp3, tmp4);
            // End Binary operator: !=
            boolean tmp5 = ( tmp3.getIntValue() != 0 );
            if ( tmp5 ) {
                { // Invoke: error "..."
                    TclObject[] objv6 = TJC.grabObjv(interp, 2);
                    TclObject tmp7;
                    try {
                        // Arg 0 constant: error
                        objv6[0] = const0;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp8 = new StringBuffer(64);
                        sbtmp8.append("expected ");
                        sbtmp8.append("{");
                        sbtmp8.append("PROC_NAME PROC_ARGS PROC_BODY");
                        sbtmp8.append("}");
                        sbtmp8.append(" : passed ");
                        { // Invoke: llength $proc_list
                            TclObject tmp9 = getVarScalar(interp, "proc_list", compiledLocals, 0);
                            int tmp10 = TclList.getLength(interp, tmp9);
                            interp.setResult(tmp10);
                        } // End Invoke: llength
                        tmp7 = interp.getResult();
                        sbtmp8.append(tmp7.toString());
                        sbtmp8.append(" args");
                        tmp7 = TclString.newInstance(sbtmp8);
                        tmp7.preserve();
                        objv6[1] = tmp7;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv6, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp7 = objv6[1];
                        if ( tmp7 != null ) {
                            tmp7.release();
                        }
                        TJC.releaseObjv(interp, objv6, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: compileproc_init
            TclObject[] objv11 = TJC.grabObjv(interp, 1);
            try {
                // Arg 0 constant: compileproc_init
                objv11[0] = const1;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                    ? cmdcache2.cmd : null), objv11, 0);
                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                    updateCmdCache(interp, 2);
                }
            } finally {
                TJC.releaseObjv(interp, objv11, 1);
            }
        } // End Invoke: compileproc_init
        { // Invoke: set name [...]
            TclObject tmp12;
            { // Invoke: lindex $proc_list 0
                TclObject tmp13 = getVarScalar(interp, "proc_list", compiledLocals, 0);
                tmp13 = TclList.index(interp, tmp13, 0);
                if ( tmp13 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp13);
                }
            } // End Invoke: lindex
            tmp12 = interp.getResult();
            setVarScalar(interp, "name", tmp12, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set args [...]
            TclObject tmp14;
            { // Invoke: lindex $proc_list 1
                TclObject tmp15 = getVarScalar(interp, "proc_list", compiledLocals, 0);
                tmp15 = TclList.index(interp, tmp15, 1);
                if ( tmp15 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp15);
                }
            } // End Invoke: lindex
            tmp14 = interp.getResult();
            setVarScalar(interp, "args", tmp14, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set body [...]
            TclObject tmp16;
            { // Invoke: lindex $proc_list 2
                TclObject tmp17 = getVarScalar(interp, "proc_list", compiledLocals, 0);
                tmp17 = TclList.index(interp, tmp17, 2);
                if ( tmp17 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp17);
                }
            } // End Invoke: lindex
            tmp16 = interp.getResult();
            setVarScalar(interp, "body", tmp16, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: set pair [...]
            TclObject tmp18;
            { // Invoke: ... $class_name
                TclObject[] objv19 = TJC.grabObjv(interp, 2);
                TclObject tmp20;
                try {
                    // Arg 0 constant: ...
                    objv19[0] = const2;
                    // Arg 1 variable: $class_name
                    tmp20 = getVarScalar(interp, "class_name", compiledLocals, 1);
                    tmp20.preserve();
                    objv19[1] = tmp20;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                        ? cmdcache3.cmd : null), objv19, 0);
                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                        updateCmdCache(interp, 3);
                    }
                } finally {
                    tmp20 = objv19[1];
                    if ( tmp20 != null ) {
                        tmp20.release();
                    }
                    TJC.releaseObjv(interp, objv19, 2);
                }
            } // End Invoke: ...
            tmp18 = interp.getResult();
            setVarScalar(interp, "pair", tmp18, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: set ... [...]
            TclObject tmp21;
            { // Invoke: lindex $pair 0
                TclObject tmp22 = getVarScalar(interp, "pair", compiledLocals, 6);
                tmp22 = TclList.index(interp, tmp22, 0);
                if ( tmp22 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp22);
                }
            } // End Invoke: lindex
            tmp21 = interp.getResult();
            setVarArray(interp, "_compileproc", "package", tmp21, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set ... [...]
            TclObject tmp23;
            { // Invoke: lindex $pair 1
                TclObject tmp24 = getVarScalar(interp, "pair", compiledLocals, 6);
                tmp24 = TclList.index(interp, tmp24, 1);
                if ( tmp24 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp24);
                }
            } // End Invoke: lindex
            tmp23 = interp.getResult();
            setVarArray(interp, "_compileproc", "classname", tmp23, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const3, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const3, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: append buffer [...]
            TclObject[] objv25 = TJC.grabObjv(interp, 1);
            TclObject tmp26;
            try {
                // Arg 2 command: [...]
                { // Invoke: ... $name
                    TclObject[] objv27 = TJC.grabObjv(interp, 2);
                    TclObject tmp28;
                    try {
                        // Arg 0 constant: ...
                        objv27[0] = const4;
                        // Arg 1 variable: $name
                        tmp28 = getVarScalar(interp, "name", compiledLocals, 3);
                        tmp28.preserve();
                        objv27[1] = tmp28;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                            ? cmdcache4.cmd : null), objv27, 0);
                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                            updateCmdCache(interp, 4);
                        }
                    } finally {
                        tmp28 = objv27[1];
                        if ( tmp28 != null ) {
                            tmp28.release();
                        }
                        TJC.releaseObjv(interp, objv27, 2);
                    }
                } // End Invoke: ...
                tmp26 = interp.getResult();
                tmp26.preserve();
                objv25[0] = tmp26;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv25, compiledLocals, 7);
            } finally {
                TJC.releaseObjvElems(interp, objv25, 1);
            }
        } // End Invoke: append
        { // Invoke: append buffer [...]
            TclObject[] objv29 = TJC.grabObjv(interp, 1);
            TclObject tmp30;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_package_name $...
                    TclObject[] objv31 = TJC.grabObjv(interp, 2);
                    TclObject tmp32;
                    try {
                        // Arg 0 constant: emitter_package_name
                        objv31[0] = const5;
                        // Arg 1 variable: $...
                        tmp32 = getVarArray(interp, "_compileproc", "package", compiledLocals, 2);
                        tmp32.preserve();
                        objv31[1] = tmp32;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                            ? cmdcache5.cmd : null), objv31, 0);
                        if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                            updateCmdCache(interp, 5);
                        }
                    } finally {
                        tmp32 = objv31[1];
                        if ( tmp32 != null ) {
                            tmp32.release();
                        }
                        TJC.releaseObjv(interp, objv31, 2);
                    }
                } // End Invoke: emitter_package_name
                tmp30 = interp.getResult();
                tmp30.preserve();
                objv29[0] = tmp30;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv29, compiledLocals, 7);
            } finally {
                TJC.releaseObjvElems(interp, objv29, 1);
            }
        } // End Invoke: append
        { // Invoke: append buffer [...]
            TclObject[] objv33 = TJC.grabObjv(interp, 1);
            TclObject tmp34;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_import_tcl
                    TclObject[] objv35 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_import_tcl
                        objv35[0] = const6;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                            ? cmdcache6.cmd : null), objv35, 0);
                        if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                            updateCmdCache(interp, 6);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv35, 1);
                    }
                } // End Invoke: emitter_import_tcl
                tmp34 = interp.getResult();
                tmp34.preserve();
                objv33[0] = tmp34;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv33, compiledLocals, 7);
            } finally {
                TJC.releaseObjvElems(interp, objv33, 1);
            }
        } // End Invoke: append
        { // Invoke: append buffer ... [...]
            TclObject[] objv36 = TJC.grabObjv(interp, 2);
            TclObject tmp37;
            try {
                // Arg 2 constant: ...
                objv36[0] = const7;
                // Arg 3 command: [...]
                { // Invoke: emitter_class_start $...
                    TclObject[] objv38 = TJC.grabObjv(interp, 2);
                    TclObject tmp39;
                    try {
                        // Arg 0 constant: emitter_class_start
                        objv38[0] = const8;
                        // Arg 1 variable: $...
                        tmp39 = getVarArray(interp, "_compileproc", "classname", compiledLocals, 2);
                        tmp39.preserve();
                        objv38[1] = tmp39;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                            ? cmdcache7.cmd : null), objv38, 0);
                        if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                            updateCmdCache(interp, 7);
                        }
                    } finally {
                        tmp39 = objv38[1];
                        if ( tmp39 != null ) {
                            tmp39.release();
                        }
                        TJC.releaseObjv(interp, objv38, 2);
                    }
                } // End Invoke: emitter_class_start
                tmp37 = interp.getResult();
                tmp37.preserve();
                objv36[1] = tmp37;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv36, compiledLocals, 7);
            } finally {
                tmp37 = objv36[1];
                if ( tmp37 != null ) {
                    tmp37.release();
                }
                TJC.releaseObjv(interp, objv36, 2);
            }
        } // End Invoke: append
        { // Invoke: append buffer [...]
            TclObject[] objv40 = TJC.grabObjv(interp, 1);
            TclObject tmp41;
            try {
                // Arg 2 command: [...]
                { // Invoke: ...
                    TclObject[] objv42 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: ...
                        objv42[0] = const9;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                            ? cmdcache8.cmd : null), objv42, 0);
                        if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                            updateCmdCache(interp, 8);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv42, 1);
                    }
                } // End Invoke: ...
                tmp41 = interp.getResult();
                tmp41.preserve();
                objv40[0] = tmp41;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv40, compiledLocals, 7);
            } finally {
                TJC.releaseObjvElems(interp, objv40, 1);
            }
        } // End Invoke: append
        { // Invoke: append buffer [...]
            TclObject[] objv43 = TJC.grabObjv(interp, 1);
            TclObject tmp44;
            try {
                // Arg 2 command: [...]
                { // Invoke: ...
                    TclObject[] objv45 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: ...
                        objv45[0] = const10;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                            ? cmdcache9.cmd : null), objv45, 0);
                        if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                            updateCmdCache(interp, 9);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv45, 1);
                    }
                } // End Invoke: ...
                tmp44 = interp.getResult();
                tmp44.preserve();
                objv43[0] = tmp44;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv43, compiledLocals, 7);
            } finally {
                TJC.releaseObjvElems(interp, objv43, 1);
            }
        } // End Invoke: append
        { // Invoke: append buffer [...]
            TclObject[] objv46 = TJC.grabObjv(interp, 1);
            TclObject tmp47;
            try {
                // Arg 2 command: [...]
                { // Invoke: ... wcmd.ns
                    TclObject[] objv48 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: ...
                        objv48[0] = const11;
                        // Arg 1 constant: wcmd.ns
                        objv48[1] = const12;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                            ? cmdcache10.cmd : null), objv48, 0);
                        if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                            updateCmdCache(interp, 10);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv48, 2);
                    }
                } // End Invoke: ...
                tmp47 = interp.getResult();
                tmp47.preserve();
                objv46[0] = tmp47;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv46, compiledLocals, 7);
            } finally {
                TJC.releaseObjvElems(interp, objv46, 1);
            }
        } // End Invoke: append
        { // Invoke: append buffer [...]
            TclObject[] objv49 = TJC.grabObjv(interp, 1);
            TclObject tmp50;
            try {
                // Arg 2 command: [...]
                { // Invoke: ...
                    TclObject[] objv51 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: ...
                        objv51[0] = const13;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache11_cmdEpoch == cmdcache11.cmdEpoch)
                            ? cmdcache11.cmd : null), objv51, 0);
                        if ( cmdcache11_cmdEpoch != cmdcache11.cmdEpoch ) {
                            updateCmdCache(interp, 11);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv51, 1);
                    }
                } // End Invoke: ...
                tmp50 = interp.getResult();
                tmp50.preserve();
                objv49[0] = tmp50;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv49, compiledLocals, 7);
            } finally {
                TJC.releaseObjvElems(interp, objv49, 1);
            }
        } // End Invoke: append
        { // Invoke: append buffer [...]
            TclObject[] objv52 = TJC.grabObjv(interp, 1);
            TclObject tmp53;
            try {
                // Arg 2 command: [...]
                { // Invoke: ... $args
                    TclObject[] objv54 = TJC.grabObjv(interp, 2);
                    TclObject tmp55;
                    try {
                        // Arg 0 constant: ...
                        objv54[0] = const14;
                        // Arg 1 variable: $args
                        tmp55 = getVarScalar(interp, "args", compiledLocals, 4);
                        tmp55.preserve();
                        objv54[1] = tmp55;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache12_cmdEpoch == cmdcache12.cmdEpoch)
                            ? cmdcache12.cmd : null), objv54, 0);
                        if ( cmdcache12_cmdEpoch != cmdcache12.cmdEpoch ) {
                            updateCmdCache(interp, 12);
                        }
                    } finally {
                        tmp55 = objv54[1];
                        if ( tmp55 != null ) {
                            tmp55.release();
                        }
                        TJC.releaseObjv(interp, objv54, 2);
                    }
                } // End Invoke: ...
                tmp53 = interp.getResult();
                tmp53.preserve();
                objv52[0] = tmp53;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv52, compiledLocals, 7);
            } finally {
                TJC.releaseObjvElems(interp, objv52, 1);
            }
        } // End Invoke: append
        { // Invoke: append buffer [...]
            TclObject[] objv56 = TJC.grabObjv(interp, 1);
            TclObject tmp57;
            try {
                // Arg 2 command: [...]
                { // Invoke: ... $body
                    TclObject[] objv58 = TJC.grabObjv(interp, 2);
                    TclObject tmp59;
                    try {
                        // Arg 0 constant: ...
                        objv58[0] = const15;
                        // Arg 1 variable: $body
                        tmp59 = getVarScalar(interp, "body", compiledLocals, 5);
                        tmp59.preserve();
                        objv58[1] = tmp59;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache13_cmdEpoch == cmdcache13.cmdEpoch)
                            ? cmdcache13.cmd : null), objv58, 0);
                        if ( cmdcache13_cmdEpoch != cmdcache13.cmdEpoch ) {
                            updateCmdCache(interp, 13);
                        }
                    } finally {
                        tmp59 = objv58[1];
                        if ( tmp59 != null ) {
                            tmp59.release();
                        }
                        TJC.releaseObjv(interp, objv58, 2);
                    }
                } // End Invoke: ...
                tmp57 = interp.getResult();
                tmp57.preserve();
                objv56[0] = tmp57;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv56, compiledLocals, 7);
            } finally {
                TJC.releaseObjvElems(interp, objv56, 1);
            }
        } // End Invoke: append
        { // Invoke: append buffer [...]
            TclObject[] objv60 = TJC.grabObjv(interp, 1);
            TclObject tmp61;
            try {
                // Arg 2 command: [...]
                { // Invoke: ... $name
                    TclObject[] objv62 = TJC.grabObjv(interp, 2);
                    TclObject tmp63;
                    try {
                        // Arg 0 constant: ...
                        objv62[0] = const16;
                        // Arg 1 variable: $name
                        tmp63 = getVarScalar(interp, "name", compiledLocals, 3);
                        tmp63.preserve();
                        objv62[1] = tmp63;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache14_cmdEpoch == cmdcache14.cmdEpoch)
                            ? cmdcache14.cmd : null), objv62, 0);
                        if ( cmdcache14_cmdEpoch != cmdcache14.cmdEpoch ) {
                            updateCmdCache(interp, 14);
                        }
                    } finally {
                        tmp63 = objv62[1];
                        if ( tmp63 != null ) {
                            tmp63.release();
                        }
                        TJC.releaseObjv(interp, objv62, 2);
                    }
                } // End Invoke: ...
                tmp61 = interp.getResult();
                tmp61.preserve();
                objv60[0] = tmp61;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv60, compiledLocals, 7);
            } finally {
                TJC.releaseObjvElems(interp, objv60, 1);
            }
        } // End Invoke: append
        { // Invoke: append buffer [...]
            TclObject[] objv64 = TJC.grabObjv(interp, 1);
            TclObject tmp65;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_cmd_proc_end
                    TclObject[] objv66 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_cmd_proc_end
                        objv66[0] = const17;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache15_cmdEpoch == cmdcache15.cmdEpoch)
                            ? cmdcache15.cmd : null), objv66, 0);
                        if ( cmdcache15_cmdEpoch != cmdcache15.cmdEpoch ) {
                            updateCmdCache(interp, 15);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv66, 1);
                    }
                } // End Invoke: emitter_cmd_proc_end
                tmp65 = interp.getResult();
                tmp65.preserve();
                objv64[0] = tmp65;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv64, compiledLocals, 7);
            } finally {
                TJC.releaseObjvElems(interp, objv64, 1);
            }
        } // End Invoke: append
        { // Invoke: set cdata [...]
            TclObject tmp67;
            { // Invoke: ...
                TclObject[] objv68 = TJC.grabObjv(interp, 1);
                try {
                    // Arg 0 constant: ...
                    objv68[0] = const18;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache16_cmdEpoch == cmdcache16.cmdEpoch)
                        ? cmdcache16.cmd : null), objv68, 0);
                    if ( cmdcache16_cmdEpoch != cmdcache16.cmdEpoch ) {
                        updateCmdCache(interp, 16);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv68, 1);
                }
            } // End Invoke: ...
            tmp67 = interp.getResult();
            setVarScalar(interp, "cdata", tmp67, compiledLocals, 8);
        } // End Invoke: set
        { // Invoke: if {$cdata != {}} ...
            // Binary operator: $cdata != ""
            TclObject tmp69 = getVarScalar(interp, "cdata", compiledLocals, 8);
            ExprValue tmp70 = evs0;
            TJC.exprEqualsEmptyString(tmp70, tmp69, true);
            // End Binary operator: !=
            boolean tmp71 = ( tmp70.getIntValue() != 0 );
            if ( tmp71 ) {
                { // Invoke: append buffer ... $cdata
                    TclObject[] objv72 = TJC.grabObjv(interp, 2);
                    TclObject tmp73;
                    try {
                        // Arg 2 constant: ...
                        objv72[0] = const7;
                        // Arg 3 variable: $cdata
                        tmp73 = getVarScalar(interp, "cdata", compiledLocals, 8);
                        tmp73.preserve();
                        objv72[1] = tmp73;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv72, compiledLocals, 7);
                    } finally {
                        tmp73 = objv72[1];
                        if ( tmp73 != null ) {
                            tmp73.release();
                        }
                        TJC.releaseObjv(interp, objv72, 2);
                    }
                } // End Invoke: append
            }
        } // End Invoke: if
        { // Invoke: append buffer [...]
            TclObject[] objv74 = TJC.grabObjv(interp, 1);
            TclObject tmp75;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_class_end $...
                    TclObject[] objv76 = TJC.grabObjv(interp, 2);
                    TclObject tmp77;
                    try {
                        // Arg 0 constant: emitter_class_end
                        objv76[0] = const19;
                        // Arg 1 variable: $...
                        tmp77 = getVarArray(interp, "_compileproc", "classname", compiledLocals, 2);
                        tmp77.preserve();
                        objv76[1] = tmp77;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache17_cmdEpoch == cmdcache17.cmdEpoch)
                            ? cmdcache17.cmd : null), objv76, 0);
                        if ( cmdcache17_cmdEpoch != cmdcache17.cmdEpoch ) {
                            updateCmdCache(interp, 17);
                        }
                    } finally {
                        tmp77 = objv76[1];
                        if ( tmp77 != null ) {
                            tmp77.release();
                        }
                        TJC.releaseObjv(interp, objv76, 2);
                    }
                } // End Invoke: emitter_class_end
                tmp75 = interp.getResult();
                tmp75.preserve();
                objv74[0] = tmp75;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv74, compiledLocals, 7);
            } finally {
                TJC.releaseObjvElems(interp, objv74, 1);
            }
        } // End Invoke: append
        { // Invoke: set _compileproc(class) $buffer
            TclObject tmp78;
            tmp78 = getVarScalar(interp, "buffer", compiledLocals, 7);
            setVarArray(interp, "_compileproc", "class", tmp78, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: return $_compileproc(class)
            TclObject tmp79 = getVarArray(interp, "_compileproc", "class", compiledLocals, 2);
            interp.resetResult();
            interp.setResult(tmp79);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_nocompile");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;
    TclObject const18;
    TclObject const19;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("error");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("compileproc_init");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("compileproc_split_classname");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("emitter_class_comment");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("emitter_package_name");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("emitter_import_tcl");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("\n");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("emitter_class_start");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("emitter_cmd_proc_start");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("emitter_init_cmd_check");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("emitter_callframe_push");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("wcmd.ns");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("emitter_callframe_try");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("compileproc_args_assign");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("emitter_eval_proc_body");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance("emitter_callframe_pop");
        const16.preserve(); const16.preserve();
        const17 = TclString.newInstance("emitter_cmd_proc_end");
        const17.preserve(); const17.preserve();
        const18 = TclString.newInstance("compileproc_constant_cache_generate");
        const18.preserve(); const18.preserve();
        const19 = TclString.newInstance("emitter_class_end");
        const19.preserve(); const19.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;
    WrappedCommand cmdcache8;
    int cmdcache8_cmdEpoch;
    WrappedCommand cmdcache9;
    int cmdcache9_cmdEpoch;
    WrappedCommand cmdcache10;
    int cmdcache10_cmdEpoch;
    WrappedCommand cmdcache11;
    int cmdcache11_cmdEpoch;
    WrappedCommand cmdcache12;
    int cmdcache12_cmdEpoch;
    WrappedCommand cmdcache13;
    int cmdcache13_cmdEpoch;
    WrappedCommand cmdcache14;
    int cmdcache14_cmdEpoch;
    WrappedCommand cmdcache15;
    int cmdcache15_cmdEpoch;
    WrappedCommand cmdcache16;
    int cmdcache16_cmdEpoch;
    WrappedCommand cmdcache17;
    int cmdcache17_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                cmdcache8 = TJC.INVALID_COMMAND_CACHE;
                cmdcache8_cmdEpoch = 0;
                cmdcache9 = TJC.INVALID_COMMAND_CACHE;
                cmdcache9_cmdEpoch = 0;
                cmdcache10 = TJC.INVALID_COMMAND_CACHE;
                cmdcache10_cmdEpoch = 0;
                cmdcache11 = TJC.INVALID_COMMAND_CACHE;
                cmdcache11_cmdEpoch = 0;
                cmdcache12 = TJC.INVALID_COMMAND_CACHE;
                cmdcache12_cmdEpoch = 0;
                cmdcache13 = TJC.INVALID_COMMAND_CACHE;
                cmdcache13_cmdEpoch = 0;
                cmdcache14 = TJC.INVALID_COMMAND_CACHE;
                cmdcache14_cmdEpoch = 0;
                cmdcache15 = TJC.INVALID_COMMAND_CACHE;
                cmdcache15_cmdEpoch = 0;
                cmdcache16 = TJC.INVALID_COMMAND_CACHE;
                cmdcache16_cmdEpoch = 0;
                cmdcache17 = TJC.INVALID_COMMAND_CACHE;
                cmdcache17_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "error";
                break;
            }
            case 2: {
                cmdName = "compileproc_init";
                break;
            }
            case 3: {
                cmdName = "compileproc_split_classname";
                break;
            }
            case 4: {
                cmdName = "emitter_class_comment";
                break;
            }
            case 5: {
                cmdName = "emitter_package_name";
                break;
            }
            case 6: {
                cmdName = "emitter_import_tcl";
                break;
            }
            case 7: {
                cmdName = "emitter_class_start";
                break;
            }
            case 8: {
                cmdName = "emitter_cmd_proc_start";
                break;
            }
            case 9: {
                cmdName = "emitter_init_cmd_check";
                break;
            }
            case 10: {
                cmdName = "emitter_callframe_push";
                break;
            }
            case 11: {
                cmdName = "emitter_callframe_try";
                break;
            }
            case 12: {
                cmdName = "compileproc_args_assign";
                break;
            }
            case 13: {
                cmdName = "emitter_eval_proc_body";
                break;
            }
            case 14: {
                cmdName = "emitter_callframe_pop";
                break;
            }
            case 15: {
                cmdName = "emitter_cmd_proc_end";
                break;
            }
            case 16: {
                cmdName = "compileproc_constant_cache_generate";
                break;
            }
            case 17: {
                cmdName = "emitter_class_end";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
            case 8: {
                cmdcache8 = lwcmd;
                cmdcache8_cmdEpoch = cmdEpoch;
                break;
            }
            case 9: {
                cmdcache9 = lwcmd;
                cmdcache9_cmdEpoch = cmdEpoch;
                break;
            }
            case 10: {
                cmdcache10 = lwcmd;
                cmdcache10_cmdEpoch = cmdEpoch;
                break;
            }
            case 11: {
                cmdcache11 = lwcmd;
                cmdcache11_cmdEpoch = cmdEpoch;
                break;
            }
            case 12: {
                cmdcache12 = lwcmd;
                cmdcache12_cmdEpoch = cmdEpoch;
                break;
            }
            case 13: {
                cmdcache13 = lwcmd;
                cmdcache13_cmdEpoch = cmdEpoch;
                break;
            }
            case 14: {
                cmdcache14 = lwcmd;
                cmdcache14_cmdEpoch = cmdEpoch;
                break;
            }
            case 15: {
                cmdcache15 = lwcmd;
                cmdcache15_cmdEpoch = cmdEpoch;
                break;
            }
            case 16: {
                cmdcache16 = lwcmd;
                cmdcache16_cmdEpoch = cmdEpoch;
                break;
            }
            case 17: {
                cmdcache17 = lwcmd;
                cmdcache17_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "proc_list",
        "class_name",
        "_compileproc",
        "name",
        "args",
        "body",
        "pair",
        "buffer",
        "cdata"
    };
} // end class CompileprocNocompileCmd

