// TJC implementation of procedure compileproc_omit_set_result
package tjc;
import tcl.lang.*;

public class CompileprocOmitSetResultCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 3, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        { // Invoke: global _compileproc ...
            TJC.makeGlobalLinkVar(interp, "_compileproc", "_compileproc", 1);
            TJC.makeGlobalLinkVar(interp, "_compileproc_key_info", "_compileproc_key_info", 2);
        } // End Invoke: global
        { // Invoke: return [...]
            { // Invoke: expr ...
                // Binary operator: $_compileproc(...) && ()
                TclObject tmp0 = getVarArray(interp, "_compileproc", "options,omit_results", compiledLocals, 1);
                ExprValue tmp1 = evs0;
                TJC.exprInitValue(interp, tmp1, tmp0);
                if (tmp1.getBooleanValue(interp)) {
                // Unary operator: ! $_compileproc_key_info(...)
                TclObject tmp2;
                StringBuffer sbtmp3 = new StringBuffer(64);
                tmp2 = getVarScalar(interp, "key", compiledLocals, 0);
                sbtmp3.append(tmp2.toString());
                sbtmp3.append(",result");
                tmp2 = getVarArray(interp, "_compileproc_key_info", sbtmp3.toString(), compiledLocals, 2);
                ExprValue tmp4 = evs1;
                if ( tmp2.isIntType() ) {
                    TJC.exprUnaryNotOperatorKnownInt(tmp4, tmp2);
                } else {
                    TJC.exprUnaryNotOperator(interp, tmp4, tmp2);
                }
                // End Unary operator: !
                tmp1.setIntValue(tmp4.getBooleanValue(interp));
                } else {
                tmp1.setIntValue(0);
                } // End if: $_compileproc(...)
                // End Binary operator: &&
                interp.setResult( tmp1.getIntValue() != 0 );
            } // End Invoke: expr
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_omit_set_result");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "_compileproc",
        "_compileproc_key_info"
    };
} // end class CompileprocOmitSetResultCmd

