// TJC implementation of procedure compileproc_pop_controls_context
package tjc;
import tcl.lang.*;

public class CompileprocPopControlsContextCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 4, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "type");
        }
        setVarScalar(interp, "type", objv[1], compiledLocals, 0);
        { // Invoke: global _compileproc
            TJC.makeGlobalLinkVar(interp, "_compileproc", "_compileproc", 1);
        } // End Invoke: global
        { // Invoke: set stack $...
            TclObject tmp0;
            tmp0 = getVarArray(interp, "_compileproc", "options,controls_stack", compiledLocals, 1);
            setVarScalar(interp, "stack", tmp0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: [...] == 0
            { // Invoke: llength $stack
                TclObject tmp1 = getVarScalar(interp, "stack", compiledLocals, 2);
                int tmp2 = TclList.getLength(interp, tmp1);
                interp.setResult(tmp2);
            } // End Invoke: llength
            TclObject tmp3 = interp.getResult();
            ExprValue tmp4 = evs0;
            TJC.exprInitValue(interp, tmp4, tmp3);
            ExprValue tmp5 = evs1;
            tmp5.setIntValue(0);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp4, tmp5);
            // End Binary operator: ==
            boolean tmp6 = ( tmp4.getIntValue() != 0 );
            if ( tmp6 ) {
                { // Invoke: error "..."
                    TclObject[] objv7 = TJC.grabObjv(interp, 2);
                    TclObject tmp8;
                    try {
                        // Arg 0 constant: error
                        objv7[0] = const0;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp9 = new StringBuffer(64);
                        sbtmp9.append("attempt to pop off empty controls stack : type was ");
                        tmp8 = getVarScalar(interp, "type", compiledLocals, 0);
                        sbtmp9.append(tmp8.toString());
                        tmp8 = TclString.newInstance(sbtmp9);
                        tmp8.preserve();
                        objv7[1] = tmp8;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv7, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp8 = objv7[1];
                        if ( tmp8 != null ) {
                            tmp8.release();
                        }
                        TJC.releaseObjv(interp, objv7, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set tuple [...]
            TclObject tmp10;
            { // Invoke: lindex $stack 0
                TclObject tmp11 = getVarScalar(interp, "stack", compiledLocals, 2);
                tmp11 = TclList.index(interp, tmp11, 0);
                if ( tmp11 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp11);
                }
            } // End Invoke: lindex
            tmp10 = interp.getResult();
            setVarScalar(interp, "tuple", tmp10, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set stack [...]
            TclObject tmp12;
            { // Invoke: lrange $stack 1 end
                TclObject[] objv13 = TJC.grabObjv(interp, 4);
                TclObject tmp14;
                try {
                    // Arg 0 constant: lrange
                    objv13[0] = const1;
                    // Arg 1 variable: $stack
                    tmp14 = getVarScalar(interp, "stack", compiledLocals, 2);
                    tmp14.preserve();
                    objv13[1] = tmp14;
                    // Arg 2 constant: 1
                    objv13[2] = const2;
                    // Arg 3 constant: end
                    objv13[3] = const3;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv13, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp14 = objv13[1];
                    if ( tmp14 != null ) {
                        tmp14.release();
                    }
                    TJC.releaseObjv(interp, objv13, 4);
                }
            } // End Invoke: lrange
            tmp12 = interp.getResult();
            setVarScalar(interp, "stack", tmp12, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: if ... ... elseif ... ...
            // Binary operator: $type != [...]
            TclObject tmp15 = getVarScalar(interp, "type", compiledLocals, 0);
            ExprValue tmp16 = evs0;
            TJC.exprInitValue(interp, tmp16, tmp15);
            { // Invoke: lindex $tuple 0
                TclObject tmp17 = getVarScalar(interp, "tuple", compiledLocals, 3);
                tmp17 = TclList.index(interp, tmp17, 0);
                if ( tmp17 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp17);
                }
            } // End Invoke: lindex
            TclObject tmp18 = interp.getResult();
            ExprValue tmp19 = evs1;
            TJC.exprInitValue(interp, tmp19, tmp18);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp16, tmp19);
            // End Binary operator: !=
            boolean tmp20 = ( tmp16.getIntValue() != 0 );
            if ( tmp20 ) {
                { // Invoke: error "..."
                    TclObject[] objv21 = TJC.grabObjv(interp, 2);
                    TclObject tmp22;
                    try {
                        // Arg 0 constant: error
                        objv21[0] = const0;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp23 = new StringBuffer(64);
                        sbtmp23.append("found controls type ");
                        { // Invoke: lindex $tuple 0
                            TclObject tmp24 = getVarScalar(interp, "tuple", compiledLocals, 3);
                            tmp24 = TclList.index(interp, tmp24, 0);
                            if ( tmp24 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp24);
                            }
                        } // End Invoke: lindex
                        tmp22 = interp.getResult();
                        sbtmp23.append(tmp22.toString());
                        sbtmp23.append(" but expected ");
                        tmp22 = getVarScalar(interp, "type", compiledLocals, 0);
                        sbtmp23.append(tmp22.toString());
                        sbtmp23.append(" : controls_stack ");
                        sbtmp23.append("{");
                        tmp22 = getVarArray(interp, "_compileproc", "options,controls_stack", compiledLocals, 1);
                        sbtmp23.append(tmp22.toString());
                        sbtmp23.append("}");
                        tmp22 = TclString.newInstance(sbtmp23);
                        tmp22.preserve();
                        objv21[1] = tmp22;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv21, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp22 = objv21[1];
                        if ( tmp22 != null ) {
                            tmp22.release();
                        }
                        TJC.releaseObjv(interp, objv21, 2);
                    }
                } // End Invoke: error
            } else {
                // Binary operator: () && ()
                // Binary operator: "proc" == [...]
                { // Invoke: lindex $tuple 0
                    TclObject tmp25 = getVarScalar(interp, "tuple", compiledLocals, 3);
                    tmp25 = TclList.index(interp, tmp25, 0);
                    if ( tmp25 == null ) {
                        interp.resetResult();
                    } else {
                        interp.setResult(tmp25);
                    }
                } // End Invoke: lindex
                TclObject tmp26 = interp.getResult();
                boolean tmp27 = tmp26.toString().equals("proc");
                ExprValue tmp28 = evs0;
                tmp28.setIntValue(tmp27);
                // End Binary operator: ==
                if (tmp28.getBooleanValue(interp)) {
                // Binary operator: $type != "proc"
                TclObject tmp29 = getVarScalar(interp, "type", compiledLocals, 0);
                boolean tmp30 = ! tmp29.toString().equals("proc");
                ExprValue tmp31 = evs1;
                tmp31.setIntValue(tmp30);
                // End Binary operator: !=
                tmp28.setIntValue(tmp31.getBooleanValue(interp));
                } else {
                tmp28.setIntValue(0);
                } // End if: ()
                // End Binary operator: &&
                boolean tmp32 = ( tmp28.getIntValue() != 0 );
                if ( tmp32 ) {
                    { // Invoke: error ...
                        TclObject[] objv33 = TJC.grabObjv(interp, 2);
                        try {
                            // Arg 0 constant: error
                            objv33[0] = const0;
                            // Arg 1 constant: ...
                            objv33[1] = const4;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                ? cmdcache1.cmd : null), objv33, 0);
                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                updateCmdCache(interp, 1);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv33, 2);
                        }
                    } // End Invoke: error
                }
            }
        } // End Invoke: if
        { // Invoke: set ... $stack
            TclObject tmp34;
            tmp34 = getVarScalar(interp, "stack", compiledLocals, 2);
            tmp34 = setVarArray(interp, "_compileproc", "options,controls_stack", tmp34, compiledLocals, 1);
            interp.setResult(tmp34);
        } // End Invoke: set
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_pop_controls_context");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("error");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("lrange");
        const1.preserve(); const1.preserve();
        const2 = TclInteger.newInstance(1);
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("end");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("popped proc control context off of controls stack");
        const4.preserve(); const4.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "error";
                break;
            }
            case 2: {
                cmdName = "lrange";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "type",
        "_compileproc",
        "stack",
        "tuple"
    };
} // end class CompileprocPopControlsContextCmd

