// TJC implementation of procedure compileproc_scan_keys_in_container
package tjc;
import tcl.lang.*;

public class CompileprocScanKeysInContainerCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 3, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        { // Invoke: set ccmds [...]
            TclObject tmp0;
            { // Invoke: descend_commands $key container
                TclObject[] objv1 = TJC.grabObjv(interp, 3);
                TclObject tmp2;
                try {
                    // Arg 0 constant: descend_commands
                    objv1[0] = const0;
                    // Arg 1 variable: $key
                    tmp2 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[1] = tmp2;
                    // Arg 2 constant: container
                    objv1[2] = const1;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[1];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 3);
                }
            } // End Invoke: descend_commands
            tmp0 = interp.getResult();
            setVarScalar(interp, "ccmds", tmp0, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: if {$ccmds == {}} ...
            // Binary operator: $ccmds == ""
            TclObject tmp3 = getVarScalar(interp, "ccmds", compiledLocals, 1);
            ExprValue tmp4 = evs0;
            TJC.exprEqualsEmptyString(tmp4, tmp3, false);
            // End Binary operator: ==
            boolean tmp5 = ( tmp4.getIntValue() != 0 );
            if ( tmp5 ) {
                { // Invoke: return
                    interp.resetResult();
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: set is_flat_list [...]
            TclObject tmp6;
            { // Invoke: ... $key
                TclObject[] objv7 = TJC.grabObjv(interp, 2);
                TclObject tmp8;
                try {
                    // Arg 0 constant: ...
                    objv7[0] = const2;
                    // Arg 1 variable: $key
                    tmp8 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp8.preserve();
                    objv7[1] = tmp8;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv7, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp8 = objv7[1];
                    if ( tmp8 != null ) {
                        tmp8.release();
                    }
                    TJC.releaseObjv(interp, objv7, 2);
                }
            } // End Invoke: ...
            tmp6 = interp.getResult();
            setVarScalar(interp, "is_flat_list", tmp6, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: if {$is_flat_list} ... else ...
            TclObject tmp9 = getVarScalar(interp, "is_flat_list", compiledLocals, 2);
            boolean tmp10 = TJC.getBoolean(interp, tmp9);
            if ( tmp10 ) {
                { // Invoke: ... $key [...]
                    TclObject[] objv11 = TJC.grabObjv(interp, 3);
                    TclObject tmp12;
                    try {
                        // Arg 0 constant: ...
                        objv11[0] = const3;
                        // Arg 1 variable: $key
                        tmp12 = getVarScalar(interp, "key", compiledLocals, 0);
                        tmp12.preserve();
                        objv11[1] = tmp12;
                        // Arg 2 command: [...]
                        { // Invoke: list $ccmds
                            TclObject tmp13 = TclList.newInstance();
                            TclObject tmp14;
                            tmp14 = getVarScalar(interp, "ccmds", compiledLocals, 1);
                            TclList.append(interp, tmp13, tmp14);
                            interp.setResult(tmp13);
                        } // End Invoke: list
                        tmp12 = interp.getResult();
                        tmp12.preserve();
                        objv11[2] = tmp12;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv11, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        tmp12 = objv11[1];
                        if ( tmp12 != null ) {
                            tmp12.release();
                        }
                        tmp12 = objv11[2];
                        if ( tmp12 != null ) {
                            tmp12.release();
                        }
                        TJC.releaseObjv(interp, objv11, 3);
                    }
                } // End Invoke: ...
            } else {
                { // Invoke: ... $key $ccmds
                    TclObject[] objv15 = TJC.grabObjv(interp, 3);
                    TclObject tmp16;
                    try {
                        // Arg 0 constant: ...
                        objv15[0] = const3;
                        // Arg 1 variable: $key
                        tmp16 = getVarScalar(interp, "key", compiledLocals, 0);
                        tmp16.preserve();
                        objv15[1] = tmp16;
                        // Arg 2 variable: $ccmds
                        tmp16 = getVarScalar(interp, "ccmds", compiledLocals, 1);
                        tmp16.preserve();
                        objv15[2] = tmp16;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv15, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        tmp16 = objv15[1];
                        if ( tmp16 != null ) {
                            tmp16.release();
                        }
                        tmp16 = objv15[2];
                        if ( tmp16 != null ) {
                            tmp16.release();
                        }
                        TJC.releaseObjv(interp, objv15, 3);
                    }
                } // End Invoke: ...
            }
        } // End Invoke: if
        { // Invoke: return
            interp.resetResult();
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_scan_keys_in_container");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("descend_commands");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("container");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("compileproc_is_container_command_keys_flat");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("compileproc_scan_keys_in_container_sublist");
        const3.preserve(); const3.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "descend_commands";
                break;
            }
            case 2: {
                cmdName = "compileproc_is_container_command_keys_flat";
                break;
            }
            case 3: {
                cmdName = "compileproc_scan_keys_in_container_sublist";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "ccmds",
        "is_flat_list"
    };
} // end class CompileprocScanKeysInContainerCmd

