// TJC implementation of procedure compileproc_setup_nonconstant_array_variable
package tjc;
import tcl.lang.*;

public class CompileprocSetupNonconstantArrayVariableCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 15, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 4) {
            throw new TclNumArgsException(interp, 1, objv, "key index tmpsymbol");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        setVarScalar(interp, "index", objv[2], compiledLocals, 1);
        setVarScalar(interp, "tmpsymbol", objv[3], compiledLocals, 2);
        { // Invoke: set tuple [...]
            TclObject tmp0;
            { // Invoke: ... $key $index
                TclObject[] objv1 = TJC.grabObjv(interp, 3);
                TclObject tmp2;
                try {
                    // Arg 0 constant: ...
                    objv1[0] = const0;
                    // Arg 1 variable: $key
                    tmp2 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[1] = tmp2;
                    // Arg 2 variable: $index
                    tmp2 = getVarScalar(interp, "index", compiledLocals, 1);
                    tmp2.preserve();
                    objv1[2] = tmp2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[1];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    tmp2 = objv1[2];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 3);
                }
            } // End Invoke: ...
            tmp0 = interp.getResult();
            setVarScalar(interp, "tuple", tmp0, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: [...] != "word"
            { // Invoke: lindex $tuple 0
                TclObject tmp3 = getVarScalar(interp, "tuple", compiledLocals, 3);
                tmp3 = TclList.index(interp, tmp3, 0);
                if ( tmp3 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp3);
                }
            } // End Invoke: lindex
            TclObject tmp4 = interp.getResult();
            boolean tmp5 = ! tmp4.toString().equals("word");
            ExprValue tmp6 = evs0;
            tmp6.setIntValue(tmp5);
            // End Binary operator: !=
            boolean tmp7 = ( tmp6.getIntValue() != 0 );
            if ( tmp7 ) {
                { // Invoke: error ...
                    TclObject[] objv8 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: error
                        objv8[0] = const1;
                        // Arg 1 constant: ...
                        objv8[1] = const2;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv8, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv8, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set elems [...]
            TclObject tmp9;
            { // Invoke: lindex $tuple 1
                TclObject tmp10 = getVarScalar(interp, "tuple", compiledLocals, 3);
                tmp10 = TclList.index(interp, tmp10, 1);
                if ( tmp10 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp10);
                }
            } // End Invoke: lindex
            tmp9 = interp.getResult();
            setVarScalar(interp, "elems", tmp9, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set first [...]
            TclObject tmp11;
            { // Invoke: lindex $elems 0 1
                TclObject[] objv12 = TJC.grabObjv(interp, 4);
                TclObject tmp13;
                try {
                    // Arg 0 constant: lindex
                    objv12[0] = const3;
                    // Arg 1 variable: $elems
                    tmp13 = getVarScalar(interp, "elems", compiledLocals, 4);
                    tmp13.preserve();
                    objv12[1] = tmp13;
                    // Arg 2 constant: 0
                    objv12[2] = const4;
                    // Arg 3 constant: 1
                    objv12[3] = const5;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                        ? cmdcache3.cmd : null), objv12, 0);
                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                        updateCmdCache(interp, 3);
                    }
                } finally {
                    tmp13 = objv12[1];
                    if ( tmp13 != null ) {
                        tmp13.release();
                    }
                    TJC.releaseObjv(interp, objv12, 4);
                }
            } // End Invoke: lindex
            tmp11 = interp.getResult();
            setVarScalar(interp, "first", tmp11, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: set ind [...]
            TclObject tmp14;
            { // Invoke: string first "(" $first
                char tmp15 = '(';
                TclObject tmp16 = getVarScalar(interp, "first", compiledLocals, 5);
                String tmp17 = tmp16.toString();
                int tmp18 = tmp17.indexOf(tmp15);
                interp.setResult(tmp18);
            } // End Invoke: string
            tmp14 = interp.getResult();
            setVarScalar(interp, "ind", tmp14, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: incr ind -1
            interp.resetResult();
            incrVarScalar(interp, "ind", -1, compiledLocals, 6);
        } // End Invoke: incr
        { // Invoke: set varname [...]
            TclObject tmp19;
            { // Invoke: string range $first 0 $ind
                TclObject tmp20 = getVarScalar(interp, "first", compiledLocals, 5);
                String tmp21 = tmp20.toString();
                TclObject tmp22 = const4;
                tmp22.preserve();
                TclObject tmp23 = getVarScalar(interp, "ind", compiledLocals, 6);
                TclObject tmp24 = TJC.stringRange(interp, tmp21, tmp22, tmp23);
                interp.setResult(tmp24);
            } // End Invoke: string
            tmp19 = interp.getResult();
            setVarScalar(interp, "varname", tmp19, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: set prefix [...]
            TclObject tmp25;
            { // Invoke: string range $first [...] end
                TclObject tmp26 = getVarScalar(interp, "first", compiledLocals, 5);
                String tmp27 = tmp26.toString();
                { // Invoke: expr {$ind + 2}
                    // Binary operator: $ind + 2
                    TclObject tmp29 = getVarScalar(interp, "ind", compiledLocals, 6);
                    ExprValue tmp30 = evs0;
                    TJC.exprInitValue(interp, tmp30, tmp29);
                    ExprValue tmp31 = evs1;
                    tmp31.setIntValue(2);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_PLUS, tmp30, tmp31);
                    // End Binary operator: +
                    TJC.exprSetResult(interp, tmp30);
                } // End Invoke: expr
                TclObject tmp28 = interp.getResult();
                tmp28.preserve();
                TclObject tmp32 = const6;
                TclObject tmp33 = TJC.stringRange(interp, tmp27, tmp28, tmp32);
                interp.setResult(tmp33);
            } // End Invoke: string
            tmp25 = interp.getResult();
            setVarScalar(interp, "prefix", tmp25, compiledLocals, 8);
        } // End Invoke: set
        { // Invoke: set last [...]
            TclObject tmp34;
            { // Invoke: lindex $elems end 1
                TclObject[] objv35 = TJC.grabObjv(interp, 4);
                TclObject tmp36;
                try {
                    // Arg 0 constant: lindex
                    objv35[0] = const3;
                    // Arg 1 variable: $elems
                    tmp36 = getVarScalar(interp, "elems", compiledLocals, 4);
                    tmp36.preserve();
                    objv35[1] = tmp36;
                    // Arg 2 constant: end
                    objv35[2] = const6;
                    // Arg 3 constant: 1
                    objv35[3] = const5;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                        ? cmdcache3.cmd : null), objv35, 0);
                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                        updateCmdCache(interp, 3);
                    }
                } finally {
                    tmp36 = objv35[1];
                    if ( tmp36 != null ) {
                        tmp36.release();
                    }
                    TJC.releaseObjv(interp, objv35, 4);
                }
            } // End Invoke: lindex
            tmp34 = interp.getResult();
            setVarScalar(interp, "last", tmp34, compiledLocals, 9);
        } // End Invoke: set
        { // Invoke: set suffix [...]
            TclObject tmp37;
            { // Invoke: string range $last 0 end-1
                TclObject tmp38 = getVarScalar(interp, "last", compiledLocals, 9);
                String tmp39 = tmp38.toString();
                TclObject tmp40 = const4;
                tmp40.preserve();
                TclObject tmp41 = const7;
                TclObject tmp42 = TJC.stringRange(interp, tmp39, tmp40, tmp41);
                interp.setResult(tmp42);
            } // End Invoke: string
            tmp37 = interp.getResult();
            setVarScalar(interp, "suffix", tmp37, compiledLocals, 10);
        } // End Invoke: set
        { // Invoke: set key_elems [...]
            TclObject tmp43;
            { // Invoke: lrange $elems 1 end-1
                TclObject[] objv44 = TJC.grabObjv(interp, 4);
                TclObject tmp45;
                try {
                    // Arg 0 constant: lrange
                    objv44[0] = const8;
                    // Arg 1 variable: $elems
                    tmp45 = getVarScalar(interp, "elems", compiledLocals, 4);
                    tmp45.preserve();
                    objv44[1] = tmp45;
                    // Arg 2 constant: 1
                    objv44[2] = const5;
                    // Arg 3 constant: end-1
                    objv44[3] = const7;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                        ? cmdcache4.cmd : null), objv44, 0);
                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                        updateCmdCache(interp, 4);
                    }
                } finally {
                    tmp45 = objv44[1];
                    if ( tmp45 != null ) {
                        tmp45.release();
                    }
                    TJC.releaseObjv(interp, objv44, 4);
                }
            } // End Invoke: lrange
            tmp43 = interp.getResult();
            setVarScalar(interp, "key_elems", tmp43, compiledLocals, 11);
        } // End Invoke: set
        { // Invoke: if {$prefix != ""} ...
            // Binary operator: $prefix != ""
            TclObject tmp46 = getVarScalar(interp, "prefix", compiledLocals, 8);
            ExprValue tmp47 = evs0;
            TJC.exprEqualsEmptyString(tmp47, tmp46, true);
            // End Binary operator: !=
            boolean tmp48 = ( tmp47.getIntValue() != 0 );
            if ( tmp48 ) {
                { // Invoke: set key_elems [...]
                    TclObject tmp49;
                    { // Invoke: linsert $key_elems 0 [...]
                        TclObject[] objv50 = TJC.grabObjv(interp, 4);
                        TclObject tmp51;
                        try {
                            // Arg 0 constant: linsert
                            objv50[0] = const9;
                            // Arg 1 variable: $key_elems
                            tmp51 = getVarScalar(interp, "key_elems", compiledLocals, 11);
                            tmp51.preserve();
                            objv50[1] = tmp51;
                            // Arg 2 constant: 0
                            objv50[2] = const4;
                            // Arg 3 command: [...]
                            { // Invoke: list text $prefix
                                TclObject tmp52 = TclList.newInstance();
                                TclObject tmp53;
                                try {
                                    TclList.append(interp, tmp52, const10);
                                    tmp53 = getVarScalar(interp, "prefix", compiledLocals, 8);
                                    TclList.append(interp, tmp52, tmp53);
                                } catch (TclException ex) {
                                    tmp52.release();
                                    throw ex;
                                }
                                interp.setResult(tmp52);
                            } // End Invoke: list
                            tmp51 = interp.getResult();
                            tmp51.preserve();
                            objv50[3] = tmp51;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                ? cmdcache5.cmd : null), objv50, 0);
                            if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                updateCmdCache(interp, 5);
                            }
                        } finally {
                            tmp51 = objv50[1];
                            if ( tmp51 != null ) {
                                tmp51.release();
                            }
                            tmp51 = objv50[3];
                            if ( tmp51 != null ) {
                                tmp51.release();
                            }
                            TJC.releaseObjv(interp, objv50, 4);
                        }
                    } // End Invoke: linsert
                    tmp49 = interp.getResult();
                    setVarScalar(interp, "key_elems", tmp49, compiledLocals, 11);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: if {$suffix != ""} ...
            // Binary operator: $suffix != ""
            TclObject tmp54 = getVarScalar(interp, "suffix", compiledLocals, 10);
            ExprValue tmp55 = evs0;
            TJC.exprEqualsEmptyString(tmp55, tmp54, true);
            // End Binary operator: !=
            boolean tmp56 = ( tmp55.getIntValue() != 0 );
            if ( tmp56 ) {
                { // Invoke: lappend key_elems [...]
                    TclObject[] objv57 = TJC.grabObjv(interp, 1);
                    TclObject tmp58;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: list text $suffix
                            TclObject tmp59 = TclList.newInstance();
                            TclObject tmp60;
                            try {
                                TclList.append(interp, tmp59, const10);
                                tmp60 = getVarScalar(interp, "suffix", compiledLocals, 10);
                                TclList.append(interp, tmp59, tmp60);
                            } catch (TclException ex) {
                                tmp59.release();
                                throw ex;
                            }
                            interp.setResult(tmp59);
                        } // End Invoke: list
                        tmp58 = interp.getResult();
                        tmp58.preserve();
                        objv57[0] = tmp58;
                        interp.resetResult();
                        lappendVarScalar(interp, "key_elems", objv57, compiledLocals, 11);
                    } finally {
                        TJC.releaseObjvElems(interp, objv57, 1);
                    }
                } // End Invoke: lappend
            }
        } // End Invoke: if
        { // Invoke: set decl_flag 0
            setVarScalar(interp, "decl_flag", const4, compiledLocals, 12);
        } // End Invoke: set
        { // Invoke: if {$tmpsymbol == {}} ...
            // Binary operator: $tmpsymbol == ""
            TclObject tmp61 = getVarScalar(interp, "tmpsymbol", compiledLocals, 2);
            ExprValue tmp62 = evs0;
            TJC.exprEqualsEmptyString(tmp62, tmp61, false);
            // End Binary operator: ==
            boolean tmp63 = ( tmp62.getIntValue() != 0 );
            if ( tmp63 ) {
                { // Invoke: set tmpsymbol [...]
                    TclObject tmp64;
                    { // Invoke: ...
                        TclObject[] objv65 = TJC.grabObjv(interp, 1);
                        try {
                            // Arg 0 constant: ...
                            objv65[0] = const11;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                ? cmdcache6.cmd : null), objv65, 0);
                            if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                updateCmdCache(interp, 6);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv65, 1);
                        }
                    } // End Invoke: ...
                    tmp64 = interp.getResult();
                    setVarScalar(interp, "tmpsymbol", tmp64, compiledLocals, 2);
                } // End Invoke: set
                { // Invoke: set decl_flag 1
                    setVarScalar(interp, "decl_flag", const5, compiledLocals, 12);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: set keysym [...]
            TclObject tmp66;
            { // Invoke: ...
                TclObject[] objv67 = TJC.grabObjv(interp, 1);
                try {
                    // Arg 0 constant: ...
                    objv67[0] = const11;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                        ? cmdcache6.cmd : null), objv67, 0);
                    if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                        updateCmdCache(interp, 6);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv67, 1);
                }
            } // End Invoke: ...
            tmp66 = interp.getResult();
            setVarScalar(interp, "keysym", tmp66, compiledLocals, 13);
        } // End Invoke: set
        { // Invoke: append word_buffer [...]
            TclObject[] objv68 = TJC.grabObjv(interp, 1);
            TclObject tmp69;
            try {
                // Arg 2 command: [...]
                { // Invoke: ... $tmpsymbol $key_elems $decl_flag $keysym
                    TclObject[] objv70 = TJC.grabObjv(interp, 5);
                    TclObject tmp71;
                    try {
                        // Arg 0 constant: ...
                        objv70[0] = const12;
                        // Arg 1 variable: $tmpsymbol
                        tmp71 = getVarScalar(interp, "tmpsymbol", compiledLocals, 2);
                        tmp71.preserve();
                        objv70[1] = tmp71;
                        // Arg 2 variable: $key_elems
                        tmp71 = getVarScalar(interp, "key_elems", compiledLocals, 11);
                        tmp71.preserve();
                        objv70[2] = tmp71;
                        // Arg 3 variable: $decl_flag
                        tmp71 = getVarScalar(interp, "decl_flag", compiledLocals, 12);
                        tmp71.preserve();
                        objv70[3] = tmp71;
                        // Arg 4 variable: $keysym
                        tmp71 = getVarScalar(interp, "keysym", compiledLocals, 13);
                        tmp71.preserve();
                        objv70[4] = tmp71;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                            ? cmdcache7.cmd : null), objv70, 0);
                        if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                            updateCmdCache(interp, 7);
                        }
                    } finally {
                        tmp71 = objv70[1];
                        if ( tmp71 != null ) {
                            tmp71.release();
                        }
                        tmp71 = objv70[2];
                        if ( tmp71 != null ) {
                            tmp71.release();
                        }
                        tmp71 = objv70[3];
                        if ( tmp71 != null ) {
                            tmp71.release();
                        }
                        tmp71 = objv70[4];
                        if ( tmp71 != null ) {
                            tmp71.release();
                        }
                        TJC.releaseObjv(interp, objv70, 5);
                    }
                } // End Invoke: ...
                tmp69 = interp.getResult();
                tmp69.preserve();
                objv68[0] = tmp69;
                interp.resetResult();
                appendVarScalar(interp, "word_buffer", objv68, compiledLocals, 14);
            } finally {
                TJC.releaseObjvElems(interp, objv68, 1);
            }
        } // End Invoke: append
        { // Invoke: return [...]
            { // Invoke: list $varname $keysym $word_buffer
                TclObject tmp72 = TclList.newInstance();
                TclObject tmp73;
                try {
                    tmp73 = getVarScalar(interp, "varname", compiledLocals, 7);
                    TclList.append(interp, tmp72, tmp73);
                    tmp73 = getVarScalar(interp, "keysym", compiledLocals, 13);
                    TclList.append(interp, tmp72, tmp73);
                    tmp73 = getVarScalar(interp, "word_buffer", compiledLocals, 14);
                    TclList.append(interp, tmp72, tmp73);
                } catch (TclException ex) {
                    tmp72.release();
                    throw ex;
                }
                interp.setResult(tmp72);
            } // End Invoke: list
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_setup_nonconstant_array_variable");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("compileproc_get_argument_tuple");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("error");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("expected word argument");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("lindex");
        const3.preserve(); const3.preserve();
        const4 = TclInteger.newInstance(0);
        const4.preserve(); const4.preserve();
        const5 = TclInteger.newInstance(1);
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("end");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("end-1");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("lrange");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("linsert");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("text");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("compileproc_tmpvar_next");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("compileproc_emit_word");
        const12.preserve(); const12.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "compileproc_get_argument_tuple";
                break;
            }
            case 2: {
                cmdName = "error";
                break;
            }
            case 3: {
                cmdName = "lindex";
                break;
            }
            case 4: {
                cmdName = "lrange";
                break;
            }
            case 5: {
                cmdName = "linsert";
                break;
            }
            case 6: {
                cmdName = "compileproc_tmpvar_next";
                break;
            }
            case 7: {
                cmdName = "compileproc_emit_word";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "index",
        "tmpsymbol",
        "tuple",
        "elems",
        "first",
        "ind",
        "varname",
        "prefix",
        "last",
        "suffix",
        "key_elems",
        "decl_flag",
        "keysym",
        "word_buffer"
    };
} // end class CompileprocSetupNonconstantArrayVariableCmd

