// TJC implementation of procedure compileproc_variable_cache_lookup
package tjc;
import tcl.lang.*;

public class CompileprocVariableCacheLookupCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 4, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "vname");
        }
        setVarScalar(interp, "vname", objv[1], compiledLocals, 0);
        { // Invoke: global ...
            TJC.makeGlobalLinkVar(interp, "_compileproc_variable_cache", "_compileproc_variable_cache", 1);
        } // End Invoke: global
        { // Invoke: if ... ...
            // Unary operator: ! [...]
            { // Invoke: info exists ...
                TclObject[] objv0 = TJC.grabObjv(interp, 3);
                try {
                    // Arg 0 constant: info
                    objv0[0] = const0;
                    // Arg 1 constant: exists
                    objv0[1] = const1;
                    // Arg 2 constant: ...
                    objv0[2] = const2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv0, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv0, 3);
                }
            } // End Invoke: info
            TclObject tmp1 = interp.getResult();
            ExprValue tmp2 = evs0;
            if ( tmp1.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp2, tmp1);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp2, tmp1);
            }
            // End Unary operator: !
            boolean tmp3 = ( tmp2.getIntValue() != 0 );
            if ( tmp3 ) {
                { // Invoke: set ... 0
                    setVarArray(interp, "_compileproc_variable_cache", "counter", const3, compiledLocals, 1);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: set key "symbol,$vname"
            TclObject tmp4;
            StringBuffer sbtmp5 = new StringBuffer(64);
            sbtmp5.append("symbol,");
            tmp4 = getVarScalar(interp, "vname", compiledLocals, 0);
            sbtmp5.append(tmp4.toString());
            tmp4 = TclString.newInstance(sbtmp5);
            setVarScalar(interp, "key", tmp4, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: if ... ... else ...
            // Unary operator: ! [...]
            { // Invoke: info exists "..."
                TclObject[] objv6 = TJC.grabObjv(interp, 3);
                TclObject tmp7;
                try {
                    // Arg 0 constant: info
                    objv6[0] = const0;
                    // Arg 1 constant: exists
                    objv6[1] = const1;
                    // Arg 2 word: "..."
                    StringBuffer sbtmp8 = new StringBuffer(64);
                    sbtmp8.append("_compileproc_variable_cache(");
                    tmp7 = getVarScalar(interp, "key", compiledLocals, 2);
                    sbtmp8.append(tmp7.toString());
                    sbtmp8.append(")");
                    tmp7 = TclString.newInstance(sbtmp8);
                    tmp7.preserve();
                    objv6[2] = tmp7;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv6, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp7 = objv6[2];
                    if ( tmp7 != null ) {
                        tmp7.release();
                    }
                    TJC.releaseObjv(interp, objv6, 3);
                }
            } // End Invoke: info
            TclObject tmp9 = interp.getResult();
            ExprValue tmp10 = evs0;
            if ( tmp9.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp10, tmp9);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp10, tmp9);
            }
            // End Unary operator: !
            boolean tmp11 = ( tmp10.getIntValue() != 0 );
            if ( tmp11 ) {
                { // Invoke: set symbol "..."
                    TclObject tmp12;
                    StringBuffer sbtmp13 = new StringBuffer(64);
                    sbtmp13.append("compiledLocals");
                    sbtmp13.append("[");
                    tmp12 = getVarArray(interp, "_compileproc_variable_cache", "counter", compiledLocals, 1);
                    sbtmp13.append(tmp12.toString());
                    sbtmp13.append("]");
                    tmp12 = TclString.newInstance(sbtmp13);
                    setVarScalar(interp, "symbol", tmp12, compiledLocals, 3);
                } // End Invoke: set
                { // Invoke: incr ...
                    interp.resetResult();
                    incrVarArray(interp, "_compileproc_variable_cache", "counter", 1, compiledLocals, 1);
                } // End Invoke: incr
                { // Invoke: set "..." $symbol
                    TclObject tmp14;
                    tmp14 = getVarScalar(interp, "key", compiledLocals, 2);
                    String tmp15 = tmp14.toString();
                    tmp14 = getVarScalar(interp, "symbol", compiledLocals, 3);
                    tmp14 = setVarArray(interp, "_compileproc_variable_cache", tmp15, tmp14, compiledLocals, 1);
                } // End Invoke: set
                { // Invoke: lappend ... $key
                    TclObject[] objv16 = TJC.grabObjv(interp, 1);
                    TclObject tmp17;
                    try {
                        // Arg 2 variable: $key
                        tmp17 = getVarScalar(interp, "key", compiledLocals, 2);
                        tmp17.preserve();
                        objv16[0] = tmp17;
                        interp.resetResult();
                        lappendVarArray(interp, "_compileproc_variable_cache", "ordered_keys", objv16, compiledLocals, 1);
                    } finally {
                        TJC.releaseObjvElems(interp, objv16, 1);
                    }
                } // End Invoke: lappend
                { // Invoke: lappend ... $vname
                    TclObject[] objv18 = TJC.grabObjv(interp, 1);
                    TclObject tmp19;
                    try {
                        // Arg 2 variable: $vname
                        tmp19 = getVarScalar(interp, "vname", compiledLocals, 0);
                        tmp19.preserve();
                        objv18[0] = tmp19;
                        interp.resetResult();
                        lappendVarArray(interp, "_compileproc_variable_cache", "ordered_vars", objv18, compiledLocals, 1);
                    } finally {
                        TJC.releaseObjvElems(interp, objv18, 1);
                    }
                } // End Invoke: lappend
            } else {
                { // Invoke: set symbol $...
                    TclObject tmp20;
                    tmp20 = getVarScalar(interp, "key", compiledLocals, 2);
                    tmp20 = getVarArray(interp, "_compileproc_variable_cache", tmp20.toString(), compiledLocals, 1);
                    setVarScalar(interp, "symbol", tmp20, compiledLocals, 3);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: return $symbol
            TclObject tmp21 = getVarScalar(interp, "symbol", compiledLocals, 3);
            interp.resetResult();
            interp.setResult(tmp21);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_variable_cache_lookup");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("info");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("exists");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("_compileproc_variable_cache(counter)");
        const2.preserve(); const2.preserve();
        const3 = TclInteger.newInstance(0);
        const3.preserve(); const3.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "info";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "vname",
        "_compileproc_variable_cache",
        "key",
        "symbol"
    };
} // end class CompileprocVariableCacheLookupCmd

