// TJC implementation of procedure descend_container_concat_body_arguments
package tjc;
import tcl.lang.*;

public class DescendContainerConcatBodyArgumentsCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 15, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        ExprValue evs2 = TJC.exprGetValue(interp);
        try {
        if (objv.length < 5 || objv.length > 6) {
            throw new TclNumArgsException(interp, 1, objv, "key script tree body_indexes ?undetermined?");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        setVarScalar(interp, "script", objv[2], compiledLocals, 1);
        setVarScalar(interp, "tree", objv[3], compiledLocals, 2);
        setVarScalar(interp, "body_indexes", objv[4], compiledLocals, 3);
        setVarScalar(interp, "undetermined", 
            ((objv.length <= 5) ? const0 : objv[5]), compiledLocals, 4);
        { // Invoke: set nested [...]
            TclObject tmp0;
            { // Invoke: descend_get_data $key nested
                TclObject[] objv1 = TJC.grabObjv(interp, 3);
                TclObject tmp2;
                try {
                    // Arg 0 constant: descend_get_data
                    objv1[0] = const1;
                    // Arg 1 variable: $key
                    tmp2 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[1] = tmp2;
                    // Arg 2 constant: nested
                    objv1[2] = const2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[1];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 3);
                }
            } // End Invoke: descend_get_data
            tmp0 = interp.getResult();
            setVarScalar(interp, "nested", tmp0, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: set outermost 0
            setVarScalar(interp, "outermost", const0, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: set ranges [...]
            TclObject tmp3;
            { // Invoke: list
                TclObject tmp4 = TclList.newInstance();
                interp.setResult(tmp4);
            } // End Invoke: list
            tmp3 = interp.getResult();
            setVarScalar(interp, "ranges", tmp3, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: set prev_body_index -1
            setVarScalar(interp, "prev_body_index", const3, compiledLocals, 8);
        } // End Invoke: set
        { // Invoke: set command ""
            setVarScalar(interp, "command", const4, compiledLocals, 9);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: [...] == 0
            { // Invoke: llength $body_indexes
                TclObject tmp5 = getVarScalar(interp, "body_indexes", compiledLocals, 3);
                int tmp6 = TclList.getLength(interp, tmp5);
                interp.setResult(tmp6);
            } // End Invoke: llength
            TclObject tmp7 = interp.getResult();
            ExprValue tmp8 = evs0;
            TJC.exprInitValue(interp, tmp8, tmp7);
            ExprValue tmp9 = evs1;
            tmp9.setIntValue(0);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp8, tmp9);
            // End Binary operator: ==
            boolean tmp10 = ( tmp8.getIntValue() != 0 );
            if ( tmp10 ) {
                { // Invoke: error ...
                    TclObject[] objv11 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: error
                        objv11[0] = const5;
                        // Arg 1 constant: ...
                        objv11[1] = const6;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv11, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv11, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: foreach body_index $body_indexes ...
            TclObject tmp12 = null;
            try {
                tmp12 = getVarScalar(interp, "body_indexes", compiledLocals, 3);
                tmp12.preserve();
                final int tmp12_length = TclList.getLength(interp, tmp12);

                for ( int index13 = 0 ; index13 < tmp12_length ; index13++ ) {
                    TclObject tmp14 = TclList.index(interp, tmp12, index13);
                    try {
                        setVarScalar(interp, "body_index", tmp14, compiledLocals, 10);
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "body_index");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: if ... ... elseif ... ... else ...
                        // Binary operator: $prev_body_index == ()
                        TclObject tmp15 = getVarScalar(interp, "prev_body_index", compiledLocals, 8);
                        ExprValue tmp16 = evs0;
                        TJC.exprInitValue(interp, tmp16, tmp15);
                        // Unary operator: - 1
                        ExprValue tmp17 = evs1;
                        tmp17.setIntValue(-1);
                        // End Unary operator: -
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp16, tmp17);
                        // End Binary operator: ==
                        boolean tmp18 = ( tmp16.getIntValue() != 0 );
                        if ( tmp18 ) {
                            { // Invoke: set prev_body_index $body_index
                                TclObject tmp19;
                                tmp19 = getVarScalar(interp, "body_index", compiledLocals, 10);
                                setVarScalar(interp, "prev_body_index", tmp19, compiledLocals, 8);
                            } // End Invoke: set
                        } else {
                            // Binary operator: $body_index != ()
                            TclObject tmp20 = getVarScalar(interp, "body_index", compiledLocals, 10);
                            ExprValue tmp21 = evs0;
                            TJC.exprInitValue(interp, tmp21, tmp20);
                            // Binary operator: $prev_body_index + 1
                            TclObject tmp22 = getVarScalar(interp, "prev_body_index", compiledLocals, 8);
                            ExprValue tmp23 = evs1;
                            TJC.exprInitValue(interp, tmp23, tmp22);
                            ExprValue tmp24 = evs2;
                            tmp24.setIntValue(1);
                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_PLUS, tmp23, tmp24);
                            // End Binary operator: +
                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp21, tmp23);
                            // End Binary operator: !=
                            boolean tmp25 = ( tmp21.getIntValue() != 0 );
                            if ( tmp25 ) {
                                { // Invoke: error "..."
                                    TclObject[] objv26 = TJC.grabObjv(interp, 2);
                                    TclObject tmp27;
                                    try {
                                        // Arg 0 constant: error
                                        objv26[0] = const5;
                                        // Arg 1 word: "..."
                                        StringBuffer sbtmp28 = new StringBuffer(64);
                                        sbtmp28.append("prev_body_index was ");
                                        tmp27 = getVarScalar(interp, "prev_body_index", compiledLocals, 8);
                                        sbtmp28.append(tmp27.toString());
                                        sbtmp28.append(", body_index was ");
                                        tmp27 = getVarScalar(interp, "body_index", compiledLocals, 10);
                                        sbtmp28.append(tmp27.toString());
                                        sbtmp28.append(", expected body index to be prev + 1");
                                        tmp27 = TclString.newInstance(sbtmp28);
                                        tmp27.preserve();
                                        objv26[1] = tmp27;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                            ? cmdcache2.cmd : null), objv26, 0);
                                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                            updateCmdCache(interp, 2);
                                        }
                                    } finally {
                                        tmp27 = objv26[1];
                                        if ( tmp27 != null ) {
                                            tmp27.release();
                                        }
                                        TJC.releaseObjv(interp, objv26, 2);
                                    }
                                } // End Invoke: error
                            } else {
                                { // Invoke: set prev_body_index $body_index
                                    TclObject tmp29;
                                    tmp29 = getVarScalar(interp, "body_index", compiledLocals, 10);
                                    setVarScalar(interp, "prev_body_index", tmp29, compiledLocals, 8);
                                } // End Invoke: set
                            }
                        }
                    } // End Invoke: if
                    { // Invoke: set body_subtree [...]
                        TclObject tmp30;
                        { // Invoke: lindex $tree $body_index
                            TclObject tmp31 = null;
                            TclObject tmp32;
                            try {
                                tmp31 = getVarScalar(interp, "tree", compiledLocals, 2);
                                tmp31.preserve();
                                tmp32 = getVarScalar(interp, "body_index", compiledLocals, 10);
                                TJC.lindexNonconst(interp, tmp31, tmp32);
                            } finally {
                                if ( tmp31 != null ) {
                                    tmp31.release();
                                }
                            }
                        } // End Invoke: lindex
                        tmp30 = interp.getResult();
                        setVarScalar(interp, "body_subtree", tmp30, compiledLocals, 11);
                    } // End Invoke: set
                    { // Invoke: if ... ...
                        // Unary operator: ! [...]
                        { // Invoke: parse_is_simple_text $body_subtree
                            TclObject[] objv33 = TJC.grabObjv(interp, 2);
                            TclObject tmp34;
                            try {
                                // Arg 0 constant: parse_is_simple_text
                                objv33[0] = const7;
                                // Arg 1 variable: $body_subtree
                                tmp34 = getVarScalar(interp, "body_subtree", compiledLocals, 11);
                                tmp34.preserve();
                                objv33[1] = tmp34;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                    ? cmdcache3.cmd : null), objv33, 0);
                                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                    updateCmdCache(interp, 3);
                                }
                            } finally {
                                tmp34 = objv33[1];
                                if ( tmp34 != null ) {
                                    tmp34.release();
                                }
                                TJC.releaseObjv(interp, objv33, 2);
                            }
                        } // End Invoke: parse_is_simple_text
                        TclObject tmp35 = interp.getResult();
                        ExprValue tmp36 = evs0;
                        if ( tmp35.isIntType() ) {
                            TJC.exprUnaryNotOperatorKnownInt(tmp36, tmp35);
                        } else {
                            TJC.exprUnaryNotOperator(interp, tmp36, tmp35);
                        }
                        // End Unary operator: !
                        boolean tmp37 = ( tmp36.getIntValue() != 0 );
                        if ( tmp37 ) {
                            { // Invoke: error "..."
                                TclObject[] objv38 = TJC.grabObjv(interp, 2);
                                TclObject tmp39;
                                try {
                                    // Arg 0 constant: error
                                    objv38[0] = const5;
                                    // Arg 1 word: "..."
                                    StringBuffer sbtmp40 = new StringBuffer(64);
                                    sbtmp40.append("body subtree at index ");
                                    tmp39 = getVarScalar(interp, "body_index", compiledLocals, 10);
                                    sbtmp40.append(tmp39.toString());
                                    sbtmp40.append(" should be simple/text");
                                    tmp39 = TclString.newInstance(sbtmp40);
                                    tmp39.preserve();
                                    objv38[1] = tmp39;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                        ? cmdcache2.cmd : null), objv38, 0);
                                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                        updateCmdCache(interp, 2);
                                    }
                                } finally {
                                    tmp39 = objv38[1];
                                    if ( tmp39 != null ) {
                                        tmp39.release();
                                    }
                                    TJC.releaseObjv(interp, objv38, 2);
                                }
                            } // End Invoke: error
                        }
                    } // End Invoke: if
                    { // Invoke: set text [...]
                        TclObject tmp41;
                        { // Invoke: ... $script $body_subtree "text"
                            TclObject[] objv42 = TJC.grabObjv(interp, 4);
                            TclObject tmp43;
                            try {
                                // Arg 0 constant: ...
                                objv42[0] = const8;
                                // Arg 1 variable: $script
                                tmp43 = getVarScalar(interp, "script", compiledLocals, 1);
                                tmp43.preserve();
                                objv42[1] = tmp43;
                                // Arg 2 variable: $body_subtree
                                tmp43 = getVarScalar(interp, "body_subtree", compiledLocals, 11);
                                tmp43.preserve();
                                objv42[2] = tmp43;
                                // Arg 3 constant: "text"
                                objv42[3] = const9;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                    ? cmdcache4.cmd : null), objv42, 0);
                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                    updateCmdCache(interp, 4);
                                }
                            } finally {
                                tmp43 = objv42[1];
                                if ( tmp43 != null ) {
                                    tmp43.release();
                                }
                                tmp43 = objv42[2];
                                if ( tmp43 != null ) {
                                    tmp43.release();
                                }
                                TJC.releaseObjv(interp, objv42, 4);
                            }
                        } // End Invoke: ...
                        tmp41 = interp.getResult();
                        setVarScalar(interp, "text", tmp41, compiledLocals, 12);
                    } // End Invoke: set
                    { // Invoke: foreach elem $text ...
                        TclObject tmp44 = null;
                        try {
                            tmp44 = getVarScalar(interp, "text", compiledLocals, 12);
                            tmp44.preserve();
                            final int tmp44_length = TclList.getLength(interp, tmp44);

                            for ( int index45 = 0 ; index45 < tmp44_length ; index45++ ) {
                                TclObject tmp46 = TclList.index(interp, tmp44, index45);
                                try {
                                    setVarScalar(interp, "elem", tmp46, compiledLocals, 13);
                                } catch (TclException ex) {
                                    TJC.foreachVarErr(interp, "elem");
                                }

                                try {
                                if ( false ) { throw (TclException) null; }
                                { // Invoke: append command $elem
                                    TclObject[] objv47 = TJC.grabObjv(interp, 1);
                                    TclObject tmp48;
                                    try {
                                        // Arg 2 variable: $elem
                                        tmp48 = getVarScalar(interp, "elem", compiledLocals, 13);
                                        tmp48.preserve();
                                        objv47[0] = tmp48;
                                        interp.resetResult();
                                        appendVarScalar(interp, "command", objv47, compiledLocals, 9);
                                    } finally {
                                        TJC.releaseObjvElems(interp, objv47, 1);
                                    }
                                } // End Invoke: append
                                { // Invoke: append command " "
                                    TclObject[] objv49 = TJC.grabObjv(interp, 1);
                                    TclObject tmp50;
                                    try {
                                        // Arg 2 constant: " "
                                        objv49[0] = const10;
                                        interp.resetResult();
                                        appendVarScalar(interp, "command", objv49, compiledLocals, 9);
                                    } finally {
                                        TJC.releaseObjv(interp, objv49, 1);
                                    }
                                } // End Invoke: append
                                } catch (TclException ex) {
                                    int type = ex.getCompletionCode();
                                    if (type == TCL.BREAK) {
                                        break;
                                    } else if (type == TCL.CONTINUE) {
                                        continue;
                                    } else {
                                        throw ex;
                                    }
                                }
                            }
                        } finally {
                            if ( tmp44 != null ) {
                                tmp44.release();
                            }
                        }
                    } // End Invoke: foreach
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
            } finally {
                if ( tmp12 != null ) {
                    tmp12.release();
                }
            }
        } // End Invoke: foreach
        { // Invoke: set chknested 0
            setVarScalar(interp, "chknested", const0, compiledLocals, 14);
        } // End Invoke: set
        { // Invoke: return [...]
            { // Invoke: descend_start $command {0 end} $nested $chknested $undetermined $outermost
                TclObject[] objv51 = TJC.grabObjv(interp, 7);
                TclObject tmp52;
                try {
                    // Arg 0 constant: descend_start
                    objv51[0] = const11;
                    // Arg 1 variable: $command
                    tmp52 = getVarScalar(interp, "command", compiledLocals, 9);
                    tmp52.preserve();
                    objv51[1] = tmp52;
                    // Arg 2 constant: {0 end}
                    objv51[2] = const12;
                    // Arg 3 variable: $nested
                    tmp52 = getVarScalar(interp, "nested", compiledLocals, 5);
                    tmp52.preserve();
                    objv51[3] = tmp52;
                    // Arg 4 variable: $chknested
                    tmp52 = getVarScalar(interp, "chknested", compiledLocals, 14);
                    tmp52.preserve();
                    objv51[4] = tmp52;
                    // Arg 5 variable: $undetermined
                    tmp52 = getVarScalar(interp, "undetermined", compiledLocals, 4);
                    tmp52.preserve();
                    objv51[5] = tmp52;
                    // Arg 6 variable: $outermost
                    tmp52 = getVarScalar(interp, "outermost", compiledLocals, 6);
                    tmp52.preserve();
                    objv51[6] = tmp52;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                        ? cmdcache5.cmd : null), objv51, 0);
                    if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                        updateCmdCache(interp, 5);
                    }
                } finally {
                    objv51[0] = null;
                    objv51[2] = null;
                    TJC.releaseObjvElems(interp, objv51, 7);
                }
            } // End Invoke: descend_start
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "descend_container_concat_body_arguments");
        } finally {
            TJC.exprReleaseValue(interp, evs2);
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclInteger.newInstance(0);
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("descend_get_data");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("nested");
        const2.preserve(); const2.preserve();
        const3 = TclInteger.newInstance(-1);
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("error");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("body_indexes can't be {}");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("parse_is_simple_text");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("parse_get_simple_text");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("text");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance(" ");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("descend_start");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("0 end");
        const12.preserve(); const12.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "descend_get_data";
                break;
            }
            case 2: {
                cmdName = "error";
                break;
            }
            case 3: {
                cmdName = "parse_is_simple_text";
                break;
            }
            case 4: {
                cmdName = "parse_get_simple_text";
                break;
            }
            case 5: {
                cmdName = "descend_start";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "script",
        "tree",
        "body_indexes",
        "undetermined",
        "nested",
        "outermost",
        "ranges",
        "prev_body_index",
        "command",
        "body_index",
        "body_subtree",
        "text",
        "elem",
        "chknested"
    };
} // end class DescendContainerConcatBodyArgumentsCmd

