// TJC implementation of procedure descend_container_if
package tjc;
import tcl.lang.*;

public class DescendContainerIfCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 9, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        { // Invoke: global _descend
            TJC.makeGlobalLinkVar(interp, "_descend", "_descend", 1);
        } // End Invoke: global
        { // Invoke: set script [...]
            TclObject tmp0;
            { // Invoke: descend_get_data $key script
                TclObject[] objv1 = TJC.grabObjv(interp, 3);
                TclObject tmp2;
                try {
                    // Arg 0 constant: descend_get_data
                    objv1[0] = const0;
                    // Arg 1 variable: $key
                    tmp2 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[1] = tmp2;
                    // Arg 2 constant: script
                    objv1[2] = const1;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[1];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 3);
                }
            } // End Invoke: descend_get_data
            tmp0 = interp.getResult();
            setVarScalar(interp, "script", tmp0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set tree [...]
            TclObject tmp3;
            { // Invoke: descend_get_data $key tree
                TclObject[] objv4 = TJC.grabObjv(interp, 3);
                TclObject tmp5;
                try {
                    // Arg 0 constant: descend_get_data
                    objv4[0] = const0;
                    // Arg 1 variable: $key
                    tmp5 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp5.preserve();
                    objv4[1] = tmp5;
                    // Arg 2 constant: tree
                    objv4[2] = const2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv4, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp5 = objv4[1];
                    if ( tmp5 != null ) {
                        tmp5.release();
                    }
                    TJC.releaseObjv(interp, objv4, 3);
                }
            } // End Invoke: descend_get_data
            tmp3 = interp.getResult();
            setVarScalar(interp, "tree", tmp3, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set result [...]
            TclObject tmp6;
            { // Invoke: ... $key
                TclObject[] objv7 = TJC.grabObjv(interp, 2);
                TclObject tmp8;
                try {
                    // Arg 0 constant: ...
                    objv7[0] = const3;
                    // Arg 1 variable: $key
                    tmp8 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp8.preserve();
                    objv7[1] = tmp8;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv7, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp8 = objv7[1];
                    if ( tmp8 != null ) {
                        tmp8.release();
                    }
                    TJC.releaseObjv(interp, objv7, 2);
                }
            } // End Invoke: ...
            tmp6 = interp.getResult();
            setVarScalar(interp, "result", tmp6, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: if {$result != "OK"} ...
            // Binary operator: $result != "OK"
            TclObject tmp9 = getVarScalar(interp, "result", compiledLocals, 4);
            boolean tmp10 = ! tmp9.toString().equals("OK");
            ExprValue tmp11 = evs0;
            tmp11.setIntValue(tmp10);
            // End Binary operator: !=
            boolean tmp12 = ( tmp11.getIntValue() != 0 );
            if ( tmp12 ) {
                { // Invoke: if ... ...
                    { // Invoke: descend_get_data $key usage
                        TclObject[] objv13 = TJC.grabObjv(interp, 3);
                        TclObject tmp14;
                        try {
                            // Arg 0 constant: descend_get_data
                            objv13[0] = const0;
                            // Arg 1 variable: $key
                            tmp14 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp14.preserve();
                            objv13[1] = tmp14;
                            // Arg 2 constant: usage
                            objv13[2] = const4;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                ? cmdcache1.cmd : null), objv13, 0);
                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                updateCmdCache(interp, 1);
                            }
                        } finally {
                            tmp14 = objv13[1];
                            if ( tmp14 != null ) {
                                tmp14.release();
                            }
                            TJC.releaseObjv(interp, objv13, 3);
                        }
                    } // End Invoke: descend_get_data
                    TclObject tmp15 = interp.getResult();
                    ExprValue tmp16 = evs0;
                    TJC.exprInitValue(interp, tmp16, tmp15);
                    boolean tmp17 = tmp16.getBooleanValue(interp);
                    if ( tmp17 ) {
                        { // Invoke: descend_report_usage $key $result
                            TclObject[] objv18 = TJC.grabObjv(interp, 3);
                            TclObject tmp19;
                            try {
                                // Arg 0 constant: descend_report_usage
                                objv18[0] = const5;
                                // Arg 1 variable: $key
                                tmp19 = getVarScalar(interp, "key", compiledLocals, 0);
                                tmp19.preserve();
                                objv18[1] = tmp19;
                                // Arg 2 variable: $result
                                tmp19 = getVarScalar(interp, "result", compiledLocals, 4);
                                tmp19.preserve();
                                objv18[2] = tmp19;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                    ? cmdcache3.cmd : null), objv18, 0);
                                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                    updateCmdCache(interp, 3);
                                }
                            } finally {
                                tmp19 = objv18[1];
                                if ( tmp19 != null ) {
                                    tmp19.release();
                                }
                                tmp19 = objv18[2];
                                if ( tmp19 != null ) {
                                    tmp19.release();
                                }
                                TJC.releaseObjv(interp, objv18, 3);
                            }
                        } // End Invoke: descend_report_usage
                    }
                } // End Invoke: if
                { // Invoke: return
                    interp.resetResult();
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: set container_commands [...]
            TclObject tmp20;
            { // Invoke: list
                TclObject tmp21 = TclList.newInstance();
                interp.setResult(tmp21);
            } // End Invoke: list
            tmp20 = interp.getResult();
            setVarScalar(interp, "container_commands", tmp20, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: set pair [...]
            TclObject tmp22;
            { // Invoke: ... $key
                TclObject[] objv23 = TJC.grabObjv(interp, 2);
                TclObject tmp24;
                try {
                    // Arg 0 constant: ...
                    objv23[0] = const6;
                    // Arg 1 variable: $key
                    tmp24 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp24.preserve();
                    objv23[1] = tmp24;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                        ? cmdcache4.cmd : null), objv23, 0);
                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                        updateCmdCache(interp, 4);
                    }
                } finally {
                    tmp24 = objv23[1];
                    if ( tmp24 != null ) {
                        tmp24.release();
                    }
                    TJC.releaseObjv(interp, objv23, 2);
                }
            } // End Invoke: ...
            tmp22 = interp.getResult();
            setVarScalar(interp, "pair", tmp22, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: set expr_index [...]
            TclObject tmp25;
            { // Invoke: lindex $pair 0
                TclObject tmp26 = getVarScalar(interp, "pair", compiledLocals, 6);
                tmp26 = TclList.index(interp, tmp26, 0);
                if ( tmp26 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp26);
                }
            } // End Invoke: lindex
            tmp25 = interp.getResult();
            setVarScalar(interp, "expr_index", tmp25, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: set body_index [...]
            TclObject tmp27;
            { // Invoke: lindex $pair 1
                TclObject tmp28 = getVarScalar(interp, "pair", compiledLocals, 6);
                tmp28 = TclList.index(interp, tmp28, 1);
                if ( tmp28 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp28);
                }
            } // End Invoke: lindex
            tmp27 = interp.getResult();
            setVarScalar(interp, "body_index", tmp27, compiledLocals, 8);
        } // End Invoke: set
        { // Invoke: ...
            TclObject[] objv29 = TJC.grabObjv(interp, 1);
            try {
                // Arg 0 constant: ...
                objv29[0] = const7;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                    ? cmdcache5.cmd : null), objv29, 0);
                if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                    updateCmdCache(interp, 5);
                }
            } finally {
                TJC.releaseObjv(interp, objv29, 1);
            }
        } // End Invoke: ...
        { // Invoke: ... $key $expr_index
            TclObject[] objv30 = TJC.grabObjv(interp, 3);
            TclObject tmp31;
            try {
                // Arg 0 constant: ...
                objv30[0] = const8;
                // Arg 1 variable: $key
                tmp31 = getVarScalar(interp, "key", compiledLocals, 0);
                tmp31.preserve();
                objv30[1] = tmp31;
                // Arg 2 variable: $expr_index
                tmp31 = getVarScalar(interp, "expr_index", compiledLocals, 7);
                tmp31.preserve();
                objv30[2] = tmp31;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                    ? cmdcache6.cmd : null), objv30, 0);
                if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                    updateCmdCache(interp, 6);
                }
            } finally {
                tmp31 = objv30[1];
                if ( tmp31 != null ) {
                    tmp31.release();
                }
                tmp31 = objv30[2];
                if ( tmp31 != null ) {
                    tmp31.release();
                }
                TJC.releaseObjv(interp, objv30, 3);
            }
        } // End Invoke: ...
        { // Invoke: lappend container_commands [...]
            TclObject[] objv32 = TJC.grabObjv(interp, 1);
            TclObject tmp33;
            try {
                // Arg 2 command: [...]
                { // Invoke: ...
                    TclObject[] objv34 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: ...
                        objv34[0] = const9;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                            ? cmdcache7.cmd : null), objv34, 0);
                        if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                            updateCmdCache(interp, 7);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv34, 1);
                    }
                } // End Invoke: ...
                tmp33 = interp.getResult();
                tmp33.preserve();
                objv32[0] = tmp33;
                interp.resetResult();
                lappendVarScalar(interp, "container_commands", objv32, compiledLocals, 5);
            } finally {
                TJC.releaseObjvElems(interp, objv32, 1);
            }
        } // End Invoke: lappend
        { // Invoke: if ... ... else ...
            { // Invoke: ... $key $body_index
                TclObject[] objv35 = TJC.grabObjv(interp, 3);
                TclObject tmp36;
                try {
                    // Arg 0 constant: ...
                    objv35[0] = const10;
                    // Arg 1 variable: $key
                    tmp36 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp36.preserve();
                    objv35[1] = tmp36;
                    // Arg 2 variable: $body_index
                    tmp36 = getVarScalar(interp, "body_index", compiledLocals, 8);
                    tmp36.preserve();
                    objv35[2] = tmp36;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                        ? cmdcache8.cmd : null), objv35, 0);
                    if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                        updateCmdCache(interp, 8);
                    }
                } finally {
                    tmp36 = objv35[1];
                    if ( tmp36 != null ) {
                        tmp36.release();
                    }
                    tmp36 = objv35[2];
                    if ( tmp36 != null ) {
                        tmp36.release();
                    }
                    TJC.releaseObjv(interp, objv35, 3);
                }
            } // End Invoke: ...
            TclObject tmp37 = interp.getResult();
            ExprValue tmp38 = evs0;
            TJC.exprInitValue(interp, tmp38, tmp37);
            boolean tmp39 = tmp38.getBooleanValue(interp);
            if ( tmp39 ) {
                { // Invoke: ...
                    TclObject[] objv40 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: ...
                        objv40[0] = const7;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                            ? cmdcache5.cmd : null), objv40, 0);
                        if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                            updateCmdCache(interp, 5);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv40, 1);
                    }
                } // End Invoke: ...
                { // Invoke: ... $key $script $tree $body_index
                    TclObject[] objv41 = TJC.grabObjv(interp, 5);
                    TclObject tmp42;
                    try {
                        // Arg 0 constant: ...
                        objv41[0] = const11;
                        // Arg 1 variable: $key
                        tmp42 = getVarScalar(interp, "key", compiledLocals, 0);
                        tmp42.preserve();
                        objv41[1] = tmp42;
                        // Arg 2 variable: $script
                        tmp42 = getVarScalar(interp, "script", compiledLocals, 2);
                        tmp42.preserve();
                        objv41[2] = tmp42;
                        // Arg 3 variable: $tree
                        tmp42 = getVarScalar(interp, "tree", compiledLocals, 3);
                        tmp42.preserve();
                        objv41[3] = tmp42;
                        // Arg 4 variable: $body_index
                        tmp42 = getVarScalar(interp, "body_index", compiledLocals, 8);
                        tmp42.preserve();
                        objv41[4] = tmp42;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                            ? cmdcache9.cmd : null), objv41, 0);
                        if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                            updateCmdCache(interp, 9);
                        }
                    } finally {
                        tmp42 = objv41[1];
                        if ( tmp42 != null ) {
                            tmp42.release();
                        }
                        tmp42 = objv41[2];
                        if ( tmp42 != null ) {
                            tmp42.release();
                        }
                        tmp42 = objv41[3];
                        if ( tmp42 != null ) {
                            tmp42.release();
                        }
                        tmp42 = objv41[4];
                        if ( tmp42 != null ) {
                            tmp42.release();
                        }
                        TJC.releaseObjv(interp, objv41, 5);
                    }
                } // End Invoke: ...
                { // Invoke: lappend container_commands [...]
                    TclObject[] objv43 = TJC.grabObjv(interp, 1);
                    TclObject tmp44;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: ...
                            TclObject[] objv45 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: ...
                                objv45[0] = const9;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                    ? cmdcache7.cmd : null), objv45, 0);
                                if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                    updateCmdCache(interp, 7);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv45, 1);
                            }
                        } // End Invoke: ...
                        tmp44 = interp.getResult();
                        tmp44.preserve();
                        objv43[0] = tmp44;
                        interp.resetResult();
                        lappendVarScalar(interp, "container_commands", objv43, compiledLocals, 5);
                    } finally {
                        TJC.releaseObjvElems(interp, objv43, 1);
                    }
                } // End Invoke: lappend
            } else {
                { // Invoke: lappend container_commands {}
                    TclObject[] objv46 = TJC.grabObjv(interp, 1);
                    TclObject tmp47;
                    try {
                        // Arg 2 constant: {}
                        objv46[0] = const12;
                        interp.resetResult();
                        lappendVarScalar(interp, "container_commands", objv46, compiledLocals, 5);
                    } finally {
                        TJC.releaseObjv(interp, objv46, 1);
                    }
                } // End Invoke: lappend
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            { // Invoke: ... $key
                TclObject[] objv48 = TJC.grabObjv(interp, 2);
                TclObject tmp49;
                try {
                    // Arg 0 constant: ...
                    objv48[0] = const13;
                    // Arg 1 variable: $key
                    tmp49 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp49.preserve();
                    objv48[1] = tmp49;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                        ? cmdcache10.cmd : null), objv48, 0);
                    if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                        updateCmdCache(interp, 10);
                    }
                } finally {
                    tmp49 = objv48[1];
                    if ( tmp49 != null ) {
                        tmp49.release();
                    }
                    TJC.releaseObjv(interp, objv48, 2);
                }
            } // End Invoke: ...
            TclObject tmp50 = interp.getResult();
            ExprValue tmp51 = evs0;
            TJC.exprInitValue(interp, tmp51, tmp50);
            boolean tmp52 = tmp51.getBooleanValue(interp);
            if ( tmp52 ) {
                { // Invoke: foreach ... [...] ...
                    TclObject tmp53 = null;
                    try {
                        { // Invoke: ... $key
                            TclObject[] objv54 = TJC.grabObjv(interp, 2);
                            TclObject tmp55;
                            try {
                                // Arg 0 constant: ...
                                objv54[0] = const14;
                                // Arg 1 variable: $key
                                tmp55 = getVarScalar(interp, "key", compiledLocals, 0);
                                tmp55.preserve();
                                objv54[1] = tmp55;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache11_cmdEpoch == cmdcache11.cmdEpoch)
                                    ? cmdcache11.cmd : null), objv54, 0);
                                if ( cmdcache11_cmdEpoch != cmdcache11.cmdEpoch ) {
                                    updateCmdCache(interp, 11);
                                }
                            } finally {
                                tmp55 = objv54[1];
                                if ( tmp55 != null ) {
                                    tmp55.release();
                                }
                                TJC.releaseObjv(interp, objv54, 2);
                            }
                        } // End Invoke: ...
                        tmp53 = interp.getResult();
                        tmp53.preserve();
                        final int tmp53_length = TclList.getLength(interp, tmp53);

                        for ( int index56 = 0 ; index56 < tmp53_length ; index56 += 2 ) {
                            TclObject tmp57 = null;
                            if ( index56 < tmp53_length ) {
                                tmp57 = TclList.index(interp, tmp53, index56);
                            }
                            TclObject tmp58 = null;
                            if ( index56 + 1 < tmp53_length ) {
                                tmp58 = TclList.index(interp, tmp53, index56 + 1);
                            }
                            try {
                                if ( tmp57 == null ) {
                                    setVarScalar(interp, "expr_index", "", compiledLocals, 7);
                                } else {
                                    setVarScalar(interp, "expr_index", tmp57, compiledLocals, 7);
                                }
                            } catch (TclException ex) {
                                TJC.foreachVarErr(interp, "expr_index");
                            }
                            try {
                                if ( tmp58 == null ) {
                                    setVarScalar(interp, "body_index", "", compiledLocals, 8);
                                } else {
                                    setVarScalar(interp, "body_index", tmp58, compiledLocals, 8);
                                }
                            } catch (TclException ex) {
                                TJC.foreachVarErr(interp, "body_index");
                            }

                            try {
                            if ( false ) { throw (TclException) null; }
                            { // Invoke: ...
                                TclObject[] objv59 = TJC.grabObjv(interp, 1);
                                try {
                                    // Arg 0 constant: ...
                                    objv59[0] = const7;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                        ? cmdcache5.cmd : null), objv59, 0);
                                    if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                        updateCmdCache(interp, 5);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv59, 1);
                                }
                            } // End Invoke: ...
                            { // Invoke: ... $key $expr_index
                                TclObject[] objv60 = TJC.grabObjv(interp, 3);
                                TclObject tmp61;
                                try {
                                    // Arg 0 constant: ...
                                    objv60[0] = const8;
                                    // Arg 1 variable: $key
                                    tmp61 = getVarScalar(interp, "key", compiledLocals, 0);
                                    tmp61.preserve();
                                    objv60[1] = tmp61;
                                    // Arg 2 variable: $expr_index
                                    tmp61 = getVarScalar(interp, "expr_index", compiledLocals, 7);
                                    tmp61.preserve();
                                    objv60[2] = tmp61;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                        ? cmdcache6.cmd : null), objv60, 0);
                                    if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                        updateCmdCache(interp, 6);
                                    }
                                } finally {
                                    tmp61 = objv60[1];
                                    if ( tmp61 != null ) {
                                        tmp61.release();
                                    }
                                    tmp61 = objv60[2];
                                    if ( tmp61 != null ) {
                                        tmp61.release();
                                    }
                                    TJC.releaseObjv(interp, objv60, 3);
                                }
                            } // End Invoke: ...
                            { // Invoke: lappend container_commands [...]
                                TclObject[] objv62 = TJC.grabObjv(interp, 1);
                                TclObject tmp63;
                                try {
                                    // Arg 2 command: [...]
                                    { // Invoke: ...
                                        TclObject[] objv64 = TJC.grabObjv(interp, 1);
                                        try {
                                            // Arg 0 constant: ...
                                            objv64[0] = const9;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                                ? cmdcache7.cmd : null), objv64, 0);
                                            if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                                updateCmdCache(interp, 7);
                                            }
                                        } finally {
                                            TJC.releaseObjv(interp, objv64, 1);
                                        }
                                    } // End Invoke: ...
                                    tmp63 = interp.getResult();
                                    tmp63.preserve();
                                    objv62[0] = tmp63;
                                    interp.resetResult();
                                    lappendVarScalar(interp, "container_commands", objv62, compiledLocals, 5);
                                } finally {
                                    TJC.releaseObjvElems(interp, objv62, 1);
                                }
                            } // End Invoke: lappend
                            { // Invoke: if ... ... else ...
                                { // Invoke: ... $key $body_index
                                    TclObject[] objv65 = TJC.grabObjv(interp, 3);
                                    TclObject tmp66;
                                    try {
                                        // Arg 0 constant: ...
                                        objv65[0] = const10;
                                        // Arg 1 variable: $key
                                        tmp66 = getVarScalar(interp, "key", compiledLocals, 0);
                                        tmp66.preserve();
                                        objv65[1] = tmp66;
                                        // Arg 2 variable: $body_index
                                        tmp66 = getVarScalar(interp, "body_index", compiledLocals, 8);
                                        tmp66.preserve();
                                        objv65[2] = tmp66;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                            ? cmdcache8.cmd : null), objv65, 0);
                                        if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                            updateCmdCache(interp, 8);
                                        }
                                    } finally {
                                        tmp66 = objv65[1];
                                        if ( tmp66 != null ) {
                                            tmp66.release();
                                        }
                                        tmp66 = objv65[2];
                                        if ( tmp66 != null ) {
                                            tmp66.release();
                                        }
                                        TJC.releaseObjv(interp, objv65, 3);
                                    }
                                } // End Invoke: ...
                                TclObject tmp67 = interp.getResult();
                                ExprValue tmp68 = evs0;
                                TJC.exprInitValue(interp, tmp68, tmp67);
                                boolean tmp69 = tmp68.getBooleanValue(interp);
                                if ( tmp69 ) {
                                    { // Invoke: ...
                                        TclObject[] objv70 = TJC.grabObjv(interp, 1);
                                        try {
                                            // Arg 0 constant: ...
                                            objv70[0] = const7;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                                ? cmdcache5.cmd : null), objv70, 0);
                                            if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                                updateCmdCache(interp, 5);
                                            }
                                        } finally {
                                            TJC.releaseObjv(interp, objv70, 1);
                                        }
                                    } // End Invoke: ...
                                    { // Invoke: ... $key $script $tree $body_index
                                        TclObject[] objv71 = TJC.grabObjv(interp, 5);
                                        TclObject tmp72;
                                        try {
                                            // Arg 0 constant: ...
                                            objv71[0] = const11;
                                            // Arg 1 variable: $key
                                            tmp72 = getVarScalar(interp, "key", compiledLocals, 0);
                                            tmp72.preserve();
                                            objv71[1] = tmp72;
                                            // Arg 2 variable: $script
                                            tmp72 = getVarScalar(interp, "script", compiledLocals, 2);
                                            tmp72.preserve();
                                            objv71[2] = tmp72;
                                            // Arg 3 variable: $tree
                                            tmp72 = getVarScalar(interp, "tree", compiledLocals, 3);
                                            tmp72.preserve();
                                            objv71[3] = tmp72;
                                            // Arg 4 variable: $body_index
                                            tmp72 = getVarScalar(interp, "body_index", compiledLocals, 8);
                                            tmp72.preserve();
                                            objv71[4] = tmp72;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                                                ? cmdcache9.cmd : null), objv71, 0);
                                            if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                                                updateCmdCache(interp, 9);
                                            }
                                        } finally {
                                            tmp72 = objv71[1];
                                            if ( tmp72 != null ) {
                                                tmp72.release();
                                            }
                                            tmp72 = objv71[2];
                                            if ( tmp72 != null ) {
                                                tmp72.release();
                                            }
                                            tmp72 = objv71[3];
                                            if ( tmp72 != null ) {
                                                tmp72.release();
                                            }
                                            tmp72 = objv71[4];
                                            if ( tmp72 != null ) {
                                                tmp72.release();
                                            }
                                            TJC.releaseObjv(interp, objv71, 5);
                                        }
                                    } // End Invoke: ...
                                    { // Invoke: lappend container_commands [...]
                                        TclObject[] objv73 = TJC.grabObjv(interp, 1);
                                        TclObject tmp74;
                                        try {
                                            // Arg 2 command: [...]
                                            { // Invoke: ...
                                                TclObject[] objv75 = TJC.grabObjv(interp, 1);
                                                try {
                                                    // Arg 0 constant: ...
                                                    objv75[0] = const9;
                                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                        updateCmdCache(interp, 0);
                                                    }
                                                    TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                                        ? cmdcache7.cmd : null), objv75, 0);
                                                    if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                                        updateCmdCache(interp, 7);
                                                    }
                                                } finally {
                                                    TJC.releaseObjv(interp, objv75, 1);
                                                }
                                            } // End Invoke: ...
                                            tmp74 = interp.getResult();
                                            tmp74.preserve();
                                            objv73[0] = tmp74;
                                            interp.resetResult();
                                            lappendVarScalar(interp, "container_commands", objv73, compiledLocals, 5);
                                        } finally {
                                            TJC.releaseObjvElems(interp, objv73, 1);
                                        }
                                    } // End Invoke: lappend
                                } else {
                                    { // Invoke: lappend container_commands {}
                                        TclObject[] objv76 = TJC.grabObjv(interp, 1);
                                        TclObject tmp77;
                                        try {
                                            // Arg 2 constant: {}
                                            objv76[0] = const12;
                                            interp.resetResult();
                                            lappendVarScalar(interp, "container_commands", objv76, compiledLocals, 5);
                                        } finally {
                                            TJC.releaseObjv(interp, objv76, 1);
                                        }
                                    } // End Invoke: lappend
                                }
                            } // End Invoke: if
                            } catch (TclException ex) {
                                int type = ex.getCompletionCode();
                                if (type == TCL.BREAK) {
                                    break;
                                } else if (type == TCL.CONTINUE) {
                                    continue;
                                } else {
                                    throw ex;
                                }
                            }
                        }
                    } finally {
                        if ( tmp53 != null ) {
                            tmp53.release();
                        }
                    }
                } // End Invoke: foreach
            }
        } // End Invoke: if
        { // Invoke: if ... ... else ...
            { // Invoke: ... $key
                TclObject[] objv78 = TJC.grabObjv(interp, 2);
                TclObject tmp79;
                try {
                    // Arg 0 constant: ...
                    objv78[0] = const15;
                    // Arg 1 variable: $key
                    tmp79 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp79.preserve();
                    objv78[1] = tmp79;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache12_cmdEpoch == cmdcache12.cmdEpoch)
                        ? cmdcache12.cmd : null), objv78, 0);
                    if ( cmdcache12_cmdEpoch != cmdcache12.cmdEpoch ) {
                        updateCmdCache(interp, 12);
                    }
                } finally {
                    tmp79 = objv78[1];
                    if ( tmp79 != null ) {
                        tmp79.release();
                    }
                    TJC.releaseObjv(interp, objv78, 2);
                }
            } // End Invoke: ...
            TclObject tmp80 = interp.getResult();
            ExprValue tmp81 = evs0;
            TJC.exprInitValue(interp, tmp81, tmp80);
            boolean tmp82 = tmp81.getBooleanValue(interp);
            if ( tmp82 ) {
                { // Invoke: set body_index [...]
                    TclObject tmp83;
                    { // Invoke: ... $key
                        TclObject[] objv84 = TJC.grabObjv(interp, 2);
                        TclObject tmp85;
                        try {
                            // Arg 0 constant: ...
                            objv84[0] = const16;
                            // Arg 1 variable: $key
                            tmp85 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp85.preserve();
                            objv84[1] = tmp85;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache13_cmdEpoch == cmdcache13.cmdEpoch)
                                ? cmdcache13.cmd : null), objv84, 0);
                            if ( cmdcache13_cmdEpoch != cmdcache13.cmdEpoch ) {
                                updateCmdCache(interp, 13);
                            }
                        } finally {
                            tmp85 = objv84[1];
                            if ( tmp85 != null ) {
                                tmp85.release();
                            }
                            TJC.releaseObjv(interp, objv84, 2);
                        }
                    } // End Invoke: ...
                    tmp83 = interp.getResult();
                    setVarScalar(interp, "body_index", tmp83, compiledLocals, 8);
                } // End Invoke: set
                { // Invoke: if ... ... else ...
                    { // Invoke: ... $key $body_index
                        TclObject[] objv86 = TJC.grabObjv(interp, 3);
                        TclObject tmp87;
                        try {
                            // Arg 0 constant: ...
                            objv86[0] = const10;
                            // Arg 1 variable: $key
                            tmp87 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp87.preserve();
                            objv86[1] = tmp87;
                            // Arg 2 variable: $body_index
                            tmp87 = getVarScalar(interp, "body_index", compiledLocals, 8);
                            tmp87.preserve();
                            objv86[2] = tmp87;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                ? cmdcache8.cmd : null), objv86, 0);
                            if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                updateCmdCache(interp, 8);
                            }
                        } finally {
                            tmp87 = objv86[1];
                            if ( tmp87 != null ) {
                                tmp87.release();
                            }
                            tmp87 = objv86[2];
                            if ( tmp87 != null ) {
                                tmp87.release();
                            }
                            TJC.releaseObjv(interp, objv86, 3);
                        }
                    } // End Invoke: ...
                    TclObject tmp88 = interp.getResult();
                    ExprValue tmp89 = evs0;
                    TJC.exprInitValue(interp, tmp89, tmp88);
                    boolean tmp90 = tmp89.getBooleanValue(interp);
                    if ( tmp90 ) {
                        { // Invoke: ...
                            TclObject[] objv91 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: ...
                                objv91[0] = const7;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                    ? cmdcache5.cmd : null), objv91, 0);
                                if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                    updateCmdCache(interp, 5);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv91, 1);
                            }
                        } // End Invoke: ...
                        { // Invoke: ... $key $script $tree $body_index
                            TclObject[] objv92 = TJC.grabObjv(interp, 5);
                            TclObject tmp93;
                            try {
                                // Arg 0 constant: ...
                                objv92[0] = const11;
                                // Arg 1 variable: $key
                                tmp93 = getVarScalar(interp, "key", compiledLocals, 0);
                                tmp93.preserve();
                                objv92[1] = tmp93;
                                // Arg 2 variable: $script
                                tmp93 = getVarScalar(interp, "script", compiledLocals, 2);
                                tmp93.preserve();
                                objv92[2] = tmp93;
                                // Arg 3 variable: $tree
                                tmp93 = getVarScalar(interp, "tree", compiledLocals, 3);
                                tmp93.preserve();
                                objv92[3] = tmp93;
                                // Arg 4 variable: $body_index
                                tmp93 = getVarScalar(interp, "body_index", compiledLocals, 8);
                                tmp93.preserve();
                                objv92[4] = tmp93;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                                    ? cmdcache9.cmd : null), objv92, 0);
                                if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                                    updateCmdCache(interp, 9);
                                }
                            } finally {
                                tmp93 = objv92[1];
                                if ( tmp93 != null ) {
                                    tmp93.release();
                                }
                                tmp93 = objv92[2];
                                if ( tmp93 != null ) {
                                    tmp93.release();
                                }
                                tmp93 = objv92[3];
                                if ( tmp93 != null ) {
                                    tmp93.release();
                                }
                                tmp93 = objv92[4];
                                if ( tmp93 != null ) {
                                    tmp93.release();
                                }
                                TJC.releaseObjv(interp, objv92, 5);
                            }
                        } // End Invoke: ...
                        { // Invoke: lappend container_commands [...]
                            TclObject[] objv94 = TJC.grabObjv(interp, 1);
                            TclObject tmp95;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: ...
                                    TclObject[] objv96 = TJC.grabObjv(interp, 1);
                                    try {
                                        // Arg 0 constant: ...
                                        objv96[0] = const9;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                            ? cmdcache7.cmd : null), objv96, 0);
                                        if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                            updateCmdCache(interp, 7);
                                        }
                                    } finally {
                                        TJC.releaseObjv(interp, objv96, 1);
                                    }
                                } // End Invoke: ...
                                tmp95 = interp.getResult();
                                tmp95.preserve();
                                objv94[0] = tmp95;
                                interp.resetResult();
                                lappendVarScalar(interp, "container_commands", objv94, compiledLocals, 5);
                            } finally {
                                TJC.releaseObjvElems(interp, objv94, 1);
                            }
                        } // End Invoke: lappend
                    } else {
                        { // Invoke: lappend container_commands {}
                            TclObject[] objv97 = TJC.grabObjv(interp, 1);
                            TclObject tmp98;
                            try {
                                // Arg 2 constant: {}
                                objv97[0] = const12;
                                interp.resetResult();
                                lappendVarScalar(interp, "container_commands", objv97, compiledLocals, 5);
                            } finally {
                                TJC.releaseObjv(interp, objv97, 1);
                            }
                        } // End Invoke: lappend
                    }
                } // End Invoke: if
            } else {
                { // Invoke: lappend container_commands {}
                    TclObject[] objv99 = TJC.grabObjv(interp, 1);
                    TclObject tmp100;
                    try {
                        // Arg 2 constant: {}
                        objv99[0] = const12;
                        interp.resetResult();
                        lappendVarScalar(interp, "container_commands", objv99, compiledLocals, 5);
                    } finally {
                        TJC.releaseObjv(interp, objv99, 1);
                    }
                } // End Invoke: lappend
            }
        } // End Invoke: if
        { // Invoke: set "..." $container_commands
            TclObject tmp101;
            String tmp102;
            StringBuffer sbtmp103 = new StringBuffer(64);
            tmp101 = getVarScalar(interp, "key", compiledLocals, 0);
            sbtmp103.append(tmp101.toString());
            sbtmp103.append(",container_commands");
            tmp102 = sbtmp103.toString();
            tmp101 = getVarScalar(interp, "container_commands", compiledLocals, 5);
            tmp101 = setVarArray(interp, "_descend", tmp102, tmp101, compiledLocals, 1);
            interp.setResult(tmp101);
        } // End Invoke: set
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "descend_container_if");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("descend_get_data");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("script");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("tree");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("descend_container_if_validate");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("usage");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("descend_report_usage");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("descend_container_if_expr_body");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("_descend_commands_push");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("descend_container_expr_argument");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("_descend_commands_pop");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("descend_container_argument_body_is_static");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("descend_container_body_argument");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("descend_container_if_has_elseif_body");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("descend_container_if_iterate_elseif_body");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("descend_container_if_has_else_body");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance("descend_container_if_else_body");
        const16.preserve(); const16.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;
    WrappedCommand cmdcache8;
    int cmdcache8_cmdEpoch;
    WrappedCommand cmdcache9;
    int cmdcache9_cmdEpoch;
    WrappedCommand cmdcache10;
    int cmdcache10_cmdEpoch;
    WrappedCommand cmdcache11;
    int cmdcache11_cmdEpoch;
    WrappedCommand cmdcache12;
    int cmdcache12_cmdEpoch;
    WrappedCommand cmdcache13;
    int cmdcache13_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                cmdcache8 = TJC.INVALID_COMMAND_CACHE;
                cmdcache8_cmdEpoch = 0;
                cmdcache9 = TJC.INVALID_COMMAND_CACHE;
                cmdcache9_cmdEpoch = 0;
                cmdcache10 = TJC.INVALID_COMMAND_CACHE;
                cmdcache10_cmdEpoch = 0;
                cmdcache11 = TJC.INVALID_COMMAND_CACHE;
                cmdcache11_cmdEpoch = 0;
                cmdcache12 = TJC.INVALID_COMMAND_CACHE;
                cmdcache12_cmdEpoch = 0;
                cmdcache13 = TJC.INVALID_COMMAND_CACHE;
                cmdcache13_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "descend_get_data";
                break;
            }
            case 2: {
                cmdName = "descend_container_if_validate";
                break;
            }
            case 3: {
                cmdName = "descend_report_usage";
                break;
            }
            case 4: {
                cmdName = "descend_container_if_expr_body";
                break;
            }
            case 5: {
                cmdName = "_descend_commands_push";
                break;
            }
            case 6: {
                cmdName = "descend_container_expr_argument";
                break;
            }
            case 7: {
                cmdName = "_descend_commands_pop";
                break;
            }
            case 8: {
                cmdName = "descend_container_argument_body_is_static";
                break;
            }
            case 9: {
                cmdName = "descend_container_body_argument";
                break;
            }
            case 10: {
                cmdName = "descend_container_if_has_elseif_body";
                break;
            }
            case 11: {
                cmdName = "descend_container_if_iterate_elseif_body";
                break;
            }
            case 12: {
                cmdName = "descend_container_if_has_else_body";
                break;
            }
            case 13: {
                cmdName = "descend_container_if_else_body";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
            case 8: {
                cmdcache8 = lwcmd;
                cmdcache8_cmdEpoch = cmdEpoch;
                break;
            }
            case 9: {
                cmdcache9 = lwcmd;
                cmdcache9_cmdEpoch = cmdEpoch;
                break;
            }
            case 10: {
                cmdcache10 = lwcmd;
                cmdcache10_cmdEpoch = cmdEpoch;
                break;
            }
            case 11: {
                cmdcache11 = lwcmd;
                cmdcache11_cmdEpoch = cmdEpoch;
                break;
            }
            case 12: {
                cmdcache12 = lwcmd;
                cmdcache12_cmdEpoch = cmdEpoch;
                break;
            }
            case 13: {
                cmdcache13 = lwcmd;
                cmdcache13_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "_descend",
        "script",
        "tree",
        "result",
        "container_commands",
        "pair",
        "expr_index",
        "body_index"
    };
} // end class DescendContainerIfCmd

