// TJC implementation of procedure descend_empty_nested_command
package tjc;
import tcl.lang.*;

public class DescendEmptyNestedCommandCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 5, compiledLocalsNames);
        try {
        if (objv.length != 3) {
            throw new TclNumArgsException(interp, 1, objv, "script range");
        }
        setVarScalar(interp, "script", objv[1], compiledLocals, 0);
        setVarScalar(interp, "range", objv[2], compiledLocals, 1);
        { // Invoke: global _descend
            TJC.makeGlobalLinkVar(interp, "_descend", "_descend", 2);
        } // End Invoke: global
        { // Invoke: set key [...]
            TclObject tmp0;
            { // Invoke: descend_next_key
                TclObject[] objv1 = TJC.grabObjv(interp, 1);
                try {
                    // Arg 0 constant: descend_next_key
                    objv1[0] = const0;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv1, 1);
                }
            } // End Invoke: descend_next_key
            tmp0 = interp.getResult();
            setVarScalar(interp, "key", tmp0, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set erange [...]
            TclObject tmp2;
            { // Invoke: list [...] 0
                TclObject tmp3 = TclList.newInstance();
                TclObject tmp4;
                try {
                    { // Invoke: lindex $range 0
                        TclObject tmp5 = getVarScalar(interp, "range", compiledLocals, 1);
                        tmp5 = TclList.index(interp, tmp5, 0);
                        if ( tmp5 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp5);
                        }
                    } // End Invoke: lindex
                    tmp4 = interp.getResult();
                    TclList.append(interp, tmp3, tmp4);
                    TclList.append(interp, tmp3, const1);
                } catch (TclException ex) {
                    tmp3.release();
                    throw ex;
                }
                interp.setResult(tmp3);
            } // End Invoke: list
            tmp2 = interp.getResult();
            setVarScalar(interp, "erange", tmp2, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set "..." $script
            TclObject tmp6;
            String tmp7;
            StringBuffer sbtmp8 = new StringBuffer(64);
            tmp6 = getVarScalar(interp, "key", compiledLocals, 3);
            sbtmp8.append(tmp6.toString());
            sbtmp8.append(",script");
            tmp7 = sbtmp8.toString();
            tmp6 = getVarScalar(interp, "script", compiledLocals, 0);
            tmp6 = setVarArray(interp, "_descend", tmp7, tmp6, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set _descend($key,range) $range
            TclObject tmp9;
            String tmp10;
            StringBuffer sbtmp11 = new StringBuffer(64);
            tmp9 = getVarScalar(interp, "key", compiledLocals, 3);
            sbtmp11.append(tmp9.toString());
            sbtmp11.append(",range");
            tmp10 = sbtmp11.toString();
            tmp9 = getVarScalar(interp, "range", compiledLocals, 1);
            tmp9 = setVarArray(interp, "_descend", tmp10, tmp9, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set "..." $erange
            TclObject tmp12;
            String tmp13;
            StringBuffer sbtmp14 = new StringBuffer(64);
            tmp12 = getVarScalar(interp, "key", compiledLocals, 3);
            sbtmp14.append(tmp12.toString());
            sbtmp14.append(",comment");
            tmp13 = sbtmp14.toString();
            tmp12 = getVarScalar(interp, "erange", compiledLocals, 4);
            tmp12 = setVarArray(interp, "_descend", tmp13, tmp12, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set "..." $erange
            TclObject tmp15;
            String tmp16;
            StringBuffer sbtmp17 = new StringBuffer(64);
            tmp15 = getVarScalar(interp, "key", compiledLocals, 3);
            sbtmp17.append(tmp15.toString());
            sbtmp17.append(",command");
            tmp16 = sbtmp17.toString();
            tmp15 = getVarScalar(interp, "erange", compiledLocals, 4);
            tmp15 = setVarArray(interp, "_descend", tmp16, tmp15, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set _descend($key,rest) $erange
            TclObject tmp18;
            String tmp19;
            StringBuffer sbtmp20 = new StringBuffer(64);
            tmp18 = getVarScalar(interp, "key", compiledLocals, 3);
            sbtmp20.append(tmp18.toString());
            sbtmp20.append(",rest");
            tmp19 = sbtmp20.toString();
            tmp18 = getVarScalar(interp, "erange", compiledLocals, 4);
            tmp18 = setVarArray(interp, "_descend", tmp19, tmp18, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set _descend($key,tree) {}
            TclObject tmp21;
            String tmp22;
            StringBuffer sbtmp23 = new StringBuffer(64);
            tmp21 = getVarScalar(interp, "key", compiledLocals, 3);
            sbtmp23.append(tmp21.toString());
            sbtmp23.append(",tree");
            tmp22 = sbtmp23.toString();
            setVarArray(interp, "_descend", tmp22, const2, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set "..." 1
            TclObject tmp24;
            String tmp25;
            StringBuffer sbtmp26 = new StringBuffer(64);
            tmp24 = getVarScalar(interp, "key", compiledLocals, 3);
            sbtmp26.append(tmp24.toString());
            sbtmp26.append(",nested");
            tmp25 = sbtmp26.toString();
            setVarArray(interp, "_descend", tmp25, const3, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set "..." 0
            TclObject tmp27;
            String tmp28;
            StringBuffer sbtmp29 = new StringBuffer(64);
            tmp27 = getVarScalar(interp, "key", compiledLocals, 3);
            sbtmp29.append(tmp27.toString());
            sbtmp29.append(",undetermined");
            tmp28 = sbtmp29.toString();
            setVarArray(interp, "_descend", tmp28, const1, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set _descend($key,usage) 0
            TclObject tmp30;
            String tmp31;
            StringBuffer sbtmp32 = new StringBuffer(64);
            tmp30 = getVarScalar(interp, "key", compiledLocals, 3);
            sbtmp32.append(tmp30.toString());
            sbtmp32.append(",usage");
            tmp31 = sbtmp32.toString();
            setVarArray(interp, "_descend", tmp31, const1, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: ... $key
            TclObject[] objv33 = TJC.grabObjv(interp, 2);
            TclObject tmp34;
            try {
                // Arg 0 constant: ...
                objv33[0] = const4;
                // Arg 1 variable: $key
                tmp34 = getVarScalar(interp, "key", compiledLocals, 3);
                tmp34.preserve();
                objv33[1] = tmp34;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                    ? cmdcache2.cmd : null), objv33, 0);
                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                    updateCmdCache(interp, 2);
                }
            } finally {
                tmp34 = objv33[1];
                if ( tmp34 != null ) {
                    tmp34.release();
                }
                TJC.releaseObjv(interp, objv33, 2);
            }
        } // End Invoke: ...
        { // Invoke: ... $key
            TclObject[] objv35 = TJC.grabObjv(interp, 2);
            TclObject tmp36;
            try {
                // Arg 0 constant: ...
                objv35[0] = const5;
                // Arg 1 variable: $key
                tmp36 = getVarScalar(interp, "key", compiledLocals, 3);
                tmp36.preserve();
                objv35[1] = tmp36;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                    ? cmdcache3.cmd : null), objv35, 0);
                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                    updateCmdCache(interp, 3);
                }
            } finally {
                tmp36 = objv35[1];
                if ( tmp36 != null ) {
                    tmp36.release();
                }
                TJC.releaseObjv(interp, objv35, 2);
            }
        } // End Invoke: ...
        { // Invoke: return $key
            TclObject tmp37 = getVarScalar(interp, "key", compiledLocals, 3);
            interp.resetResult();
            interp.setResult(tmp37);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "descend_empty_nested_command");
        } finally {
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("descend_next_key");
        const0.preserve(); const0.preserve();
        const1 = TclInteger.newInstance(0);
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("");
        const2.preserve(); const2.preserve();
        const3 = TclInteger.newInstance(1);
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("descend_report_command");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("descend_report_command_finish");
        const5.preserve(); const5.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "descend_next_key";
                break;
            }
            case 2: {
                cmdName = "descend_report_command";
                break;
            }
            case 3: {
                cmdName = "descend_report_command_finish";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "script",
        "range",
        "_descend",
        "key",
        "erange"
    };
} // end class DescendEmptyNestedCommandCmd

