// TJC implementation of procedure emitter_container_switch_invoke
package tjc;
import tcl.lang.*;

public class EmitterContainerSwitchInvokeCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 8, compiledLocalsNames);
        try {
        if (objv.length != 7) {
            throw new TclNumArgsException(interp, 1, objv, "tmpsymbol objv pbIndex size stringsymbol mode");
        }
        setVarScalar(interp, "tmpsymbol", objv[1], compiledLocals, 0);
        setVarScalar(interp, "objv", objv[2], compiledLocals, 1);
        setVarScalar(interp, "pbIndex", objv[3], compiledLocals, 2);
        setVarScalar(interp, "size", objv[4], compiledLocals, 3);
        setVarScalar(interp, "stringsymbol", objv[5], compiledLocals, 4);
        setVarScalar(interp, "mode", objv[6], compiledLocals, 5);
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const0, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: switch -exact -- $mode {default} - {exact} ... {glob} ... {regexp} ...
            TclObject tmp0 = getVarScalar(interp, "mode", compiledLocals, 5);
            String tmp1 = tmp0.toString();
            int tmp1_length = tmp1.length();
            char tmp1_first = '\n';
            if ( tmp1_length > 0 ) {
                tmp1_first = tmp1.charAt(0);
            }
            if ( ( tmp1_length == 7 && tmp1_first == 'd'
                    && tmp1.compareTo("default") == 0 ) ||
                ( tmp1_length == 5 && tmp1_first == 'e'
                    && tmp1.compareTo("exact") == 0 ) ) {
                // Pattern {exact}
                { // Invoke: set modestr ...
                    setVarScalar(interp, "modestr", const1, compiledLocals, 7);
                } // End Invoke: set
            } else if ( tmp1_length == 4 && tmp1_first == 'g'
                    && tmp1.compareTo("glob") == 0 ) {
                // Pattern {glob}
                { // Invoke: set modestr ...
                    setVarScalar(interp, "modestr", const2, compiledLocals, 7);
                } // End Invoke: set
            } else if ( tmp1_length == 6 && tmp1_first == 'r'
                    && tmp1.compareTo("regexp") == 0 ) {
                // Pattern {regexp}
                { // Invoke: set modestr ...
                    setVarScalar(interp, "modestr", const3, compiledLocals, 7);
                } // End Invoke: set
            }
        } // End Invoke: switch
        { // Invoke: append buffer [...] $tmpsymbol ... $objv ", " $pbIndex ...
            TclObject[] objv2 = TJC.grabObjv(interp, 7);
            TclObject tmp3;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv4 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv4[0] = const4;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv4, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv4, 1);
                    }
                } // End Invoke: emitter_indent
                tmp3 = interp.getResult();
                tmp3.preserve();
                objv2[0] = tmp3;
                // Arg 3 variable: $tmpsymbol
                tmp3 = getVarScalar(interp, "tmpsymbol", compiledLocals, 0);
                tmp3.preserve();
                objv2[1] = tmp3;
                // Arg 4 constant: ...
                objv2[2] = const5;
                // Arg 5 variable: $objv
                tmp3 = getVarScalar(interp, "objv", compiledLocals, 1);
                tmp3.preserve();
                objv2[3] = tmp3;
                // Arg 6 constant: ", "
                objv2[4] = const6;
                // Arg 7 variable: $pbIndex
                tmp3 = getVarScalar(interp, "pbIndex", compiledLocals, 2);
                tmp3.preserve();
                objv2[5] = tmp3;
                // Arg 8 constant: ...
                objv2[6] = const7;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv2, compiledLocals, 6);
            } finally {
                tmp3 = objv2[0];
                if ( tmp3 != null ) {
                    tmp3.release();
                }
                tmp3 = objv2[1];
                if ( tmp3 != null ) {
                    tmp3.release();
                }
                tmp3 = objv2[3];
                if ( tmp3 != null ) {
                    tmp3.release();
                }
                tmp3 = objv2[5];
                if ( tmp3 != null ) {
                    tmp3.release();
                }
                TJC.releaseObjv(interp, objv2, 7);
            }
        } // End Invoke: append
        { // Invoke: emitter_indent_level +1
            TclObject[] objv5 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv5[0] = const8;
                // Arg 1 constant: +1
                objv5[1] = const9;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                    ? cmdcache2.cmd : null), objv5, 0);
                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                    updateCmdCache(interp, 2);
                }
            } finally {
                TJC.releaseObjv(interp, objv5, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: append buffer [...] $stringsymbol ", " $modestr ...
            TclObject[] objv6 = TJC.grabObjv(interp, 5);
            TclObject tmp7;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv8 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv8[0] = const4;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv8, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv8, 1);
                    }
                } // End Invoke: emitter_indent
                tmp7 = interp.getResult();
                tmp7.preserve();
                objv6[0] = tmp7;
                // Arg 3 variable: $stringsymbol
                tmp7 = getVarScalar(interp, "stringsymbol", compiledLocals, 4);
                tmp7.preserve();
                objv6[1] = tmp7;
                // Arg 4 constant: ", "
                objv6[2] = const6;
                // Arg 5 variable: $modestr
                tmp7 = getVarScalar(interp, "modestr", compiledLocals, 7);
                tmp7.preserve();
                objv6[3] = tmp7;
                // Arg 6 constant: ...
                objv6[4] = const10;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv6, compiledLocals, 6);
            } finally {
                tmp7 = objv6[0];
                if ( tmp7 != null ) {
                    tmp7.release();
                }
                tmp7 = objv6[1];
                if ( tmp7 != null ) {
                    tmp7.release();
                }
                tmp7 = objv6[3];
                if ( tmp7 != null ) {
                    tmp7.release();
                }
                TJC.releaseObjv(interp, objv6, 5);
            }
        } // End Invoke: append
        { // Invoke: emitter_indent_level -1
            TclObject[] objv9 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv9[0] = const8;
                // Arg 1 constant: -1
                objv9[1] = const11;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                    ? cmdcache2.cmd : null), objv9, 0);
                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                    updateCmdCache(interp, 2);
                }
            } finally {
                TJC.releaseObjv(interp, objv9, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: append buffer [...] [...] ... $objv ", " $size ")" ... [...]
            TclObject[] objv10 = TJC.grabObjv(interp, 9);
            TclObject tmp11;
            try {
                // Arg 2 command: [...]
                { // Invoke: ...
                    TclObject[] objv12 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: ...
                        objv12[0] = const12;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv12, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv12, 1);
                    }
                } // End Invoke: ...
                tmp11 = interp.getResult();
                tmp11.preserve();
                objv10[0] = tmp11;
                // Arg 3 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv13 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv13[0] = const4;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv13, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv13, 1);
                    }
                } // End Invoke: emitter_indent
                tmp11 = interp.getResult();
                tmp11.preserve();
                objv10[1] = tmp11;
                // Arg 4 constant: ...
                objv10[2] = const13;
                // Arg 5 variable: $objv
                tmp11 = getVarScalar(interp, "objv", compiledLocals, 1);
                tmp11.preserve();
                objv10[3] = tmp11;
                // Arg 6 constant: ", "
                objv10[4] = const6;
                // Arg 7 variable: $size
                tmp11 = getVarScalar(interp, "size", compiledLocals, 3);
                tmp11.preserve();
                objv10[5] = tmp11;
                // Arg 8 constant: ")"
                objv10[6] = const14;
                // Arg 9 constant: ...
                objv10[7] = const15;
                // Arg 10 command: [...]
                { // Invoke: ...
                    TclObject[] objv14 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: ...
                        objv14[0] = const16;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                            ? cmdcache4.cmd : null), objv14, 0);
                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                            updateCmdCache(interp, 4);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv14, 1);
                    }
                } // End Invoke: ...
                tmp11 = interp.getResult();
                tmp11.preserve();
                objv10[8] = tmp11;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv10, compiledLocals, 6);
            } finally {
                objv10[2] = null;
                objv10[4] = null;
                objv10[6] = null;
                objv10[7] = null;
                TJC.releaseObjvElems(interp, objv10, 9);
            }
        } // End Invoke: append
        { // Invoke: return $buffer
            TclObject tmp15 = getVarScalar(interp, "buffer", compiledLocals, 6);
            interp.resetResult();
            interp.setResult(tmp15);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "emitter_container_switch_invoke");
        } finally {
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("TJC.SWITCH_MODE_EXACT");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("TJC.SWITCH_MODE_GLOB");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("TJC.SWITCH_MODE_REGEXP");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("emitter_indent");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance(" = TJC.invokeSwitch(interp, ");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance(", ");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance(",\n");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("emitter_indent_level");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("+1");
        TclInteger.get(interp, const9);
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance(");\n");
        const10.preserve(); const10.preserve();
        const11 = TclInteger.newInstance(-1);
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("emitter_container_try_finally");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("TJC.releaseObjvElems(interp, ");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance(")");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance(";\n");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance("emitter_container_try_end");
        const16.preserve(); const16.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "emitter_indent";
                break;
            }
            case 2: {
                cmdName = "emitter_indent_level";
                break;
            }
            case 3: {
                cmdName = "emitter_container_try_finally";
                break;
            }
            case 4: {
                cmdName = "emitter_container_try_end";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "tmpsymbol",
        "objv",
        "pbIndex",
        "size",
        "stringsymbol",
        "mode",
        "buffer",
        "modestr"
    };
} // end class EmitterContainerSwitchInvokeCmd

