// TJC implementation of procedure jdk_tool_javac_classfile
package tjc;
import tcl.lang.*;

public class JdkToolJavacClassfileCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 10, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "sourcefile");
        }
        setVarScalar(interp, "sourcefile", objv[1], compiledLocals, 0);
        { // Invoke: set names [...]
            TclObject tmp0;
            { // Invoke: file split $sourcefile
                TclObject[] objv1 = TJC.grabObjv(interp, 3);
                TclObject tmp2;
                try {
                    // Arg 0 constant: file
                    objv1[0] = const0;
                    // Arg 1 constant: split
                    objv1[1] = const1;
                    // Arg 2 variable: $sourcefile
                    tmp2 = getVarScalar(interp, "sourcefile", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[2] = tmp2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[2];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 3);
                }
            } // End Invoke: file
            tmp0 = interp.getResult();
            setVarScalar(interp, "names", tmp0, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: set ind [...]
            TclObject tmp3;
            { // Invoke: lsearch -exact $names [...]
                TclObject[] objv4 = TJC.grabObjv(interp, 4);
                TclObject tmp5;
                try {
                    // Arg 0 constant: lsearch
                    objv4[0] = const2;
                    // Arg 1 constant: -exact
                    objv4[1] = const3;
                    // Arg 2 variable: $names
                    tmp5 = getVarScalar(interp, "names", compiledLocals, 1);
                    tmp5.preserve();
                    objv4[2] = tmp5;
                    // Arg 3 command: [...]
                    { // Invoke: jdk_tjc_rootdir
                        TclObject[] objv6 = TJC.grabObjv(interp, 1);
                        try {
                            // Arg 0 constant: jdk_tjc_rootdir
                            objv6[0] = const4;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv6, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv6, 1);
                        }
                    } // End Invoke: jdk_tjc_rootdir
                    tmp5 = interp.getResult();
                    tmp5.preserve();
                    objv4[3] = tmp5;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                        ? cmdcache3.cmd : null), objv4, 0);
                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                        updateCmdCache(interp, 3);
                    }
                } finally {
                    tmp5 = objv4[2];
                    if ( tmp5 != null ) {
                        tmp5.release();
                    }
                    tmp5 = objv4[3];
                    if ( tmp5 != null ) {
                        tmp5.release();
                    }
                    TJC.releaseObjv(interp, objv4, 4);
                }
            } // End Invoke: lsearch
            tmp3 = interp.getResult();
            setVarScalar(interp, "ind", tmp3, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: if {$ind == -1} ...
            // Binary operator: $ind == ()
            TclObject tmp7 = getVarScalar(interp, "ind", compiledLocals, 2);
            ExprValue tmp8 = evs0;
            TJC.exprInitValue(interp, tmp8, tmp7);
            // Unary operator: - 1
            ExprValue tmp9 = evs1;
            tmp9.setIntValue(-1);
            // End Unary operator: -
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp8, tmp9);
            // End Binary operator: ==
            boolean tmp10 = ( tmp8.getIntValue() != 0 );
            if ( tmp10 ) {
                { // Invoke: error "..."
                    TclObject[] objv11 = TJC.grabObjv(interp, 2);
                    TclObject tmp12;
                    try {
                        // Arg 0 constant: error
                        objv11[0] = const5;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp13 = new StringBuffer(64);
                        sbtmp13.append("TJC dir not found in ");
                        sbtmp13.append("{");
                        tmp12 = getVarScalar(interp, "names", compiledLocals, 1);
                        sbtmp13.append(tmp12.toString());
                        sbtmp13.append("}");
                        tmp12 = TclString.newInstance(sbtmp13);
                        tmp12.preserve();
                        objv11[1] = tmp12;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                            ? cmdcache4.cmd : null), objv11, 0);
                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                            updateCmdCache(interp, 4);
                        }
                    } finally {
                        tmp12 = objv11[1];
                        if ( tmp12 != null ) {
                            tmp12.release();
                        }
                        TJC.releaseObjv(interp, objv11, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set src_names [...]
            TclObject tmp14;
            { // Invoke: lrange $names [...] end
                TclObject[] objv15 = TJC.grabObjv(interp, 4);
                TclObject tmp16;
                try {
                    // Arg 0 constant: lrange
                    objv15[0] = const6;
                    // Arg 1 variable: $names
                    tmp16 = getVarScalar(interp, "names", compiledLocals, 1);
                    tmp16.preserve();
                    objv15[1] = tmp16;
                    // Arg 2 command: [...]
                    { // Invoke: expr {$ind + 2}
                        // Binary operator: $ind + 2
                        TclObject tmp17 = getVarScalar(interp, "ind", compiledLocals, 2);
                        ExprValue tmp18 = evs0;
                        TJC.exprInitValue(interp, tmp18, tmp17);
                        ExprValue tmp19 = evs1;
                        tmp19.setIntValue(2);
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_PLUS, tmp18, tmp19);
                        // End Binary operator: +
                        TJC.exprSetResult(interp, tmp18);
                    } // End Invoke: expr
                    tmp16 = interp.getResult();
                    tmp16.preserve();
                    objv15[2] = tmp16;
                    // Arg 3 constant: end
                    objv15[3] = const7;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                        ? cmdcache5.cmd : null), objv15, 0);
                    if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                        updateCmdCache(interp, 5);
                    }
                } finally {
                    tmp16 = objv15[1];
                    if ( tmp16 != null ) {
                        tmp16.release();
                    }
                    tmp16 = objv15[2];
                    if ( tmp16 != null ) {
                        tmp16.release();
                    }
                    TJC.releaseObjv(interp, objv15, 4);
                }
            } // End Invoke: lrange
            tmp14 = interp.getResult();
            setVarScalar(interp, "src_names", tmp14, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set src_file [...]
            TclObject tmp20;
            { // Invoke: lindex $names end
                TclObject tmp21 = null;
                TclObject tmp22;
                try {
                    tmp21 = getVarScalar(interp, "names", compiledLocals, 1);
                    tmp21.preserve();
                    tmp22 = const7;
                    TJC.lindexNonconst(interp, tmp21, tmp22);
                } finally {
                    if ( tmp21 != null ) {
                        tmp21.release();
                    }
                }
            } // End Invoke: lindex
            tmp20 = interp.getResult();
            setVarScalar(interp, "src_file", tmp20, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set src_ext [...]
            TclObject tmp23;
            { // Invoke: file extension $src_file
                TclObject[] objv24 = TJC.grabObjv(interp, 3);
                TclObject tmp25;
                try {
                    // Arg 0 constant: file
                    objv24[0] = const0;
                    // Arg 1 constant: extension
                    objv24[1] = const8;
                    // Arg 2 variable: $src_file
                    tmp25 = getVarScalar(interp, "src_file", compiledLocals, 4);
                    tmp25.preserve();
                    objv24[2] = tmp25;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv24, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp25 = objv24[2];
                    if ( tmp25 != null ) {
                        tmp25.release();
                    }
                    TJC.releaseObjv(interp, objv24, 3);
                }
            } // End Invoke: file
            tmp23 = interp.getResult();
            setVarScalar(interp, "src_ext", tmp23, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: $src_ext != ".java"
            TclObject tmp26 = getVarScalar(interp, "src_ext", compiledLocals, 5);
            boolean tmp27 = ! tmp26.toString().equals(".java");
            ExprValue tmp28 = evs0;
            tmp28.setIntValue(tmp27);
            // End Binary operator: !=
            boolean tmp29 = ( tmp28.getIntValue() != 0 );
            if ( tmp29 ) {
                { // Invoke: error "..."
                    TclObject[] objv30 = TJC.grabObjv(interp, 2);
                    TclObject tmp31;
                    try {
                        // Arg 0 constant: error
                        objv30[0] = const5;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp32 = new StringBuffer(64);
                        sbtmp32.append("expected .java file, got ");
                        sbtmp32.append("\"");
                        tmp31 = getVarScalar(interp, "src_file", compiledLocals, 4);
                        sbtmp32.append(tmp31.toString());
                        sbtmp32.append("\"");
                        tmp31 = TclString.newInstance(sbtmp32);
                        tmp31.preserve();
                        objv30[1] = tmp31;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                            ? cmdcache4.cmd : null), objv30, 0);
                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                            updateCmdCache(interp, 4);
                        }
                    } finally {
                        tmp31 = objv30[1];
                        if ( tmp31 != null ) {
                            tmp31.release();
                        }
                        TJC.releaseObjv(interp, objv30, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: if ... ... else ...
            // Binary operator: () && ()
            // Binary operator: [...] == 2
            { // Invoke: llength $src_names
                TclObject tmp33 = getVarScalar(interp, "src_names", compiledLocals, 3);
                int tmp34 = TclList.getLength(interp, tmp33);
                interp.setResult(tmp34);
            } // End Invoke: llength
            TclObject tmp35 = interp.getResult();
            ExprValue tmp36 = evs0;
            TJC.exprInitValue(interp, tmp36, tmp35);
            ExprValue tmp37 = evs1;
            tmp37.setIntValue(2);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp36, tmp37);
            // End Binary operator: ==
            if (tmp36.getBooleanValue(interp)) {
            // Binary operator: [...] == "default"
            { // Invoke: lindex $src_names 0
                TclObject tmp38 = getVarScalar(interp, "src_names", compiledLocals, 3);
                tmp38 = TclList.index(interp, tmp38, 0);
                if ( tmp38 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp38);
                }
            } // End Invoke: lindex
            TclObject tmp39 = interp.getResult();
            boolean tmp40 = tmp39.toString().equals("default");
            ExprValue tmp41 = evs1;
            tmp41.setIntValue(tmp40);
            // End Binary operator: ==
            tmp36.setIntValue(tmp41.getBooleanValue(interp));
            } else {
            tmp36.setIntValue(0);
            } // End if: ()
            // End Binary operator: &&
            boolean tmp42 = ( tmp36.getIntValue() != 0 );
            if ( tmp42 ) {
                { // Invoke: set default 1
                    setVarScalar(interp, "default", const9, compiledLocals, 6);
                } // End Invoke: set
                { // Invoke: set src_name [...]
                    TclObject tmp43;
                    { // Invoke: lindex $src_names 1
                        TclObject tmp44 = getVarScalar(interp, "src_names", compiledLocals, 3);
                        tmp44 = TclList.index(interp, tmp44, 1);
                        if ( tmp44 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp44);
                        }
                    } // End Invoke: lindex
                    tmp43 = interp.getResult();
                    setVarScalar(interp, "src_name", tmp43, compiledLocals, 7);
                } // End Invoke: set
                { // Invoke: set class_name [...]
                    TclObject tmp45;
                    { // Invoke: string map {.java .class} $src_name
                        TclObject[] objv46 = TJC.grabObjv(interp, 4);
                        TclObject tmp47;
                        try {
                            // Arg 0 constant: string
                            objv46[0] = const10;
                            // Arg 1 constant: map
                            objv46[1] = const11;
                            // Arg 2 constant: {.java .class}
                            objv46[2] = const12;
                            // Arg 3 variable: $src_name
                            tmp47 = getVarScalar(interp, "src_name", compiledLocals, 7);
                            tmp47.preserve();
                            objv46[3] = tmp47;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                ? cmdcache6.cmd : null), objv46, 0);
                            if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                updateCmdCache(interp, 6);
                            }
                        } finally {
                            tmp47 = objv46[3];
                            if ( tmp47 != null ) {
                                tmp47.release();
                            }
                            TJC.releaseObjv(interp, objv46, 4);
                        }
                    } // End Invoke: string
                    tmp45 = interp.getResult();
                    setVarScalar(interp, "class_name", tmp45, compiledLocals, 8);
                } // End Invoke: set
                { // Invoke: set class_file $class_name
                    TclObject tmp48;
                    tmp48 = getVarScalar(interp, "class_name", compiledLocals, 8);
                    setVarScalar(interp, "class_file", tmp48, compiledLocals, 9);
                } // End Invoke: set
            } else {
                { // Invoke: set default 0
                    setVarScalar(interp, "default", const13, compiledLocals, 6);
                } // End Invoke: set
                { // Invoke: set src_name [...]
                    TclObject tmp49;
                    { // Invoke: lindex $names end
                        TclObject tmp50 = null;
                        TclObject tmp51;
                        try {
                            tmp50 = getVarScalar(interp, "names", compiledLocals, 1);
                            tmp50.preserve();
                            tmp51 = const7;
                            TJC.lindexNonconst(interp, tmp50, tmp51);
                        } finally {
                            if ( tmp50 != null ) {
                                tmp50.release();
                            }
                        }
                    } // End Invoke: lindex
                    tmp49 = interp.getResult();
                    setVarScalar(interp, "src_name", tmp49, compiledLocals, 7);
                } // End Invoke: set
                { // Invoke: set class_name [...]
                    TclObject tmp52;
                    { // Invoke: string map {.java .class} $src_name
                        TclObject[] objv53 = TJC.grabObjv(interp, 4);
                        TclObject tmp54;
                        try {
                            // Arg 0 constant: string
                            objv53[0] = const10;
                            // Arg 1 constant: map
                            objv53[1] = const11;
                            // Arg 2 constant: {.java .class}
                            objv53[2] = const12;
                            // Arg 3 variable: $src_name
                            tmp54 = getVarScalar(interp, "src_name", compiledLocals, 7);
                            tmp54.preserve();
                            objv53[3] = tmp54;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                ? cmdcache6.cmd : null), objv53, 0);
                            if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                updateCmdCache(interp, 6);
                            }
                        } finally {
                            tmp54 = objv53[3];
                            if ( tmp54 != null ) {
                                tmp54.release();
                            }
                            TJC.releaseObjv(interp, objv53, 4);
                        }
                    } // End Invoke: string
                    tmp52 = interp.getResult();
                    setVarScalar(interp, "class_name", tmp52, compiledLocals, 8);
                } // End Invoke: set
                { // Invoke: set class_file [...]
                    TclObject tmp55;
                    { // Invoke: eval file join [...] $class_name
                        TclObject[] objv56 = TJC.grabObjv(interp, 5);
                        TclObject tmp57;
                        try {
                            // Arg 0 constant: eval
                            objv56[0] = const14;
                            // Arg 1 constant: file
                            objv56[1] = const0;
                            // Arg 2 constant: join
                            objv56[2] = const15;
                            // Arg 3 command: [...]
                            { // Invoke: lrange $src_names 0 end-1
                                TclObject[] objv58 = TJC.grabObjv(interp, 4);
                                TclObject tmp59;
                                try {
                                    // Arg 0 constant: lrange
                                    objv58[0] = const6;
                                    // Arg 1 variable: $src_names
                                    tmp59 = getVarScalar(interp, "src_names", compiledLocals, 3);
                                    tmp59.preserve();
                                    objv58[1] = tmp59;
                                    // Arg 2 constant: 0
                                    objv58[2] = const13;
                                    // Arg 3 constant: end-1
                                    objv58[3] = const16;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                        ? cmdcache5.cmd : null), objv58, 0);
                                    if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                        updateCmdCache(interp, 5);
                                    }
                                } finally {
                                    tmp59 = objv58[1];
                                    if ( tmp59 != null ) {
                                        tmp59.release();
                                    }
                                    TJC.releaseObjv(interp, objv58, 4);
                                }
                            } // End Invoke: lrange
                            tmp57 = interp.getResult();
                            tmp57.preserve();
                            objv56[3] = tmp57;
                            // Arg 4 variable: $class_name
                            tmp57 = getVarScalar(interp, "class_name", compiledLocals, 8);
                            tmp57.preserve();
                            objv56[4] = tmp57;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                ? cmdcache7.cmd : null), objv56, 0);
                            if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                updateCmdCache(interp, 7);
                            }
                        } finally {
                            tmp57 = objv56[3];
                            if ( tmp57 != null ) {
                                tmp57.release();
                            }
                            tmp57 = objv56[4];
                            if ( tmp57 != null ) {
                                tmp57.release();
                            }
                            TJC.releaseObjv(interp, objv56, 5);
                        }
                    } // End Invoke: eval
                    tmp55 = interp.getResult();
                    setVarScalar(interp, "class_file", tmp55, compiledLocals, 9);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: return [...]
            { // Invoke: eval {file join} [...] {build $class_file}
                TclObject[] objv60 = TJC.grabObjv(interp, 4);
                TclObject tmp61;
                try {
                    // Arg 0 constant: eval
                    objv60[0] = const14;
                    // Arg 1 constant: {file join}
                    objv60[1] = const17;
                    // Arg 2 command: [...]
                    { // Invoke: lrange $names 0 $ind
                        TclObject[] objv62 = TJC.grabObjv(interp, 4);
                        TclObject tmp63;
                        try {
                            // Arg 0 constant: lrange
                            objv62[0] = const6;
                            // Arg 1 variable: $names
                            tmp63 = getVarScalar(interp, "names", compiledLocals, 1);
                            tmp63.preserve();
                            objv62[1] = tmp63;
                            // Arg 2 constant: 0
                            objv62[2] = const13;
                            // Arg 3 variable: $ind
                            tmp63 = getVarScalar(interp, "ind", compiledLocals, 2);
                            tmp63.preserve();
                            objv62[3] = tmp63;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                ? cmdcache5.cmd : null), objv62, 0);
                            if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                updateCmdCache(interp, 5);
                            }
                        } finally {
                            tmp63 = objv62[1];
                            if ( tmp63 != null ) {
                                tmp63.release();
                            }
                            tmp63 = objv62[3];
                            if ( tmp63 != null ) {
                                tmp63.release();
                            }
                            TJC.releaseObjv(interp, objv62, 4);
                        }
                    } // End Invoke: lrange
                    tmp61 = interp.getResult();
                    tmp61.preserve();
                    objv60[2] = tmp61;
                    // Arg 3 constant: {build $class_file}
                    objv60[3] = const18;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                        ? cmdcache7.cmd : null), objv60, 0);
                    if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                        updateCmdCache(interp, 7);
                    }
                } finally {
                    tmp61 = objv60[2];
                    if ( tmp61 != null ) {
                        tmp61.release();
                    }
                    TJC.releaseObjv(interp, objv60, 4);
                }
            } // End Invoke: eval
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "jdk_tool_javac_classfile");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;
    TclObject const18;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("file");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("split");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("lsearch");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("-exact");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("jdk_tjc_rootdir");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("error");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("lrange");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("end");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("extension");
        const8.preserve(); const8.preserve();
        const9 = TclInteger.newInstance(1);
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("string");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("map");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance(".java .class");
        const12.preserve(); const12.preserve();
        const13 = TclInteger.newInstance(0);
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("eval");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("join");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance("end-1");
        const16.preserve(); const16.preserve();
        const17 = TclString.newInstance("file join");
        const17.preserve(); const17.preserve();
        const18 = TclString.newInstance("build $class_file");
        const18.preserve(); const18.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "file";
                break;
            }
            case 2: {
                cmdName = "jdk_tjc_rootdir";
                break;
            }
            case 3: {
                cmdName = "lsearch";
                break;
            }
            case 4: {
                cmdName = "error";
                break;
            }
            case 5: {
                cmdName = "lrange";
                break;
            }
            case 6: {
                cmdName = "string";
                break;
            }
            case 7: {
                cmdName = "eval";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "sourcefile",
        "names",
        "ind",
        "src_names",
        "src_file",
        "src_ext",
        "default",
        "src_name",
        "class_name",
        "class_file"
    };
} // end class JdkToolJavacClassfileCmd

