// TJC implementation of procedure nameproc_full_class_name
package tjc;
import tcl.lang.*;

public class NameprocFullClassNameCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 2, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 3) {
            throw new TclNumArgsException(interp, 1, objv, "package class_name");
        }
        setVarScalar(interp, "package", objv[1], compiledLocals, 0);
        setVarScalar(interp, "class_name", objv[2], compiledLocals, 1);
        { // Invoke: if ... ... else ...
            // Binary operator: $package == "default"
            TclObject tmp0 = getVarScalar(interp, "package", compiledLocals, 0);
            boolean tmp1 = tmp0.toString().equals("default");
            ExprValue tmp2 = evs0;
            tmp2.setIntValue(tmp1);
            // End Binary operator: ==
            boolean tmp3 = ( tmp2.getIntValue() != 0 );
            if ( tmp3 ) {
                { // Invoke: return $class_name
                    TclObject tmp4 = getVarScalar(interp, "class_name", compiledLocals, 1);
                    interp.resetResult();
                    interp.setResult(tmp4);
                    if ( true ) { return; }
                } // End Invoke: return
            } else {
                { // Invoke: return "..."
                    TclObject tmp5;
                    StringBuffer sbtmp6 = new StringBuffer(64);
                    tmp5 = getVarScalar(interp, "package", compiledLocals, 0);
                    sbtmp6.append(tmp5.toString());
                    sbtmp6.append(".");
                    tmp5 = getVarScalar(interp, "class_name", compiledLocals, 1);
                    sbtmp6.append(tmp5.toString());
                    tmp5 = TclString.newInstance(sbtmp6);
                    interp.resetResult();
                    interp.setResult(tmp5);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "nameproc_full_class_name");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    String[] compiledLocalsNames = {
        "package",
        "class_name"
    };
} // end class NameprocFullClassNameCmd

