// TJC implementation of procedure _parse_expr_iterate_descend
package tjc;
import tcl.lang.*;

public class ParseExprIterateDescendCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 36, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        ExprValue evs2 = TJC.exprGetValue(interp);
        ExprValue evs3 = TJC.exprGetValue(interp);
        try {
        if (objv.length < 4 || objv.length > 5) {
            throw new TclNumArgsException(interp, 1, objv, "script etree cmd ?private?");
        }
        setVarScalar(interp, "script", objv[1], compiledLocals, 0);
        setVarScalar(interp, "etree", objv[2], compiledLocals, 1);
        setVarScalar(interp, "cmd", objv[3], compiledLocals, 2);
        setVarScalar(interp, "private", 
            ((objv.length <= 4) ? const0 : objv[4]), compiledLocals, 3);
        { // Invoke: global _parse
            TJC.makeGlobalLinkVar(interp, "_parse", "_parse", 4);
        } // End Invoke: global
        { // Invoke: set type [...]
            TclObject tmp0;
            { // Invoke: lindex $etree 0
                TclObject tmp1 = getVarScalar(interp, "etree", compiledLocals, 1);
                tmp1 = TclList.index(interp, tmp1, 0);
                if ( tmp1 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp1);
                }
            } // End Invoke: lindex
            tmp0 = interp.getResult();
            setVarScalar(interp, "type", tmp0, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: set range [...]
            TclObject tmp2;
            { // Invoke: lindex $etree 1
                TclObject tmp3 = getVarScalar(interp, "etree", compiledLocals, 1);
                tmp3 = TclList.index(interp, tmp3, 1);
                if ( tmp3 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp3);
                }
            } // End Invoke: lindex
            tmp2 = interp.getResult();
            setVarScalar(interp, "range", tmp2, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: set setree [...]
            TclObject tmp4;
            { // Invoke: lindex $etree 2
                TclObject tmp5 = getVarScalar(interp, "etree", compiledLocals, 1);
                tmp5 = TclList.index(interp, tmp5, 2);
                if ( tmp5 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp5);
                }
            } // End Invoke: lindex
            tmp4 = interp.getResult();
            setVarScalar(interp, "setree", tmp4, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: if {$type == "subexpr"} ...
            // Binary operator: $type == "subexpr"
            TclObject tmp6 = getVarScalar(interp, "type", compiledLocals, 5);
            boolean tmp7 = tmp6.toString().equals("subexpr");
            ExprValue tmp8 = evs0;
            tmp8.setIntValue(tmp7);
            // End Binary operator: ==
            boolean tmp9 = ( tmp8.getIntValue() != 0 );
            if ( tmp9 ) {
                { // Invoke: set no_arg_mfunc 0
                    setVarScalar(interp, "no_arg_mfunc", const1, compiledLocals, 8);
                } // End Invoke: set
                { // Invoke: if ... ...
                    // Binary operator: [...] == 1
                    { // Invoke: llength $setree
                        TclObject tmp10 = getVarScalar(interp, "setree", compiledLocals, 7);
                        int tmp11 = TclList.getLength(interp, tmp10);
                        interp.setResult(tmp11);
                    } // End Invoke: llength
                    TclObject tmp12 = interp.getResult();
                    ExprValue tmp13 = evs0;
                    TJC.exprInitValue(interp, tmp13, tmp12);
                    ExprValue tmp14 = evs1;
                    tmp14.setIntValue(1);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp13, tmp14);
                    // End Binary operator: ==
                    boolean tmp15 = ( tmp13.getIntValue() != 0 );
                    if ( tmp15 ) {
                        { // Invoke: set value [...]
                            TclObject tmp16;
                            { // Invoke: lindex $setree 0
                                TclObject tmp17 = getVarScalar(interp, "setree", compiledLocals, 7);
                                tmp17 = TclList.index(interp, tmp17, 0);
                                if ( tmp17 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp17);
                                }
                            } // End Invoke: lindex
                            tmp16 = interp.getResult();
                            setVarScalar(interp, "value", tmp16, compiledLocals, 9);
                        } // End Invoke: set
                        { // Invoke: if ... ...
                            // Binary operator: () && ()
                            // Binary operator: [...] == "operator"
                            { // Invoke: lindex $value 0
                                TclObject tmp18 = getVarScalar(interp, "value", compiledLocals, 9);
                                tmp18 = TclList.index(interp, tmp18, 0);
                                if ( tmp18 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp18);
                                }
                            } // End Invoke: lindex
                            TclObject tmp19 = interp.getResult();
                            boolean tmp20 = tmp19.toString().equals("operator");
                            ExprValue tmp21 = evs0;
                            tmp21.setIntValue(tmp20);
                            // End Binary operator: ==
                            if (tmp21.getBooleanValue(interp)) {
                            // Binary operator: [...] == ""
                            { // Invoke: lindex $value 2
                                TclObject tmp22 = getVarScalar(interp, "value", compiledLocals, 9);
                                tmp22 = TclList.index(interp, tmp22, 2);
                                if ( tmp22 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp22);
                                }
                            } // End Invoke: lindex
                            TclObject tmp23 = interp.getResult();
                            ExprValue tmp24 = evs1;
                            TJC.exprEqualsEmptyString(tmp24, tmp23, false);
                            // End Binary operator: ==
                            tmp21.setIntValue(tmp24.getBooleanValue(interp));
                            } else {
                            tmp21.setIntValue(0);
                            } // End if: ()
                            // End Binary operator: &&
                            boolean tmp25 = ( tmp21.getIntValue() != 0 );
                            if ( tmp25 ) {
                                { // Invoke: set no_arg_mfunc 1
                                    setVarScalar(interp, "no_arg_mfunc", const2, compiledLocals, 8);
                                } // End Invoke: set
                            }
                        } // End Invoke: if
                    }
                } // End Invoke: if
                { // Invoke: if ... ... else ...
                    // Binary operator: () || $no_arg_mfunc
                    // Binary operator: [...] >= 2
                    { // Invoke: llength $setree
                        TclObject tmp26 = getVarScalar(interp, "setree", compiledLocals, 7);
                        int tmp27 = TclList.getLength(interp, tmp26);
                        interp.setResult(tmp27);
                    } // End Invoke: llength
                    TclObject tmp28 = interp.getResult();
                    ExprValue tmp29 = evs0;
                    TJC.exprInitValue(interp, tmp29, tmp28);
                    ExprValue tmp30 = evs1;
                    tmp30.setIntValue(2);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GEQ, tmp29, tmp30);
                    // End Binary operator: >=
                    if (!tmp29.getBooleanValue(interp)) {
                    TclObject tmp31 = getVarScalar(interp, "no_arg_mfunc", compiledLocals, 8);
                    ExprValue tmp32 = evs1;
                    TJC.exprInitValue(interp, tmp32, tmp31);
                    tmp29.setIntValue(tmp32.getBooleanValue(interp));
                    } else {
                    tmp29.setIntValue(1);
                    } // End if: !()
                    // End Binary operator: ||
                    boolean tmp33 = ( tmp29.getIntValue() != 0 );
                    if ( tmp33 ) {
                        { // Invoke: set op [...]
                            TclObject tmp34;
                            { // Invoke: lindex $setree 0
                                TclObject tmp35 = getVarScalar(interp, "setree", compiledLocals, 7);
                                tmp35 = TclList.index(interp, tmp35, 0);
                                if ( tmp35 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp35);
                                }
                            } // End Invoke: lindex
                            tmp34 = interp.getResult();
                            setVarScalar(interp, "op", tmp34, compiledLocals, 10);
                        } // End Invoke: set
                        { // Invoke: set num_operands [...]
                            TclObject tmp36;
                            { // Invoke: expr ...
                                // Binary operator: [...] - 1
                                { // Invoke: llength $setree
                                    TclObject tmp37 = getVarScalar(interp, "setree", compiledLocals, 7);
                                    int tmp38 = TclList.getLength(interp, tmp37);
                                    interp.setResult(tmp38);
                                } // End Invoke: llength
                                TclObject tmp39 = interp.getResult();
                                ExprValue tmp40 = evs0;
                                TJC.exprInitValue(interp, tmp40, tmp39);
                                ExprValue tmp41 = evs1;
                                tmp41.setIntValue(1);
                                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MINUS, tmp40, tmp41);
                                // End Binary operator: -
                                TJC.exprSetResult(interp, tmp40);
                            } // End Invoke: expr
                            tmp36 = interp.getResult();
                            setVarScalar(interp, "num_operands", tmp36, compiledLocals, 11);
                        } // End Invoke: set
                        { // Invoke: if ... ...
                            // Binary operator: () && ()
                            // Unary operator: ! $no_arg_mfunc
                            TclObject tmp42 = getVarScalar(interp, "no_arg_mfunc", compiledLocals, 8);
                            ExprValue tmp43 = evs0;
                            if ( tmp42.isIntType() ) {
                                TJC.exprUnaryNotOperatorKnownInt(tmp43, tmp42);
                            } else {
                                TJC.exprUnaryNotOperator(interp, tmp43, tmp42);
                            }
                            // End Unary operator: !
                            if (tmp43.getBooleanValue(interp)) {
                            // Binary operator: () || ()
                            // Binary operator: $num_operands < 1
                            TclObject tmp44 = getVarScalar(interp, "num_operands", compiledLocals, 11);
                            ExprValue tmp45 = evs1;
                            TJC.exprInitValue(interp, tmp45, tmp44);
                            ExprValue tmp46 = evs2;
                            tmp46.setIntValue(1);
                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp45, tmp46);
                            // End Binary operator: <
                            if (!tmp45.getBooleanValue(interp)) {
                            // Binary operator: $num_operands > 3
                            TclObject tmp47 = getVarScalar(interp, "num_operands", compiledLocals, 11);
                            ExprValue tmp48 = evs2;
                            TJC.exprInitValue(interp, tmp48, tmp47);
                            ExprValue tmp49 = evs3;
                            tmp49.setIntValue(3);
                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GREATER, tmp48, tmp49);
                            // End Binary operator: >
                            tmp45.setIntValue(tmp48.getBooleanValue(interp));
                            } else {
                            tmp45.setIntValue(1);
                            } // End if: !()
                            // End Binary operator: ||
                            tmp43.setIntValue(tmp45.getBooleanValue(interp));
                            } else {
                            tmp43.setIntValue(0);
                            } // End if: ()
                            // End Binary operator: &&
                            boolean tmp50 = ( tmp43.getIntValue() != 0 );
                            if ( tmp50 ) {
                                { // Invoke: error "..."
                                    TclObject[] objv51 = TJC.grabObjv(interp, 2);
                                    TclObject tmp52;
                                    try {
                                        // Arg 0 constant: error
                                        objv51[0] = const3;
                                        // Arg 1 word: "..."
                                        StringBuffer sbtmp53 = new StringBuffer(64);
                                        sbtmp53.append("invalid num_operands ");
                                        tmp52 = getVarScalar(interp, "num_operands", compiledLocals, 11);
                                        sbtmp53.append(tmp52.toString());
                                        tmp52 = TclString.newInstance(sbtmp53);
                                        tmp52.preserve();
                                        objv51[1] = tmp52;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                            ? cmdcache1.cmd : null), objv51, 0);
                                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                            updateCmdCache(interp, 1);
                                        }
                                    } finally {
                                        tmp52 = objv51[1];
                                        if ( tmp52 != null ) {
                                            tmp52.release();
                                        }
                                        TJC.releaseObjv(interp, objv51, 2);
                                    }
                                } // End Invoke: error
                            }
                        } // End Invoke: if
                        { // Invoke: set operands [...]
                            TclObject tmp54;
                            { // Invoke: list
                                TclObject tmp55 = TclList.newInstance();
                                interp.setResult(tmp55);
                            } // End Invoke: list
                            tmp54 = interp.getResult();
                            setVarScalar(interp, "operands", tmp54, compiledLocals, 12);
                        } // End Invoke: set
                        { // Invoke: for {set i 1} ... {incr i} ...
                            { // Invoke: set i 1
                                setVarScalar(interp, "i", const2, compiledLocals, 13);
                            } // End Invoke: set
                            for ( boolean skip62 = true ; true ; ) {
                                if ( skip62 ) {
                                    skip62 = false;
                                } else {
                                    try {
                                    if ( false ) { throw (TclException) null; }
                                    { // Invoke: incr i
                                        interp.resetResult();
                                        incrVarScalar(interp, "i", 1, compiledLocals, 13);
                                    } // End Invoke: incr
                                    } catch (TclException ex) {
                                        int type = ex.getCompletionCode();
                                        if (type == TCL.BREAK) {
                                            break;
                                        } else {
                                            throw ex;
                                        }
                                    }
                                }

                                // Binary operator: $i < ()
                                TclObject tmp56 = getVarScalar(interp, "i", compiledLocals, 13);
                                ExprValue tmp57 = evs0;
                                TJC.exprInitValue(interp, tmp57, tmp56);
                                // Binary operator: $num_operands + 1
                                TclObject tmp58 = getVarScalar(interp, "num_operands", compiledLocals, 11);
                                ExprValue tmp59 = evs1;
                                TJC.exprInitValue(interp, tmp59, tmp58);
                                ExprValue tmp60 = evs2;
                                tmp60.setIntValue(1);
                                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_PLUS, tmp59, tmp60);
                                // End Binary operator: +
                                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp57, tmp59);
                                // End Binary operator: <
                                boolean tmp61 = ( tmp57.getIntValue() != 0 );
                                if ( ! tmp61 ) { break; }

                                try {
                                if ( false ) { throw (TclException) null; }
                                { // Invoke: lappend operands [...]
                                    TclObject[] objv63 = TJC.grabObjv(interp, 1);
                                    TclObject tmp64;
                                    try {
                                        // Arg 2 command: [...]
                                        { // Invoke: lindex $setree $i
                                            TclObject tmp65 = null;
                                            TclObject tmp66;
                                            try {
                                                tmp65 = getVarScalar(interp, "setree", compiledLocals, 7);
                                                tmp65.preserve();
                                                tmp66 = getVarScalar(interp, "i", compiledLocals, 13);
                                                TJC.lindexNonconst(interp, tmp65, tmp66);
                                            } finally {
                                                if ( tmp65 != null ) {
                                                    tmp65.release();
                                                }
                                            }
                                        } // End Invoke: lindex
                                        tmp64 = interp.getResult();
                                        tmp64.preserve();
                                        objv63[0] = tmp64;
                                        interp.resetResult();
                                        lappendVarScalar(interp, "operands", objv63, compiledLocals, 12);
                                    } finally {
                                        TJC.releaseObjvElems(interp, objv63, 1);
                                    }
                                } // End Invoke: lappend
                                } catch (TclException ex) {
                                    int type = ex.getCompletionCode();
                                    if (type == TCL.BREAK) {
                                        break;
                                    } else if (type == TCL.CONTINUE) {
                                        continue;
                                    } else {
                                        throw ex;
                                    }
                                }
                            }
                        } // End Invoke: for
                        { // Invoke: set expr_list [...]
                            TclObject tmp67;
                            { // Invoke: lindex $... 0
                                TclObject tmp68 = getVarArray(interp, "_parse", "parse_expr_iterate_stack", compiledLocals, 4);
                                tmp68 = TclList.index(interp, tmp68, 0);
                                if ( tmp68 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp68);
                                }
                            } // End Invoke: lindex
                            tmp67 = interp.getResult();
                            setVarScalar(interp, "expr_list", tmp67, compiledLocals, 14);
                        } // End Invoke: set
                        { // Invoke: lappend expr_list [...]
                            TclObject[] objv69 = TJC.grabObjv(interp, 1);
                            TclObject tmp70;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: list subexpr {}
                                    TclObject tmp71 = TclList.newInstance();
                                    try {
                                        TclList.append(interp, tmp71, const4);
                                        TclList.append(interp, tmp71, const0);
                                    } catch (TclException ex) {
                                        tmp71.release();
                                        throw ex;
                                    }
                                    interp.setResult(tmp71);
                                } // End Invoke: list
                                tmp70 = interp.getResult();
                                tmp70.preserve();
                                objv69[0] = tmp70;
                                interp.resetResult();
                                lappendVarScalar(interp, "expr_list", objv69, compiledLocals, 14);
                            } finally {
                                TJC.releaseObjvElems(interp, objv69, 1);
                            }
                        } // End Invoke: lappend
                        { // Invoke: set ... [...]
                            TclObject tmp72;
                            { // Invoke: lreplace $... 0 0 $expr_list
                                TclObject[] objv73 = TJC.grabObjv(interp, 5);
                                TclObject tmp74;
                                try {
                                    // Arg 0 constant: lreplace
                                    objv73[0] = const5;
                                    // Arg 1 variable: $...
                                    tmp74 = getVarArray(interp, "_parse", "parse_expr_iterate_stack", compiledLocals, 4);
                                    tmp74.preserve();
                                    objv73[1] = tmp74;
                                    // Arg 2 constant: 0
                                    objv73[2] = const1;
                                    // Arg 3 constant: 0
                                    objv73[3] = const1;
                                    // Arg 4 variable: $expr_list
                                    tmp74 = getVarScalar(interp, "expr_list", compiledLocals, 14);
                                    tmp74.preserve();
                                    objv73[4] = tmp74;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                        ? cmdcache2.cmd : null), objv73, 0);
                                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                        updateCmdCache(interp, 2);
                                    }
                                } finally {
                                    tmp74 = objv73[1];
                                    if ( tmp74 != null ) {
                                        tmp74.release();
                                    }
                                    tmp74 = objv73[4];
                                    if ( tmp74 != null ) {
                                        tmp74.release();
                                    }
                                    TJC.releaseObjv(interp, objv73, 5);
                                }
                            } // End Invoke: lreplace
                            tmp72 = interp.getResult();
                            setVarArray(interp, "_parse", "parse_expr_iterate_stack", tmp72, compiledLocals, 4);
                        } // End Invoke: set
                        { // Invoke: set ... [...]
                            TclObject tmp75;
                            { // Invoke: linsert $... 0 {}
                                TclObject[] objv76 = TJC.grabObjv(interp, 4);
                                TclObject tmp77;
                                try {
                                    // Arg 0 constant: linsert
                                    objv76[0] = const6;
                                    // Arg 1 variable: $...
                                    tmp77 = getVarArray(interp, "_parse", "parse_expr_iterate_stack", compiledLocals, 4);
                                    tmp77.preserve();
                                    objv76[1] = tmp77;
                                    // Arg 2 constant: 0
                                    objv76[2] = const1;
                                    // Arg 3 constant: {}
                                    objv76[3] = const0;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                        ? cmdcache3.cmd : null), objv76, 0);
                                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                        updateCmdCache(interp, 3);
                                    }
                                } finally {
                                    tmp77 = objv76[1];
                                    if ( tmp77 != null ) {
                                        tmp77.release();
                                    }
                                    TJC.releaseObjv(interp, objv76, 4);
                                }
                            } // End Invoke: linsert
                            tmp75 = interp.getResult();
                            setVarArray(interp, "_parse", "parse_expr_iterate_stack", tmp75, compiledLocals, 4);
                        } // End Invoke: set
                        { // Invoke: ... $script $op $cmd $num_operands
                            TclObject[] objv78 = TJC.grabObjv(interp, 5);
                            TclObject tmp79;
                            try {
                                // Arg 0 constant: ...
                                objv78[0] = const7;
                                // Arg 1 variable: $script
                                tmp79 = getVarScalar(interp, "script", compiledLocals, 0);
                                tmp79.preserve();
                                objv78[1] = tmp79;
                                // Arg 2 variable: $op
                                tmp79 = getVarScalar(interp, "op", compiledLocals, 10);
                                tmp79.preserve();
                                objv78[2] = tmp79;
                                // Arg 3 variable: $cmd
                                tmp79 = getVarScalar(interp, "cmd", compiledLocals, 2);
                                tmp79.preserve();
                                objv78[3] = tmp79;
                                // Arg 4 variable: $num_operands
                                tmp79 = getVarScalar(interp, "num_operands", compiledLocals, 11);
                                tmp79.preserve();
                                objv78[4] = tmp79;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                    ? cmdcache4.cmd : null), objv78, 0);
                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                    updateCmdCache(interp, 4);
                                }
                            } finally {
                                tmp79 = objv78[1];
                                if ( tmp79 != null ) {
                                    tmp79.release();
                                }
                                tmp79 = objv78[2];
                                if ( tmp79 != null ) {
                                    tmp79.release();
                                }
                                tmp79 = objv78[3];
                                if ( tmp79 != null ) {
                                    tmp79.release();
                                }
                                tmp79 = objv78[4];
                                if ( tmp79 != null ) {
                                    tmp79.release();
                                }
                                TJC.releaseObjv(interp, objv78, 5);
                            }
                        } // End Invoke: ...
                        { // Invoke: foreach operand $operands ...
                            TclObject tmp80 = null;
                            try {
                                tmp80 = getVarScalar(interp, "operands", compiledLocals, 12);
                                tmp80.preserve();
                                final int tmp80_length = TclList.getLength(interp, tmp80);

                                for ( int index81 = 0 ; index81 < tmp80_length ; index81++ ) {
                                    TclObject tmp82 = TclList.index(interp, tmp80, index81);
                                    try {
                                        setVarScalar(interp, "operand", tmp82, compiledLocals, 15);
                                    } catch (TclException ex) {
                                        TJC.foreachVarErr(interp, "operand");
                                    }

                                    try {
                                    if ( false ) { throw (TclException) null; }
                                    { // Invoke: ... $script $operand $cmd
                                        TclObject[] objv83 = TJC.grabObjv(interp, 4);
                                        TclObject tmp84;
                                        try {
                                            // Arg 0 constant: ...
                                            objv83[0] = const7;
                                            // Arg 1 variable: $script
                                            tmp84 = getVarScalar(interp, "script", compiledLocals, 0);
                                            tmp84.preserve();
                                            objv83[1] = tmp84;
                                            // Arg 2 variable: $operand
                                            tmp84 = getVarScalar(interp, "operand", compiledLocals, 15);
                                            tmp84.preserve();
                                            objv83[2] = tmp84;
                                            // Arg 3 variable: $cmd
                                            tmp84 = getVarScalar(interp, "cmd", compiledLocals, 2);
                                            tmp84.preserve();
                                            objv83[3] = tmp84;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                                ? cmdcache4.cmd : null), objv83, 0);
                                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                                updateCmdCache(interp, 4);
                                            }
                                        } finally {
                                            tmp84 = objv83[1];
                                            if ( tmp84 != null ) {
                                                tmp84.release();
                                            }
                                            tmp84 = objv83[2];
                                            if ( tmp84 != null ) {
                                                tmp84.release();
                                            }
                                            tmp84 = objv83[3];
                                            if ( tmp84 != null ) {
                                                tmp84.release();
                                            }
                                            TJC.releaseObjv(interp, objv83, 4);
                                        }
                                    } // End Invoke: ...
                                    } catch (TclException ex) {
                                        int type = ex.getCompletionCode();
                                        if (type == TCL.BREAK) {
                                            break;
                                        } else if (type == TCL.CONTINUE) {
                                            continue;
                                        } else {
                                            throw ex;
                                        }
                                    }
                                }
                            } finally {
                                if ( tmp80 != null ) {
                                    tmp80.release();
                                }
                            }
                        } // End Invoke: foreach
                        { // Invoke: set expr_list [...]
                            TclObject tmp85;
                            { // Invoke: lindex $... 0
                                TclObject tmp86 = getVarArray(interp, "_parse", "parse_expr_iterate_stack", compiledLocals, 4);
                                tmp86 = TclList.index(interp, tmp86, 0);
                                if ( tmp86 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp86);
                                }
                            } // End Invoke: lindex
                            tmp85 = interp.getResult();
                            setVarScalar(interp, "expr_list", tmp85, compiledLocals, 14);
                        } // End Invoke: set
                        { // Invoke: set ... [...]
                            TclObject tmp87;
                            { // Invoke: lreplace $... 0 0
                                TclObject[] objv88 = TJC.grabObjv(interp, 4);
                                TclObject tmp89;
                                try {
                                    // Arg 0 constant: lreplace
                                    objv88[0] = const5;
                                    // Arg 1 variable: $...
                                    tmp89 = getVarArray(interp, "_parse", "parse_expr_iterate_stack", compiledLocals, 4);
                                    tmp89.preserve();
                                    objv88[1] = tmp89;
                                    // Arg 2 constant: 0
                                    objv88[2] = const1;
                                    // Arg 3 constant: 0
                                    objv88[3] = const1;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                        ? cmdcache2.cmd : null), objv88, 0);
                                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                        updateCmdCache(interp, 2);
                                    }
                                } finally {
                                    tmp89 = objv88[1];
                                    if ( tmp89 != null ) {
                                        tmp89.release();
                                    }
                                    TJC.releaseObjv(interp, objv88, 4);
                                }
                            } // End Invoke: lreplace
                            tmp87 = interp.getResult();
                            setVarArray(interp, "_parse", "parse_expr_iterate_stack", tmp87, compiledLocals, 4);
                        } // End Invoke: set
                        { // Invoke: foreach elem $expr_list ...
                            TclObject tmp90 = null;
                            try {
                                tmp90 = getVarScalar(interp, "expr_list", compiledLocals, 14);
                                tmp90.preserve();
                                final int tmp90_length = TclList.getLength(interp, tmp90);

                                for ( int index91 = 0 ; index91 < tmp90_length ; index91++ ) {
                                    TclObject tmp92 = TclList.index(interp, tmp90, index91);
                                    try {
                                        setVarScalar(interp, "elem", tmp92, compiledLocals, 16);
                                    } catch (TclException ex) {
                                        TJC.foreachVarErr(interp, "elem");
                                    }

                                    try {
                                    if ( false ) { throw (TclException) null; }
                                    { // Invoke: lappend ... $elem
                                        TclObject[] objv93 = TJC.grabObjv(interp, 1);
                                        TclObject tmp94;
                                        try {
                                            // Arg 2 variable: $elem
                                            tmp94 = getVarScalar(interp, "elem", compiledLocals, 16);
                                            tmp94.preserve();
                                            objv93[0] = tmp94;
                                            interp.resetResult();
                                            lappendVarArray(interp, "_parse", "parse_expr_iterate_result", objv93, compiledLocals, 4);
                                        } finally {
                                            TJC.releaseObjvElems(interp, objv93, 1);
                                        }
                                    } // End Invoke: lappend
                                    } catch (TclException ex) {
                                        int type = ex.getCompletionCode();
                                        if (type == TCL.BREAK) {
                                            break;
                                        } else if (type == TCL.CONTINUE) {
                                            continue;
                                        } else {
                                            throw ex;
                                        }
                                    }
                                }
                            } finally {
                                if ( tmp90 != null ) {
                                    tmp90.release();
                                }
                            }
                        } // End Invoke: foreach
                    } else {
                        { // Invoke: set value [...]
                            TclObject tmp95;
                            { // Invoke: lindex $setree 0
                                TclObject tmp96 = getVarScalar(interp, "setree", compiledLocals, 7);
                                tmp96 = TclList.index(interp, tmp96, 0);
                                if ( tmp96 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp96);
                                }
                            } // End Invoke: lindex
                            tmp95 = interp.getResult();
                            setVarScalar(interp, "value", tmp95, compiledLocals, 9);
                        } // End Invoke: set
                        { // Invoke: ... $script $value $cmd 0
                            TclObject[] objv97 = TJC.grabObjv(interp, 5);
                            TclObject tmp98;
                            try {
                                // Arg 0 constant: ...
                                objv97[0] = const7;
                                // Arg 1 variable: $script
                                tmp98 = getVarScalar(interp, "script", compiledLocals, 0);
                                tmp98.preserve();
                                objv97[1] = tmp98;
                                // Arg 2 variable: $value
                                tmp98 = getVarScalar(interp, "value", compiledLocals, 9);
                                tmp98.preserve();
                                objv97[2] = tmp98;
                                // Arg 3 variable: $cmd
                                tmp98 = getVarScalar(interp, "cmd", compiledLocals, 2);
                                tmp98.preserve();
                                objv97[3] = tmp98;
                                // Arg 4 constant: 0
                                objv97[4] = const1;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                    ? cmdcache4.cmd : null), objv97, 0);
                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                    updateCmdCache(interp, 4);
                                }
                            } finally {
                                tmp98 = objv97[1];
                                if ( tmp98 != null ) {
                                    tmp98.release();
                                }
                                tmp98 = objv97[2];
                                if ( tmp98 != null ) {
                                    tmp98.release();
                                }
                                tmp98 = objv97[3];
                                if ( tmp98 != null ) {
                                    tmp98.release();
                                }
                                TJC.releaseObjv(interp, objv97, 5);
                            }
                        } // End Invoke: ...
                        { // Invoke: if ... ...
                            // Binary operator: [...] == 1
                            { // Invoke: llength $...
                                TclObject tmp99 = getVarArray(interp, "_parse", "parse_expr_iterate_stack", compiledLocals, 4);
                                int tmp100 = TclList.getLength(interp, tmp99);
                                interp.setResult(tmp100);
                            } // End Invoke: llength
                            TclObject tmp101 = interp.getResult();
                            ExprValue tmp102 = evs0;
                            TJC.exprInitValue(interp, tmp102, tmp101);
                            ExprValue tmp103 = evs1;
                            tmp103.setIntValue(1);
                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp102, tmp103);
                            // End Binary operator: ==
                            boolean tmp104 = ( tmp102.getIntValue() != 0 );
                            if ( tmp104 ) {
                                { // Invoke: set expr_list [...]
                                    TclObject tmp105;
                                    { // Invoke: lindex $... 0
                                        TclObject tmp106 = getVarArray(interp, "_parse", "parse_expr_iterate_stack", compiledLocals, 4);
                                        tmp106 = TclList.index(interp, tmp106, 0);
                                        if ( tmp106 == null ) {
                                            interp.resetResult();
                                        } else {
                                            interp.setResult(tmp106);
                                        }
                                    } // End Invoke: lindex
                                    tmp105 = interp.getResult();
                                    setVarScalar(interp, "expr_list", tmp105, compiledLocals, 14);
                                } // End Invoke: set
                                { // Invoke: foreach elem $expr_list ...
                                    TclObject tmp107 = null;
                                    try {
                                        tmp107 = getVarScalar(interp, "expr_list", compiledLocals, 14);
                                        tmp107.preserve();
                                        final int tmp107_length = TclList.getLength(interp, tmp107);

                                        for ( int index108 = 0 ; index108 < tmp107_length ; index108++ ) {
                                            TclObject tmp109 = TclList.index(interp, tmp107, index108);
                                            try {
                                                setVarScalar(interp, "elem", tmp109, compiledLocals, 16);
                                            } catch (TclException ex) {
                                                TJC.foreachVarErr(interp, "elem");
                                            }

                                            try {
                                            if ( false ) { throw (TclException) null; }
                                            { // Invoke: lappend ... $elem
                                                TclObject[] objv110 = TJC.grabObjv(interp, 1);
                                                TclObject tmp111;
                                                try {
                                                    // Arg 2 variable: $elem
                                                    tmp111 = getVarScalar(interp, "elem", compiledLocals, 16);
                                                    tmp111.preserve();
                                                    objv110[0] = tmp111;
                                                    interp.resetResult();
                                                    lappendVarArray(interp, "_parse", "parse_expr_iterate_result", objv110, compiledLocals, 4);
                                                } finally {
                                                    TJC.releaseObjvElems(interp, objv110, 1);
                                                }
                                            } // End Invoke: lappend
                                            } catch (TclException ex) {
                                                int type = ex.getCompletionCode();
                                                if (type == TCL.BREAK) {
                                                    break;
                                                } else if (type == TCL.CONTINUE) {
                                                    continue;
                                                } else {
                                                    throw ex;
                                                }
                                            }
                                        }
                                    } finally {
                                        if ( tmp107 != null ) {
                                            tmp107.release();
                                        }
                                    }
                                } // End Invoke: foreach
                            }
                        } // End Invoke: if
                    }
                } // End Invoke: if
                { // Invoke: return
                    interp.resetResult();
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: switch -exact -- $type {command} {} {operator} {} {text} {} {variable} {} {word} {} {backslash} ... default ...
            TclObject tmp112 = getVarScalar(interp, "type", compiledLocals, 5);
            String tmp113 = tmp112.toString();
            int tmp113_length = tmp113.length();
            char tmp113_first = '\n';
            if ( tmp113_length > 0 ) {
                tmp113_first = tmp113.charAt(0);
            }
            if ( tmp113_length == 7 && tmp113_first == 'c'
                    && tmp113.compareTo("command") == 0 ) {
                // Pattern {command}
            } else if ( tmp113_length == 8 && tmp113_first == 'o'
                    && tmp113.compareTo("operator") == 0 ) {
                // Pattern {operator}
            } else if ( tmp113_length == 4 && tmp113_first == 't'
                    && tmp113.compareTo("text") == 0 ) {
                // Pattern {text}
            } else if ( tmp113_length == 8 && tmp113_first == 'v'
                    && tmp113.compareTo("variable") == 0 ) {
                // Pattern {variable}
            } else if ( tmp113_length == 4 && tmp113_first == 'w'
                    && tmp113.compareTo("word") == 0 ) {
                // Pattern {word}
            } else if ( tmp113_length == 9 && tmp113_first == 'b'
                    && tmp113.compareTo("backslash") == 0 ) {
                // Pattern {backslash}
                { // Invoke: set range_before [...]
                    TclObject tmp114;
                    { // Invoke: expr ...
                        // Binary operator: [...] - 1
                        { // Invoke: lindex $range 0
                            TclObject tmp115 = getVarScalar(interp, "range", compiledLocals, 6);
                            tmp115 = TclList.index(interp, tmp115, 0);
                            if ( tmp115 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp115);
                            }
                        } // End Invoke: lindex
                        TclObject tmp116 = interp.getResult();
                        ExprValue tmp117 = evs0;
                        TJC.exprInitValue(interp, tmp117, tmp116);
                        ExprValue tmp118 = evs1;
                        tmp118.setIntValue(1);
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MINUS, tmp117, tmp118);
                        // End Binary operator: -
                        TJC.exprSetResult(interp, tmp117);
                    } // End Invoke: expr
                    tmp114 = interp.getResult();
                    setVarScalar(interp, "range_before", tmp114, compiledLocals, 17);
                } // End Invoke: set
                { // Invoke: set before [...]
                    TclObject tmp119;
                    { // Invoke: parse getstring $script [...]
                        TclObject[] objv120 = TJC.grabObjv(interp, 4);
                        TclObject tmp121;
                        try {
                            // Arg 0 constant: parse
                            objv120[0] = const8;
                            // Arg 1 constant: getstring
                            objv120[1] = const9;
                            // Arg 2 variable: $script
                            tmp121 = getVarScalar(interp, "script", compiledLocals, 0);
                            tmp121.preserve();
                            objv120[2] = tmp121;
                            // Arg 3 command: [...]
                            { // Invoke: list $range_before 1
                                TclObject tmp122 = TclList.newInstance();
                                TclObject tmp123;
                                try {
                                    tmp123 = getVarScalar(interp, "range_before", compiledLocals, 17);
                                    TclList.append(interp, tmp122, tmp123);
                                    TclList.append(interp, tmp122, const2);
                                } catch (TclException ex) {
                                    tmp122.release();
                                    throw ex;
                                }
                                interp.setResult(tmp122);
                            } // End Invoke: list
                            tmp121 = interp.getResult();
                            tmp121.preserve();
                            objv120[3] = tmp121;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                ? cmdcache5.cmd : null), objv120, 0);
                            if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                updateCmdCache(interp, 5);
                            }
                        } finally {
                            tmp121 = objv120[2];
                            if ( tmp121 != null ) {
                                tmp121.release();
                            }
                            tmp121 = objv120[3];
                            if ( tmp121 != null ) {
                                tmp121.release();
                            }
                            TJC.releaseObjv(interp, objv120, 4);
                        }
                    } // End Invoke: parse
                    tmp119 = interp.getResult();
                    setVarScalar(interp, "before", tmp119, compiledLocals, 18);
                } // End Invoke: set
                { // Invoke: if ... ...
                    // Binary operator: $before != "\""
                    TclObject tmp124 = getVarScalar(interp, "before", compiledLocals, 18);
                    boolean tmp125 = ! tmp124.toString().equals("\"");
                    ExprValue tmp126 = evs0;
                    tmp126.setIntValue(tmp125);
                    // End Binary operator: !=
                    boolean tmp127 = ( tmp126.getIntValue() != 0 );
                    if ( tmp127 ) {
                        { // Invoke: error "..."
                            TclObject[] objv128 = TJC.grabObjv(interp, 2);
                            TclObject tmp129;
                            try {
                                // Arg 0 constant: error
                                objv128[0] = const3;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp130 = new StringBuffer(64);
                                sbtmp130.append("expected double quote before backslash character, got '");
                                tmp129 = getVarScalar(interp, "before", compiledLocals, 18);
                                sbtmp130.append(tmp129.toString());
                                sbtmp130.append("'");
                                tmp129 = TclString.newInstance(sbtmp130);
                                tmp129.preserve();
                                objv128[1] = tmp129;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                    ? cmdcache1.cmd : null), objv128, 0);
                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                    updateCmdCache(interp, 1);
                                }
                            } finally {
                                tmp129 = objv128[1];
                                if ( tmp129 != null ) {
                                    tmp129.release();
                                }
                                TJC.releaseObjv(interp, objv128, 2);
                            }
                        } // End Invoke: error
                    }
                } // End Invoke: if
                { // Invoke: set range_after [...]
                    TclObject tmp131;
                    { // Invoke: expr ...
                        // Binary operator: [...] + [...]
                        { // Invoke: lindex $range 0
                            TclObject tmp132 = getVarScalar(interp, "range", compiledLocals, 6);
                            tmp132 = TclList.index(interp, tmp132, 0);
                            if ( tmp132 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp132);
                            }
                        } // End Invoke: lindex
                        TclObject tmp133 = interp.getResult();
                        ExprValue tmp134 = evs0;
                        TJC.exprInitValue(interp, tmp134, tmp133);
                        { // Invoke: lindex $range 1
                            TclObject tmp135 = getVarScalar(interp, "range", compiledLocals, 6);
                            tmp135 = TclList.index(interp, tmp135, 1);
                            if ( tmp135 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp135);
                            }
                        } // End Invoke: lindex
                        TclObject tmp136 = interp.getResult();
                        ExprValue tmp137 = evs1;
                        TJC.exprInitValue(interp, tmp137, tmp136);
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_PLUS, tmp134, tmp137);
                        // End Binary operator: +
                        TJC.exprSetResult(interp, tmp134);
                    } // End Invoke: expr
                    tmp131 = interp.getResult();
                    setVarScalar(interp, "range_after", tmp131, compiledLocals, 19);
                } // End Invoke: set
                { // Invoke: set after [...]
                    TclObject tmp138;
                    { // Invoke: parse getstring $script [...]
                        TclObject[] objv139 = TJC.grabObjv(interp, 4);
                        TclObject tmp140;
                        try {
                            // Arg 0 constant: parse
                            objv139[0] = const8;
                            // Arg 1 constant: getstring
                            objv139[1] = const9;
                            // Arg 2 variable: $script
                            tmp140 = getVarScalar(interp, "script", compiledLocals, 0);
                            tmp140.preserve();
                            objv139[2] = tmp140;
                            // Arg 3 command: [...]
                            { // Invoke: list $range_after 1
                                TclObject tmp141 = TclList.newInstance();
                                TclObject tmp142;
                                try {
                                    tmp142 = getVarScalar(interp, "range_after", compiledLocals, 19);
                                    TclList.append(interp, tmp141, tmp142);
                                    TclList.append(interp, tmp141, const2);
                                } catch (TclException ex) {
                                    tmp141.release();
                                    throw ex;
                                }
                                interp.setResult(tmp141);
                            } // End Invoke: list
                            tmp140 = interp.getResult();
                            tmp140.preserve();
                            objv139[3] = tmp140;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                ? cmdcache5.cmd : null), objv139, 0);
                            if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                updateCmdCache(interp, 5);
                            }
                        } finally {
                            tmp140 = objv139[2];
                            if ( tmp140 != null ) {
                                tmp140.release();
                            }
                            tmp140 = objv139[3];
                            if ( tmp140 != null ) {
                                tmp140.release();
                            }
                            TJC.releaseObjv(interp, objv139, 4);
                        }
                    } // End Invoke: parse
                    tmp138 = interp.getResult();
                    setVarScalar(interp, "after", tmp138, compiledLocals, 20);
                } // End Invoke: set
                { // Invoke: if ... ...
                    // Binary operator: $after != "\""
                    TclObject tmp143 = getVarScalar(interp, "after", compiledLocals, 20);
                    boolean tmp144 = ! tmp143.toString().equals("\"");
                    ExprValue tmp145 = evs0;
                    tmp145.setIntValue(tmp144);
                    // End Binary operator: !=
                    boolean tmp146 = ( tmp145.getIntValue() != 0 );
                    if ( tmp146 ) {
                        { // Invoke: error "..."
                            TclObject[] objv147 = TJC.grabObjv(interp, 2);
                            TclObject tmp148;
                            try {
                                // Arg 0 constant: error
                                objv147[0] = const3;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp149 = new StringBuffer(64);
                                sbtmp149.append("expected double quote after backslash character, got '");
                                tmp148 = getVarScalar(interp, "after", compiledLocals, 20);
                                sbtmp149.append(tmp148.toString());
                                sbtmp149.append("'");
                                tmp148 = TclString.newInstance(sbtmp149);
                                tmp148.preserve();
                                objv147[1] = tmp148;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                    ? cmdcache1.cmd : null), objv147, 0);
                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                    updateCmdCache(interp, 1);
                                }
                            } finally {
                                tmp148 = objv147[1];
                                if ( tmp148 != null ) {
                                    tmp148.release();
                                }
                                TJC.releaseObjv(interp, objv147, 2);
                            }
                        } // End Invoke: error
                    }
                } // End Invoke: if
                { // Invoke: set range_with_quotes [...]
                    TclObject tmp150;
                    { // Invoke: list $range_before [...]
                        TclObject tmp151 = TclList.newInstance();
                        TclObject tmp152;
                        try {
                            tmp152 = getVarScalar(interp, "range_before", compiledLocals, 17);
                            TclList.append(interp, tmp151, tmp152);
                            { // Invoke: expr ...
                                // Binary operator: [...] + 2
                                { // Invoke: lindex $range 1
                                    TclObject tmp153 = getVarScalar(interp, "range", compiledLocals, 6);
                                    tmp153 = TclList.index(interp, tmp153, 1);
                                    if ( tmp153 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp153);
                                    }
                                } // End Invoke: lindex
                                TclObject tmp154 = interp.getResult();
                                ExprValue tmp155 = evs0;
                                TJC.exprInitValue(interp, tmp155, tmp154);
                                ExprValue tmp156 = evs1;
                                tmp156.setIntValue(2);
                                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_PLUS, tmp155, tmp156);
                                // End Binary operator: +
                                TJC.exprSetResult(interp, tmp155);
                            } // End Invoke: expr
                            tmp152 = interp.getResult();
                            TclList.append(interp, tmp151, tmp152);
                        } catch (TclException ex) {
                            tmp151.release();
                            throw ex;
                        }
                        interp.setResult(tmp151);
                    } // End Invoke: list
                    tmp150 = interp.getResult();
                    setVarScalar(interp, "range_with_quotes", tmp150, compiledLocals, 21);
                } // End Invoke: set
                { // Invoke: set bstree [...]
                    TclObject tmp157;
                    { // Invoke: list "backslash" $range {}
                        TclObject tmp158 = TclList.newInstance();
                        TclObject tmp159;
                        try {
                            TclList.append(interp, tmp158, const10);
                            tmp159 = getVarScalar(interp, "range", compiledLocals, 6);
                            TclList.append(interp, tmp158, tmp159);
                            TclList.append(interp, tmp158, const0);
                        } catch (TclException ex) {
                            tmp158.release();
                            throw ex;
                        }
                        interp.setResult(tmp158);
                    } // End Invoke: list
                    tmp157 = interp.getResult();
                    setVarScalar(interp, "bstree", tmp157, compiledLocals, 22);
                } // End Invoke: set
                { // Invoke: set type {word}
                    setVarScalar(interp, "type", const11, compiledLocals, 5);
                } // End Invoke: set
                { // Invoke: set setree [...]
                    TclObject tmp160;
                    { // Invoke: list $bstree
                        TclObject tmp161 = TclList.newInstance();
                        TclObject tmp162;
                        tmp162 = getVarScalar(interp, "bstree", compiledLocals, 22);
                        TclList.append(interp, tmp161, tmp162);
                        interp.setResult(tmp161);
                    } // End Invoke: list
                    tmp160 = interp.getResult();
                    setVarScalar(interp, "setree", tmp160, compiledLocals, 7);
                } // End Invoke: set
                { // Invoke: set range $range_with_quotes
                    TclObject tmp163;
                    tmp163 = getVarScalar(interp, "range_with_quotes", compiledLocals, 21);
                    setVarScalar(interp, "range", tmp163, compiledLocals, 6);
                } // End Invoke: set
                { // Invoke: set etree [...]
                    TclObject tmp164;
                    { // Invoke: list $type $range_with_quotes $setree
                        TclObject tmp165 = TclList.newInstance();
                        TclObject tmp166;
                        try {
                            tmp166 = getVarScalar(interp, "type", compiledLocals, 5);
                            TclList.append(interp, tmp165, tmp166);
                            tmp166 = getVarScalar(interp, "range_with_quotes", compiledLocals, 21);
                            TclList.append(interp, tmp165, tmp166);
                            tmp166 = getVarScalar(interp, "setree", compiledLocals, 7);
                            TclList.append(interp, tmp165, tmp166);
                        } catch (TclException ex) {
                            tmp165.release();
                            throw ex;
                        }
                        interp.setResult(tmp165);
                    } // End Invoke: list
                    tmp164 = interp.getResult();
                    setVarScalar(interp, "etree", tmp164, compiledLocals, 1);
                } // End Invoke: set
            } else {
                // Pattern default
                { // Invoke: error "..."
                    TclObject[] objv167 = TJC.grabObjv(interp, 2);
                    TclObject tmp168;
                    try {
                        // Arg 0 constant: error
                        objv167[0] = const3;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp169 = new StringBuffer(64);
                        sbtmp169.append("Unknown expr type ");
                        sbtmp169.append("\"");
                        tmp168 = getVarScalar(interp, "type", compiledLocals, 5);
                        sbtmp169.append(tmp168.toString());
                        sbtmp169.append("\"");
                        tmp168 = TclString.newInstance(sbtmp169);
                        tmp168.preserve();
                        objv167[1] = tmp168;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv167, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp168 = objv167[1];
                        if ( tmp168 != null ) {
                            tmp168.release();
                        }
                        TJC.releaseObjv(interp, objv167, 2);
                    }
                } // End Invoke: error
                { // Invoke: return
                    interp.resetResult();
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: switch
        { // Invoke: set type_str [...]
            TclObject tmp170;
            { // Invoke: parse getstring $script $range
                TclObject[] objv171 = TJC.grabObjv(interp, 4);
                TclObject tmp172;
                try {
                    // Arg 0 constant: parse
                    objv171[0] = const8;
                    // Arg 1 constant: getstring
                    objv171[1] = const9;
                    // Arg 2 variable: $script
                    tmp172 = getVarScalar(interp, "script", compiledLocals, 0);
                    tmp172.preserve();
                    objv171[2] = tmp172;
                    // Arg 3 variable: $range
                    tmp172 = getVarScalar(interp, "range", compiledLocals, 6);
                    tmp172.preserve();
                    objv171[3] = tmp172;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                        ? cmdcache5.cmd : null), objv171, 0);
                    if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                        updateCmdCache(interp, 5);
                    }
                } finally {
                    tmp172 = objv171[2];
                    if ( tmp172 != null ) {
                        tmp172.release();
                    }
                    tmp172 = objv171[3];
                    if ( tmp172 != null ) {
                        tmp172.release();
                    }
                    TJC.releaseObjv(interp, objv171, 4);
                }
            } // End Invoke: parse
            tmp170 = interp.getResult();
            setVarScalar(interp, "type_str", tmp170, compiledLocals, 23);
        } // End Invoke: set
        { // Invoke: set expr_list [...]
            TclObject tmp173;
            { // Invoke: lindex $... 0
                TclObject tmp174 = getVarArray(interp, "_parse", "parse_expr_iterate_stack", compiledLocals, 4);
                tmp174 = TclList.index(interp, tmp174, 0);
                if ( tmp174 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp174);
                }
            } // End Invoke: lindex
            tmp173 = interp.getResult();
            setVarScalar(interp, "expr_list", tmp173, compiledLocals, 14);
        } // End Invoke: set
        { // Invoke: switch -exact -- $type {command} ... {operator} ... {text} ... {variable} ... {word} ...
            TclObject tmp175 = getVarScalar(interp, "type", compiledLocals, 5);
            String tmp176 = tmp175.toString();
            int tmp176_length = tmp176.length();
            char tmp176_first = '\n';
            if ( tmp176_length > 0 ) {
                tmp176_first = tmp176.charAt(0);
            }
            if ( tmp176_length == 7 && tmp176_first == 'c'
                    && tmp176.compareTo("command") == 0 ) {
                // Pattern {command}
                { // Invoke: if {$setree != {}} ...
                    // Binary operator: $setree != ""
                    TclObject tmp177 = getVarScalar(interp, "setree", compiledLocals, 7);
                    ExprValue tmp178 = evs0;
                    TJC.exprEqualsEmptyString(tmp178, tmp177, true);
                    // End Binary operator: !=
                    boolean tmp179 = ( tmp178.getIntValue() != 0 );
                    if ( tmp179 ) {
                        { // Invoke: error "..."
                            TclObject[] objv180 = TJC.grabObjv(interp, 2);
                            TclObject tmp181;
                            try {
                                // Arg 0 constant: error
                                objv180[0] = const3;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp182 = new StringBuffer(64);
                                sbtmp182.append("expected empty subtree, got ");
                                sbtmp182.append("{");
                                tmp181 = getVarScalar(interp, "setree", compiledLocals, 7);
                                sbtmp182.append(tmp181.toString());
                                sbtmp182.append("}");
                                tmp181 = TclString.newInstance(sbtmp182);
                                tmp181.preserve();
                                objv180[1] = tmp181;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                    ? cmdcache1.cmd : null), objv180, 0);
                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                    updateCmdCache(interp, 1);
                                }
                            } finally {
                                tmp181 = objv180[1];
                                if ( tmp181 != null ) {
                                    tmp181.release();
                                }
                                TJC.releaseObjv(interp, objv180, 2);
                            }
                        } // End Invoke: error
                    }
                } // End Invoke: if
                { // Invoke: set range [...]
                    TclObject tmp183;
                    { // Invoke: ... $script $range
                        TclObject[] objv184 = TJC.grabObjv(interp, 3);
                        TclObject tmp185;
                        try {
                            // Arg 0 constant: ...
                            objv184[0] = const12;
                            // Arg 1 variable: $script
                            tmp185 = getVarScalar(interp, "script", compiledLocals, 0);
                            tmp185.preserve();
                            objv184[1] = tmp185;
                            // Arg 2 variable: $range
                            tmp185 = getVarScalar(interp, "range", compiledLocals, 6);
                            tmp185.preserve();
                            objv184[2] = tmp185;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                ? cmdcache6.cmd : null), objv184, 0);
                            if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                updateCmdCache(interp, 6);
                            }
                        } finally {
                            tmp185 = objv184[1];
                            if ( tmp185 != null ) {
                                tmp185.release();
                            }
                            tmp185 = objv184[2];
                            if ( tmp185 != null ) {
                                tmp185.release();
                            }
                            TJC.releaseObjv(interp, objv184, 3);
                        }
                    } // End Invoke: ...
                    tmp183 = interp.getResult();
                    setVarScalar(interp, "range", tmp183, compiledLocals, 6);
                } // End Invoke: set
                { // Invoke: set type_str [...]
                    TclObject tmp186;
                    { // Invoke: parse getstring $script $range
                        TclObject[] objv187 = TJC.grabObjv(interp, 4);
                        TclObject tmp188;
                        try {
                            // Arg 0 constant: parse
                            objv187[0] = const8;
                            // Arg 1 constant: getstring
                            objv187[1] = const9;
                            // Arg 2 variable: $script
                            tmp188 = getVarScalar(interp, "script", compiledLocals, 0);
                            tmp188.preserve();
                            objv187[2] = tmp188;
                            // Arg 3 variable: $range
                            tmp188 = getVarScalar(interp, "range", compiledLocals, 6);
                            tmp188.preserve();
                            objv187[3] = tmp188;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                ? cmdcache5.cmd : null), objv187, 0);
                            if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                updateCmdCache(interp, 5);
                            }
                        } finally {
                            tmp188 = objv187[2];
                            if ( tmp188 != null ) {
                                tmp188.release();
                            }
                            tmp188 = objv187[3];
                            if ( tmp188 != null ) {
                                tmp188.release();
                            }
                            TJC.releaseObjv(interp, objv187, 4);
                        }
                    } // End Invoke: parse
                    tmp186 = interp.getResult();
                    setVarScalar(interp, "type_str", tmp186, compiledLocals, 23);
                } // End Invoke: set
                { // Invoke: set atype {command operand}
                    setVarScalar(interp, "atype", const13, compiledLocals, 24);
                } // End Invoke: set
                { // Invoke: set avalues [...]
                    TclObject tmp189;
                    { // Invoke: list $type_str
                        TclObject tmp190 = TclList.newInstance();
                        TclObject tmp191;
                        tmp191 = getVarScalar(interp, "type_str", compiledLocals, 23);
                        TclList.append(interp, tmp190, tmp191);
                        interp.setResult(tmp190);
                    } // End Invoke: list
                    tmp189 = interp.getResult();
                    setVarScalar(interp, "avalues", tmp189, compiledLocals, 25);
                } // End Invoke: set
                { // Invoke: set aranges [...]
                    TclObject tmp192;
                    { // Invoke: list $range
                        TclObject tmp193 = TclList.newInstance();
                        TclObject tmp194;
                        tmp194 = getVarScalar(interp, "range", compiledLocals, 6);
                        TclList.append(interp, tmp193, tmp194);
                        interp.setResult(tmp193);
                    } // End Invoke: list
                    tmp192 = interp.getResult();
                    setVarScalar(interp, "aranges", tmp192, compiledLocals, 26);
                } // End Invoke: set
                { // Invoke: set cmdlist [...]
                    TclObject tmp195;
                    { // Invoke: list $cmd $script $etree $atype $avalues $aranges
                        TclObject tmp196 = TclList.newInstance();
                        TclObject tmp197;
                        try {
                            tmp197 = getVarScalar(interp, "cmd", compiledLocals, 2);
                            TclList.append(interp, tmp196, tmp197);
                            tmp197 = getVarScalar(interp, "script", compiledLocals, 0);
                            TclList.append(interp, tmp196, tmp197);
                            tmp197 = getVarScalar(interp, "etree", compiledLocals, 1);
                            TclList.append(interp, tmp196, tmp197);
                            tmp197 = getVarScalar(interp, "atype", compiledLocals, 24);
                            TclList.append(interp, tmp196, tmp197);
                            tmp197 = getVarScalar(interp, "avalues", compiledLocals, 25);
                            TclList.append(interp, tmp196, tmp197);
                            tmp197 = getVarScalar(interp, "aranges", compiledLocals, 26);
                            TclList.append(interp, tmp196, tmp197);
                        } catch (TclException ex) {
                            tmp196.release();
                            throw ex;
                        }
                        interp.setResult(tmp196);
                    } // End Invoke: list
                    tmp195 = interp.getResult();
                    setVarScalar(interp, "cmdlist", tmp195, compiledLocals, 27);
                } // End Invoke: set
                { // Invoke: lappend expr_list [...]
                    TclObject[] objv198 = TJC.grabObjv(interp, 1);
                    TclObject tmp199;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: list value $cmdlist
                            TclObject tmp200 = TclList.newInstance();
                            TclObject tmp201;
                            try {
                                TclList.append(interp, tmp200, const14);
                                tmp201 = getVarScalar(interp, "cmdlist", compiledLocals, 27);
                                TclList.append(interp, tmp200, tmp201);
                            } catch (TclException ex) {
                                tmp200.release();
                                throw ex;
                            }
                            interp.setResult(tmp200);
                        } // End Invoke: list
                        tmp199 = interp.getResult();
                        tmp199.preserve();
                        objv198[0] = tmp199;
                        interp.resetResult();
                        lappendVarScalar(interp, "expr_list", objv198, compiledLocals, 14);
                    } finally {
                        TJC.releaseObjvElems(interp, objv198, 1);
                    }
                } // End Invoke: lappend
            } else if ( tmp176_length == 8 && tmp176_first == 'o'
                    && tmp176.compareTo("operator") == 0 ) {
                // Pattern {operator}
                { // Invoke: if {$setree != {}} ...
                    // Binary operator: $setree != ""
                    TclObject tmp202 = getVarScalar(interp, "setree", compiledLocals, 7);
                    ExprValue tmp203 = evs0;
                    TJC.exprEqualsEmptyString(tmp203, tmp202, true);
                    // End Binary operator: !=
                    boolean tmp204 = ( tmp203.getIntValue() != 0 );
                    if ( tmp204 ) {
                        { // Invoke: error "..."
                            TclObject[] objv205 = TJC.grabObjv(interp, 2);
                            TclObject tmp206;
                            try {
                                // Arg 0 constant: error
                                objv205[0] = const3;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp207 = new StringBuffer(64);
                                sbtmp207.append("expected empty subtree, got ");
                                sbtmp207.append("{");
                                tmp206 = getVarScalar(interp, "setree", compiledLocals, 7);
                                sbtmp207.append(tmp206.toString());
                                sbtmp207.append("}");
                                tmp206 = TclString.newInstance(sbtmp207);
                                tmp206.preserve();
                                objv205[1] = tmp206;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                    ? cmdcache1.cmd : null), objv205, 0);
                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                    updateCmdCache(interp, 1);
                                }
                            } finally {
                                tmp206 = objv205[1];
                                if ( tmp206 != null ) {
                                    tmp206.release();
                                }
                                TJC.releaseObjv(interp, objv205, 2);
                            }
                        } // End Invoke: error
                    }
                } // End Invoke: if
                { // Invoke: set num_operands $private
                    TclObject tmp208;
                    tmp208 = getVarScalar(interp, "private", compiledLocals, 3);
                    setVarScalar(interp, "num_operands", tmp208, compiledLocals, 11);
                } // End Invoke: set
                { // Invoke: lappend expr_list [...]
                    TclObject[] objv209 = TJC.grabObjv(interp, 1);
                    TclObject tmp210;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: list operator $script $etree $num_operands $type_str [...]
                            TclObject tmp211 = TclList.newInstance();
                            TclObject tmp212;
                            try {
                                TclList.append(interp, tmp211, const15);
                                tmp212 = getVarScalar(interp, "script", compiledLocals, 0);
                                TclList.append(interp, tmp211, tmp212);
                                tmp212 = getVarScalar(interp, "etree", compiledLocals, 1);
                                TclList.append(interp, tmp211, tmp212);
                                tmp212 = getVarScalar(interp, "num_operands", compiledLocals, 11);
                                TclList.append(interp, tmp211, tmp212);
                                tmp212 = getVarScalar(interp, "type_str", compiledLocals, 23);
                                TclList.append(interp, tmp211, tmp212);
                                { // Invoke: list $range
                                    TclObject tmp213 = TclList.newInstance();
                                    TclObject tmp214;
                                    tmp214 = getVarScalar(interp, "range", compiledLocals, 6);
                                    TclList.append(interp, tmp213, tmp214);
                                    interp.setResult(tmp213);
                                } // End Invoke: list
                                tmp212 = interp.getResult();
                                TclList.append(interp, tmp211, tmp212);
                            } catch (TclException ex) {
                                tmp211.release();
                                throw ex;
                            }
                            interp.setResult(tmp211);
                        } // End Invoke: list
                        tmp210 = interp.getResult();
                        tmp210.preserve();
                        objv209[0] = tmp210;
                        interp.resetResult();
                        lappendVarScalar(interp, "expr_list", objv209, compiledLocals, 14);
                    } finally {
                        TJC.releaseObjvElems(interp, objv209, 1);
                    }
                } // End Invoke: lappend
            } else if ( tmp176_length == 4 && tmp176_first == 't'
                    && tmp176.compareTo("text") == 0 ) {
                // Pattern {text}
                { // Invoke: if {$setree != {}} ...
                    // Binary operator: $setree != ""
                    TclObject tmp215 = getVarScalar(interp, "setree", compiledLocals, 7);
                    ExprValue tmp216 = evs0;
                    TJC.exprEqualsEmptyString(tmp216, tmp215, true);
                    // End Binary operator: !=
                    boolean tmp217 = ( tmp216.getIntValue() != 0 );
                    if ( tmp217 ) {
                        { // Invoke: error "..."
                            TclObject[] objv218 = TJC.grabObjv(interp, 2);
                            TclObject tmp219;
                            try {
                                // Arg 0 constant: error
                                objv218[0] = const3;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp220 = new StringBuffer(64);
                                sbtmp220.append("expected empty subtree, got ");
                                sbtmp220.append("{");
                                tmp219 = getVarScalar(interp, "setree", compiledLocals, 7);
                                sbtmp220.append(tmp219.toString());
                                sbtmp220.append("}");
                                tmp219 = TclString.newInstance(sbtmp220);
                                tmp219.preserve();
                                objv218[1] = tmp219;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                    ? cmdcache1.cmd : null), objv218, 0);
                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                    updateCmdCache(interp, 1);
                                }
                            } finally {
                                tmp219 = objv218[1];
                                if ( tmp219 != null ) {
                                    tmp219.release();
                                }
                                TJC.releaseObjv(interp, objv218, 2);
                            }
                        } // End Invoke: error
                    }
                } // End Invoke: if
                { // Invoke: set atype {literal operand}
                    setVarScalar(interp, "atype", const16, compiledLocals, 24);
                } // End Invoke: set
                { // Invoke: set range_start [...]
                    TclObject tmp221;
                    { // Invoke: lindex $range 0
                        TclObject tmp222 = getVarScalar(interp, "range", compiledLocals, 6);
                        tmp222 = TclList.index(interp, tmp222, 0);
                        if ( tmp222 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp222);
                        }
                    } // End Invoke: lindex
                    tmp221 = interp.getResult();
                    setVarScalar(interp, "range_start", tmp221, compiledLocals, 28);
                } // End Invoke: set
                { // Invoke: set range_length [...]
                    TclObject tmp223;
                    { // Invoke: lindex $range 1
                        TclObject tmp224 = getVarScalar(interp, "range", compiledLocals, 6);
                        tmp224 = TclList.index(interp, tmp224, 1);
                        if ( tmp224 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp224);
                        }
                    } // End Invoke: lindex
                    tmp223 = interp.getResult();
                    setVarScalar(interp, "range_length", tmp223, compiledLocals, 29);
                } // End Invoke: set
                { // Invoke: set ... [...]
                    TclObject tmp225;
                    { // Invoke: expr {$range_start - 1}
                        // Binary operator: $range_start - 1
                        TclObject tmp226 = getVarScalar(interp, "range_start", compiledLocals, 28);
                        ExprValue tmp227 = evs0;
                        TJC.exprInitValue(interp, tmp227, tmp226);
                        ExprValue tmp228 = evs1;
                        tmp228.setIntValue(1);
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MINUS, tmp227, tmp228);
                        // End Binary operator: -
                        TJC.exprSetResult(interp, tmp227);
                    } // End Invoke: expr
                    tmp225 = interp.getResult();
                    setVarScalar(interp, "char_before_range_index", tmp225, compiledLocals, 30);
                } // End Invoke: set
                { // Invoke: if ... ... else ...
                    // Binary operator: $char_before_range_index < 0
                    TclObject tmp229 = getVarScalar(interp, "char_before_range_index", compiledLocals, 30);
                    ExprValue tmp230 = evs0;
                    TJC.exprInitValue(interp, tmp230, tmp229);
                    ExprValue tmp231 = evs1;
                    tmp231.setIntValue(0);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp230, tmp231);
                    // End Binary operator: <
                    boolean tmp232 = ( tmp230.getIntValue() != 0 );
                    if ( tmp232 ) {
                        { // Invoke: set char_before ""
                            setVarScalar(interp, "char_before", const0, compiledLocals, 31);
                        } // End Invoke: set
                    } else {
                        { // Invoke: set char_before [...]
                            TclObject tmp233;
                            { // Invoke: parse getstring $script [...]
                                TclObject[] objv234 = TJC.grabObjv(interp, 4);
                                TclObject tmp235;
                                try {
                                    // Arg 0 constant: parse
                                    objv234[0] = const8;
                                    // Arg 1 constant: getstring
                                    objv234[1] = const9;
                                    // Arg 2 variable: $script
                                    tmp235 = getVarScalar(interp, "script", compiledLocals, 0);
                                    tmp235.preserve();
                                    objv234[2] = tmp235;
                                    // Arg 3 command: [...]
                                    { // Invoke: list $... 1
                                        TclObject tmp236 = TclList.newInstance();
                                        TclObject tmp237;
                                        try {
                                            tmp237 = getVarScalar(interp, "char_before_range_index", compiledLocals, 30);
                                            TclList.append(interp, tmp236, tmp237);
                                            TclList.append(interp, tmp236, const2);
                                        } catch (TclException ex) {
                                            tmp236.release();
                                            throw ex;
                                        }
                                        interp.setResult(tmp236);
                                    } // End Invoke: list
                                    tmp235 = interp.getResult();
                                    tmp235.preserve();
                                    objv234[3] = tmp235;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                        ? cmdcache5.cmd : null), objv234, 0);
                                    if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                        updateCmdCache(interp, 5);
                                    }
                                } finally {
                                    tmp235 = objv234[2];
                                    if ( tmp235 != null ) {
                                        tmp235.release();
                                    }
                                    tmp235 = objv234[3];
                                    if ( tmp235 != null ) {
                                        tmp235.release();
                                    }
                                    TJC.releaseObjv(interp, objv234, 4);
                                }
                            } // End Invoke: parse
                            tmp233 = interp.getResult();
                            setVarScalar(interp, "char_before", tmp233, compiledLocals, 31);
                        } // End Invoke: set
                    }
                } // End Invoke: if
                { // Invoke: set max_range [...]
                    TclObject tmp238;
                    { // Invoke: parse getrange $script
                        TclObject[] objv239 = TJC.grabObjv(interp, 3);
                        TclObject tmp240;
                        try {
                            // Arg 0 constant: parse
                            objv239[0] = const8;
                            // Arg 1 constant: getrange
                            objv239[1] = const17;
                            // Arg 2 variable: $script
                            tmp240 = getVarScalar(interp, "script", compiledLocals, 0);
                            tmp240.preserve();
                            objv239[2] = tmp240;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                ? cmdcache5.cmd : null), objv239, 0);
                            if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                updateCmdCache(interp, 5);
                            }
                        } finally {
                            tmp240 = objv239[2];
                            if ( tmp240 != null ) {
                                tmp240.release();
                            }
                            TJC.releaseObjv(interp, objv239, 3);
                        }
                    } // End Invoke: parse
                    tmp238 = interp.getResult();
                    setVarScalar(interp, "max_range", tmp238, compiledLocals, 32);
                } // End Invoke: set
                { // Invoke: set max_index [...]
                    TclObject tmp241;
                    { // Invoke: expr ...
                        // Binary operator: () - 1
                        // Binary operator: [...] + [...]
                        { // Invoke: lindex $max_range 0
                            TclObject tmp242 = getVarScalar(interp, "max_range", compiledLocals, 32);
                            tmp242 = TclList.index(interp, tmp242, 0);
                            if ( tmp242 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp242);
                            }
                        } // End Invoke: lindex
                        TclObject tmp243 = interp.getResult();
                        ExprValue tmp244 = evs0;
                        TJC.exprInitValue(interp, tmp244, tmp243);
                        { // Invoke: lindex $max_range 1
                            TclObject tmp245 = getVarScalar(interp, "max_range", compiledLocals, 32);
                            tmp245 = TclList.index(interp, tmp245, 1);
                            if ( tmp245 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp245);
                            }
                        } // End Invoke: lindex
                        TclObject tmp246 = interp.getResult();
                        ExprValue tmp247 = evs1;
                        TJC.exprInitValue(interp, tmp247, tmp246);
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_PLUS, tmp244, tmp247);
                        // End Binary operator: +
                        ExprValue tmp248 = evs1;
                        tmp248.setIntValue(1);
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MINUS, tmp244, tmp248);
                        // End Binary operator: -
                        TJC.exprSetResult(interp, tmp244);
                    } // End Invoke: expr
                    tmp241 = interp.getResult();
                    setVarScalar(interp, "max_index", tmp241, compiledLocals, 33);
                } // End Invoke: set
                { // Invoke: set ... [...]
                    TclObject tmp249;
                    { // Invoke: expr ...
                        // Binary operator: $range_start + $range_length
                        TclObject tmp250 = getVarScalar(interp, "range_start", compiledLocals, 28);
                        ExprValue tmp251 = evs0;
                        TJC.exprInitValue(interp, tmp251, tmp250);
                        TclObject tmp252 = getVarScalar(interp, "range_length", compiledLocals, 29);
                        ExprValue tmp253 = evs1;
                        TJC.exprInitValue(interp, tmp253, tmp252);
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_PLUS, tmp251, tmp253);
                        // End Binary operator: +
                        TJC.exprSetResult(interp, tmp251);
                    } // End Invoke: expr
                    tmp249 = interp.getResult();
                    setVarScalar(interp, "char_after_range_index", tmp249, compiledLocals, 34);
                } // End Invoke: set
                { // Invoke: if ... ... else ...
                    // Binary operator: $char_after_range_index > $max_index
                    TclObject tmp254 = getVarScalar(interp, "char_after_range_index", compiledLocals, 34);
                    ExprValue tmp255 = evs0;
                    TJC.exprInitValue(interp, tmp255, tmp254);
                    TclObject tmp256 = getVarScalar(interp, "max_index", compiledLocals, 33);
                    ExprValue tmp257 = evs1;
                    TJC.exprInitValue(interp, tmp257, tmp256);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GREATER, tmp255, tmp257);
                    // End Binary operator: >
                    boolean tmp258 = ( tmp255.getIntValue() != 0 );
                    if ( tmp258 ) {
                        { // Invoke: set char_after ""
                            setVarScalar(interp, "char_after", const0, compiledLocals, 35);
                        } // End Invoke: set
                    } else {
                        { // Invoke: set char_after [...]
                            TclObject tmp259;
                            { // Invoke: parse getstring $script [...]
                                TclObject[] objv260 = TJC.grabObjv(interp, 4);
                                TclObject tmp261;
                                try {
                                    // Arg 0 constant: parse
                                    objv260[0] = const8;
                                    // Arg 1 constant: getstring
                                    objv260[1] = const9;
                                    // Arg 2 variable: $script
                                    tmp261 = getVarScalar(interp, "script", compiledLocals, 0);
                                    tmp261.preserve();
                                    objv260[2] = tmp261;
                                    // Arg 3 command: [...]
                                    { // Invoke: list $... 1
                                        TclObject tmp262 = TclList.newInstance();
                                        TclObject tmp263;
                                        try {
                                            tmp263 = getVarScalar(interp, "char_after_range_index", compiledLocals, 34);
                                            TclList.append(interp, tmp262, tmp263);
                                            TclList.append(interp, tmp262, const2);
                                        } catch (TclException ex) {
                                            tmp262.release();
                                            throw ex;
                                        }
                                        interp.setResult(tmp262);
                                    } // End Invoke: list
                                    tmp261 = interp.getResult();
                                    tmp261.preserve();
                                    objv260[3] = tmp261;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                        ? cmdcache5.cmd : null), objv260, 0);
                                    if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                        updateCmdCache(interp, 5);
                                    }
                                } finally {
                                    tmp261 = objv260[2];
                                    if ( tmp261 != null ) {
                                        tmp261.release();
                                    }
                                    tmp261 = objv260[3];
                                    if ( tmp261 != null ) {
                                        tmp261.release();
                                    }
                                    TJC.releaseObjv(interp, objv260, 4);
                                }
                            } // End Invoke: parse
                            tmp259 = interp.getResult();
                            setVarScalar(interp, "char_after", tmp259, compiledLocals, 35);
                        } // End Invoke: set
                    }
                } // End Invoke: if
                { // Invoke: if ... ... elseif ... ... else ...
                    // Binary operator: () && ()
                    // Binary operator: $char_before == "\""
                    TclObject tmp264 = getVarScalar(interp, "char_before", compiledLocals, 31);
                    boolean tmp265 = tmp264.toString().equals("\"");
                    ExprValue tmp266 = evs0;
                    tmp266.setIntValue(tmp265);
                    // End Binary operator: ==
                    if (tmp266.getBooleanValue(interp)) {
                    // Binary operator: $char_after == "\""
                    TclObject tmp267 = getVarScalar(interp, "char_after", compiledLocals, 35);
                    boolean tmp268 = tmp267.toString().equals("\"");
                    ExprValue tmp269 = evs1;
                    tmp269.setIntValue(tmp268);
                    // End Binary operator: ==
                    tmp266.setIntValue(tmp269.getBooleanValue(interp));
                    } else {
                    tmp266.setIntValue(0);
                    } // End if: ()
                    // End Binary operator: &&
                    boolean tmp270 = ( tmp266.getIntValue() != 0 );
                    if ( tmp270 ) {
                        { // Invoke: set avalues [...]
                            TclObject tmp271;
                            { // Invoke: list [...]
                                TclObject tmp272 = TclList.newInstance();
                                TclObject tmp273;
                                { // Invoke: list "string" $type_str
                                    TclObject tmp274 = TclList.newInstance();
                                    TclObject tmp275;
                                    try {
                                        TclList.append(interp, tmp274, const18);
                                        tmp275 = getVarScalar(interp, "type_str", compiledLocals, 23);
                                        TclList.append(interp, tmp274, tmp275);
                                    } catch (TclException ex) {
                                        tmp274.release();
                                        throw ex;
                                    }
                                    interp.setResult(tmp274);
                                } // End Invoke: list
                                tmp273 = interp.getResult();
                                TclList.append(interp, tmp272, tmp273);
                                interp.setResult(tmp272);
                            } // End Invoke: list
                            tmp271 = interp.getResult();
                            setVarScalar(interp, "avalues", tmp271, compiledLocals, 25);
                        } // End Invoke: set
                    } else {
                        // Binary operator: () && ()
                        // Binary operator: $char_before == "{"
                        TclObject tmp276 = getVarScalar(interp, "char_before", compiledLocals, 31);
                        boolean tmp277 = tmp276.toString().equals("{");
                        ExprValue tmp278 = evs0;
                        tmp278.setIntValue(tmp277);
                        // End Binary operator: ==
                        if (tmp278.getBooleanValue(interp)) {
                        // Binary operator: $char_after == "}"
                        TclObject tmp279 = getVarScalar(interp, "char_after", compiledLocals, 35);
                        boolean tmp280 = tmp279.toString().equals("}");
                        ExprValue tmp281 = evs1;
                        tmp281.setIntValue(tmp280);
                        // End Binary operator: ==
                        tmp278.setIntValue(tmp281.getBooleanValue(interp));
                        } else {
                        tmp278.setIntValue(0);
                        } // End if: ()
                        // End Binary operator: &&
                        boolean tmp282 = ( tmp278.getIntValue() != 0 );
                        if ( tmp282 ) {
                            { // Invoke: set avalues [...]
                                TclObject tmp283;
                                { // Invoke: list [...]
                                    TclObject tmp284 = TclList.newInstance();
                                    TclObject tmp285;
                                    { // Invoke: list "braced string" $type_str
                                        TclObject tmp286 = TclList.newInstance();
                                        TclObject tmp287;
                                        try {
                                            TclList.append(interp, tmp286, const19);
                                            tmp287 = getVarScalar(interp, "type_str", compiledLocals, 23);
                                            TclList.append(interp, tmp286, tmp287);
                                        } catch (TclException ex) {
                                            tmp286.release();
                                            throw ex;
                                        }
                                        interp.setResult(tmp286);
                                    } // End Invoke: list
                                    tmp285 = interp.getResult();
                                    TclList.append(interp, tmp284, tmp285);
                                    interp.setResult(tmp284);
                                } // End Invoke: list
                                tmp283 = interp.getResult();
                                setVarScalar(interp, "avalues", tmp283, compiledLocals, 25);
                            } // End Invoke: set
                        } else {
                            { // Invoke: set avalues [...]
                                TclObject tmp288;
                                { // Invoke: list [...]
                                    TclObject tmp289 = TclList.newInstance();
                                    TclObject tmp290;
                                    { // Invoke: list "text" $type_str
                                        TclObject tmp291 = TclList.newInstance();
                                        TclObject tmp292;
                                        try {
                                            TclList.append(interp, tmp291, const20);
                                            tmp292 = getVarScalar(interp, "type_str", compiledLocals, 23);
                                            TclList.append(interp, tmp291, tmp292);
                                        } catch (TclException ex) {
                                            tmp291.release();
                                            throw ex;
                                        }
                                        interp.setResult(tmp291);
                                    } // End Invoke: list
                                    tmp290 = interp.getResult();
                                    TclList.append(interp, tmp289, tmp290);
                                    interp.setResult(tmp289);
                                } // End Invoke: list
                                tmp288 = interp.getResult();
                                setVarScalar(interp, "avalues", tmp288, compiledLocals, 25);
                            } // End Invoke: set
                        }
                    }
                } // End Invoke: if
                { // Invoke: set aranges [...]
                    TclObject tmp293;
                    { // Invoke: list $range
                        TclObject tmp294 = TclList.newInstance();
                        TclObject tmp295;
                        tmp295 = getVarScalar(interp, "range", compiledLocals, 6);
                        TclList.append(interp, tmp294, tmp295);
                        interp.setResult(tmp294);
                    } // End Invoke: list
                    tmp293 = interp.getResult();
                    setVarScalar(interp, "aranges", tmp293, compiledLocals, 26);
                } // End Invoke: set
                { // Invoke: set cmdlist [...]
                    TclObject tmp296;
                    { // Invoke: list $cmd $script $etree $atype $avalues $aranges
                        TclObject tmp297 = TclList.newInstance();
                        TclObject tmp298;
                        try {
                            tmp298 = getVarScalar(interp, "cmd", compiledLocals, 2);
                            TclList.append(interp, tmp297, tmp298);
                            tmp298 = getVarScalar(interp, "script", compiledLocals, 0);
                            TclList.append(interp, tmp297, tmp298);
                            tmp298 = getVarScalar(interp, "etree", compiledLocals, 1);
                            TclList.append(interp, tmp297, tmp298);
                            tmp298 = getVarScalar(interp, "atype", compiledLocals, 24);
                            TclList.append(interp, tmp297, tmp298);
                            tmp298 = getVarScalar(interp, "avalues", compiledLocals, 25);
                            TclList.append(interp, tmp297, tmp298);
                            tmp298 = getVarScalar(interp, "aranges", compiledLocals, 26);
                            TclList.append(interp, tmp297, tmp298);
                        } catch (TclException ex) {
                            tmp297.release();
                            throw ex;
                        }
                        interp.setResult(tmp297);
                    } // End Invoke: list
                    tmp296 = interp.getResult();
                    setVarScalar(interp, "cmdlist", tmp296, compiledLocals, 27);
                } // End Invoke: set
                { // Invoke: lappend expr_list [...]
                    TclObject[] objv299 = TJC.grabObjv(interp, 1);
                    TclObject tmp300;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: list value $cmdlist
                            TclObject tmp301 = TclList.newInstance();
                            TclObject tmp302;
                            try {
                                TclList.append(interp, tmp301, const14);
                                tmp302 = getVarScalar(interp, "cmdlist", compiledLocals, 27);
                                TclList.append(interp, tmp301, tmp302);
                            } catch (TclException ex) {
                                tmp301.release();
                                throw ex;
                            }
                            interp.setResult(tmp301);
                        } // End Invoke: list
                        tmp300 = interp.getResult();
                        tmp300.preserve();
                        objv299[0] = tmp300;
                        interp.resetResult();
                        lappendVarScalar(interp, "expr_list", objv299, compiledLocals, 14);
                    } finally {
                        TJC.releaseObjvElems(interp, objv299, 1);
                    }
                } // End Invoke: lappend
            } else if ( tmp176_length == 8 && tmp176_first == 'v'
                    && tmp176.compareTo("variable") == 0 ) {
                // Pattern {variable}
                { // Invoke: set atype {variable operand}
                    setVarScalar(interp, "atype", const21, compiledLocals, 24);
                } // End Invoke: set
                { // Invoke: set avalues [...]
                    TclObject tmp303;
                    { // Invoke: list $type_str
                        TclObject tmp304 = TclList.newInstance();
                        TclObject tmp305;
                        tmp305 = getVarScalar(interp, "type_str", compiledLocals, 23);
                        TclList.append(interp, tmp304, tmp305);
                        interp.setResult(tmp304);
                    } // End Invoke: list
                    tmp303 = interp.getResult();
                    setVarScalar(interp, "avalues", tmp303, compiledLocals, 25);
                } // End Invoke: set
                { // Invoke: set aranges [...]
                    TclObject tmp306;
                    { // Invoke: list $range
                        TclObject tmp307 = TclList.newInstance();
                        TclObject tmp308;
                        tmp308 = getVarScalar(interp, "range", compiledLocals, 6);
                        TclList.append(interp, tmp307, tmp308);
                        interp.setResult(tmp307);
                    } // End Invoke: list
                    tmp306 = interp.getResult();
                    setVarScalar(interp, "aranges", tmp306, compiledLocals, 26);
                } // End Invoke: set
                { // Invoke: set cmdlist [...]
                    TclObject tmp309;
                    { // Invoke: list $cmd $script $etree $atype $avalues $aranges
                        TclObject tmp310 = TclList.newInstance();
                        TclObject tmp311;
                        try {
                            tmp311 = getVarScalar(interp, "cmd", compiledLocals, 2);
                            TclList.append(interp, tmp310, tmp311);
                            tmp311 = getVarScalar(interp, "script", compiledLocals, 0);
                            TclList.append(interp, tmp310, tmp311);
                            tmp311 = getVarScalar(interp, "etree", compiledLocals, 1);
                            TclList.append(interp, tmp310, tmp311);
                            tmp311 = getVarScalar(interp, "atype", compiledLocals, 24);
                            TclList.append(interp, tmp310, tmp311);
                            tmp311 = getVarScalar(interp, "avalues", compiledLocals, 25);
                            TclList.append(interp, tmp310, tmp311);
                            tmp311 = getVarScalar(interp, "aranges", compiledLocals, 26);
                            TclList.append(interp, tmp310, tmp311);
                        } catch (TclException ex) {
                            tmp310.release();
                            throw ex;
                        }
                        interp.setResult(tmp310);
                    } // End Invoke: list
                    tmp309 = interp.getResult();
                    setVarScalar(interp, "cmdlist", tmp309, compiledLocals, 27);
                } // End Invoke: set
                { // Invoke: lappend expr_list [...]
                    TclObject[] objv312 = TJC.grabObjv(interp, 1);
                    TclObject tmp313;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: list value $cmdlist
                            TclObject tmp314 = TclList.newInstance();
                            TclObject tmp315;
                            try {
                                TclList.append(interp, tmp314, const14);
                                tmp315 = getVarScalar(interp, "cmdlist", compiledLocals, 27);
                                TclList.append(interp, tmp314, tmp315);
                            } catch (TclException ex) {
                                tmp314.release();
                                throw ex;
                            }
                            interp.setResult(tmp314);
                        } // End Invoke: list
                        tmp313 = interp.getResult();
                        tmp313.preserve();
                        objv312[0] = tmp313;
                        interp.resetResult();
                        lappendVarScalar(interp, "expr_list", objv312, compiledLocals, 14);
                    } finally {
                        TJC.releaseObjvElems(interp, objv312, 1);
                    }
                } // End Invoke: lappend
            } else if ( tmp176_length == 4 && tmp176_first == 'w'
                    && tmp176.compareTo("word") == 0 ) {
                // Pattern {word}
                { // Invoke: if {$setree == {}} ...
                    // Binary operator: $setree == ""
                    TclObject tmp316 = getVarScalar(interp, "setree", compiledLocals, 7);
                    ExprValue tmp317 = evs0;
                    TJC.exprEqualsEmptyString(tmp317, tmp316, false);
                    // End Binary operator: ==
                    boolean tmp318 = ( tmp317.getIntValue() != 0 );
                    if ( tmp318 ) {
                        { // Invoke: error "..."
                            TclObject[] objv319 = TJC.grabObjv(interp, 2);
                            TclObject tmp320;
                            try {
                                // Arg 0 constant: error
                                objv319[0] = const3;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp321 = new StringBuffer(64);
                                sbtmp321.append("expected non-empty subtree, got ");
                                sbtmp321.append("{");
                                tmp320 = getVarScalar(interp, "setree", compiledLocals, 7);
                                sbtmp321.append(tmp320.toString());
                                sbtmp321.append("}");
                                tmp320 = TclString.newInstance(sbtmp321);
                                tmp320.preserve();
                                objv319[1] = tmp320;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                    ? cmdcache1.cmd : null), objv319, 0);
                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                    updateCmdCache(interp, 1);
                                }
                            } finally {
                                tmp320 = objv319[1];
                                if ( tmp320 != null ) {
                                    tmp320.release();
                                }
                                TJC.releaseObjv(interp, objv319, 2);
                            }
                        } // End Invoke: error
                    }
                } // End Invoke: if
                { // Invoke: set atype {word operand}
                    setVarScalar(interp, "atype", const22, compiledLocals, 24);
                } // End Invoke: set
                { // Invoke: set avalues [...]
                    TclObject tmp322;
                    { // Invoke: list $type_str
                        TclObject tmp323 = TclList.newInstance();
                        TclObject tmp324;
                        tmp324 = getVarScalar(interp, "type_str", compiledLocals, 23);
                        TclList.append(interp, tmp323, tmp324);
                        interp.setResult(tmp323);
                    } // End Invoke: list
                    tmp322 = interp.getResult();
                    setVarScalar(interp, "avalues", tmp322, compiledLocals, 25);
                } // End Invoke: set
                { // Invoke: set aranges [...]
                    TclObject tmp325;
                    { // Invoke: list $range
                        TclObject tmp326 = TclList.newInstance();
                        TclObject tmp327;
                        tmp327 = getVarScalar(interp, "range", compiledLocals, 6);
                        TclList.append(interp, tmp326, tmp327);
                        interp.setResult(tmp326);
                    } // End Invoke: list
                    tmp325 = interp.getResult();
                    setVarScalar(interp, "aranges", tmp325, compiledLocals, 26);
                } // End Invoke: set
                { // Invoke: set cmdlist [...]
                    TclObject tmp328;
                    { // Invoke: list $cmd $script $etree $atype $avalues $aranges
                        TclObject tmp329 = TclList.newInstance();
                        TclObject tmp330;
                        try {
                            tmp330 = getVarScalar(interp, "cmd", compiledLocals, 2);
                            TclList.append(interp, tmp329, tmp330);
                            tmp330 = getVarScalar(interp, "script", compiledLocals, 0);
                            TclList.append(interp, tmp329, tmp330);
                            tmp330 = getVarScalar(interp, "etree", compiledLocals, 1);
                            TclList.append(interp, tmp329, tmp330);
                            tmp330 = getVarScalar(interp, "atype", compiledLocals, 24);
                            TclList.append(interp, tmp329, tmp330);
                            tmp330 = getVarScalar(interp, "avalues", compiledLocals, 25);
                            TclList.append(interp, tmp329, tmp330);
                            tmp330 = getVarScalar(interp, "aranges", compiledLocals, 26);
                            TclList.append(interp, tmp329, tmp330);
                        } catch (TclException ex) {
                            tmp329.release();
                            throw ex;
                        }
                        interp.setResult(tmp329);
                    } // End Invoke: list
                    tmp328 = interp.getResult();
                    setVarScalar(interp, "cmdlist", tmp328, compiledLocals, 27);
                } // End Invoke: set
                { // Invoke: lappend expr_list [...]
                    TclObject[] objv331 = TJC.grabObjv(interp, 1);
                    TclObject tmp332;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: list value $cmdlist
                            TclObject tmp333 = TclList.newInstance();
                            TclObject tmp334;
                            try {
                                TclList.append(interp, tmp333, const14);
                                tmp334 = getVarScalar(interp, "cmdlist", compiledLocals, 27);
                                TclList.append(interp, tmp333, tmp334);
                            } catch (TclException ex) {
                                tmp333.release();
                                throw ex;
                            }
                            interp.setResult(tmp333);
                        } // End Invoke: list
                        tmp332 = interp.getResult();
                        tmp332.preserve();
                        objv331[0] = tmp332;
                        interp.resetResult();
                        lappendVarScalar(interp, "expr_list", objv331, compiledLocals, 14);
                    } finally {
                        TJC.releaseObjvElems(interp, objv331, 1);
                    }
                } // End Invoke: lappend
            }
        } // End Invoke: switch
        { // Invoke: set ... [...]
            TclObject tmp335;
            { // Invoke: lreplace $... 0 0 $expr_list
                TclObject[] objv336 = TJC.grabObjv(interp, 5);
                TclObject tmp337;
                try {
                    // Arg 0 constant: lreplace
                    objv336[0] = const5;
                    // Arg 1 variable: $...
                    tmp337 = getVarArray(interp, "_parse", "parse_expr_iterate_stack", compiledLocals, 4);
                    tmp337.preserve();
                    objv336[1] = tmp337;
                    // Arg 2 constant: 0
                    objv336[2] = const1;
                    // Arg 3 constant: 0
                    objv336[3] = const1;
                    // Arg 4 variable: $expr_list
                    tmp337 = getVarScalar(interp, "expr_list", compiledLocals, 14);
                    tmp337.preserve();
                    objv336[4] = tmp337;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv336, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp337 = objv336[1];
                    if ( tmp337 != null ) {
                        tmp337.release();
                    }
                    tmp337 = objv336[4];
                    if ( tmp337 != null ) {
                        tmp337.release();
                    }
                    TJC.releaseObjv(interp, objv336, 5);
                }
            } // End Invoke: lreplace
            tmp335 = interp.getResult();
            setVarArray(interp, "_parse", "parse_expr_iterate_stack", tmp335, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: return
            interp.resetResult();
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "_parse_expr_iterate_descend");
        } finally {
            TJC.exprReleaseValue(interp, evs3);
            TJC.exprReleaseValue(interp, evs2);
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;
    TclObject const18;
    TclObject const19;
    TclObject const20;
    TclObject const21;
    TclObject const22;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclInteger.newInstance(0);
        const1.preserve(); const1.preserve();
        const2 = TclInteger.newInstance(1);
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("error");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("subexpr");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("lreplace");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("linsert");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("_parse_expr_iterate_descend");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("parse");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("getstring");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("backslash");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("word");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("parse_range_without_brackets");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("command operand");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("value");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("operator");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance("literal operand");
        const16.preserve(); const16.preserve();
        const17 = TclString.newInstance("getrange");
        const17.preserve(); const17.preserve();
        const18 = TclString.newInstance("string");
        const18.preserve(); const18.preserve();
        const19 = TclString.newInstance("braced string");
        const19.preserve(); const19.preserve();
        const20 = TclString.newInstance("text");
        const20.preserve(); const20.preserve();
        const21 = TclString.newInstance("variable operand");
        const21.preserve(); const21.preserve();
        const22 = TclString.newInstance("word operand");
        const22.preserve(); const22.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "error";
                break;
            }
            case 2: {
                cmdName = "lreplace";
                break;
            }
            case 3: {
                cmdName = "linsert";
                break;
            }
            case 4: {
                cmdName = "_parse_expr_iterate_descend";
                break;
            }
            case 5: {
                cmdName = "parse";
                break;
            }
            case 6: {
                cmdName = "parse_range_without_brackets";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "script",
        "etree",
        "cmd",
        "private",
        "_parse",
        "type",
        "range",
        "setree",
        "no_arg_mfunc",
        "value",
        "op",
        "num_operands",
        "operands",
        "i",
        "expr_list",
        "operand",
        "elem",
        "range_before",
        "before",
        "range_after",
        "after",
        "range_with_quotes",
        "bstree",
        "type_str",
        "atype",
        "avalues",
        "aranges",
        "cmdlist",
        "range_start",
        "range_length",
        "char_before_range_index",
        "char_before",
        "max_range",
        "max_index",
        "char_after_range_index",
        "char_after"
    };
} // end class ParseExprIterateDescendCmd

