// TJC implementation of procedure parse_expr_iterate_type_value
package tjc;
import tcl.lang.*;

public class ParseExprIterateTypeValueCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 3, compiledLocalsNames);
        try {
        if (objv.length != 3) {
            throw new TclNumArgsException(interp, 1, objv, "type value");
        }
        setVarScalar(interp, "type", objv[1], compiledLocals, 0);
        setVarScalar(interp, "value", objv[2], compiledLocals, 1);
        { // Invoke: set ... [...]
            TclObject tmp0;
            { // Invoke: list $type $value
                TclObject tmp1 = TclList.newInstance();
                TclObject tmp2;
                try {
                    tmp2 = getVarScalar(interp, "type", compiledLocals, 0);
                    TclList.append(interp, tmp1, tmp2);
                    tmp2 = getVarScalar(interp, "value", compiledLocals, 1);
                    TclList.append(interp, tmp1, tmp2);
                } catch (TclException ex) {
                    tmp1.release();
                    throw ex;
                }
                interp.setResult(tmp1);
            } // End Invoke: list
            tmp0 = interp.getResult();
            initVarScoped(interp, "::_parse", compiledLocals, 2);
            setVarArray(interp, "::_parse", "parse_expr_iterate_type_value", tmp0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: return
            interp.resetResult();
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "parse_expr_iterate_type_value");
        } finally {
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    String[] compiledLocalsNames = {
        "type",
        "value",
        "::_parse"
    };
} // end class ParseExprIterateTypeValueCmd

