// TJC implementation of procedure parse_range_without_brackets
package tjc;
import tcl.lang.*;

public class ParseRangeWithoutBracketsCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 7, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 3) {
            throw new TclNumArgsException(interp, 1, objv, "script range");
        }
        setVarScalar(interp, "script", objv[1], compiledLocals, 0);
        setVarScalar(interp, "range", objv[2], compiledLocals, 1);
        { // Invoke: set range_text [...]
            TclObject tmp0;
            { // Invoke: parse getstring $script $range
                TclObject[] objv1 = TJC.grabObjv(interp, 4);
                TclObject tmp2;
                try {
                    // Arg 0 constant: parse
                    objv1[0] = const0;
                    // Arg 1 constant: getstring
                    objv1[1] = const1;
                    // Arg 2 variable: $script
                    tmp2 = getVarScalar(interp, "script", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[2] = tmp2;
                    // Arg 3 variable: $range
                    tmp2 = getVarScalar(interp, "range", compiledLocals, 1);
                    tmp2.preserve();
                    objv1[3] = tmp2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[2];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    tmp2 = objv1[3];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 4);
                }
            } // End Invoke: parse
            tmp0 = interp.getResult();
            setVarScalar(interp, "range_text", tmp0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set first [...]
            TclObject tmp3;
            { // Invoke: string index $range_text 0
                TclObject tmp4 = getVarScalar(interp, "range_text", compiledLocals, 2);
                String tmp5 = tmp4.toString();
                TclObject tmp6 = TJC.stringIndex(interp, tmp5, const2);
                interp.setResult(tmp6);
            } // End Invoke: string
            tmp3 = interp.getResult();
            setVarScalar(interp, "first", tmp3, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set last [...]
            TclObject tmp7;
            { // Invoke: string index $range_text end
                TclObject tmp8 = getVarScalar(interp, "range_text", compiledLocals, 2);
                String tmp9 = tmp8.toString();
                TclObject tmp10 = TJC.stringIndex(interp, tmp9, const3);
                interp.setResult(tmp10);
            } // End Invoke: string
            tmp7 = interp.getResult();
            setVarScalar(interp, "last", tmp7, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: if ... ... else ...
            // Binary operator: () && ()
            // Binary operator: $first == "["
            TclObject tmp11 = getVarScalar(interp, "first", compiledLocals, 3);
            boolean tmp12 = tmp11.toString().equals("[");
            ExprValue tmp13 = evs0;
            tmp13.setIntValue(tmp12);
            // End Binary operator: ==
            if (tmp13.getBooleanValue(interp)) {
            // Binary operator: $last == "]"
            TclObject tmp14 = getVarScalar(interp, "last", compiledLocals, 4);
            boolean tmp15 = tmp14.toString().equals("]");
            ExprValue tmp16 = evs1;
            tmp16.setIntValue(tmp15);
            // End Binary operator: ==
            tmp13.setIntValue(tmp16.getBooleanValue(interp));
            } else {
            tmp13.setIntValue(0);
            } // End if: ()
            // End Binary operator: &&
            boolean tmp17 = ( tmp13.getIntValue() != 0 );
            if ( tmp17 ) {
            } else {
                { // Invoke: error "..."
                    TclObject[] objv18 = TJC.grabObjv(interp, 2);
                    TclObject tmp19;
                    try {
                        // Arg 0 constant: error
                        objv18[0] = const4;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp20 = new StringBuffer(64);
                        sbtmp20.append("parse_range_without_brackets: range_text ");
                        sbtmp20.append("\"");
                        tmp19 = getVarScalar(interp, "range_text", compiledLocals, 2);
                        sbtmp20.append(tmp19.toString());
                        sbtmp20.append("\"");
                        sbtmp20.append(" should be enclosed in brackets");
                        tmp19 = TclString.newInstance(sbtmp20);
                        tmp19.preserve();
                        objv18[1] = tmp19;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv18, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp19 = objv18[1];
                        if ( tmp19 != null ) {
                            tmp19.release();
                        }
                        TJC.releaseObjv(interp, objv18, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set range_start [...]
            TclObject tmp21;
            { // Invoke: lindex $range 0
                TclObject tmp22 = getVarScalar(interp, "range", compiledLocals, 1);
                tmp22 = TclList.index(interp, tmp22, 0);
                if ( tmp22 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp22);
                }
            } // End Invoke: lindex
            tmp21 = interp.getResult();
            setVarScalar(interp, "range_start", tmp21, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: set range_len [...]
            TclObject tmp23;
            { // Invoke: lindex $range 1
                TclObject tmp24 = getVarScalar(interp, "range", compiledLocals, 1);
                tmp24 = TclList.index(interp, tmp24, 1);
                if ( tmp24 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp24);
                }
            } // End Invoke: lindex
            tmp23 = interp.getResult();
            setVarScalar(interp, "range_len", tmp23, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: return [...]
            { // Invoke: list [...] [...]
                TclObject tmp25 = TclList.newInstance();
                TclObject tmp26;
                try {
                    { // Invoke: expr {$range_start + 1}
                        // Binary operator: $range_start + 1
                        TclObject tmp27 = getVarScalar(interp, "range_start", compiledLocals, 5);
                        ExprValue tmp28 = evs0;
                        TJC.exprInitValue(interp, tmp28, tmp27);
                        ExprValue tmp29 = evs1;
                        tmp29.setIntValue(1);
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_PLUS, tmp28, tmp29);
                        // End Binary operator: +
                        TJC.exprSetResult(interp, tmp28);
                    } // End Invoke: expr
                    tmp26 = interp.getResult();
                    TclList.append(interp, tmp25, tmp26);
                    { // Invoke: expr {$range_len - 2}
                        // Binary operator: $range_len - 2
                        TclObject tmp30 = getVarScalar(interp, "range_len", compiledLocals, 6);
                        ExprValue tmp31 = evs0;
                        TJC.exprInitValue(interp, tmp31, tmp30);
                        ExprValue tmp32 = evs1;
                        tmp32.setIntValue(2);
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MINUS, tmp31, tmp32);
                        // End Binary operator: -
                        TJC.exprSetResult(interp, tmp31);
                    } // End Invoke: expr
                    tmp26 = interp.getResult();
                    TclList.append(interp, tmp25, tmp26);
                } catch (TclException ex) {
                    tmp25.release();
                    throw ex;
                }
                interp.setResult(tmp25);
            } // End Invoke: list
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "parse_range_without_brackets");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("parse");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("getstring");
        const1.preserve(); const1.preserve();
        const2 = TclInteger.newInstance(0);
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("end");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("error");
        const4.preserve(); const4.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "parse";
                break;
            }
            case 2: {
                cmdName = "error";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "script",
        "range",
        "range_text",
        "first",
        "last",
        "range_start",
        "range_len"
    };
} // end class ParseRangeWithoutBracketsCmd

