// TJC implementation of procedure tjc_util_file_saveas
package tjc;
import tcl.lang.*;

public class TjcUtilFileSaveasCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 3, compiledLocalsNames);
        try {
        if (objv.length != 3) {
            throw new TclNumArgsException(interp, 1, objv, "filename data");
        }
        setVarScalar(interp, "filename", objv[1], compiledLocals, 0);
        setVarScalar(interp, "data", objv[2], compiledLocals, 1);
        { // Invoke: set fd [...]
            TclObject tmp0;
            { // Invoke: open $filename w
                TclObject[] objv1 = TJC.grabObjv(interp, 3);
                TclObject tmp2;
                try {
                    // Arg 0 constant: open
                    objv1[0] = const0;
                    // Arg 1 variable: $filename
                    tmp2 = getVarScalar(interp, "filename", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[1] = tmp2;
                    // Arg 2 constant: w
                    objv1[2] = const1;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[1];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 3);
                }
            } // End Invoke: open
            tmp0 = interp.getResult();
            setVarScalar(interp, "fd", tmp0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: fconfigure $fd -translation lf
            TclObject[] objv3 = TJC.grabObjv(interp, 4);
            TclObject tmp4;
            try {
                // Arg 0 constant: fconfigure
                objv3[0] = const2;
                // Arg 1 variable: $fd
                tmp4 = getVarScalar(interp, "fd", compiledLocals, 2);
                tmp4.preserve();
                objv3[1] = tmp4;
                // Arg 2 constant: -translation
                objv3[2] = const3;
                // Arg 3 constant: lf
                objv3[3] = const4;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                    ? cmdcache2.cmd : null), objv3, 0);
                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                    updateCmdCache(interp, 2);
                }
            } finally {
                tmp4 = objv3[1];
                if ( tmp4 != null ) {
                    tmp4.release();
                }
                TJC.releaseObjv(interp, objv3, 4);
            }
        } // End Invoke: fconfigure
        { // Invoke: puts $fd $data
            TclObject[] objv5 = TJC.grabObjv(interp, 3);
            TclObject tmp6;
            try {
                // Arg 0 constant: puts
                objv5[0] = const5;
                // Arg 1 variable: $fd
                tmp6 = getVarScalar(interp, "fd", compiledLocals, 2);
                tmp6.preserve();
                objv5[1] = tmp6;
                // Arg 2 variable: $data
                tmp6 = getVarScalar(interp, "data", compiledLocals, 1);
                tmp6.preserve();
                objv5[2] = tmp6;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                    ? cmdcache3.cmd : null), objv5, 0);
                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                    updateCmdCache(interp, 3);
                }
            } finally {
                tmp6 = objv5[1];
                if ( tmp6 != null ) {
                    tmp6.release();
                }
                tmp6 = objv5[2];
                if ( tmp6 != null ) {
                    tmp6.release();
                }
                TJC.releaseObjv(interp, objv5, 3);
            }
        } // End Invoke: puts
        { // Invoke: close $fd
            TclObject[] objv7 = TJC.grabObjv(interp, 2);
            TclObject tmp8;
            try {
                // Arg 0 constant: close
                objv7[0] = const6;
                // Arg 1 variable: $fd
                tmp8 = getVarScalar(interp, "fd", compiledLocals, 2);
                tmp8.preserve();
                objv7[1] = tmp8;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                    ? cmdcache4.cmd : null), objv7, 0);
                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                    updateCmdCache(interp, 4);
                }
            } finally {
                tmp8 = objv7[1];
                if ( tmp8 != null ) {
                    tmp8.release();
                }
                TJC.releaseObjv(interp, objv7, 2);
            }
        } // End Invoke: close
        { // Invoke: return
            interp.resetResult();
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "tjc_util_file_saveas");
        } finally {
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("open");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("w");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("fconfigure");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("-translation");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("lf");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("puts");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("close");
        const6.preserve(); const6.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "open";
                break;
            }
            case 2: {
                cmdName = "fconfigure";
                break;
            }
            case 3: {
                cmdName = "puts";
                break;
            }
            case 4: {
                cmdName = "close";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "filename",
        "data",
        "fd"
    };
} // end class TjcUtilFileSaveasCmd

